//////////////////////////////////////////////////////////////////////////

/// started: 2000
/// last modified: November 2014
/// license: GPL V2 or 3

//////////////////////////////////////////////////////////////////////////

#ifndef X4AssertH
#define X4AssertH

//////////////////////////////////////////////////////////////////////////

#include "x4basics.h"

//////////////////////////////////////////////////////////////////////////

#include "X4Exception.h"

//////////////////////////////////////////////////////////////////////////

namespace X4 {

#if defined(X4_DEBUG)

	#define X4ASSERT_STRINGIFY(x) #x
	#define X4ASSERT_TOSTRING(x) X4ASSERT_STRINGIFY(x)

	#define x4Assert(c) X4::x4AssertExt(c, __FILE__, X4ASSERT_TOSTRING(__LINE__), #c)
	inline void x4AssertExt(bool cond, const char* filename, const char* line, const char* c)
	{
		if (!cond)
		{
			throw X4Exception(std::string(filename) + std::string("(") + std::string(line) + std::string(") - Assertion failed: ") + std::string(c));
		}
	}

#else
   #define x4Assert(C)
#endif



#if defined(X4_DEBUG)
inline void x4AssertMsg(bool cond, std::string msg)
{
   if (!cond) {
      throw X4Exception(msg);
   }
}
#else
   #define x4AssertMsg(C, M)
#endif

}


#endif
