//////////////////////////////////////////////////////////////////////////

/// author: Michael Wand, WSI/GRIS, MPI-INF
/// started: 2000
/// last modified: September 2013
/// license: GPL V2 or 3

//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
#include "precompiledHeadersBasics.h"
//////////////////////////////////////////////////////////////////////////
#include "X4Exception.h"
//////////////////////////////////////////////////////////////////////////
#include <string>
#include <iostream>
//////////////////////////////////////////////////////////////////////////
using namespace X4;
//////////////////////////////////////////////////////////////////////////


X4Exception::X4Exception(const std::string msg) {
	this->msg = msg;
	//#ifdef DEBUG
	//std::cerr << msg.c_str();
	//#endif
}

void X4Exception::print()
{
	std::cerr << msg.c_str();
}



std::string X4Exception::getTypeString()
{
	return "X4Exception";
}


std::string ERangeCheck::getTypeString()
{
	return "ERangeCheck";
}


std::string EIOException::getTypeString()
{
	return "EIOException";
}


std::string EMath::getTypeString()
{
	return "EMath";
}


std::string EInvalidState::getTypeString()
{
	return "EInvalidState";
}

std::string ETypeMismatch::getTypeString()
{
	return "ETypeMismatch";
}


std::string EInvalidArgument::getTypeString()
{
	return "EInvalidArgument";
}


std::string EOutOfMemory::getTypeString()
{
	return "EOutOfMemory";
}
