//////////////////////////////////////////////////////////////////////////

/// author: Michael Wand, WSI/GRIS
/// started: 2000
/// last modified: September 2013
/// license: GPL V2 or 3

//////////////////////////////////////////////////////////////////////////

#ifndef X4ExceptionH
#define X4ExceptionH

//////////////////////////////////////////////////////////////////////////

#include "x4basics.h"

//////////////////////////////////////////////////////////////////////////

#include <string>
#include <iostream>

//////////////////////////////////////////////////////////////////////////


namespace X4 {

class X4BASICS_API X4Exception {
 protected:
	std::string msg;
 public:
	X4Exception(const std::string msg);
	virtual std::string getMsg() {return msg;}
	void print();
	virtual std::string getTypeString();
	virtual ~X4Exception() {};
};

class X4BASICS_API ERangeCheck : public X4Exception {
 public:
	ERangeCheck(const std::string msg) : X4Exception(msg) {};
	virtual std::string getTypeString();
};

class X4BASICS_API EIOException : public X4Exception {
 public:
	EIOException(const std::string msg) : X4Exception(msg) {};
	virtual std::string getTypeString();
};

class X4BASICS_API EMath : public X4Exception {
 public:
	EMath(const std::string msg) : X4Exception(msg) {};
	virtual std::string getTypeString();
};

class X4BASICS_API EInvalidState : public X4Exception {
 public:
	EInvalidState(const std::string msg) : X4Exception(msg) {};
	virtual std::string getTypeString();
};

class X4BASICS_API ETypeMismatch : public X4Exception {
 public:
	ETypeMismatch(const std::string msg) : X4Exception(msg) {};
	virtual std::string getTypeString();
};

class X4BASICS_API EInvalidArgument : public X4Exception {
 public:
	EInvalidArgument(const std::string msg) : X4Exception(msg) {};
	virtual std::string getTypeString();
};

class X4BASICS_API EOutOfMemory : public X4Exception {
 public:
	EOutOfMemory(const std::string msg) : X4Exception(msg) {};
	virtual std::string getTypeString();
};


}

#endif
