//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "AttachedData.h"
//---------------------------------------------------------------------------
#include <X4Assert.h>
#include <Tools.h>
#include <HashTables.inline.h>
#include "MemoryManager.h"
#include "NumericalClassProperty.h"
#include "StringClassProperty.h"
#include "AttachedDataContainer.h"
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------


IMPLEMENT_X4_CLASS(AttachedData, 0)
{
	BEGIN_CLASS_INIT(AttachedData);
	ADD_STRING_PROP( m_name, 0 );
	SET_EDIT_READONLY( true );
	ADD_CARD32_PROP( m_flags, 0 );
}

// ----

AttachedData::AttachedData():m_flags(0), m_memManObj(NULL),m_MyContainer(NULL){
}

AttachedData::~AttachedData()
{
   if( m_MyContainer )
      m_MyContainer->removeData( m_name );
}

void AttachedData::setup(const std::string& name, const card32 flags, MemoryManager* mm){
   m_flags=flags;
   m_name=name;
   if(mm){
      m_memManObj=mm->createNewMMObject(this);
   }
}

void AttachedData::assign(const Object* obj, X4CopyContext *context)
{
   //Persistent::assign(obj, context );
   AttachedData * data = (AttachedData *)obj;
   m_name = data->m_name;
   m_flags = data->m_flags;
   m_MyContainer = NULL;
   forget(context);
}

static void copyCallback(void* context, std::string name, AttachedData *data) {
   AttachedDataContainer *thisInst = (AttachedDataContainer*)context;
   if ((data->getFlags() & AttachedData::ADF_PERSISTENT) != 0) {
      thisInst->attachData((AttachedData*)(data->copy()));
   }
}

// in class AttachedData to allow access to destructor
void AttachedData::delCallback(std::string name, AttachedData *data) {
   delete data;
}




