//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "BinaryAttachment.h"
//---------------------------------------------------------------------------
#include "X4Assert.h"
#include "Tools.h"
#include "HashTables.inline.h"
#include "MemoryManager.h"
#include "NumericalClassProperty.h"
#include "StringClassProperty.h"
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



IMPLEMENT_X4_CLASS( BinaryAttachment ,0)
{
	BEGIN_CLASS_INIT( BinaryAttachment );
}

void BinaryAttachment::write(OutputObjectStream *s) const {
	AttachedData::write(s);

	s->writeString( getDataAsString() );
}

void BinaryAttachment::read(InputObjectStream *s) {
	AttachedData::read(s);

	std::string str;
	s->readString(str);

	setData(str);
}

void BinaryAttachment::assign(const Object* obj, X4CopyContext *context)
{
	const BinaryAttachment * o = dynamic_cast<const BinaryAttachment*>(obj);
	x4Assert( o != NULL );

	AttachedData::assign( obj, context );

	m_data = o->m_data;
}



