//---------------------------------------------------------------------------
#ifndef BinaryAttachmentH
#define BinaryAttachmentH
//---------------------------------------------------------------------------
#include "x4core.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
#include "HashTables.h"
#include "X4Assert.h"
#include <string>
#include <vector>
#include "AttachedData.h"
//---------------------------------------------------------------------------

namespace X4 {
   

class MemoryManager;
class MemoryManagedObject;
class AttachedDataContainer;



class X4CORE_API BinaryAttachment : public AttachedData
{
	X4_CLASS( BinaryAttachment );

	std::vector<char> m_data; // this is binary data - never truncate at a '\0' character but use the length of the std::string

public:
	const std::vector<char>& getData() const {return m_data;}
	void setData( const std::vector<char>& s ) {m_data = s;}

	std::string getDataAsString() const { return std::string( m_data.begin(), m_data.end() ); }
	void setData( std::string s ) { m_data.resize(s.size()); std::copy(s.begin(), s.end(), m_data.begin() ); }

	virtual void write(OutputObjectStream *s) const;
	virtual void read(InputObjectStream *s);

	virtual void assign(const Object* obj, X4CopyContext *context = NULL);
};



}


#endif
