//---------------------------------------------------------------------------
#ifndef ClassTypeClassPropertyH
#define ClassTypeClassPropertyH
//---------------------------------------------------------------------------
#include "x4core.h"
//---------------------------------------------------------------------------
#include "SingleClassProperty.h"
//---------------------------------------------------------------------------

namespace X4 {
   


class X4CORE_API ClassTypeClassProperty : public SingleClassProperty {
    X4_CLASS(ClassTypeClassProperty);

 private:
   ClassTypeClassProperty() {}
   const MetaClass *baseClass;

 public:
   ClassTypeClassProperty(const std::string CName, const Version introducedInVersion,
                          pointer_diff offset, const MetaClass *baseClass);

   const MetaClass* getValue(const Object *obj, pointer_diff offset) const;
   void setValue(Object *obj, pointer_diff offset, const MetaClass *v) const;

   const MetaClass *getBaseClass() const;
   void setBaseClass(const MetaClass *baseClass);

   virtual void writeProperty(const Object* obj, pointer_diff offset, OutputObjectStream *out) const;
   virtual void readProperty(Object* obj, pointer_diff offset, InputObjectStream *in, card64 expectedSize) const;
   virtual std::string toString(const Object* obj, pointer_diff offset) const;
   virtual void fromString(Object* obj, pointer_diff offset, const std::string str) const;
   virtual const std::string getTypeName() const;

   virtual void assignProperty(const Object *from, Object *to, pointer_diff offset) const;

   ClassProperty* copyClassProperty();
};

#define ADD_METACLASS_PROP( propName, version, baseClass ) \
	((MetaClass*)getClass())->addProperty( new ClassTypeClassProperty( #propName , MetaClass::FIRST_VERSION + version, \
	(pointer_diff)((pointer_diff)&( obj_null_pointer->##propName ) - obj_null_offset) , baseClass ) );


}

#endif
