//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "Configuration.h"
//---------------------------------------------------------------------------
#include "StringAttachment.h"
#include "BinaryObjectStreams.h"
#include <ApplicationDirectories.h>
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------

X4::AttachedDataContainer  *X4::Configuration::configuration = NULL;


//std::string X4::Configuration::getConfigurationString(std::string name)
//{
//   StringAttachment * strAtt = dynamic_cast<StringAttachment *>(configuration->getData(name));
//   if( strAtt )
//      return strAtt->getString();
//   else
//      return "";
//}

void X4::Configuration::createConfiguration()
{
	if (!configuration) {
		configuration = new AttachedDataContainer();
	}
}

void X4::Configuration::loadConfiguration( std::string filename )
{
	bool readDefault = (filename == "");
   if (readDefault) filename = ApplicationDirectories::getConfigDir() + std::string("config.x4obj");
	delete configuration;
	configuration = NULL;
   try {
	   BinaryInputObjectStream in(filename);
	   in.readAnyObject(configuration);
   } catch (...) {
      if (readDefault) {
         filename = ApplicationDirectories::getConfigDir() + std::string("defaultConfig.x4obj");
         BinaryInputObjectStream in(filename);
         in.readAnyObject(configuration);
      } else throw;
   }
}

void X4::Configuration::deleteConfiguration()
{
	delete configuration;
	configuration = NULL;
}

void X4::Configuration::writeConfiguration( std::string filename /*= ""*/ )
{
	if (filename == "") {
		filename = ApplicationDirectories::getConfigDir() + std::string("config.x4obj");
	}
	BinaryOutputObjectStream out(filename);
	out.writeObject(configuration);
}

AttachedDataContainer *Configuration::getConfiguration() {
	if (!configuration) {
		createConfiguration();
	}
	return configuration;
}

extern X4CORE_API std::string X4::getConfigurationString( std::string name )
{
   AttachedDataContainer *conf = Configuration::getConfiguration();

   StringAttachment * strAtt = dynamic_cast<StringAttachment *>(conf->getData(name));
   if( strAtt )
      return strAtt->getString();
   else
      return "";
}
