//---------------------------------------------------------------------------
#ifndef ConfigurationH
#define ConfigurationH
//---------------------------------------------------------------------------
#include "x4core.h"
//---------------------------------------------------------------------------
#include "AttachedDataContainer.h"
//---------------------------------------------------------------------------

namespace X4 {

class AttachedDataContainer;

class X4CORE_API Configuration {
 public:
   static AttachedDataContainer  *configuration;

	/// creates an empty configuration (modules should check whether their configuration object exist in the container and if not, create a default object)
	static void createConfiguration();
	/// loads configuration object from file; if filename is not specified, the default location is used
	static void loadConfiguration(std::string filename = "");
	/// write configuration object to file; if filename is not specified, the default location is used
	static void writeConfiguration(std::string filename = "");
	/// deletes the configuration object and sets the pointer to NULL
	static void deleteConfiguration();
	/// get pointer to configuration object
	static AttachedDataContainer *getConfiguration();

	///// tries to get a StringAttachment 'name' from Configuration and returns the std::string
	///// if StringAttachment 'name' doesn't exist then "" is returned
	//static std::string getConfigurationString(std::string name);
};

/// tries to get a StringAttachment 'name' from Configuration and returns the std::string
/// if StringAttachment 'name' doesn't exist then "" is returned
extern X4CORE_API std::string getConfigurationString(std::string name);


}

#endif
