//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "EmbeddedObjectClassProperty.h"
#include "MetaClass.h"
#include "Persistent.h"
#include "ObjectStreams.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------

/*
void X4::EmbeddedObjectClassProperty_addDefaultEditor(ClassProperty *c) {
   c->addPropertyEditor(EmbeddedObjectClassPropertyEditor::getClass(), true);
}*/
// TODO (art): discuss this

IMPLEMENT_X4_ABSTRACT_CLASS(EmbeddedObjectClassProperty, 0)
{
	BEGIN_CLASS_INIT(EmbeddedObjectClassProperty);
}


EmbeddedObjectClassProperty::EmbeddedObjectClassProperty(const std::string CName, const Version introducedInVersion,
                               pointer_diff offset, const MetaClass * mc) 
							   : SingleClassProperty(CName, introducedInVersion) 
{
	m_MetaClass = (MetaClass *)mc;
	x4Assert( !mc->isAbstract() );
	setOffset( offset );
    //EmbeddedObjectClassProperty_addDefaultEditor(this);
}

void EmbeddedObjectClassProperty::writeProperty(const Object* obj, pointer_diff offset, OutputObjectStream *out) const 
{
	Persistent * src = dynamic_cast<Persistent*>(getSubObjectAdress( (Object *)obj, offset ));
	x4Assert( src != NULL );
	out->writeObject(src);
}

void EmbeddedObjectClassProperty::readProperty(Object* obj, pointer_diff offset, InputObjectStream *in, card64 expectedSize) const 
{
	Persistent * dest = NULL;
	in->readObject(dest);
	x4Assert( dest != NULL);

	getSubObjectAdress( obj, offset )->assign(dest);
	delete dest; // TODO (art) we can optimize this if we allow reading of objects without creating new instances, so that we don't have to copy it after read
}


std::string EmbeddedObjectClassProperty::toString(const Object* obj, pointer_diff offset) const {
   return makeObjectDescription( getSubObjectAdress( (Object*)obj,offset ) );
}

void EmbeddedObjectClassProperty::fromString(Object* /*obj*/, pointer_diff /*offset*/, const std::string /*str*/) const {
	return;
}

const std::string EmbeddedObjectClassProperty::getTypeName() const 
{
   return m_MetaClass->getClassName();
}

ClassProperty* EmbeddedObjectClassProperty::copyClassProperty() {
   EmbeddedObjectClassProperty *result = new EmbeddedObjectClassProperty();
   *result = *this;
   return result;
}

void EmbeddedObjectClassProperty::assignProperty(const Object *from, Object *to, pointer_diff offset) const 
{
	Object * src = getSubObjectAdress( (Object*)from, offset );
	Object * dest = getSubObjectAdress( to, offset );
	dest->assign( src );
}


Object *EmbeddedObjectClassProperty::getSubObjectAdress(Object *obj, pointer_diff offset) const
{
   return (Object*)((char*)obj + getOffset() + offset);
}

