//---------------------------------------------------------------------------
#ifndef EmbeddedObjectClassPropertyH
#define EmbeddedObjectClassPropertyH
//---------------------------------------------------------------------------
#include "x4core.h"
//---------------------------------------------------------------------------
#include "SingleClassProperty.h"
//---------------------------------------------------------------------------


namespace X4 {
   

class MetaClass;

//void X4CORE_API EmbeddedObjectClassProperty_addDefaultEditor(ClassProperty *c);
// TODO (art): discuss and make it correct

#if 0
// (art) - disabled this class since it just do nothing and is only another abstraction where it is not required at all
class X4CORE_API GeneralEmbeddedObjectClassProperty : public SingleClassProperty {
 protected:
   GeneralEmbeddedObjectClassProperty() : SingleClassProperty("", 1) {}
 public:
   GeneralEmbeddedObjectClassProperty(const std::string CName, const Version introducedInVersion)
    : SingleClassProperty(CName, introducedInVersion) {}
   virtual Object *getSubObjectAdress(Object *obj, pointer_diff offset) const = 0;
};
#endif


class X4CORE_API EmbeddedObjectClassProperty : public SingleClassProperty
{
	X4_CLASS(EmbeddedObjectClassProperty);

	private:
		EmbeddedObjectClassProperty() : SingleClassProperty("", 1) {}

		MetaClass	*	m_MetaClass;

	public:
		EmbeddedObjectClassProperty(const std::string CName, const Version introducedInVersion,
									pointer_diff offset, const MetaClass * mc);

		virtual void writeProperty(const Object* obj, pointer_diff offset, OutputObjectStream *out) const;
		virtual void readProperty(Object* obj, pointer_diff offset, InputObjectStream *in, card64 expectedSize) const;
		virtual std::string toString(const Object* obj, pointer_diff offset) const;
		virtual void fromString(Object* obj, pointer_diff offset, const std::string str) const;
		virtual const std::string getTypeName() const;
		ClassProperty* copyClassProperty();
		virtual void assignProperty(const Object *from, Object *to, pointer_diff offset) const;


		virtual Object *getSubObjectAdress(Object *obj, pointer_diff offset) const;
};

#define ADD_EMBEDDED_OBJECT_PROP( propName, version, objectClass ) \
	((MetaClass*)getClass())->addProperty( new EmbeddedObjectClassProperty( #propName , MetaClass::FIRST_VERSION + version, \
	(pointer_diff)((pointer_diff)&( obj_null_pointer->##propName ) - obj_null_offset), objectClass) );

}


#endif
