//---------------------------------------------------------------------------
#ifndef MultiPartPersistentH
#define MultiPartPersistentH
//---------------------------------------------------------------------------
#include "x4core.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace X4 {


/// This class represents objects that objects that are serialized in multiple parts (rather than at once).
/// Typically, they are stored in MultiObjectStreams.
class X4CORE_API MultiPartPersistent : public Persistent {
	X4_CLASS(MultiPartPersistent)
 public:
	/// deletes only this part, not any other parts owned / linked by this one
	/// standard behavior implemented here: delete this
	virtual void shallowDelete();
};

}

#endif
