//---------------------------------------------------------------------------
#ifndef StreamContext__H
#define StreamContext__H
//---------------------------------------------------------------------------
#include "x4core.h"
//---------------------------------------------------------------------------
#include "Persistent.h"

namespace X4
{
	/**
	* A context which is hold together with the stream and contains additional information for streamed objects.
	* Such a context can be useful when certain behaviour for streamed objects is required, e.g. partial loading.
	* Each streamed object should know how to process such a context.
	**/
	class X4CORE_API StreamContext : public Persistent
	{
		X4_ABSTRACT_CLASS(StreamContext);

	public:
		StreamContext() {};
		virtual ~StreamContext() = 0;
	};

}
#endif
