//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "StringAttachment.h"
//---------------------------------------------------------------------------
#include "X4Assert.h"
#include "Tools.h"
#include "HashTables.inline.h"
#include "MemoryManager.h"
#include "NumericalClassProperty.h"
#include "StringClassProperty.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



MetaClass* StringAttachment::StringAttachmentMetaClass = NULL;

const MetaClass* StringAttachment::getInstanceClass() const {
   return getClass();
}

Object* StringAttachment::newInstance() {
   return new StringAttachment;
}

const MetaClass* StringAttachment::getClass() {
   if (StringAttachmentMetaClass==NULL) {
      StringAttachmentMetaClass = new MetaClass("StringAttachment", "no description.",
                                  newInstance, sizeof(StringAttachment));
   }
   return StringAttachmentMetaClass;
}

void StringAttachment::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   StringAttachmentMetaClass->copyParentProperties();
	BEGIN_CLASS_INIT(StringAttachment);
	ADD_STRING_PROP( m_String, 0 );
}

void StringAttachment::shutdown() {
   delete StringAttachmentMetaClass;
}


void StringAttachment::assign(const Object* obj, X4CopyContext *context)
{
   AttachedData::assign( obj, context );
   const StringAttachment * att = dynamic_cast<const StringAttachment*>(obj);
   x4Assert( att );
   m_String = att->m_String;
}


