//---------------------------------------------------------------------------
#ifndef StringAttachmentH
#define StringAttachmentH
//---------------------------------------------------------------------------
#include "x4core.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
#include "HashTables.h"
#include "X4Assert.h"
#include <string>
#include <vector>
#include "AttachedData.h"
//---------------------------------------------------------------------------

namespace X4 {
   

class MemoryManager;
class MemoryManagedObject;
class AttachedDataContainer;



class X4CORE_API StringAttachment : public AttachedData
{
private:
	static MetaClass *StringAttachmentMetaClass;
	static Object* newInstance();

public:
	virtual const MetaClass *getInstanceClass() const;
	static const MetaClass *getClass();
	static void init(const MetaClass *parentClass);
	static void shutdown();

	std::string getString() {return m_String;}
	void setString( std::string s ) {m_String = s;}

	virtual void assign(const Object* obj, X4CopyContext *context = NULL);

	std::string   m_String;

};


}


#endif
