#ifndef ClassTypeClassPropertyEditorWidgetH 
#define ClassTypeClassPropertyEditorWidgetH
//---------------------------------------------------------------------------
#include "x4interface.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include <QComboBox>
#include "Delegate.h"
//---------------------------------------------------------------------------

namespace X4
{

class ClassTypeClassProperty;

class X4INTERFACE_API ClassTypeClassPropertyEditorWidget : public QComboBox
{
	Q_OBJECT

 private:
	void collectClassList(const std::string baseClass, QStringList &list );

	ClassTypeClassProperty	*	m_Object;
	bool initialized;
	Delegate callBack;
	std::string ignorePrefix;

	std::string handlePrefix(const std::string s);
	
 public:
	ClassTypeClassPropertyEditorWidget(QWidget * parent = NULL, Qt::WindowFlags f=0);
	~ClassTypeClassPropertyEditorWidget(void);

	void setup( ClassTypeClassProperty * obj );
	void setNotify(Delegate callBack) {this->callBack = callBack;}
	
	/// update editor content with object data
	void updateEditor();

	void initialize(card32 ident, const MetaClass *mc);
   const MetaClass *getSelected();
   void setSelection(const MetaClass *mc);
	void collectClasses(const std::string baseClass, bool sortByName = false, std::string ignorePrefix = "");
   void setSelection(const std::string className);

 private slots:
   virtual void selectionChanged(int index);

 signals:
   void sigModified();
   
};

MAKE_CLASS_EDITOR( X4INTERFACE_API , ClassTypeClassProperty )


}

#endif