//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "ClassTypePropertyEditor.h"
//---------------------------------------------------------------------------
#include "ClassTypeClassPropertyEditorWidget.h"
#include "Delegate.h"
#include "ClassTypeClassProperty.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



IMPLEMENT_X4_CLASS( ClassTypePropertyEditor ,0)
{
}


ClassTypePropertyEditor::ClassTypePropertyEditor(void)
{
	m_ElementEditor = NULL;
}

ClassTypePropertyEditor::~ClassTypePropertyEditor(void)
{
}

QWidget * ClassTypePropertyEditor::makeEditor(QWidget *parent, bool readOnly)
{
	x4Assert( m_Object != NULL );
	x4Assert( m_Property != NULL );
	x4Assert( m_ElementEditor == NULL );

	m_ElementEditor = new ClassTypeClassPropertyEditorWidget( parent );

	ClassTypeClassProperty *prop = dynamic_cast<ClassTypeClassProperty*>(m_Property);
	x4Assert(prop);
	m_ElementEditor->setup( prop );
	m_ElementEditor->updateEditor();
	m_ElementEditor->setSelection(prop->getValue(m_Object, 0));
	m_ElementEditor->setNotify(Delegate(this, (Delegate::MethodPtr)&ClassTypePropertyEditor::writeBackSelection));
	return m_ElementEditor;
}

void ClassTypePropertyEditor::update()
{
	x4Assert( m_ElementEditor != NULL );
	const ClassTypeClassProperty *prop = dynamic_cast<const ClassTypeClassProperty*>(m_Property);
	x4Assert(prop);
	m_ElementEditor->setSelection(prop->getValue(m_Object, 0));
}

card32 ClassTypePropertyEditor::getPreferredHeight()
{
	x4Assert( m_ElementEditor != NULL );
	return m_ElementEditor->height();
}

void ClassTypePropertyEditor::writeBackSelection() 
{
	const ClassTypeClassProperty *prop = dynamic_cast<const ClassTypeClassProperty*>(m_Property);
	x4Assert(prop);
	prop->setValue(m_Object, 0, m_ElementEditor->getSelected());
}
