//---------------------------------------------------------------------------
#ifndef DebugOutputCounterH
#define DebugOutputCounterH
//---------------------------------------------------------------------------
#include "x4interface.h"
#include "EventCounterDisplay.h"
//---------------------------------------------------------------------------


namespace X4 {

///
/// helper class to output counter events.
/// usage: debugOutput << DBOCounter("name", value);
///
class DBOCounter {
 public:
   std::string name;
   int32 value;

   DBOCounter(std::string name, int32 value) {
      this->name = name;
      this->value = value;
   }
};

/// output operator for debug outputs
inline DebugOutput &operator<<(DebugOutput &dbo, DBOCounter &rhs) {
   EventCounterDisplay::NewValueStepOnChange e;
   e.value = rhs.value;
   dbo.displayEvent(EventCounterDisplay::getClass(), rhs.name, &e);
   return dbo;
}


}


#endif