#ifndef EmbeddedObjectClassPropertyEditorH
#define EmbeddedObjectClassPropertyEditorH
//---------------------------------------------------------------------------
#include "x4interface.h"
//---------------------------------------------------------------------------
#include "ElementEditor.h"
#include "Object.h"
#include "PropertyEditor.h"
//---------------------------------------------------------------------------

namespace X4
{

class EmbeddedObjectElementEditor;
class EmbeddedObjectInlineElementEditor;


class X4INTERFACE_API EmbeddedObjectClassPropertyEditor : public PropertyEditor
{
	X4_CLASS( EmbeddedObjectClassPropertyEditor )

private:
	
	EmbeddedObjectElementEditor	*	m_ElementEditor;

public:
	EmbeddedObjectClassPropertyEditor(void);

	/// creates an editor
	virtual QWidget *makeEditor(QWidget * parent, bool readOnly);	

	/// update editor
	virtual void update();

   virtual card32 getPreferredHeight();

};


// ----


class X4INTERFACE_API EmbeddedObjectClassPropertyInlineEditor : public PropertyEditor
{
	X4_CLASS( EmbeddedObjectClassPropertyInlineEditor )

private:
	
	EmbeddedObjectInlineElementEditor	*	m_ElementEditor;

public:
	EmbeddedObjectClassPropertyInlineEditor(void);

	/// creates an editor
	virtual QWidget *makeEditor(QWidget * parent, bool readOnly);	

	/// update editor
	virtual void update();

   virtual card32 getPreferredHeight();

};

}

#endif