//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "EventDisplayer.h"
#include "EventDisplayerBaseWidget.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------


MetaClass* EventDisplayer::EventDisplayerMetaClass = NULL;

const MetaClass* EventDisplayer::getInstanceClass() const {
   return getClass();
}

const MetaClass* EventDisplayer::getClass() {
   if (EventDisplayerMetaClass==NULL) {
      EventDisplayerMetaClass = new MetaClass("EventDisplayer", "no description.",
                                              NULL, sizeof(EventDisplayer));
   }
   return EventDisplayerMetaClass;
}

void EventDisplayer::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   EventDisplayerMetaClass->copyParentProperties();
}

void EventDisplayer::shutdown() {
   delete EventDisplayerMetaClass;
}

EventDisplayer::EventDisplayer() {
   baseWidget = NULL;
}


QWidget* EventDisplayer::makeWidget(QWidget* Owner, std::string name) {
	if (baseWidget==NULL) {
		baseWidget = new EventDisplayerBaseWidget(Owner);
		baseWidget->setName(name);
		QWidget* specialWidget = createSpecialWidget(baseWidget);
		baseWidget->setSpecialDisplayWidget(specialWidget);
	};
	return baseWidget;
};

