//---------------------------------------------------------------------------
#ifndef EventDisplayerBaseWidgetH
#define EventDisplayerBaseWidgetH
//---------------------------------------------------------------------------
#include "x4interface.h"
//---------------------------------------------------------------------------
#include "Object.h"
#include "X4Types.h"
#include <QWidget>
//---------------------------------------------------------------------------
//this file is generated from the ui file by a custom buildstep, include it here
#include "x4interface/EventDisplayerBaseWidgetForm_ui.h"
//---------------------------------------------------------------------------


namespace X4 {

class X4INTERFACE_API EventDisplayerBaseWidget : public QWidget {

	Q_OBJECT

	protected:
		///used to access buttons, etc. from QtDesigner
		Ui_EventDisplayerBaseWidgetForm baseUI;
		QWidget* mySpecialWidget;

	public:
		EventDisplayerBaseWidget(QWidget *parent = NULL);
		~EventDisplayerBaseWidget();

		inline void setName(std::string n) { baseUI.LabelBaseName->setText(QString(n.c_str())); };
		inline std::string getName() { return qPrintable(baseUI.LabelBaseName->text()); };

		inline void setValue(std::string v) { baseUI.LabelBaseValue->setText(QString(v.c_str())); };
		inline std::string getValue() { return qPrintable(baseUI.LabelBaseValue->text()); };

		inline void setSpecialDisplayWidget(QWidget* w) { 
			mySpecialWidget = w;
			baseUI.FrameSpecialDisplayer->layout()->addWidget(w);
		};
		inline QWidget* getSpecialDisplayWidget() { 
			return mySpecialWidget;
		};

		inline bool isMinimized() { return !baseUI.FrameSpecialDisplayer->isVisible(); };


	public slots:
		void on_TBMinimize_clicked();
		void on_TBClose_clicked();

	signals:
		void sigCloseWidget(std::string);

};

}


#endif
