//---------------------------------------------------------------------------
#ifndef EventViewerWidgetH
#define EventViewerWidgetH
//---------------------------------------------------------------------------
#include "x4interface.h"
//---------------------------------------------------------------------------
#include "X4Types.h"
//---------------------------------------------------------------------------
#include <QWidget>
//---------------------------------------------------------------------------
#include "x4interface\EventViewerWidget_ui.h"
#include "MetaClass.h"
//---------------------------------------------------------------------------

namespace X4 {

class EventDisplayer;
class EventDisplayerEvent;

class X4INTERFACE_API EventViewerWidget : public QWidget {
   Q_OBJECT
 
 private:
	Ui_EventViewerWidget ui;

	struct EventEntry {
      std::string name;
      EventDisplayer *evDisp;
      QWidget *evWidget;
   };
   std::vector <EventEntry> eventViewers;
	
	void updateEvLabel();
	
 private slots:
	/// deletes the event displayer identified by name
   void sltDeleteEventDisplayer(std::string name); 

 public:
	EventViewerWidget(QWidget *parent=0, Qt::WindowFlags f=0, bool standAlone = true);

   void displayEvent(const MetaClass *eventType /* of type EventDisplayer */, 
                     std::string name, 
                     const EventDisplayerEvent *event,
                     const char *logFile = NULL);

	~EventViewerWidget();
};

}

#endif