#ifndef MenuWidgetH
#define MenuWidgetH
// -------------------------------------------------------------------
#include "x4interface.h"
// -------------------------------------------------------------------
#include <QMainWindow>
//---------------------------------------------------------------------------
#include <map>
#include <string>
#include <vector>
// -------------------------------------------------------------------

class QMenu;
class QMenuBar;

namespace X4 
{

class X4INTERFACE_API MenuWidget :	public QMainWindow
{
	Q_OBJECT

public:
	MenuWidget(QWidget * parent=NULL, Qt::WindowFlags f = 0);
	~MenuWidget(void);

	/// adds a menu entry - id holds the menu path seperated by / and has to be unique
	/// example id: "file/new/scene"
	void addMenuEntry( std::string id, bool checkAble = false );

	/// checks/unchecks menu entry 'id'
	void setMenuEntryChecked( std::string id, bool checked );
	/// returns checked-state of menu entry
	bool menuEntryChecked( std::string id );

	/// sets icon 'icon' for menu entry 'id'
	void setMenuEntryIcon( std::string id, QIcon &icon );


protected:

	virtual void menuItemTriggered( std::string id );

public slots:
	void sltMenuHandler( QAction * action );

private:

	std::vector<QString> splitID( std::string id );

	std::map<std::string, QAction * >		m_Actions;	/// stores actions for later access
	std::map<QAction *, std::string>		m_ActionsMap;
	std::map<std::string, QMenu * >		m_Menu;
	//QMenuBar	*	m_MenuBar;

};

}

#endif