//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "ObjectCreationDialog.h"
#include "ClassEditor.h"
#include "ClassCreator.h"
#include "ExceptionHandling.h"
//---------------------------------------------------------------------------
#include <QVBoxLayout>
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------


ObjectCreationDialog::ObjectCreationDialog(QWidget* parent) {
	ui.setupUi(this);
}

Object *ObjectCreationDialog::execute(QWidget *parent, ClassCreator *cc) {
	Object *result = NULL;

	STD_GLOBAL_EXCEPTION_HANDLER_START
	ObjectCreationDialog *diag = new ObjectCreationDialog(parent);
	x4Assert(cc != NULL);
	if (cc == NULL) return NULL;
	const MetaClass *edmc = cc->getInstanceClass()->getGUIDescriptor()->getDefaultClassEditor();
	x4Assert(edmc != NULL);
	if (edmc == NULL) return NULL;
	ClassEditor *ed = (ClassEditor*)edmc->newInstance();
	QVBoxLayout *l = new QVBoxLayout(diag->ui.frameCreatorEditor);
	l->setMargin(0);
	l->setSpacing(0);
	l->addWidget(ed->makeEditor(diag->ui.frameCreatorEditor, cc));
	if (diag->exec() == QDialog::Accepted) {
		result = cc->makeObject();
	}
	delete ed;
	STD_GLOBAL_EXCEPTION_HANDLER_END

	return result;
}

#include "ObjectCreationDialog_moc.h"
