#ifndef ObjectDictionaryEditorWidgetH
#define ObjectDictionaryEditorWidgetH
//---------------------------------------------------------------------------
#include "x4interface.h"
//---------------------------------------------------------------------------
#include <QListWidget>
#include "ClassEditor.h"
#include <map>
//---------------------------------------------------------------------------

class QMenu;
class QAction;
class QMouseEvent;

namespace X4
{

class ObjectDictionary;
class ClassSelectionDialog;
class MetaClass;

class X4INTERFACE_API ObjectDictionaryEditorWidget : public QListWidget
{
	Q_OBJECT

private:

	void buildMenu( QListWidgetItem * item );
	void saveFile( Object * obj, std::string filename );

//	QAction	*	m_EditorsAction;
//	QAction	*	m_MethodsAction;
//	QAction	*	m_ApplicationsAction;
	QAction	*	m_NewAction;
	QAction	*	m_OpenAction;
	QAction	*	m_NewFolderAction;
	//QAction	*	m_SaveAction;
	QAction  *  m_RenameAction;
	QAction	*	m_SaveAsAction;
	QAction	*	m_DeleteAction;
	QMenu		*	m_ItemMenu;
	QMenu		*	m_EditorsMenu;

	struct TMetaInfo
	{
		MetaClass * mc;
		Object	*	obj;
		std::string		name;
		bool			isDefault;
	};
	std::map<QAction*, TMetaInfo >	m_EditorClasses;
	
	ObjectDictionary * m_ObjectDict;
	ClassSelectionDialog	*	m_ClassSelectionDialog;

public:
	ObjectDictionaryEditorWidget(QWidget * parent);
	~ObjectDictionaryEditorWidget(void);

	void setup( ObjectDictionary * obj ) {m_ObjectDict = obj;}
	void updateEditor();
	void load();
	void save();
	Object* getSelectedObject();
	void loadFile( std::string filename );
	void openFirstItem();
	void addObject( Object * obj, std::string name );

public slots:
	void sltMenuHandler( QAction * action );

protected:

	virtual void mousePressEvent( QMouseEvent * e);
	virtual void mouseDoubleClickEvent( QMouseEvent * e );
	virtual void dragEnterEvent( QDragEnterEvent *e);
	virtual void dragMoveEvent( QDragMoveEvent *e);
	virtual void dropEvent( QDropEvent * e);


};

MAKE_CLASS_EDITOR( X4INTERFACE_API, ObjectDictionary )


}

#endif