//---------------------------------------------------------------------------
#include "StdAfx.h"

//---------------------------------------------------------------------------
#include "OnlineHelp.h"
//---------------------------------------------------------------------------
#include "X4Assert.h"
#include "OnlineHelpWidget.h"
#include "Tools.h"
//---------------------------------------------------------------------------
#include "Configuration.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



void OnlineHelp::show() {
//   x4Assert(onlineHelpForm);
//   onlineHelpForm->showHelp();
	init();
	onlineHelpWindow->show();

}

void OnlineHelp::newTopic(std::string topic, std::string defaultTopic) {
	init();
	std::string helpPath=getConfigurationString("BIN_PATH")+"\\help\\";

	if (!X4::FileExists((helpPath+topic).c_str())) {
      if (defaultTopic == "" || !X4::FileExists((helpPath+defaultTopic).c_str())) {
         topic = "noEntry.html";
      } else {
         topic = defaultTopic;
      }
   }

	onlineHelpWindow->setSourceFile(topic.c_str());
}

void OnlineHelp::showIndex(){
	init();
	onlineHelpWindow->showIndex();
}

void OnlineHelp::position(int x, int y, int width, int height) {
	init();;
//   onlineHelpForm->position(x,y,width,height);
}

void OnlineHelp::hide() {
	init();
	onlineHelpWindow->hide();
}

void OnlineHelp::shutdown() {
	if(onlineHelpWindow) delete onlineHelpWindow;
	onlineHelpWindow=NULL;
}

void OnlineHelp::init() {
	if (!onlineHelpWindow)
		onlineHelpWindow= new OnlineHelpWidget();
}

