//---------------------------------------------------------------------------
#ifndef OnlineHelpH
#define OnlineHelpH
//---------------------------------------------------------------------------
#include "x4interface.h"
//---------------------------------------------------------------------------
#include <string>
//---------------------------------------------------------------------------

namespace X4 {

class X4INTERFACE_API OnlineHelp {
 public:
   /// show online help window, bring to front
   static void show();
   /// display a new topic (html fetched from directory "help")
   /// provide html file name from X4\bin\help directory. path will be added automatically.
   /// if the file is not found, the defaultTopic is shown (error page if defaultPage == "")
   static void newTopic(std::string topic, std::string defaultTopic = "");
	/// show index of all files
   static void showIndex();
   /// move help window to a new position
   static void position(int x, int y, int width, int height);
   /// hide online help window
   static void hide();
   ///call to shutdown help when closing X4	
   static void shutdown();
 private:
   ///create Helpwidget, if it dosen't exist
   static void init();
};

}

#endif
