#include "StdAfx.h"
#include "OnlineHelpWidget.h"
#include "Configuration.h"
//---------------------------------------------------------------------------

using namespace X4;

OnlineHelpWidget *X4::onlineHelpWindow = NULL;

OnlineHelpWidget::OnlineHelpWidget(void)
:QWidget(NULL)
{
	//call ui.setupUi(this) to set up the layout from QtDesigner
	ui.setupUi(this);

	dModel = new QDirModel;
	dModel->setNameFilters(QStringList(QString("*.html")));

	//easy access to QtDesigner buttons, etc. by ui object
	ui.treeView->setModel(dModel);
	ui.treeView->setRootIndex(dModel->index(QString("help\\")));
	ui.treeView->resizeColumnToContents(0);
	ui.treeView->setColumnHidden(1,true);
	ui.treeView->setColumnHidden(2,true);
	ui.treeView->setColumnHidden(3,true);
	ui.textBrowser->setSearchPaths(QStringList(QString("help\\")));
	ui.textBrowser->setSource(QString("help\\index.html"));


   ui.treeView->setRootIsDecorated(false);
	ui.treeView->setItemsExpandable(false);

	setWindowIcon(QIcon(":/foundation/images/Buttons/GeoXLIcon.png"));

	QObject::connect(ui.treeView, SIGNAL(doubleClicked(QModelIndex)), this, SLOT(sltIndexClicked(QModelIndex)));
}

OnlineHelpWidget::~OnlineHelpWidget(void)
{
}

void OnlineHelpWidget::setSourceFile(const char* name){
	ui.textBrowser->setSource( QString(name));
}

void OnlineHelpWidget::on_textBrowser_anchorClicked(const QUrl & link){
	QString linkText=link.toString();
	QString helpText=QString("OpenHelpIndex");
	if(linkText.endsWith(helpText)){
		showIndex();		
	}
}

void OnlineHelpWidget::showIndex(){
	ui.tabWidget->setCurrentIndex(1);
	ui.textBrowser->setSource( QString("index.html"));
}

void OnlineHelpWidget::sltIndexClicked(const QModelIndex & index){
	ui.textBrowser->setSource(dModel->fileName(index));
	ui.tabWidget->setCurrentIndex(0);
}


#include "OnlineHelpWidget_moc.h"
