/***************************************************************************
*   Copyright (c) 2009   Art Tevs                                         *
*                                                                         *
*   This library is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU Lesser General Public License as        *
*   published by the Free Software Foundation; either version 3 of        *
*   the License, or (at your option) any later version.                   *
*                                                                         *
*   This library is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU Lesse General Public License for more details.                    *
*                                                                         *
*   The full license is in LICENSE file included with this distribution.  *
***************************************************************************/

#ifndef ProgressFrameWidgetH
#define ProgressFrameWidgetH
//---------------------------------------------------------------------------
#include "x4interface.h"
//---------------------------------------------------------------------------
#include "ProgressWidget.h"
//---------------------------------------------------------------------------
//this file is generated from the ui file by a custom buildstep, include it here
#include "x4interface/ProgressFrameWidgetForm_ui.h"
//---------------------------------------------------------------------------

namespace X4
{
    class X4INTERFACE_API ProgressFrameWidget : public ProgressWidget
    {
        Q_OBJECT;

        public:
            ProgressFrameWidget(QWidget *parent);
            ~ProgressFrameWidget(void);

        private slots:
            void cancel_clicked(bool);

        public slots:

            void showForm();
            void setToolProgress(card32 position);
            void setOverallProgress(card32 position);
            void setToolProgressAvailable(bool available);
            void setOverallProgressAvailable(bool available);
            void setToolName(const std::string& name);
            void setToolMessage(const std::string& msg);
            void drawUpdates();
            void closeForm();
			void setToolStartTime(time_t timeInSeconds);
			void setToolEstimatedTime(card64 estTimeInSeconds, time_t currentTimeInSeconds);

        signals:
            void cancelProgress();

        private:
            Ui_ProgressFrameWidgetForm ui;
            QString _currentStatusMsg;
			time_t toolTimeStartedInSeconds;
    };

}

#endif
