#ifndef ProgressWidgetH
#define ProgressWidgetH
//---------------------------------------------------------------------------
#include "x4interface.h"
//---------------------------------------------------------------------------
#include <QWidget>
#include "X4Types.h"
//---------------------------------------------------------------------------

namespace X4
{

    //---------------------------------------------------------------------------
    class X4INTERFACE_API ProgressWidget : public QWidget
    {
        Q_OBJECT;
		public:
			ProgressWidget(QWidget *parent) : QWidget(parent) {};
			virtual ~ProgressWidget(void) {};

        public slots:

            virtual void showForm() = 0;
            virtual void setToolProgress(card32 position) = 0;
            virtual void setOverallProgress(card32 position) = 0;
            virtual void setToolProgressAvailable(bool available) = 0;
            virtual void setOverallProgressAvailable(bool available) = 0;
            virtual void setToolName(const std::string& name) = 0;
            virtual void setToolMessage(const std::string& msg) = 0;
            virtual void drawUpdates() = 0;
            virtual void closeForm() = 0;
			virtual void setToolStartTime(time_t timeInSeconds) = 0;
			virtual void setToolEstimatedTime(card64 estTimeInSeconds, time_t currentTimeInSeconds) = 0;

        signals:
            void showToolMessage(QString msg);
            void progressCanceled();
            void progressHided();
            void progressShowed();
    };

}

#endif
