#ifndef ProgressWindowWidgetH
#define ProgressWindowWidgetH
//---------------------------------------------------------------------------
#include "x4interface.h"
//---------------------------------------------------------------------------
#include "ProgressWidget.h"
//---------------------------------------------------------------------------
//this file is generated from the ui file by a custom buildstep, include it here
#include "x4interface/ProgressWindowWidgetForm_ui.h"
//---------------------------------------------------------------------------

namespace X4
{

//---------------------------------------------------------------------------
class X4INTERFACE_API ProgressWindowWidget : public ProgressWidget
{
    Q_OBJECT;
    public:
        ProgressWindowWidget(QWidget *parent);
        ~ProgressWindowWidget(void);

    public slots:

        void showForm();
        void setToolProgress(card32 position);
        void setOverallProgress(card32 position);
        void setToolProgressAvailable(bool available);
        void setOverallProgressAvailable(bool available);
        void setToolName(const std::string& name);
        void setToolMessage(const std::string& msg);
        void drawUpdates();
        void closeForm();
		void setToolStartTime(time_t timeInSeconds);
		void setToolEstimatedTime(card64 estTimeInSeconds, time_t currentTimeInSeconds);

    private:
        Ui_ProgressWindowWidgetForm ui;
		time_t toolTimeStartedInSeconds;
};


extern ProgressWindowWidget *progressWindowWidget;

}

#endif
