//---------------------------------------------------------------------------
#ifndef SeparatorClassPropertyH
#define SeparatorClassPropertyH
//---------------------------------------------------------------------------
#include "x4interface.h"
//---------------------------------------------------------------------------
#include "SingleClassProperty.h"
//---------------------------------------------------------------------------
#include "Object.h"
#include "X4Types.h"
#include "ObjectStreams.h"
//---------------------------------------------------------------------------

namespace X4 {

/**
	this is a dummy class property - it does not do anything; 
	it just causes a named separator bar to be displayed in automatically generated user interfaces
*/
class X4INTERFACE_API SeparatorClassProperty : public SingleClassProperty
{
	X4_CLASS( SeparatorClassProperty )

 private:
	SeparatorClassProperty() {}
	
 public:
   SeparatorClassProperty(const std::string name);

   virtual void writeProperty(const Object* obj, pointer_diff offset, OutputObjectStream *out) const {}
   virtual void readProperty(Object* obj, pointer_diff offset, InputObjectStream *in, card64 expectedSize) const {}
   virtual std::string toString(const Object* obj, pointer_diff offset) const {return getCName();}
   virtual void fromString(Object* obj, pointer_diff offset, const std::string str) const {}
   virtual const std::string getTypeName() const {return "SEPARATOR";}
   void assignProperty(const Object *from, Object *to, pointer_diff offset) const {}
   virtual ClassProperty* copyClassProperty();
};

/// add a separator to the class' property list - name must be enclosed in ""-quotes
#define ADD_SEPARATOR( name ) \
	((MetaClass*)getClass())->addProperty( new SeparatorClassProperty( name ) );

}

#endif