//---------------------------------------------------------------------------
#ifndef StandardTimeControllerH
#define StandardTimeControllerH
//---------------------------------------------------------------------------
#include "x4interface.h"
//---------------------------------------------------------------------------
#include "TimeController.h"
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace X4 {


class X4INTERFACE_API StandardTimeController : public Persistent {//, public TimeController {
 private:
   static MetaClass *StandardTimeControllerMetaClass;
   static Object* newInstance();

   float32 startTime;
   float32 endTime;
   float32 increment;
   bool cyclic;
   bool followRealTime;
   float32 realTimeFactor;
   bool limitRTDelta;
   float32 maxDelta;

 public:
   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   StandardTimeController();
   virtual float32 getNewTime(float32 lastTime, float32 deltaTReal);
};

}

#endif
