#ifndef PCH_X4INTERFACE_H
#define PCH_X4INTERFACE_H


// note: the header file is not located in the subdirectory x4basics because the msvc compiler does not 
//       handle directory prefixes on precompiled header files

/// precompiled header file that includes common headers from the standard C++ library, Windows, and QT Core,Gui
/// precompiled headers can be shared among several projects

////////////////////////////////////////////////
//                                            //
//                  Global                    //
//                                            //
////////////////////////////////////////////////

#include <X4GlobalDefinitions.h>


////////////////////////////////////////////////
//                                            //
//                  Windows                   //
//                                            //
////////////////////////////////////////////////

#if defined(WIN32) || defined(WIN64)

	#ifndef WINVER                          // Specifies that the minimum required platform is Windows Vista.
	#define WINVER 0x0600           // Change this to the appropriate value to target other versions of Windows.
	#endif

	#ifndef _WIN32_WINNT            // Specifies that the minimum required platform is Windows Vista.
	#define _WIN32_WINNT 0x0600     // Change this to the appropriate value to target other versions of Windows.
	#endif

	#ifndef _WIN32_WINDOWS          // Specifies that the minimum required platform is Windows 98.
	#define _WIN32_WINDOWS 0x0410 // Change this to the appropriate value to target Windows Me or later.
	#endif

	#ifndef _WIN32_IE                       // Specifies that the minimum required platform is Internet Explorer 7.0.
	#define _WIN32_IE 0x0700        // Change this to the appropriate value to target other versions of IE.
	#endif

	#define NOMINMAX
	#define WIN32_LEAN_AND_MEAN             // Exclude rarely-used stuff from Windows headers
	// Windows Header Files:
	#include <windows.h>

   #include <mmsystem.h>

#endif


////////////////////////////////////////////////
//                                            //
//                 C++ / STD                  //
//                                            //
////////////////////////////////////////////////


// C RunTime Header Files
#include <stdlib.h>
#include <stdio.h>
#include <malloc.h>
#include <memory.h>
#include <tchar.h>

// standard template library
#include <string>
#include <vector>
#include <iostream>
#include <list>
#include <deque>
#include <algorithm>
#include <vector>
#include <map>

////////////////////////////////////////////////
//                                            //
//                    QT                      //
//                                            //
////////////////////////////////////////////////

#include <QtCore/QtCore>
#include <QtGui/QtGui>
#include <QtOpenGL/QGLWidget>


////////////////////////////////////////////////
//                                            //
//                    X4                      //
//                                            //
////////////////////////////////////////////////


#include "ClassEditor.h"
#include "ClassSelectionDialog.h"
#include "CustomCheckBox.h"
#include "DebugOutput.h"
#include "DebugOutputCounter.h"
#include "ElementEditor.h"
#include "EmbeddedObjectClassPropertyEditor.h"
#include "EventCounterDisplay.h"
#include "EventDisplayer.h"
#include "EventDisplayerBaseWidget.h"
#include "EventViewerWidget.h"
#include "ExceptionHandling.h"
#include "FileDialogs.h"
#include "HelpBrowser.h"
#include "IEditor.h"
#include "KeyboardController.h"
#include "MemberBrowser.h"
#include "MenuWidget.h"
#include "MethodBrowser.h"
#include "MouseController.h"
#include "ObjectCreationDialog.h"
#include "ObjectElementEditor.h"
#include "ObjectListElementEditor.h"
#include "ObjectListPropertyEditor.h"
#include "ObjectPropertyEditor.h"
#include "ObjectViewsTable.h"
#include "OnlineHelp.h"
#include "OnlineHelpWidget.h"
#include "PerformanceGraphWidget.h"
#include "PopupWindow.h"
#include "ProgressFrameWidget.h"
#include "ProgressWidget.h"
#include "ProgressWindow.h"
#include "ProgressWindowWidget.h"
#include "PropertyBrowser.h"
#include "PropertyEditor.h"
#include "qtHelpers.h"
#include "SeparatorClassProperty.h"
#include "SeparatorPropertyEditor.h"
#include "StandardTimeController.h"
#include "StringElementEditor.h"
#include "StringPropertyEditor.h"
#include "UserSettings.h"
#include "UserSettingsEditorWidget.h"
#include "VariableArrayClassPropertyEditor.h"
#include "VariableArrayElementEditor.h"
#include "VerticalScrollView.h"


#endif