#ifndef UserSettingsEditorWidgetH 
#define UserSettingsEditorWidgetH
//---------------------------------------------------------------------------
#include "x4interface.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "UserSettingsEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace X4
{

class UserSettings;

class X4INTERFACE_API UserSettingsEditorWidget : public QWidget
{
	Q_OBJECT

private:

	UserSettings	*	m_Object;

	///used to access buttons, etc. from QtDesigner
	Ui_UserSettingsEditorForm ui;

public:
	UserSettingsEditorWidget(QWidget * parent = NULL, Qt::WindowFlags f=0);
	~UserSettingsEditorWidget(void);

	void setup( UserSettings * obj );

	/// update editor content with object data
	void updateEditor();

public slots:

	void on_cbAskBeforeQuit_stateChanged(int);
	void on_cbSortTools_stateChanged(int);
	void on_cbSortCommands_stateChanged(int);
	void on_cbDisplayDebugEvents_stateChanged(int);


};

MAKE_CLASS_EDITOR( X4INTERFACE_API , UserSettings )


}

#endif