#ifndef QTHelpersH
#define QTHelpersH
//---------------------------------------------------------------------------
#include "x4interface.h"
//---------------------------------------------------------------------------
#include <string>
#include <map>
#include <qtCore/qstring>
//---------------------------------------------------------------------------

class QString;
class QPixmap;
namespace X4
{

class X4INTERFACE_API QTHelpers
{
public:

	/// converts a qstd::string to a std::string
	static std::string toSTLString( const QString &str );

	/// converts a std::string to a qstd::string
	static QString toQString( const std::string &str );

	/// creates an pixmap from file 'filename' and defines the color in pixel(0,0) as transparent
	/// returns NULL if file doesn't exist
	static QPixmap * createPixmap( const QString &filename );

	/// final cleanup
	static void cleanup();

	/// create a question messagebox with yes/no and returns true, if yes was pressed
	static bool question( QWidget * parent, const QString &question_str );

private:
	
	static std::map<QString,QPixmap*>	m_Pixmaps;

};

}

#endif