#include "StdAfx.h"
#include "x4interface.h"

#include "TaggingMacros.h"
#include "ClassEditor.h"
#include "ClassTypeClassProperty.h"
#include "ClassTypePropertyEditor.h"
#include "x4interface_rcc.h"
#include "MemberBrowser.h"
#include "ClassProperty.h"

#include <QtCore/qobject.h>

using namespace X4;

#include "x4interface.init.cpp"
#include "BooleanClassProperty.h"
#include "EmbeddedObjectClassProperty.h"
#include "FixedArrayClassProperty.h"
#include "NumericalClassProperty.h"
#include "SeparatorClassProperty.h"
#include "ObjectClassProperty.h"
#include "ObjectListProperty.h"
#include "StringClassProperty.h"
#include "VariableArrayClassProperty.h"
#include "VariableArrayClassPropertyEditor.h"
#include "StringPropertyEditor.h"
#include "ObjectListPropertyEditor.h"
#include "FixedArrayPropertyEditor.h"
#include "BooleanPropertyEditor.h"
#include "ObjectPropertyEditor.h"
#include "SeparatorPropertyEditor.h"
#include "EmbeddedObjectClassPropertyEditor.h"
#include "InterfaceGlobals.h"
#include "ObjectDictionary.h"
#include "ObjectDictionaryEditorWidget.h"
#include "AttachedDataContainer.h"
#include "AttachedDataContainerEditorWidget.h"
#include "UserSettings.h"


// class TMP_MemBrowserConnector : public MUIActionInstanceConnector {
//  public:
// 	ObjectBrowserWindow *target;
// 	virtual void actionInstantiated(MUIAction *action, MUIHandler *container) {
// 		if (!QObject::connect(action, SIGNAL(actionTriggered(bool)), target, SLOT(showToggle(bool)) )) {
// 			x4Assert(false);
// 		}
// 	}
// };


BEGIN_INIT_MODULE
	qInitResources();
	((GUIDescriptor * )ObjectDictionary::getClass()->getGUIDescriptor())->addClassEditor(
	ObjectDictionaryEditor::getClass(), true);
	((GUIDescriptor * )ClassTypeClassProperty::getClass()->getGUIDescriptor())->addClassEditor(
	ClassTypePropertyEditor::getClass(), true);

   ClassProperty::addPropertyEditorByType(Card8ClassProperty::getClass(), StringPropertyEditor::getClass());
   ClassProperty::addPropertyEditorByType(Card16ClassProperty::getClass(), StringPropertyEditor::getClass());
   ClassProperty::addPropertyEditorByType(Card32ClassProperty::getClass(), StringPropertyEditor::getClass());
   ClassProperty::addPropertyEditorByType(Card64ClassProperty::getClass(), StringPropertyEditor::getClass());
   ClassProperty::addPropertyEditorByType(Int8ClassProperty::getClass(), StringPropertyEditor::getClass());
   ClassProperty::addPropertyEditorByType(Int16ClassProperty::getClass(), StringPropertyEditor::getClass());
   ClassProperty::addPropertyEditorByType(Int32ClassProperty::getClass(), StringPropertyEditor::getClass());
   ClassProperty::addPropertyEditorByType(Int64ClassProperty::getClass(), StringPropertyEditor::getClass());
   ClassProperty::addPropertyEditorByType(MaxPlatformIntClassProperty::getClass(), StringPropertyEditor::getClass());
   ClassProperty::addPropertyEditorByType(MaxPlatformCardClassProperty::getClass(), StringPropertyEditor::getClass());
   ClassProperty::addPropertyEditorByType(Float32ClassProperty::getClass(), StringPropertyEditor::getClass());
   ClassProperty::addPropertyEditorByType(Float64ClassProperty::getClass(), StringPropertyEditor::getClass());

   //ClassProperty::addPropertyEditorByType(DynamicVectorClassProperty::getClass(), DynamicVectorPropertyEditor::getClass()); mw - fixme - missing
   ClassProperty::addPropertyEditorByType(SeparatorClassProperty::getClass(), SeparatorPropertyEditor::getClass());
   ClassProperty::addPropertyEditorByType(BooleanClassProperty::getClass(), BooleanPropertyEditor::getClass());
   ClassProperty::addPropertyEditorByType(ClassTypeClassProperty::getClass(), ClassTypePropertyEditor::getClass());
   ClassProperty::addPropertyEditorByType(FixedArrayClassProperty::getClass(), FixedArrayPropertyEditor::getClass());

   ClassProperty::addPropertyEditorByType(ObjectClassProperty::getClass(), ObjectPropertyEditor::getClass());
   ClassProperty::addPropertyEditorByType(EmbeddedObjectClassProperty::getClass(), EmbeddedObjectClassPropertyEditor::getClass());
   ClassProperty::addPropertyEditorByType(ObjectListProperty::getClass(), ObjectListPropertyEditor::getClass());
   ClassProperty::addPropertyEditorByType(StringClassProperty::getClass(), StringPropertyEditor::getClass());
   // mw: fixme not sure that this makes sense: ClassProperty::addPropertyEditorByType(UnknownClassProperty::getClass(), ObjectPropertyEditor::getClass());
   ClassProperty::addPropertyEditorByType(VariableArrayClassProperty::getClass(), VariableArrayClassPropertyEditor::getClass());

	const_cast<MetaClass*>(Object::getClass())->addClassEditorToSubtree(MemberBrowser::getClass(), false);
	const_cast<MetaClass*>(AttachedDataContainer::getClass())->addClassEditorToSubtree(AttachedDataContainerEditor::getClass(), true);
// 	GUIDescriptor::EditorParameters objectInfoParams;
// 	objectInfoParams.useAsMainEditor = false;
// 	objectInfoParams.useAsSideEditor = true;
//    const_cast<MetaClass*>(Object::getClass())->addClassEditorToSubtree(ObjectInfoClassEditor::getClass(), false, objectInfoParams);

// 	MUIActionToggle *action = new MUIActionToggle(
// 		"Show Memory Object Manager...",
// 		":/images/memory.png",  
// 		"click to show/hide the in-memory object manager",
// 		"Memory");

// 	ObjectBrowserWindow *rootBrowser = RootObjectDictionary::getRootObjectDictionary()->getBaseEditorBrowser(InterfaceGlobals::getMainWindow());
// 
// 	TMP_MemBrowserConnector *memBrowserConnector = new TMP_MemBrowserConnector();
// 	memBrowserConnector->target = rootBrowser;
// 
// 	muiTemplates.addAction("x4shell", action, memBrowserConnector);   

END_INIT_MODULE


BEGIN_SHUTDOWN_MODULE
	delete progressWindow;
END_SHUTDOWN_MODULE


BEGIN_X4_LOADABLE_MODULE(x4interface)
   #include "x4interface.tags.h"
END_X4_LOADABLE_MODULE(x4interface)


