//---------------------------------------------------------------------------
#ifndef DynamicArrayClassPropertyH
#define DynamicArrayClassPropertyH
//---------------------------------------------------------------------------
#include <CompoundClassProperty.h>
#include <NumericalClassProperty.h>
#include "DynamicLinearAlgebra.h"
//---------------------------------------------------------------------------

namespace X4
{
#if 0
    class OBJECTS_API DynamicVectorClassProperty : public CompoundClassProperty
    {
    private:

        pointer_diff calculateElementDiff( unsigned i ) const;
        const DynamicVector* getDynamicVector(Object* obj, pointer_diff offset) const;
        DynamicVector* getDynamicVector(Object* obj, pointer_diff offset);

        ClassProperty	*	m_ElementProperty;
        pointer_diff		m_Offset;
        card32				m_EntriesPerRow;
        card32				m_Stride;

    protected:
        DynamicVectorClassProperty() {}

    public:
        /// contructs an array property, becomes owner of prop
        DynamicVectorClassProperty(const std::string cName, const Version introducedInVersion,
            pointer_diff offset, ClassProperty * prop, card32 stride, card32 entriesPerRow = 1);
        virtual ~DynamicVectorClassProperty();

        pointer_diff getOffset() const {return m_Offset;}
        card32 getEntriesPerRow() const {return m_EntriesPerRow;}
        card32 getStride() const {return m_Stride;}
        ClassProperty * getElementProperty() const {return m_ElementProperty;}

        virtual const std::string getTypeName() const;
        virtual void writeProperty(const Object* obj, pointer_diff offset, OutputObjectStream *out) const;
        virtual void readProperty(Object* obj, pointer_diff offset, InputObjectStream *in) const;
        virtual std::string toString(const Object* obj, pointer_diff offset) const;
        virtual void fromString(Object* obj, pointer_diff offset, const std::string str) const;

        virtual void assignProperty(const Object *from, Object *to, pointer_diff offset) const;

        virtual ClassProperty* copyClassProperty();

    };

#define ADD_FLOAT32_DYNAMIC_VECTOR_PROP( propName, version, entriesPerRow ) \
    ((MetaClass*)getClass())->addProperty( new DynamicVectorClassProperty( #propName , MetaClass::FIRST_VERSION + version, \
    (pointer_diff)((pointer_diff)&( obj_null_pointer->##propName ) - obj_null_offset) , new Float32ClassProperty("", version , NULL) \
    , sizeof(float32), entriesPerRow ));

#define ADD_FLOAT64_DYNAMIC_VECTOR_PROP( propName, version, entriesPerRow ) \
    ((MetaClass*)getClass())->addProperty( new DynamicVectorClassProperty( #propName , MetaClass::FIRST_VERSION + version, \
    (pointer_diff)((pointer_diff)&( obj_null_pointer->##propName ) - obj_null_offset) , new Float64ClassProperty("", version , NULL) \
    , sizeof(float64), entriesPerRow ));

#define ADD_INT32_DYNAMIC_VECTOR_PROP( propName, version, entriesPerRow ) \
    ((MetaClass*)getClass())->addProperty( new DynamicVectorClassProperty( #propName , MetaClass::FIRST_VERSION + version, \
    (pointer_diff)((pointer_diff)&( obj_null_pointer->##propName ) - obj_null_offset) , new Int32ClassProperty("", version , NULL) \
    , sizeof(int32), entriesPerRow ));

#endif
}

#endif