//---------------------------------------------------------------------------
#include "stdafx.h"

//---------------------------------------------------------------------------
#include "FilterMask.h"
//---------------------------------------------------------------------------
#include "FixedArrayClassProperty.h"
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
using namespace X4;


MetaClass* FilterMask::FilterMaskMetaClass = NULL;

const MetaClass* FilterMask::getInstanceClass() const {
   return getClass();
}

const MetaClass* FilterMask::getClass() {
   if (FilterMaskMetaClass==NULL) {
      FilterMaskMetaClass = new MetaClass("FilterMask", "no description.",
                                  NULL, sizeof(FilterMask));
   }
   return FilterMaskMetaClass;
}

void FilterMask::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   FilterMaskMetaClass->copyParentProperties();
}

void FilterMask::shutdown() {
   delete FilterMaskMetaClass;
}


// ----

MetaClass* FixedFilterMask_9x9::FixedFilterMask_9x9MetaClass = NULL;

const MetaClass* FixedFilterMask_9x9::getInstanceClass() const {
   return getClass();
}

Object* FixedFilterMask_9x9::newInstance() {
   return new FixedFilterMask_9x9;
}

const MetaClass* FixedFilterMask_9x9::getClass() {
   if (FixedFilterMask_9x9MetaClass==NULL) {
      FixedFilterMask_9x9MetaClass = new MetaClass("FixedFilterMask_9x9", "no description.",
                                  newInstance, sizeof(FixedFilterMask_9x9));
   }
   return FixedFilterMask_9x9MetaClass;
}

void FixedFilterMask_9x9::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   FixedFilterMask_9x9MetaClass->copyParentProperties();

	BEGIN_CLASS_INIT( FixedFilterMask_9x9 );
	ADD_FLOAT32_FIXED_ARRAY_PROP( m_FilterMask, 0, 9*9, 1 );
}

void FixedFilterMask_9x9::shutdown() {
   delete FixedFilterMask_9x9MetaClass;
}


// ----

MetaClass* FixedFilterMask_21x21::FixedFilterMask_21x21MetaClass = NULL;

const MetaClass* FixedFilterMask_21x21::getInstanceClass() const {
   return getClass();
}

Object* FixedFilterMask_21x21::newInstance() {
   return new FixedFilterMask_21x21;
}

const MetaClass* FixedFilterMask_21x21::getClass() {
   if (FixedFilterMask_21x21MetaClass==NULL) {
      FixedFilterMask_21x21MetaClass = new MetaClass("FixedFilterMask_21x21", "no description.",
                                  newInstance, sizeof(FixedFilterMask_21x21));
   }
   return FixedFilterMask_21x21MetaClass;
}

void FixedFilterMask_21x21::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   FixedFilterMask_21x21MetaClass->copyParentProperties();

	BEGIN_CLASS_INIT( FixedFilterMask_21x21 );
	ADD_FLOAT32_FIXED_ARRAY_PROP( m_FilterMask, 0, 21*21, 1 );

}

void FixedFilterMask_21x21::shutdown() {
   delete FixedFilterMask_21x21MetaClass;
}


// ----

template <int dim>
void TemplatedFixedFilterMask<dim>::setElement( int x, int y, float w )
{
   x4Assert( x + dim/2 < dim );
   x4Assert( y + dim/2 < dim );
   x4Assert( x + dim/2 >= 0 );
   x4Assert( y + dim/2 >= 0 );
   m_FilterMask[(x+dim/2) + (y+dim/2)*dim] = w;
}

