//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "KMeansClustering.h"
#include "KMeansClustering.inline.h"
#include "BoundingBox.inline.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



void KMeansClustering3f::prequantize(card32 res) 
{
   if (data.empty()) return;
   BoundingBox3f bb(data[0]);
   for (unsigned i=0; i<data.size(); i++) {
      bb.addPoint(data[i]);
   }
   Vector3f w = bb.upperCorner-bb.lowerCorner;
   if (w[0] <= 0) w[0] = 1.0f;
   if (w[1] <= 0) w[1] = 1.0f;
   if (w[2] <= 0) w[2] = 1.0f;
   std::vector<float32> grid(res*res*res, 0);
   for (unsigned i=0; i<data.size(); i++) {
      Vector3f normCoord = (data[i] - bb.lowerCorner);
      normCoord[0] /= w[0];
      normCoord[1] /= w[1];
      normCoord[2] /= w[2];
      if (normCoord[0] <=0) normCoord[0] = 0.0f;
      if (normCoord[0] >=1) normCoord[0] = 1.0f;
      if (normCoord[1] <=0) normCoord[1] = 0.0f;
      if (normCoord[1] >=1) normCoord[1] = 1.0f;
      if (normCoord[2] <=0) normCoord[2] = 0.0f;
      if (normCoord[2] >=1) normCoord[2] = 1.0f;
      Vector3i ind = makeVector3i(normCoord[0]*res, normCoord[1]*res, normCoord[2]*res);
      if (ind[0] >= (int32)res) ind[0] = res-1;
      if (ind[1] >= (int32)res) ind[1] = res-1;
      if (ind[2] >= (int32)res) ind[2] = res-1;
      
      grid[ind[0]+res*ind[1]+res*res*ind[2]] += weights[i];
   }
   data.clear();
   weights.clear();
   for (unsigned i=0; i<grid.size(); i++) {
      if (grid[i] > 0) {
         Vector3f p = makeVector3f(i % res, (i/res) % res, i /(res*res)) + makeVector3f(0.5f, 0.5f, 0.5f);
         p /= res;
         p[0] *= w[0];
         p[1] *= w[1];
         p[2] *= w[2];
         p += bb.lowerCorner;
         data.push_back(p);
         weights.push_back(grid[i]);
      }
   }
}

void KMeansClustering3f::calcQuantized(card32 numClusters, std::vector<Vector3f> &centroids, float32 relConvThreshold, card32 numTrials, card32 res)
{
   prequantize(res);
	calc(numClusters, centroids, relConvThreshold, numTrials);
}
