//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "LinearAlgebra.h"
#include "LinearAlgebra.inline.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



const Vector2ub X4::NULL_VECTOR2UB = makeVector2ub(0, 0);
const Vector3ub X4::NULL_VECTOR3UB = makeVector3ub(0, 0, 0);
const Vector4ub X4::NULL_VECTOR4UB = makeVector4ub(0, 0, 0, 0);

const Vector2i X4::NULL_VECTOR2I = makeVector2i(0, 0);
const Vector3i X4::NULL_VECTOR3I = makeVector3i(0, 0, 0);
const Vector4i X4::NULL_VECTOR4I = makeVector4i(0, 0, 0, 0);

const Vector2f X4::NULL_VECTOR2F = makeVector2f(0.0, 0.0);
const Vector3f X4::NULL_VECTOR3F = makeVector3f(0.0, 0.0, 0.0);
const Vector4f X4::NULL_VECTOR4F = makeVector4f(0.0, 0.0, 0.0, 0.0);
const Vector6f X4::NULL_VECTOR6F = makeVector6f(0.0, 0.0, 0.0, 0.0, 0.0, 0.0);
const Vector4f X4::HOMOGENEOUS_NULL_VECTOR4F = makeVector4f(0.0, 0.0, 0.0, 1.0);

const Vector2d X4::NULL_VECTOR2D = makeVector2d(0.0, 0.0);
const Vector3d X4::NULL_VECTOR3D = makeVector3d(0.0, 0.0, 0.0);
const Vector4d X4::NULL_VECTOR4D = makeVector4d(0.0, 0.0, 0.0, 0.0);
const Vector6d X4::NULL_VECTOR6D = makeVector6d(0.0, 0.0, 0.0, 0.0, 0.0, 0.0);

const Vector3f X4::XAXIS_VECTOR3F = makeVector3f(1.0, 0.0, 0.0);
const Vector3f X4::YAXIS_VECTOR3F = makeVector3f(0.0, 1.0, 0.0);
const Vector3f X4::ZAXIS_VECTOR3F = makeVector3f(0.0, 0.0, 1.0);
const Vector4f X4::XAXIS_VECTOR4F = makeVector4f(1.0, 0.0, 0.0, 1.0);
const Vector4f X4::YAXIS_VECTOR4F = makeVector4f(0.0, 1.0, 0.0, 1.0);
const Vector4f X4::ZAXIS_VECTOR4F = makeVector4f(0.0, 0.0, 1.0, 1.0);

const Matrix2f X4::IDENTITY2F = makeMatrix2f(1.0, 0.0,
											   0.0, 1.0);
const Matrix3f X4::IDENTITY3F = makeMatrix3f(1.0, 0.0, 0.0,
                                             0.0, 1.0, 0.0,
                                             0.0, 0.0, 1.0);
const Matrix4f X4::IDENTITY4F = makeMatrix4f(1.0, 0.0, 0.0, 0.0,
                                             0.0, 1.0, 0.0, 0.0,
                                             0.0, 0.0, 1.0, 0.0,
                                             0.0, 0.0, 0.0, 1.0);
const Matrix6f X4::IDENTITY6F = makeMatrix6f(
                                   1.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                   0.0, 1.0, 0.0, 0.0, 0.0, 0.0,
                                   0.0, 0.0, 1.0, 0.0, 0.0, 0.0,
                                   0.0, 0.0, 0.0, 1.0, 0.0, 0.0,
											  0.0, 0.0, 0.0, 0.0, 1.0, 0.0,
											  0.0, 0.0, 0.0, 0.0, 0.0, 1.0);
const Matrix3d X4::IDENTITY3D = makeMatrix3d(1.0, 0.0, 0.0,
                                             0.0, 1.0, 0.0,
                                             0.0, 0.0, 1.0);


