//---------------------------------------------------------------------------
#ifndef LineSearchGradientDescentInlineH
#define LineSearchGradientDescentInlineH
//---------------------------------------------------------------------------
#include <x4math.h>
//---------------------------------------------------------------------------
#include <NonLinearIterativeSolvers.h>
#include <MathTools.h>
#include <MathTools.inline.h>
#include <LinearAlgebra.inline.h>
#include <DynamicLinearAlgebra.inline.h>
//---------------------------------------------------------------------------

namespace X4 {


// --- NonLinearCGNumLineSearch


//template <typename FloatType, typename IntType>
//NonLinearCGNumLineSearch<FloatType, IntType>::NonLinearCGNumLineSearch(
//   FloatType initialStepSize,
//   FloatType maxGradientNormConv,
//   FloatType maxStepSizeConv,
//   IntType   maxNumSteps,
//   IntType   maxDivs,
//   FloatType minSecondOrderCoeff,
//   bool      iterateLineSearch,
//   FloatType maxItLineSearchStepSize,
//   FloatType maxItLineSearchDirDeriv,
//   IntType   maxLineSearchIterations,
//   bool      useConjugateGradients,
//   bool      useFletcherReeves,
//   IntType   cgResetSteps)
//{
//   this->initialStepSize         = initialStepSize;
//   this->maxGradientNormConv     = maxGradientNormConv;
//   this->maxStepSizeConv         = maxStepSizeConv;
//   this->maxNumSteps             = maxNumSteps;
//   this->maxDivs                 = maxDivs;
//   this->minSecondOrderCoeff     = minSecondOrderCoeff;
//   this->iterateLineSearch       = iterateLineSearch;
//   this->maxItLineSearchStepSize = maxItLineSearchStepSize;
//   this->maxItLineSearchDirDeriv = maxItLineSearchDirDeriv;
//   this->maxLineSearchIterations = maxLineSearchIterations;
//   this->useConjugateGradients   = useConjugateGradients;
//   this->useFletcherReeves       = useFletcherReeves;
//   this->cgResetSteps            = cgResetSteps;
//
//   firstStep = true;
//   stepNum = 0;
//   statNumGradEvals = 0;
//   statNumFunctionEvals = 0;
//   currentStepSize = initialStepSize;
//}
//
//template <typename FloatType, typename IntType>
//void NonLinearCGNumLineSearch<FloatType, IntType>::getCurrentEstimate(
//   DynamicVector<FloatType> &est) const
//{
//   est = pos;
//}
//
//template <typename FloatType, typename IntType>
//void NonLinearCGNumLineSearch<FloatType, IntType>::doStep()
//{
//   lastPos = pos;
//   lastGrad = currentGrad;
//   currentGrad.setDim(pos.getDim());
//   function->gradient(pos, currentGrad);
//   if (useConjugateGradients && !((stepNum % cgResetSteps) == 0) && stepNum >= 1) {
//      FloatType lastGradSquared = lastGrad * lastGrad;
//      if (sqrt(lastGradSquared) <= maxGradientNormConv) return; // converged, use <= to account for zero maxGradientNormConv
//      FloatType beta;
//      if (useFletcherReeves) {
//         beta = (currentGrad * currentGrad) / lastGradSquared;
//      } else {
//         beta = (currentGrad * (currentGrad - lastGrad)) / lastGradSquared;
//      }
//      searchDir = currentGrad + lastSearchDir * beta;
//      lastSearchDir = searchDir;
//   } else {
//      searchDir = currentGrad;
//      lastSearchDir = currentGrad;
//   }
//
//
//   statNumGradEvals++;
//
//   lastGradNorm = norm(currentGrad);
//
//   IntType lineStepNum = 0;
//   FloatType v1, v2, v3;
//   do {
//      // reset step size if recent guess does not work as good as initial guess
//      statNumFunctionEvals += 2;
//      if (function->eval(pos - searchDir*currentStepSize) > function->eval(pos - searchDir*initialStepSize)) {
//         currentStepSize = initialStepSize;
//      }
//
//      v1 = function->eval(pos);
//      v2 = function->eval(pos - searchDir*currentStepSize);
//      v3 = function->eval(pos - searchDir*(currentStepSize*2));
//      statNumFunctionEvals += 3;
//
//      StaticMatrix<FloatType, 2, 2> M;
//      M[0][0] =   currentStepSize*currentStepSize;   M[1][0] = currentStepSize;
//      M[0][1] = 4*currentStepSize*currentStepSize;   M[1][1] = 2*currentStepSize;
//
//      StaticVector<FloatType, 2> v;
//      v[0] = v2-v1;
//      v[1] = v3-v1;
//
//      FloatType stepSizeGuess;
//      const FloatType s = currentStepSize;
//      const FloatType a = ( v3 - v1 - 2*(v2-v1) )  /  (2*s*s);
//      if (fabs(a) >= minSecondOrderCoeff) {
//         const FloatType b = ( v2 - v1 - s*s*a) / s;
//         stepSizeGuess = -b / ((FloatType)2.0*a);
//      } else {
//         stepSizeGuess = currentStepSize;
//      }
//
//      int divs = 0;
//      while (function->eval(pos - searchDir*stepSizeGuess) > v1 && divs < maxDivs) {
//         statNumFunctionEvals++;
//         if (function->eval(pos + searchDir*stepSizeGuess) < v1) {
//            statNumFunctionEvals++;
//            stepSizeGuess = -stepSizeGuess;
//            break;
//         } else {
//            statNumFunctionEvals++;
//         }
//         stepSizeGuess /= 2.0;
//         divs++;
//      }
//
//      pos -= searchDir*stepSizeGuess;
//      lineStepNum++;
//      currentStepSize = fabs(stepSizeGuess);
//
//      if (!iterateLineSearch) break;
//
//   } while (currentStepSize > 0 && lineStepNum < maxLineSearchIterations && fabs(v2-v1)/currentStepSize > maxItLineSearchDirDeriv && currentStepSize > maxItLineSearchStepSize);
//   firstStep = false;
//   stepNum++;
//}
//
//template <typename FloatType, typename IntType>
//bool NonLinearCGNumLineSearch<FloatType, IntType>::converged() const
//{
//   return (!firstStep) && (norm(pos - lastPos) < maxStepSizeConv || lastGradNorm < maxGradientNormConv || stepNum >= maxNumSteps);
//}
//
//template <typename FloatType, typename IntType>
//void NonLinearCGNumLineSearch<FloatType, IntType>::setup(
//   const NonLinearIterativeSolvers::ObjectiveFunction<FloatType> *function,
//   const DynamicVector<FloatType> &startEstimate)
//{
//   this->function = function;
//   pos = startEstimate;
//   lastPos = startEstimate;
//   firstStep = true;
//   stepNum = 0;
//}


// --- ObjectiveFunctionAuto2ndOrderDirDeriv

template <typename FloatType>
FloatType ObjectiveFunctionAuto2ndOrderDirDeriv<FloatType>::gradDirSecondDerivative(
	const DynamicVector<FloatType> &pos, 
	const DynamicVector<FloatType> &normalizedGradient) const
{
	FloatType valMinus = eval(pos - normalizedGradient*numericalStepWidth);
	FloatType val      = eval(pos);
	FloatType valPlus  = eval(pos + normalizedGradient*numericalStepWidth);
	return (valMinus + valPlus - 2*val) / (numericalStepWidth * numericalStepWidth);
}



// --- GradientDescentOptimization

template <typename FloatType>
void GradientDescentOptimization<FloatType>::optimizeSimple(
	const Parameters &params, 
	const X4::ObjectiveFunction<FloatType> *function, 
	const X4::DynamicVector<FloatType> &startEstimate, 
	X4::DynamicVector<FloatType> &result,
	bool printDebugOutput)
{
	card32 numIterations = 0;
	bool converged = false;
	DVectorF grad;
	grad.setDim(startEstimate.getDim());
	result = startEstimate;
	do {
		function->gradient(result, grad);
		result -= grad*params.stepSize;
		if (norm(grad) < params.maxGradConv) {
			converged = true;
		}
		numIterations++;
	}  while (!converged && numIterations < params.maxNumSteps);
	if (printDebugOutput) x4console << "GradientDescentOptimization::optimizeSimple()\n - numIterations: " <<  numIterations << "\n";
}


template <typename FloatType>
void GradientDescentOptimization<FloatType>::optimizeLineSearch(
	const Parameters &params, 
	const X4::ObjectiveFunction2ndOrderDirDeriv<FloatType> *function, 
	const X4::DynamicVector<FloatType> &startEstimate, 
	X4::DynamicVector<FloatType> &result,
	bool printDebugOutput)
{
	if (printDebugOutput) x4console << "GradientDescentOptimization::optimizeLineSearch()\n";
	card32 numIterations = 0;
	bool converged = false;
	DVectorF grad;
	grad.setDim(startEstimate.getDim());
	result = startEstimate;
	if (printDebugOutput) {
		//for (card32 i=0; i<startEstimate.getDim(); i++) {
		//	x4console << startEstimate[i] << "\t";
		//}
		//x4console.cr();
	}		
	function->gradient(result, grad);
	FloatType gradNorm = norm(grad);
	do {
		FloatType currentValue = function->eval(result);
		FloatType secondDirDerivative = function->gradDirSecondDerivative(result, grad/gradNorm);
		// (a/2)*x^2 + b*x --> min
		// x^2 +(2*b/a)x --> min
		// 2*x + (2*b/a) = 0
		// x = -b/a
		// b is already the length of the gradient, therefore, we get:
		FloatType optStep = -((FloatType)1)/secondDirDerivative;
		FloatType subStep = 1;
		do {
			DynamicVector<FloatType> newPos = result + grad*optStep*subStep;
			FloatType newVal = function->eval(newPos);
			if (printDebugOutput) {
				//for (card32 i=0; i<newPos.getDim(); i++) {
				//	x4console << newPos[i] << "\t";
				//}
				//x4console.cr();
				x4console << newVal << "\n";
			}		
			if (newVal < currentValue) {
				currentValue = newVal;
				result = newPos;
				break;
			}
			subStep /= 2;
		} while (subStep > (FloatType)1/(FloatType)1024);
		if (subStep <= (FloatType)1/(FloatType)1024) {
			converged = true;
		}  else {
			//if (printDebugOutput) x4console << "\t\tsubstepSize:\t" << subStep << "\n";
			function->gradient(result, grad);
			gradNorm = norm(grad);
			if (gradNorm < params.maxGradConv) {
				converged = true;
			}
		}
		numIterations++;
	}  while (!converged && numIterations < params.maxNumSteps);
	if (printDebugOutput) x4console << " - numIterations: " <<  numIterations << "\n";
}


template <typename FloatType>
void ConjugateGradientDescentOptimization<FloatType>::optimize(
	const Parameters &params, 
	const X4::ObjectiveFunction2ndOrderDirDeriv<FloatType> *function, 
	const X4::DynamicVector<FloatType> &startEstimate, 
	X4::DynamicVector<FloatType> &result,
	bool printDebugOutput)
{
	if (printDebugOutput) x4console << "ConjugateGradientDescentOptimization::optimize()\n";
	card32 numIterations = 0;
	bool converged = false;
	DVectorF grad;
	grad.setDim(startEstimate.getDim());
	DynamicVector<FloatType> newGradient;
	newGradient.setDim(startEstimate.getDim());
	result = startEstimate;
	function->gradient(result, grad);
	DynamicVector<FloatType> searchDir = -grad;
	do {
		FloatType currentValue = function->eval(result);
		DynamicVector<float32> searchDirNormalized = searchDir/norm(searchDir);
		FloatType secondDirDerivative = function->gradDirSecondDerivative(result, searchDirNormalized);
		FloatType firstDirDerivative = grad * searchDirNormalized;
		// (a/2)*x^2 + b*x --> min
		// x^2 +(2*b/a)x --> min
		// 2*x + (2*b/a) = 0
		// x = -b/a
		FloatType optStep = -firstDirDerivative/secondDirDerivative;
		FloatType subStep = 1;
		do {
			DynamicVector<FloatType> newPos = result + searchDirNormalized*optStep*subStep;
			FloatType newVal = function->eval(newPos);
			if (printDebugOutput) {
				x4console << newVal << "\n";
			}		
			if (newVal < currentValue) {
				currentValue = newVal;
				result = newPos;
				break;
			}
			subStep /= 2;
		} while (subStep > (FloatType)1/(FloatType)1024);
		if (subStep <= (FloatType)1/(FloatType)1024) {
			converged = true;
			break;
		} else {
			function->gradient(result, newGradient);
			FloatType newGradNorm = norm(newGradient);
			if (newGradNorm < params.maxGradConv) {
				converged = true;
				break;
			}
			
			if (!(numIterations % params.restartIterations == 0 && numIterations > 0)) {
				FloatType beta;
				if (params.usePolakRibiere) {
					beta = std::max((newGradient * (newGradient - grad)) / (grad*grad), (FloatType)0);
				} else {
					beta = (newGradient * newGradient) / (grad*grad);
				}
				searchDir = newGradient + searchDir * beta;
			} else {
				searchDir = newGradient;
			}
			grad = newGradient;
		}
		numIterations++;
	}  while (!converged && numIterations < params.maxNumSteps);
	if (printDebugOutput) x4console << " - numIterations: " <<  numIterations << "\n";
}


}


#endif

 