//---------------------------------------------------------------------------
#ifndef NormalConeInlineH
#define NormalConeInlineH
//---------------------------------------------------------------------------
#include <x4math.h>
//---------------------------------------------------------------------------
#include "LinearAlgebra.h"
#include "LinearAlgebra.inline.h"
//---------------------------------------------------------------------------

namespace X4 {


template <class FloatType, unsigned dim>
NormalCone<FloatType, dim>::NormalCone(StaticVector<FloatType, dim> normal, FloatType angle) {
   this->normal = normal;
   this->angle = angle;
}

template <class FloatType, unsigned dim>
const StaticVector<FloatType, dim> &NormalCone<FloatType, dim>::getNormal() const {
   return normal;
}

template <class FloatType, unsigned dim>
void NormalCone<FloatType, dim>::setNormal(const StaticVector<FloatType, dim> &normal) {
   this->normal = normal;
}

template <class FloatType, unsigned dim>
const FloatType &NormalCone<FloatType, dim>::getAngle() const {
   return angle;
}

template <class FloatType, unsigned dim>
void NormalCone<FloatType, dim>::setAngle(const FloatType &angle) {
   this->angle = angle;
}

}

#endif

 