#ifndef NORMAL_DISTRIBUTION_H
#define NORMAL_DISTRIBUTION_H

#include "LinearAlgebra.h"

namespace X4 {

/// Providing several small utilities
class X4MATH_API NormalDistribution {	
	public:
		static void initExpTable();
		static void clearExpTable();

		/// Return normal distributed number
		static float32 randomNumber( const float32 mean, const float32 stdDeviation );

		/// returns approximately exp(-x), x >= 0
		inline static float32 expApproximation(float x){
			float xf = x * expMultiplier;
			int xi = xf;
			xi = max(0,xi);
			return xi < expTableSize ? expTable[xi] : 0.0f;
		}
private:

	static const int expTableSize = 1000;
	static float expMultiplier;
	static float * expTable;

};

}

#endif
