//---------------------------------------------------------------------------
#ifndef REGRESSION_LINE3F_H
#define REGRESSION_LINE3F_H
//---------------------------------------------------------------------------
#include "x4math.h"
//---------------------------------------------------------------------------
#include "Line3f.h"
#include "PCA.h"
//---------------------------------------------------------------------------

namespace X4
{

/// Container for a plane defined by a normal and one point within the plane.
class X4MATH_API RegressionLine3f : public Line3f
{
	protected:
		/// Centroid of the given points
		PCA<float32,3> pca;

	public:
		/// Clear all member values
		void clear();
      /// Add point
		void addPoint( Vector3f p );
      /// Compute regression line, return true on success
      bool computeRegressionLine();

};


}

#endif
