//---------------------------------------------------------------------------
#include "stdafx.h"
//---------------------------------------------------------------------------
#include "RegressionPlane.h"
//---------------------------------------------------------------------------
using namespace X4;



/**
 * Create new object, init members
 */
RegressionPlane::RegressionPlane()
{
   clear();
}

/**
 * Delete object
 */
RegressionPlane::~RegressionPlane()
{
}

/**
 * Reset all members to the initial state
 */
void RegressionPlane::clear()
{
   pca.clear();
   Plane::clear();
}

/**
 * Save point in container
 */
void RegressionPlane::addPoint( Vector3f p )
{
   pca.addPoint( p );
}

void RegressionPlane::computePlane(){
	Vector3f eigenValues;
	Matrix3f eigenVectors;
   pca.analyze( eigenValues, eigenVectors, point );
	normal = eigenVectors[2];

	u = eigenVectors[0] * ( ( eigenValues[0] > 0 )? sqrt( eigenValues[0] ) : 1.0 );
	v = eigenVectors[1] * ( ( eigenValues[1] > 0 )? sqrt( eigenValues[1] ) : 1.0 );
	s0 = t0 = s1 = t1 = 0;
}