//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "RegressionPlane3f.h"
//---------------------------------------------------------------------------
using namespace X4;



/**
 * Create new object, init members
 */
RegressionPlane3f::RegressionPlane3f()
{
   clear();
}

/**
 * Delete object
 */
RegressionPlane3f::~RegressionPlane3f()
{
}

/**
 * Reset all members to the initial state
 */
void RegressionPlane3f::clear()
{
   pca.clear();
   Plane3f::clear();
}

/**
 * Save point in container
 */
void RegressionPlane3f::addPoint( Vector3f p )
{
   pca.addPoint( p );
}

void RegressionPlane3f::computePlane(){
	Vector3f eigenValues;
	Matrix3f eigenVectors;
   pca.analyze( eigenValues, eigenVectors, point );
	normal = eigenVectors[2];

	u = eigenVectors[0] * ( ( eigenValues[0] > 0 )? sqrt( eigenValues[0] ) : 1.0 );
	v = eigenVectors[1] * ( ( eigenValues[1] > 0 )? sqrt( eigenValues[1] ) : 1.0 );
	s0 = t0 = s1 = t1 = 0;
}