#ifndef REGRESSION_PLANE3F_H
#define REGRESSION_PLANE3F_H

// Xrt
#include "ParametricPlane3f.h"
#include "PCA.h"
#include "PCA.inline.h"

namespace X4
{

/// Implementation of a regression plane. The class allows to add an arbitrary number of templated points in order to compute the associated regression plane via the covariance matrix.
class X4MATH_API RegressionPlane3f : public ParametricPlane3f
{
	private:
      /// PCA estimator
      PCA<float,3> pca;

   public:
		/// Constructor
		RegressionPlane3f();
		/// Destructor
		~RegressionPlane3f();
		/// Reinitialize the point set and all matrices
		void clear();
		/// Add a point to the regression set
		void addPoint( Vector3f p );
		/// Compute the repression plane
		void computePlane();
};

}

#endif
