#ifndef PCH_X4MATH_H
#define PCH_X4MATH_H


// note: the header file is not located in the subdirectory x4basics because the msvc compiler does not 
//       handle directory prefixes on precompiled header files

/// precompiled header file that includes common headers from the standard C++ library, Windows, and QT Core,Gui
/// precompiled headers can be shared among several projects

////////////////////////////////////////////////
//                                            //
//                  Global                    //
//                                            //
////////////////////////////////////////////////

#include <X4GlobalDefinitions.h>


////////////////////////////////////////////////
//                                            //
//                  Windows                   //
//                                            //
////////////////////////////////////////////////

#if defined(WIN32) || defined(WIN64)

	#ifndef WINVER                          // Specifies that the minimum required platform is Windows Vista.
	#define WINVER 0x0600           // Change this to the appropriate value to target other versions of Windows.
	#endif

	#ifndef _WIN32_WINNT            // Specifies that the minimum required platform is Windows Vista.
	#define _WIN32_WINNT 0x0600     // Change this to the appropriate value to target other versions of Windows.
	#endif

	#ifndef _WIN32_WINDOWS          // Specifies that the minimum required platform is Windows 98.
	#define _WIN32_WINDOWS 0x0410 // Change this to the appropriate value to target Windows Me or later.
	#endif

	#ifndef _WIN32_IE                       // Specifies that the minimum required platform is Internet Explorer 7.0.
	#define _WIN32_IE 0x0700        // Change this to the appropriate value to target other versions of IE.
	#endif

	#define NOMINMAX
	#define WIN32_LEAN_AND_MEAN             // Exclude rarely-used stuff from Windows headers
	// Windows Header Files:
	#include <windows.h>

   #include <mmsystem.h>

#endif


////////////////////////////////////////////////
//                                            //
//                 C++ / STD                  //
//                                            //
////////////////////////////////////////////////


// C RunTime Header Files
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <tchar.h>

// standard template library
#include <string>
#include <vector>

////////////////////////////////////////////////
//                                            //
//                    QT                      //
//                                            //
////////////////////////////////////////////////

#include <QtCore/QtCore>


////////////////////////////////////////////////
//                                            //
//                    X4                      //
//                                            //
////////////////////////////////////////////////

#include "x4math.h"
#include "BoundingBox.h"
#include "BoundingBox.inline.h"
#include "BVIntersection.h"
#include "ColorTools.h"
#include "DynamicLinearAlgebra.h"
#include "DynamicLinearAlgebra.inline.h"
#include "DynamicVectorClassProperty.h"
#include "X4Exception.h"
#include "FixedArrayClassProperty.h"
#include "Frustum.h"
#include "HalfSpace.h"
#include "HalfSpace.inline.h"
#include "IterativeSolvers.h"
#include "IterativeSolvers.inline.h"
#include "Line3f.h"
#include "LinearAlgebra.h"
#include "LinearAlgebra.inline.h"
#include "MathIOTools.h"
#include "MathTools.h"
#include "MathTools.inline.h"
#include "NonLinearIterativeSolvers.h"
#include "NonLinearIterativeSolvers.inline.h"
#include "NormalCone.h"
#include "NormalCone.inline.h"
#include "NormalDistribution.h"
#include "ParametricPlane3f.h"
#include "PartialDerivative.h"
#include "PartialDerivative.inline.h"
#include "Plane3f.h"
#include "PolarCoordinates.h"
#include "Polygon.h"
#include "Polygon.inline.h"
#include "Random.h"
#include "RaytracingMath.h"
#include "RaytracingMath.inline.h"
#include "RegressionLine3f.h"
#include "RegressionPlane3f.h"
#include "RegularData.h"
#include "RegularData.inline.h"
#include "ScalarDerivative.h"
#include "ScalarDerivative.inline.h"
#include "SparseLinearAlgebra.h"
#include "SparseLinearAlgebra.inline.h"
#include "Sphere.h"

#endif