#ifndef TriangleBBIntersectionH
#define TriangleBBIntersectionH
//---------------------------------------------------------------------------
#include "x4math.h"
//---------------------------------------------------------------------------

namespace X4
{
	bool X4MATH_API triBoxOverlap(float boxcenter[3],float boxhalfsize[3],float triverts[3][3]);
	inline bool X4MATH_API triangleIntersectsBB( const Vector3f &v1,const Vector3f &v2,const Vector3f &v3, const BoundingBox3f &bb )
	{
		Vector3f bbc = bb.getCenter();
		Vector3f sidelength_2 = (bb.upperCorner - bb.lowerCorner) / 2.0f;
		float tri[3][3];
		tri[0][0] = v1[0];	tri[0][1] = v1[1];	tri[0][2] = v1[2];
		tri[1][0] = v2[0];	tri[1][1] = v2[1];	tri[1][2] = v2[2];
		tri[2][0] = v3[0];	tri[2][1] = v3[1];	tri[2][2] = v3[2];
		return triBoxOverlap(bbc.data(),sidelength_2.data(),tri);
	}

	bool X4MATH_API rayIntersectsBoundingBox( const Vector3f &origin, const Vector3f &dir, const BoundingBox3f &bb);
	bool X4MATH_API rayIntersectsBoundingBox( const Vector3f &origin, const Vector3f &dir, const BoundingBox3f &bb,
		float &t0, float &t1);

}

#endif