#ifndef CameraPathRecorderEditorWidgetH
#define CameraPathRecorderEditorWidgetH
//---------------------------------------------------------------------------
#include "x4interface.h"
//---------------------------------------------------------------------------
#include <QWidget>
#include "ClassEditor.h"
#include "CameraPathRecorder.h"
//---------------------------------------------------------------------------
//this file is generated from the ui file by a custom buildstep
#include "CameraPathRecorderEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace X4 { 

class X4MISCFOUNDATION_API CameraPathRecorderEditorWidget
: public QWidget 
{
Q_OBJECT 


public: 
CameraPathRecorderEditorWidget (QWidget * parent); 

void setup( CameraPathRecorder* obj );
void updateEditor();


public slots:
	void sltIEKeyFrameValueChanged(int);
	void sltGotoKeyFrame();
	void sltAddKeyFrame();
	void sltRemoveKeyFrame();
	void sltEditSubController();
	void sltSetExaminerCamController();
	void sltSetFreeCamController();
	void sltFEPathTimeValueChanged(double);
   void sltInterpolationToggled(bool);
	void sltCBRecordFramesStateChanged(int);


private:
	///used to access buttons, etc. from QtDesigner
	Ui_CameraPathRecorderEditorForm ui;

	CameraPathRecorder   *  m_Recorder;

	// user definitions
	bool changing;
	void setNumFrames(int numFrames);
	void limitFrameEd(int limit);

}; 

MAKE_CLASS_EDITOR( X4MISCFOUNDATION_API, CameraPathRecorder )

}

#endif