//---------------------------------------------------------------------------
#ifndef CmdObjMemberMethodH
#define CmdObjMemberMethodH
//---------------------------------------------------------------------------
#include "x4miscFoundation.h"
//---------------------------------------------------------------------------
#include "CommandObject.h"
//---------------------------------------------------------------------------

namespace X4 {

/**
	this command object represents the execution of a member function of a persistent class
	the command object stores the method name and the state of the object at the point of execution
	undo is not supported (at least not by this base class)
*/
class X4MISCFOUNDATION_API CmdObjMemberMethod : public CommandObject {
	X4_CLASS( CmdObjMemberMethod )

 private:
	std::string methodName;
	Persistent *obj;

 public:
	CmdObjMemberMethod();
	
	virtual void setup(std::string methodName, const Persistent *obj);

   void assign(const Object* obj, X4CopyContext *context = NULL);

   virtual void doAction(Object *context);
   virtual void undoAction(Object *context);
   virtual bool canUndo();
   virtual std::string getDescription();

   inline Persistent* getObject() {return obj;}

	~CmdObjMemberMethod();

};


}

#endif