#ifndef CommandObjMacroEditorWidgetH 
#define CommandObjMacroEditorWidgetH
//---------------------------------------------------------------------------
#include "x4miscFoundation.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "CommandObjMacroEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace X4
{

class CommandObject;
class CommandObjMacro;

class X4MISCFOUNDATION_API CommandObjMacroEditorWidget : public QWidget
{
	Q_OBJECT

private:

	CommandObjMacro	*	m_CmdObjMacro;

	///used to access buttons, etc. from QtDesigner
	Ui_CommandObjMacroEditorForm ui;

	/// class editor of command object selected in Command List
	ClassEditor* commandEditor;
	/// class editor widget of command object selected in Command List
	QWidget* commandEditorWidget;

	/// udates/changes the class editor of the selected command object which is shown in bottom frame
   void updateSelectedItemEditor(CommandObject *obj);


public slots:
	/// duplicate button pressed
	void sltBTDuplicateClicked();
	/// delete button pressed
	void sltBTDeleteClicked();
	/// bottom button pressed
	void sltBTBottomClicked();
	/// down button pressed
	void sltBTDownClicked();
	/// up button pressed
	void sltBTUpClicked();
	/// top button pressed
	void sltBTTopClicked();
	/// script list selection changed
	void sltLVCommandsChanged(QTreeWidgetItem* currentItem, QTreeWidgetItem* previousItem);
	/// check box to show line number was clicked
	void sltCBShowLineNumberChanged(int);


public:
	CommandObjMacroEditorWidget(QWidget * parent = NULL, Qt::WindowFlags f=0);
	~CommandObjMacroEditorWidget(void);

	void setup( CommandObjMacro * obj );

	/// update editor content with object data
	void updateEditor();


};


MAKE_CLASS_EDITOR( X4MISCFOUNDATION_API , CommandObjMacro )

}

#endif


