//---------------------------------------------------------------------------
#ifndef GloballyUniqueIDH
#define GloballyUniqueIDH
//---------------------------------------------------------------------------
#include "x4miscFoundation.h"
//---------------------------------------------------------------------------
#ifdef PLATFORM_WINDOWS
#include "Windows.h"
#endif

#include <qtCore/quuid.h>
//---------------------------------------------------------------------------

namespace X4 {

class GloballyUniqueID {
 public:
   QUuid m_Guid;

   GloballyUniqueID() {}
   void createNewID() 
	{
		m_Guid = QUuid::createUuid();      
   }
   bool equal(const GloballyUniqueID &other) 
	{
		return m_Guid == other.m_Guid;
   }
   bool operator==(const GloballyUniqueID &other) {
      return equal(other);
   }
   bool operator!=(const GloballyUniqueID &other) {
      return !equal(other);
   }
   void operator=(const GloballyUniqueID &other) {
      m_Guid = other.m_Guid;
   }
   GloballyUniqueID(const GloballyUniqueID &other) {
      m_Guid = other.m_Guid;
   }

};


}


#endif
 