//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "Histogram.h"
//---------------------------------------------------------------------------
#include "StringHelper.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------


void Histogram::addEntry(int bin, double increment) {
	std::map<int, double>::iterator pos = entries.find(bin);
	if (pos != entries.end()) {
		pos->second += increment;
	} else {
		pair<int, double> entry(bin, increment);
		entries.insert(entry);
	}
}


std::string Histogram::toString(float32 binScale) {
	std::string result;
	std::map<int, double>::iterator pos = entries.begin();
	std::map<int, double>::iterator end = entries.end();
	while (pos != end) {
		result += floatToStr(pos->first*binScale) + std::string("\t") + intToStr(pos->second) + std::string("\n");
		++pos;
	}
	return result;
}
