//---------------------------------------------------------------------------
#ifndef LargeBinaryFileH
#define LargeBinaryFileH
//---------------------------------------------------------------------------
#include "x4miscFoundation.h"
//---------------------------------------------------------------------------
#include "X4Types.h"
//---------------------------------------------------------------------------
#ifdef PLATFORM_WINDOWS
#include <windows.h>
#endif
//---------------------------------------------------------------------------

namespace X4 {


/// Wrapper class for large (64 bit length) files 
class X4MISCFOUNDATION_API LargeBinaryFile {
 private:
   #ifdef PLATFORM_WINDOWS
   HANDLE file;
   bool read, write;
   #endif

 public:
   /// open file, read || write must not be false
   LargeBinaryFile(const char *filename, bool read = true, bool write = true);
   /// write some piece of memory
   void writeBuffer(const void *buffer, const max_platform_card numBytes);
   /// read some piece of memory
   void readBuffer(void *buffer, const max_platform_card numBytes);

   ///  move file pointer to byte number "position"
   void seek(card64 position);
   /// get file pointer (in bytes)
   card64 getCurrentFilePointer();

   /// get current file size
   card64 getFileSize();
   /// set current file size (sets file pointer to zero)
   void setFileSize(card64 newSize);

   /// writeback pending buffers (if any)
   void sync();

   static void unitTest();

   /// close file again
   ~LargeBinaryFile();
};


}


#endif
