//---------------------------------------------------------------------------
#ifndef MemoryManagedAttachmentH
#define MemoryManagedAttachmentH
//---------------------------------------------------------------------------
#include "x4miscFoundation.h"
//---------------------------------------------------------------------------
#include "AttachedData.h"
#include "MemoryManager.h"
//---------------------------------------------------------------------------

namespace X4 {

class GLVertexBuffer;
class GLContext;
class VertexDescriptor;


class X4MISCFOUNDATION_API MemoryManagedAttachment : public AttachedData, public MMOOwner {
	X4_ABSTRACT_CLASS(MemoryManagedAttachment)
private:

   MemoryManagedObject  *  m_ManagedObject;

protected:

   virtual card32 getManagedSize() = 0;
   void setManagedSize( const card32 &size);

public:

// MMOOwner - methods
   virtual void onDeleteMMO(MemoryManagedObject*) {m_ManagedObject = NULL; /* avoid infinit recursion */ delete this;}
// -----------

   /// setup attachment & memory managed object
   /// getManagedSize() is used in here!
   virtual void setupMMA( const std::string &name, MemoryManager * mm, bool deleteOnUpdate=true);

   /// informs MemoryManager that this object is valid
   /// call touched() every time you use this object
   void touched();

   MemoryManagedAttachment();
   virtual ~MemoryManagedAttachment();


};

}

#endif
