#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "ObjectAttachment.h"
//---------------------------------------------------------------------------
#include "CopyObjectProperties.h"
#include "ObjectClassProperty.h"
#include "AttachedDataContainer.h"
//---------------------------------------------------------------------------
using namespace X4;

IMPLEMENT_X4_CLASS( ObjectAttachment ,0)
{
	BEGIN_CLASS_INIT( ObjectAttachment );
	ADD_OBJECT_PROP(m_Object,0,Object::getClass(),true);
}

ObjectAttachment::ObjectAttachment(void)
{
	m_Object = NULL;
}

ObjectAttachment::~ObjectAttachment(void)
{
	delete m_Object;
}

void ObjectAttachment::assign(const Object* obj, X4CopyContext *context)
{
	AttachedData::assign(obj,context);
	const ObjectAttachment * o = dynamic_cast<const ObjectAttachment*>(obj);
	x4Assert( o != NULL );

	copyObjectProperties(obj,this);
}

void X4::ObjectAttachment::replaceObject( Object * obj )
{
	delete m_Object;
	setObject(obj);
}

void X4::ObjectAttachment::setObject( Object * obj )
{
	m_Object = obj;
}

Object * X4::ObjectAttachment::get( AttachedDataContainer * att_container, const std::string &name )
{
	ObjectAttachment * 	att = dynamic_cast<ObjectAttachment*>(att_container->getData(name));
	if( att)
		return att->getObject();
	else
		return NULL;
}

void X4::ObjectAttachment::set( AttachedDataContainer * att_container, const std::string &name,Object * obj,bool persistent )
{
	ObjectAttachment * 	att = dynamic_cast<ObjectAttachment*>(att_container->getData(name));
	if( att )	
		att->replaceObject(obj);
	else
	{
		att = new ObjectAttachment;
		att->setup(name,persistent?AttachedData::ADF_PERSISTENT:0);
		att->setObject(obj);
		att_container->attachData(att);
	}
}