#ifndef ObjectAttachmentH
#define ObjectAttachmentH
//---------------------------------------------------------------------------
#include "x4miscFoundation.h"
//---------------------------------------------------------------------------
#include "AttachedData.h"
//---------------------------------------------------------------------------

namespace X4
{

/**
	object attachment - that pretty much describes it :-)

	for lazy people:
	Object * myObj = ...;
	ObjectAttachment::set(attachments, "myobj", myObj);
	...
	myObj = ObjectAttachment::get(attachments, "myobj");
*/
class X4MISCFOUNDATION_API ObjectAttachment : public AttachedData
{
	X4_CLASS( ObjectAttachment )

public:
	ObjectAttachment(void);
	~ObjectAttachment(void);

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);


   /// delete old object, set new
   void replaceObject(Object * obj);
   
   /// set object without deleting existing
   void setObject(Object * obj);

   /// get object
   Object * getObject() {return m_Object;}

   /// tries to find attachment and returns object (or NULL if attachment or object don't exist)
   static Object * get(AttachedDataContainer * att_container, const std::string &name);

   /// use existing attachment and replace obj OR create new attachment
   static void set(AttachedDataContainer * att_container, const std::string &name,Object * obj, bool persistent=true);

private:

	Object * m_Object;

};

}

#endif