//---------------------------------------------------------------------------
#ifndef ToolsH
#define ToolsH
//---------------------------------------------------------------------------
#include <x4tools.h>
//---------------------------------------------------------------------------
#include <X4Types.h>
#include <string>
//---------------------------------------------------------------------------

namespace X4 {

	#ifdef _DEBUG
	   template <class T>
	   void forget(T) {}
	#else
		#ifdef X4_PLATFORM_MSVC
			#pragma warning(disable:4101)
			#pragma warning(disable:4189)
		#endif
		#define forget(T)
	#endif

	extern void X4TOOLS_API notImplemented();

	extern X4TOOLS_API bool FileExists( const char * filename );


	template<class T>
	inline const T& getFromDataPointer(const byte* ptr)
	{
		return *(reinterpret_cast<const T*>(ptr));
	}
	template<class T>
	inline T& getFromDataPointer(byte* ptr)
	{
		return *(reinterpret_cast<T*>(ptr));
	}

	template<class T>
	inline void setToDataPointer(const byte* ptr, const T& data)
	{
		*(reinterpret_cast<const T*>(ptr)) = data;
	}
	template<class T>
	inline void setToDataPointer(byte* ptr, const T& data)
	{
		*(reinterpret_cast<T*>(ptr)) = data;
	}

	template<class T>
	inline void addToDataAtPointer(const byte* ptr, const T& data)
	{
		*(reinterpret_cast<const T*>(ptr)) += data;
	}
	template<class T>
	inline void addToDataAtPointer(byte* ptr, const T& data)
	{
		*(reinterpret_cast<T*>(ptr)) += data;
	}

}

#endif
