//---------------------------------------------------------------------------
#ifndef X4TypeNamesH
#define X4TypeNamesH
//---------------------------------------------------------------------------
#include "x4tools.h"
//---------------------------------------------------------------------------
#include <X4Types.h>
#include <string>
//---------------------------------------------------------------------------

namespace X4
{

	// templates for RTTI

	//! Returns single std::string long name of a type (i.e. float, uchar, uint, ...)
	template<class T> std::string GetTypeName();

	//! Returns short name of a type (i.e. f, B, I, ...)
	template<class T> std::string GetTypeShortName();

	// Full names
	template<> X4TOOLS_API std::string GetTypeName<int8>();
	template<> X4TOOLS_API std::string GetTypeName<int16>();
	template<> X4TOOLS_API std::string GetTypeName<int32>();
	template<> X4TOOLS_API std::string GetTypeName<int64>();

	template<> X4TOOLS_API std::string GetTypeName<card8>();
	template<> X4TOOLS_API std::string GetTypeName<card16>();
	template<> X4TOOLS_API std::string GetTypeName<card32>();
	template<> X4TOOLS_API std::string GetTypeName<card64>();

	template<> X4TOOLS_API std::string GetTypeName<float32>();
	template<> X4TOOLS_API std::string GetTypeName<float64>();

	// Short names
	template<> X4TOOLS_API std::string GetTypeShortName<int8>();
	template<> X4TOOLS_API std::string GetTypeShortName<int16>();
	template<> X4TOOLS_API std::string GetTypeShortName<int32>();
	template<> X4TOOLS_API std::string GetTypeShortName<int64>();

	template<> X4TOOLS_API std::string GetTypeShortName<card8>();
	template<> X4TOOLS_API std::string GetTypeShortName<card16>();
	template<> X4TOOLS_API std::string GetTypeShortName<card32>();
	template<> X4TOOLS_API std::string GetTypeShortName<card64>();

	template<> X4TOOLS_API std::string GetTypeShortName<float32>();
	template<> X4TOOLS_API std::string GetTypeShortName<float64>();
}

#define PROVIDE_TYPE(type) template<> std::string GetTypeName<type>();
#define PROVIDE_MODULE_TYPE(api, type) template<> api std::string GetTypeName<type>();

#define REGISTER_TYPE_NAME(type, name) template<> std::string GetTypeName<type>(){return name;}
#define REGISTER_TYPE_SHORTNAME(type, name) template<> std::string GetTypeShortName<type>(){return name;}


#endif
