#ifndef ApplicationDirectoriesH
#define ApplicationDirectoriesH

#include "x4modules.h"
#include <string>

namespace X4 {

class X4MODULES_API ApplicationDirectories 
{
 private:
   static bool isSetup;
   static std::string applicationDir;
   static std::string resourcesDir;
   static std::string configDir;
   static std::string docsDir;
   static std::string binDir;
   static std::string logDir;
   
 public:
   /// sets the directories, can only be called once
   /// uses QCoreApplication::applicationDirPath()
   static void setup();
 
   static std::string getApplicationDir();
   static std::string getBinDir();
   static std::string getResourcesDir();
   static std::string getDocsDir();
   static std::string getConfigDir();
   static std::string getLogDir();

   static std::string getStartupModulesListFilenameAndPath();
   static std::string getStartupModulesListFilename();
};


}



#endif
