//---------------------------------------------------------------------------
#include "precompiledHeadersBasics.h"
//---------------------------------------------------------------------------
#include "BasicStringUtils.h"
#include <X4Exception.h>
#include <sstream>
#include <iostream>
#include <QtCore/QString>
#include <iomanip>
//---------------------------------------------------------------------------


std::string X4::intToStr( int64 i, int64 minWidth )
{
	std::string s;
	std::ostringstream os;
	os << std::setw(minWidth) << std::setfill('0') << i;
	s = os.str();
	return s;
}
std::string X4::mpcardToStr( mpcard i )
{
	std::string s;
	std::ostringstream os;
	os << i;
	s = os.str();
	return s;
}

std::string X4::floatToStr( float f )
{
	std::string s;
	std::ostringstream os;
	os << f;
	s = os.str();
	return s;
}


std::string X4::strLCase(std::string s)
{
	for (unsigned i = 0; i != s.size(); ++i)
		s[i] = (unsigned char)tolower(s[i]);
	return s;
}

std::string X4::strUCase(std::string s)
{
	for (unsigned i = 0; i != s.size(); ++i)
		s[i] = (unsigned char)toupper(s[i]);
	return s;
}

/**
 * Extracts the first part from the std::string s until but excluding c
 * if c is not part of the std::string, s will be returned and s will be empty
 * Example:
 * s = "a.b";
 * c = extractToChar(s, '.');
 * Result: c is "a", s is "b" */
std::string X4::extractToChar(std::string& s, char c)
{
	unsigned i=0;
	const size_t l = s.length();
	for( i=0;i<l;i++ )
	{
		if( s[i] == c)
			break;
	}

	std::string word;
	if( i == l)
	{
		word = s;
		s = "";
		return word;
	}
	word = s.substr(0,i);
	s = s.substr(i,l);

  return word;
}

std::string X4::removePathFromFilename( const std::string &s )
{
  std::string ret = "";
  for (int i=(int)s.length()-1; i >= 0; i--)
    if ((s[i] == '/') || (s[i] == '\\') || s[i] == ':')
      return s.substr(i+1, s.length()-i-1);

  return s;
}

std::string X4::removeFilenameFromPath( const std::string &s )
{
  std::string ret = "";
  for (int i=(int)s.length()-1; i >= 0; i--)
    if ((s[i] == '/') || (s[i] == '\\') || s[i] == ':')
      return s.substr(0, i+1);

  return s;
}


std::string X4::qString2STLString(const QString &str) {
	QByteArray temp = str.toLatin1();
	const char *data = temp.constData();
	return std::string(data);
}


