//---------------------------------------------------------------------------
#ifndef BasicStringUtilsH
#define BasicStringUtilsH
//---------------------------------------------------------------------------
#include "x4modules.h"
#include <X4Types.h>
//---------------------------------------------------------------------------
#include <string>
#include <vector>
//---------------------------------------------------------------------------

class QString;

namespace X4 {


/// Converts int to a std::string
std::string X4MODULES_API intToStr(int64 i, int64 minWidth = 0);
/// Converts unsigned 32 bit int to a std::string
std::string X4MODULES_API mpcardToStr(mpcard i);
/// Converts float to a std::string
std::string X4MODULES_API floatToStr(float32 f);


/// Converts the std::string into lower case and returns the result
std::string X4MODULES_API strLCase(std::string s);
/// Converts the std::string into upper case and returns the result
std::string X4MODULES_API strUCase(std::string s);
/// Extracts the characters up to a certain character (see detailed descr. in implementation part)
std::string X4MODULES_API extractToChar(std::string& s, char c);


/// Example: "dir/test.abc" -> "test.abc"
std::string X4MODULES_API removePathFromFilename( const std::string &filename );
/// Example: "dir/test.abc" -> "dir/"
std::string X4MODULES_API removeFilenameFromPath( const std::string &filename );


/// Converts QString to an STL std::string (std::string)
std::string X4MODULES_API qString2STLString(const QString &str);

}

#endif
