#include "precompiledHeadersBasics.h"

#include "ModuleEvents.h"
#include "BasicStringUtils.h"

using namespace X4;

std::vector<ModuleEvents::EventProc> X4::ModuleEvents::postInitEvents;
std::vector<ModuleEvents::EventProc> X4::ModuleEvents::preShutdownEvents;


void ModuleEvents::addPostInitEvent(ModuleEvents::EventProc ev)
{
	postInitEvents.push_back(ev);
}

void ModuleEvents::callPostInitEvents()
{
	for (size_t i=0; i<postInitEvents.size(); i++) {
		(*(postInitEvents[i]))();
	}
}


void ModuleEvents::addPreShutdownEvent(ModuleEvents::EventProc ev)
{
	preShutdownEvents.push_back(ev);
}

void ModuleEvents::callPreShutdownEvents()
{
	for (size_t i=0; i<preShutdownEvents.size(); i++) {
		(*(preShutdownEvents[i]))();
	}
}
