#ifndef ModuleListH
#define ModuleListH

#include "x4modules.h"

#include <vector>

namespace X4 {

class Module;

class X4MODULES_API ModuleList {
 private:
   std::vector<Module*> modules;
 
 public:
   
   void addModule(Module *mod);
   /// returns true if successful, otherwise, the error text is set
   bool tryLoadModule(std::string filename, std::string &error);
   /// load modules from a list of modules
   bool tryLoadModules(const std::vector<std::string> &filenames, std::vector<std::string> &errors);
   
   unsigned getNumModules() const;
   
   /// returns -1 if not found
   int findModule(std::string name) const; 
   
   Module *getModule(unsigned i);
   Module *getModule(std::string name);
   
   const Module *getModule(unsigned i) const;
   const Module *getModule(std::string name) const;
   
   ~ModuleList();
};


extern X4MODULES_API ModuleList x4modules;


}


#endif