#ifndef TagHeaderParserH
#define TagHeaderParserH

#include "x4modules.h"
#include <QtCore/qstring.h>

namespace X4 {

class TagList;


/// a parser for .tags.h files (to convert them straight into tag lists without C++ compiler)
class X4MODULES_API TagHeaderParser {
 private:
   /// temporary global variable to track line numbers
   int lineNumber;
   /// temporary global variable to track the last line read
   std::string lastLineRead;
   void addError(const std::string& error);
   QString findKeyword(QString &s);
   std::string getString(QString &s);

 public:
   /// will contain error information if parsing went wrong
   std::string errors;  
   /// will be 1 if something went wrong, 0 otherwise
   int errorLevel;

   TagHeaderParser();
   TagList *parseTagFile(const std::string& filename);

};

}


#endif