//---------------------------------------------------------------------------
#ifndef X4ConsoleWindowH
#define X4ConsoleWindowH
//---------------------------------------------------------------------------
#include "X4GlobalDefinitions.h"
//---------------------------------------------------------------------------
#include "X4ConsoleWindow.h"
#include "X4ConsoleWindow_ui.h"
//---------------------------------------------------------------------------


namespace X4 {

class ModuleManagerWindow;
class ConsoleWidget;

class X4ConsoleWindow : public QMainWindow {
	Q_OBJECT
 private:
	bool shutdown;
	Ui_X4ConsoleWindow ui;
	ModuleManagerWindow  * moduleManager;
	QTimer *autoCloseCheck;
	DWORD parentProcessID;

 protected:
	void closeEvent(QCloseEvent *event);

 public:
	 X4ConsoleWindow(QWidget * parent = NULL, Qt::WindowFlags f = 0);
	ConsoleWidget *getConsoleWidget();
	~X4ConsoleWindow(void);

 private slots:
	void on_exitButton_clicked();
	void on_actionE_xit_triggered();
	void on_action_Module_Manager_triggered();
	void on_action_Info_triggered();

 public slots:
	void resizeWin(int w, int h);
	void moveWin(int x,int y);
	void showWin();
	void hideWin();
	void showHideWinToggle();
	void closeAll();
	void flush();
	void newText(char *text);
	void newHTML(char *text);
	void newBinary(char *buffer, int size);
	void parentProcessIDReceived(card64 pid);
	void checkParentProcess();
};

}

#endif