//---------------------------------------------------------------------------
#ifndef ConstraintsInterfaceH
#define ConstraintsInterfaceH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

namespace X4 {

class PositionConstraint;
class VelocityConstraint;
class InstantaneousVelocityConstraint;


class ConstraintsInterface {
 public:
   virtual void addPositionConstraint(const PositionConstraint *c) = 0;
};


class TimeVariantConstraintsInterface : public ConstraintsInterface {
 public:
   virtual void addVelocityConstraint(const VelocityConstraint *c) = 0;
   virtual void addInstantaneousVelocityConstraint(const InstantaneousVelocityConstraint *c) = 0;
};


}

#endif