//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "ARPointCloudSeqEval.h"
//---------------------------------------------------------------------------
#include "ARDeformationOptimizationContext.h"
#include "ARSequence.h"
#include "SGListNode.h"
#include "DeformationEvaluator.h"
#include "ARSettings.h"
#include "UnstructuredInCorePointCloud.h"
#include "SGObjectNode.h"
#include "AREvaluateDeformation.h"
#include "StringHelper.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



IMPLEMENT_X4_CLASS( ARPointCloudSeqEval , 0 ) {
	BEGIN_CLASS_INIT( ARPointCloudSeqEval );
}

// ----

ARPointCloudSeqEval::ARPointCloudSeqEval() {}

ARPointCloudSeqEval::~ARPointCloudSeqEval() {}




void ARPointCloudSeqEval::evalSeq(
   ARSequence *seq, 
   SGListNode *target, 
   DeformationEvaluator *deformEval,
   ARSettings *settings) 
{
   ARDeformationOptimizationContext *context = seq->getDeformation();
   PointCloud *urshape = seq->getUrshape();
   float32 step = 1.0f / settings->outFramesPerFrame;
   float32 start = 0;
   float32 end = seq->getDuration()+1;
   card32 findex = 0;
   for (float32 t=start; t<end; t+=step) {
//       UnstructuredInCorePointCloud *f = AREvaluateDeformation::evaluatePC(urshape, context, deformEval, t, settings);
// 	  VertexDescriptor vd;
// 	  vd.pushAttrib(mVAD("color", 3, VAD::DATA_FORMAT_FLOAT32));
// 	  UnstructuredInCorePointCloud* frame = dynamic_cast<UnstructuredInCorePointCloud*>( f->appendFields( &vd ) );
// 	  delete f;
	  UnstructuredInCorePointCloud* frame = AREvaluateDeformation::evaluatePC(urshape, context, deformEval, t, settings);
      SGObjectNode *sg = new SGObjectNode();
      sg->clearAndSetup(frame);
      sg->setName(std::string("result_")+intToStr(findex));
      target->addChildNode(sg);
      findex++;

	  // Init channels
	  AAT FLAGS = frame->getAAT( "flags" );
	  //AAT COLOR = frame->getAAT( "color" );
	  for ( unsigned int pIndex = 0; pIndex < frame->getNumPoints(); pIndex++ ){
		  frame->getPointSet()->set1i( pIndex, FLAGS, 0 );
		  //frame->getPointSet()->set3f( pIndex, COLOR, makeVector3f( 0.25f, 0.25f, 0.75f  ) );
	  }
   }
}
