//---------------------------------------------------------------------------
#ifndef ARSequenceEvaluatorH
#define ARSequenceEvaluatorH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace X4 {

class ARSequence;
class SGListNode;
class ARSettings;
class DeformationEvaluator;

///
///   this abstract class is used to create the final output
///   it interpolates a sequence temporally and spatially
///
class X3DEFORMATION_API ARSequenceEvaluator : public Persistent {
	X4_ABSTRACT_CLASS( ARSequenceEvaluator )
 public:
	virtual void assign(const Object* obj, X4CopyContext *context = NULL);
   virtual void evalSeq(
      ARSequence *seq, 
      SGListNode *target, 
      DeformationEvaluator *deformEval,
      ARSettings *settings) = 0;

};

}

#endif