//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "ARConstraints.h"
//---------------------------------------------------------------------------
#include "EmbeddedObjectClassProperty.h"
using namespace X4;
//---------------------------------------------------------------------------


IMPLEMENT_X4_CLASS( ARConstraintAnchor , 0 ) {
	BEGIN_CLASS_INIT( ARConstraintAnchor );
	ADD_VECTOR3F_PROP(pos, 0);
	ADD_MAX_PLATFORM_INT_PROP(topologicalAnchor, 0)
}


IMPLEMENT_X4_CLASS( GeneralARConstraint , 0 ) {
	BEGIN_CLASS_INIT( GeneralARConstraint );
	ADD_EMBEDDED_OBJECT_PROP( anchor, 0, ARConstraintAnchor::getClass());
}

IMPLEMENT_X4_ABSTRACT_CLASS( VectorValuedARConstraint , 0 ) {
	BEGIN_CLASS_INIT( VectorValuedARConstraint );
}

IMPLEMENT_X4_ABSTRACT_CLASS( MatrixValuedARConstraint , 0 ) {
	BEGIN_CLASS_INIT( MatrixValuedARConstraint );
}

IMPLEMENT_X4_CLASS( PositionARConstraint, 0) {
	BEGIN_CLASS_INIT( PositionARConstraint );
	ADD_VECTOR3F_PROP(toPoint, 0);
	ADD_MATRIX3F_PROP(covariance, 0);
	ADD_FLOAT32_PROP(time, 0);
}

IMPLEMENT_X4_CLASS( VelocityVectorARConstraint, 0) {
	BEGIN_CLASS_INIT( VelocityVectorARConstraint );
	ADD_FLOAT32_PROP(fromTime, 0);
	ADD_FLOAT32_PROP(toTime, 0);
	ADD_VECTOR3F_PROP(velocity, 0);
	ADD_MATRIX3F_PROP(covariance, 0);
}

IMPLEMENT_X4_CLASS( InstantaneousVelocityARConstraint, 0) {
	BEGIN_CLASS_INIT( InstantaneousVelocityARConstraint );
	ADD_FLOAT32_PROP(time, 0);
	ADD_VECTOR3F_PROP(instVelocity, 0);
}


IMPLEMENT_X4_CLASS( ARHalfSpaceConstraint, 0) {
	BEGIN_CLASS_INIT( ARHalfSpaceConstraint );
	ADD_FLOAT32_PROP(time, 0);
	ADD_VECTOR3F_PROP(halfSpaceFootPoint, 0);
	ADD_VECTOR3F_PROP(halfSpaceNormal, 0);
	ADD_FLOAT32_PROP(penaltyWeight, 0);
}

IMPLEMENT_X4_CLASS( SpatialDerivativeARConstraint, 0) {
	BEGIN_CLASS_INIT( SpatialDerivativeARConstraint );
	ADD_FLOAT32_PROP(time, 0);
	ADD_MATRIX3F_PROP(targetDerivative, 0);
}


IMPLEMENT_X4_CLASS( SimpleSpatialDerivativeARConstraint, 0) {
	BEGIN_CLASS_INIT( SimpleSpatialDerivativeARConstraint );
	ADD_FLOAT32_PROP(time, 0);
	ADD_MATRIX3F_PROP(targetDerivative, 0);
   ADD_VECTOR3F_PROP(columnWeights, 0)
}
