//---------------------------------------------------------------------------
#ifndef AROptimizationContextH
#define AROptimizationContextH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace X4 {

class SGEShape;

///   --- mw 11/27/2007
///
///   This class is the base class of storage objects that contain all the
///   temporary data that is necessary to perform an optimization task
///   such as surface reconstruction or deformation optimization
///
///   For example, for deformation optimization, this might be a set of nodes in space-time
///   and a parametrization domain. Details are handled in the sub classes.
///
class X3DEFORMATION_API AROptimizationContext : public Persistent {
	X4_ABSTRACT_CLASS( AROptimizationContext )
 public:
	virtual void assign(const Object* obj, X4CopyContext *context = NULL);
};

}

#endif