//---------------------------------------------------------------------------
#ifndef ARShapeOptimizationContextH
#define ARShapeOptimizationContextH
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
#include "AROptimizationContext.h"
//---------------------------------------------------------------------------

namespace X4 {

class ARSettings;

///   --- mw 11/27/2007
///
///   This specific AROptimizationContext deals with shape optimization only
///   (i.e. computation on a single frame). It is typically used for surface 
///   reconstruction.
///
class X3DEFORMATION_API ARShapeOptimizationContext : public AROptimizationContext {
	X4_ABSTRACT_CLASS( ARShapeOptimizationContext )
 private:

 public:
	ARShapeOptimizationContext();

	/// initializes the shape optimization data structures from a candidate shape
	virtual void initializeFromShape(SceneObject *obj, const ARSettings *params) = 0;

   ~ARShapeOptimizationContext();
};

}

#endif