//---------------------------------------------------------------------------
#ifndef AttachedNodeInformationH
#define AttachedNodeInformationH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "AttachedData.h"
#include "NodeInformation.h"

namespace X4 {


/**
  * Holds for every node, additional information which
  * holds the node's neighbors and the evaluated shape functions
  * and gradient coefficients.
  */
class X3DEFORMATION_API AttachedNodeInformation : public AttachedData {
	//X4_CLASS( AttachedNodeInformation )

private:

	std::vector<NodeInformation*> nodeInformation;

public:

	mpcard nbNodes() const {
		return nodeInformation.size();
	}

	void addNodeInformation(NodeInformation * ni) {
		nodeInformation.push_back(ni);
	}

	NodeInformation* getNodeInformation(card32 index) {
		return nodeInformation[index];
	}


};

}

#endif