#ifndef MMConstraintsOOCH
#define MMConstraintsOOCH

#include "x3deformation.h"

#include "MMConstraints.h"
#include <vector>
#include <hash_map>
using namespace stdext;

namespace X4 {

	class ARSettings;
	class MMDeformations;

	/**
	* Holds for every frame, the cached constraints
	* information. in ooc
	*/
	class X3DEFORMATION_API MMConstraintsOOC : public  MMConstraints{

	private:
		bool dataOnDisk;
		std::string fileName;
		std::vector<ABMatrix3fVec>* dataAfterLoading;
		bool dataReloaded;


		static mpcard constraintsInMem;
		static queue<MMConstraintsOOC*> lruQueue;

		void moveToDisk();
		void reloadFromDisk();
		void checkSwapIn();
		void checkSwapOut();

	public:

		MMConstraintsOOC(const size_t numFrames, const size_t myFrameNum);
		virtual ~MMConstraintsOOC();

		virtual void addPositionConstraint(MMPositionConstraint *c);
		virtual float32 fCorrespondences(MMDeformations * deformations, float32 tempCorrespondenceParam);
		virtual void gCorrespondences(std::vector<Vector3f> &gradient, MMDeformations * deformations, float32 tempCorrespondenceParam);
		virtual void clearConstraints();

		static bool   useConstraintsOOC;
		static std::string OOCPathFilename;
		static mpcard maxConstraintsInMem;

	};
}


#endif