//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "MMDeformations.h"
//---------------------------------------------------------------------------
#include "ObjectStreams.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



IMPLEMENT_X4_CLASS( MMDeformations, 1 ) {
	BEGIN_CLASS_INIT( MMDeformations );
	ADD_BOOLEAN_PROP(frameActive, 1)
}

void MMDeformations::write(OutputObjectStream *s) const 
{
   mpcard n = deformations.size();
   s->writeMaxPlatformCard(n);
   for (mpcard i=0; i<n; i++) {
      s->write(deformations[i]);
      s->write(real_deformations[i]);
      s->writeBool(active[i]);
      s->write(realIndex[i]);
   }
}

void MMDeformations::read(InputObjectStream *s) 
{
   mpcard n;
   s->readMaxPlatformCard(n);
   deformations.resize(n);
   real_deformations.resize(n);
   active.resize(n);
   realIndex.resize(n);
   for (mpcard i=0; i<n; i++) {
      s->read(deformations[i]);
      s->read(real_deformations[i]);
      bool b;
      s->readBool(b);
      active[i] = b;
      s->read(realIndex[i]);
   }
}
