#ifndef MMSamplerH
#define MMSamplerH

#include "x3deformation.h"
#include <set>
#include <hash_map>

namespace X4 {

	class UnstructuredInCorePointCloud;
	class MMNodes;
	class ARSettings;
	class MMNeighborContainer;

	/**
	  * Create a nodal sampling from the given geometry.
	  */
	class X3DEFORMATION_API MMSampler : public Persistent {
		X4_ABSTRACT_CLASS( MMSampler )
	
public:

	virtual MMNodes* createNodes(const ARSettings *settings, UnstructuredInCorePointCloud * geometry) = 0;

	virtual void initializeCache(stdext::hash_map<mpint,MMNeighborContainer*> &cached_neighbors, bool &haveTopology) {
		// by default we do nothing
		haveTopology = false;
	}
	

};

}
#endif