#ifndef MMTopologyGridSamplerH
#define MMTopologyGridSamplerH

#include "x3deformation.h"
#include "MMSampler.h"
#include <set>
#include <hash_map>

namespace X4 {
	class MMNeighborContainer;

	class X3DEFORMATION_API GridEntryType : public Object {
	public:
		std::set<card32> ids;
	};

	class X3DEFORMATION_API TempNeighbor : public Object {
	public:
		//Vector3f pos;
		card32 index;
		card32 i,j,k;
	};

	class X3DEFORMATION_API TempNeighbors: public Object {
	public:
		std::set<card32> ids; // for fast intersection testing
		std::vector<TempNeighbor> neighbors;
	};


	class X3DEFORMATION_API MMTopologyGridSampler : public MMSampler {
		X4_CLASS( MMTopologyGridSampler )
	
public:

	virtual MMNodes* createNodes(const ARSettings *settings, UnstructuredInCorePointCloud * geometry);

	MMNeighborContainer* getNeighborContainer(card32 id);
	
	~MMTopologyGridSampler();

	virtual void initializeCache(stdext::hash_map<mpint,MMNeighborContainer*> &cached_neighbors, bool &haveTopology);
	
	private:

		std::vector<TempNeighbors> tempGeometryNeighbors;
		std::vector<TempNeighbors> tempNodeNeighbors;

		std::vector<MMNeighborContainer*> neighborContainers;
	
};

}
#endif