//---------------------------------------------------------------------------
#ifndef RWDeformationContextH
#define RWDeformationContextH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "ARDeformationOptimizationContext.h"
#include "SparseGrid.h"
#include "SparseLinearAlgebra.h"
#include "DynamicLinearAlgebra.h"
#include "ARConstraints.h"
//---------------------------------------------------------------------------

namespace X4 {

class RegularInCoreVolume;
class RWDeformationSolver;
class RWDeformationEvaluator;

///   mw - 02/03/2010
///
///   Elastic deformation solver with iteratively reweighted least squares
///
class X3DEFORMATION_API RWDeformationContext : public ARDeformationOptimizationContext {
	X4_CLASS( RWDeformationContext )
 protected:
   
 private:
   const ARSettings *settings;
   int32 startTime, endTime;
   UnstructuredInCorePointCloud *urshape;   

 protected:

 public:
	RWDeformationContext();

	virtual void initializeFromShape(const SceneObject *obj, Vector2f timeInterval, const ARSettings *settings);
	virtual float32 getDuration();

	virtual DeformationSolver *createSolver();
	virtual DeformationEvaluator *createEvaluator();
	virtual float32 getBaseResolution();

   ~RWDeformationContext();
 friend RWDeformationSolver;
 friend RWDeformationEvaluator;
};


}

#endif