//---------------------------------------------------------------------------
#ifndef RWDeformationDiscretizationH
#define RWDeformationDiscretizationH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "X4Types.h"
//---------------------------------------------------------------------------


namespace X4 {

class InCorePCTopologyGraph;
class PointSet;


/// discretization for the rw solver: point cloud w/topology
class X3DEFORMATION_API RWDeformationDiscretization : public Persistent {
	X4_CLASS( RWDeformationDiscretization )
 private:
   PointSet *controlPoints;
   InCorePCTopologyGraph *topology;
   AAT positionAAT;
   AAT weightAAT;
   AAT localRigidTransfAAT;
   
 public:
	RWDeformationDiscretization();
	
	/// setup from a shape with topology and a sampling spacing
	void clearAndSetup(const UnstructuredInCorePointCloud *ptsWTop, float32 eps);
	
	/// create an unstructured pc object that encodes the current deformation
	/// includes topology
	UnstructuredInCorePointCloud *createPC();
	
	virtual void assign(const Object* obj, X4CopyContext *context = NULL);
	~RWDeformationDiscretization();
};


}

#endif
