//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "RWDeformationEvaluator.h"
//---------------------------------------------------------------------------
#include "CopyObjectProperties.h"
#include "FiniteDifferencesDeformation.h"
#include "ARConstraints.h"
#include "FiniteDifferencesDeformation.h"
#include "FiniteDifferencesDeformation.inline.h"
#include "RegularVolume.h"
#include "RegularVolume.inline.h"
#include "SGEVolumeGridDeformationSequence.h"
#include "RegularInCoreVolume.h"
#include "RWDeformationEvaluator.h"
#include "RWDeformationContext.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



IMPLEMENT_X4_CLASS( RWDeformationEvaluator , 0 ) {
	BEGIN_CLASS_INIT( RWDeformationEvaluator );
}


// ----


RWDeformationEvaluator::RWDeformationEvaluator()
{
	context = NULL;
	settings = NULL;
}

RWDeformationEvaluator::~RWDeformationEvaluator()
{
}



AROptimizationContext *RWDeformationEvaluator::createOptContext() 
{
   return new RWDeformationContext;
}

void RWDeformationEvaluator::setup(AROptimizationContext *context, const ARSettings *settings) 
{
	if (!dynamic_cast<RWDeformationContext*>(context)) {
		throw ETypeMismatch("RWDeformationSolver::setup() - context does not have the correct dynamic type.");
	}
	this->context = (RWDeformationContext*)context;
	this->settings = settings;	
}

void RWDeformationEvaluator::beginQuery(float32 time) 
{
   this->time = time;
   if (this->time != time) {
      throw ERangeCheck("RWDeformationEvaluator::beginQuery() - the TS-evaluator currently supports integral time steps.");
   }
}




Vector3f RWDeformationEvaluator::getPosition(const ARConstraintAnchor &at)
{
   return NULL_VECTOR3F;// context->getPosition(time, at);
}

Vector3f RWDeformationEvaluator::getVelocity(const ARConstraintAnchor &at)
{
   return NULL_VECTOR3F;
}

Vector3f RWDeformationEvaluator::getAcceleration(const ARConstraintAnchor &at)
{
   return NULL_VECTOR3F;
}

Matrix3f RWDeformationEvaluator::getSpatialGradient(const ARConstraintAnchor &at)
{
   return IDENTITY3F;//context->getSpatialGradient(time, at);
}


void RWDeformationEvaluator::endQuery() {}

