//---------------------------------------------------------------------------
#ifndef RWDeformationEvaluatorH
#define RWDeformationEvaluatorH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "DeformationEvaluator.h"
#include "ARConstraints.h"
//---------------------------------------------------------------------------

namespace X4 {

class RegularVolume;
class RWDeformationContext;

///   mw - 02/03/2010
///
///   Elastic deformation solver with iteratively reweighted least squares
///
class X3DEFORMATION_API RWDeformationEvaluator : public DeformationEvaluator {
	X4_CLASS( RWDeformationEvaluator )
 private:
	RWDeformationContext *context;
	const ARSettings *settings;
	
	// --- temp
	int32 time;
	
 public:
	RWDeformationEvaluator();

	AROptimizationContext *createOptContext();
	virtual void setup(AROptimizationContext *context, const ARSettings *settings);

   virtual void beginQuery(float32 time);

   virtual Vector3f getPosition(const ARConstraintAnchor &at);
   virtual Vector3f getVelocity(const ARConstraintAnchor &at);
   virtual Vector3f getAcceleration(const ARConstraintAnchor &at);
   virtual Matrix3f getSpatialGradient(const ARConstraintAnchor &at);

   virtual void endQuery();

   ~RWDeformationEvaluator();
};

}

#endif