//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "RWDeformationSolver.h"
//---------------------------------------------------------------------------
#include "SGEVolumeGridDeformationSequence.h"
#include "SGEPointCloud.h"
#include "BoundingBox.h"
#include "BoundingBox.inline.h"
#include "ARSettings.h"
#include "ARConstraints.h"
#include "RWDeformationContext.h"
#include "RWDeformationEvaluator.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



IMPLEMENT_X4_CLASS( RWDeformationSolver ,0)
{
	BEGIN_CLASS_INIT( RWDeformationSolver );
}

RWDeformationSolver::RWDeformationSolver()
{
	context = NULL;
	settings = NULL;
}

RWDeformationSolver::~RWDeformationSolver() {}



AROptimizationContext *RWDeformationSolver::createOptContext() {
	return new RWDeformationContext();
}

void RWDeformationSolver::setup(AROptimizationContext *context, const ARSettings *settings) {
	if (!dynamic_cast<RWDeformationContext*>(context)) {
		throw ETypeMismatch("RWDeformationSolver::setup() - context does not have the correct dynamic type.");
	}
	this->context = (RWDeformationContext*)context;
	this->settings = settings;
}



void RWDeformationSolver::beginConstraints() 
{
}


void RWDeformationSolver::addPositionConstraint(const PositionARConstraint *c)
{
   notImplemented();
}

void RWDeformationSolver::addVelocityConstraint(const VelocityVectorARConstraint *c)
{
   notImplemented();
}

void RWDeformationSolver::addInstantaneousVelocityConstraint(const InstantaneousVelocityARConstraint *c) 
{
   notImplemented();
}

void RWDeformationSolver::addHalfSpaceConstraint( const ARHalfSpaceConstraint *c )
{
   notImplemented();
}

void RWDeformationSolver::addSpatialDerivativeConstraint(const SpatialDerivativeARConstraint *c)
{
}

void RWDeformationSolver::addSimpleSpatialDerivativeConstraint(const SimpleSpatialDerivativeARConstraint *c)
{
}

void RWDeformationSolver::solve() 
{
}



void RWDeformationSolver::callCallbacks() 
{
   for (unsigned i=0; i<callbacks.size(); i++) {
      callbacks[i]();
   }
}

void RWDeformationSolver::addUserFeedbackCallback(Delegate d) {
   callbacks.push_back(d);
}

void RWDeformationSolver::clearUserFeedbackCallbacks() 
{
   callbacks.clear();
}

DeformationEvaluator *RWDeformationSolver::createEvaluator() 
{
	return new RWDeformationEvaluator();
}

