//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "TSDeformationEvaluator.h"
//---------------------------------------------------------------------------
#include "CopyObjectProperties.h"
#include "FiniteDifferencesDeformation.h"
#include "ARConstraints.h"
#include "FiniteDifferencesDeformation.h"
#include "FiniteDifferencesDeformation.inline.h"
#include "RegularVolume.h"
#include "RegularVolume.inline.h"
#include "SGEVolumeGridDeformationSequence.h"
#include "RegularInCoreVolume.h"
#include "TSDeformationEvaluator.h"
#include "TSDeformationContext.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



IMPLEMENT_X4_CLASS( TSDeformationEvaluator , 0 ) {
	BEGIN_CLASS_INIT( TSDeformationEvaluator );
}


// ----


TSDeformationEvaluator::TSDeformationEvaluator()
{
	context = NULL;
	settings = NULL;
}

TSDeformationEvaluator::~TSDeformationEvaluator()
{
}



AROptimizationContext *TSDeformationEvaluator::createOptContext() 
{
   return new TSDeformationContext;
}

void TSDeformationEvaluator::setup(AROptimizationContext *context, const ARSettings *settings) 
{
	if (!dynamic_cast<TSDeformationContext*>(context)) {
		throw ETypeMismatch("TSDeformationSolver::setup() - context does not have the correct dynamic type.");
	}
	this->context = (TSDeformationContext*)context;
	this->settings = settings;	
}

void TSDeformationEvaluator::beginQuery(float32 time) 
{
   this->time = time;
   if (this->time != time) {
      throw ERangeCheck("TSDeformationEvaluator::beginQuery() - the TS-evaluator currently supports integral time steps.");
   }
}




Vector3f TSDeformationEvaluator::getPosition(const ARConstraintAnchor &at)
{
   return context->getPosition(time, at);
}

Vector3f TSDeformationEvaluator::getVelocity(const ARConstraintAnchor &at)
{
   return NULL_VECTOR3F;
}

Vector3f TSDeformationEvaluator::getAcceleration(const ARConstraintAnchor &at)
{
   return NULL_VECTOR3F;
}

Matrix3f TSDeformationEvaluator::getSpatialGradient(const ARConstraintAnchor &at)
{
   return context->getSpatialGradient(time, at);
}


void TSDeformationEvaluator::endQuery() {}

