//---------------------------------------------------------------------------
#ifndef TSDeformationEvaluatorH
#define TSDeformationEvaluatorH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "DeformationEvaluator.h"
#include "ARConstraints.h"
//---------------------------------------------------------------------------

namespace X4 {

class RegularVolume;
class TSDeformationContext;

///   mw - 12/12/2008
///
///
///   Deformation solver that uses a 3D->3D thin plate spline energy
///   on a sparse regular grid
///
class X3DEFORMATION_API TSDeformationEvaluator : public DeformationEvaluator {
	X4_CLASS( TSDeformationEvaluator )
 private:
	TSDeformationContext *context;
	const ARSettings *settings;
	
	// --- temp
	int32 time;
	
 public:
	TSDeformationEvaluator();

	AROptimizationContext *createOptContext();
	virtual void setup(AROptimizationContext *context, const ARSettings *settings);

   virtual void beginQuery(float32 time);

   virtual Vector3f getPosition(const ARConstraintAnchor &at);
   virtual Vector3f getVelocity(const ARConstraintAnchor &at);
   virtual Vector3f getAcceleration(const ARConstraintAnchor &at);
   virtual Matrix3f getSpatialGradient(const ARConstraintAnchor &at);

   virtual void endQuery();

   ~TSDeformationEvaluator();
};

}

#endif