//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "TSSmoothDeformationEvaluator.h"
//---------------------------------------------------------------------------
#include "CopyObjectProperties.h"
#include "FiniteDifferencesDeformation.h"
#include "ARConstraints.h"
#include "FiniteDifferencesDeformation.h"
#include "FiniteDifferencesDeformation.inline.h"
#include "RegularVolume.h"
#include "RegularVolume.inline.h"
#include "SGEVolumeGridDeformationSequence.h"
#include "RegularInCoreVolume.h"
#include "TSSmoothDeformationEvaluator.h"
#include "TSDeformationContext.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



IMPLEMENT_X4_CLASS( TSSmoothDeformationEvaluator , 0 ) {
	BEGIN_CLASS_INIT( TSSmoothDeformationEvaluator );
}


// ----


TSSmoothDeformationEvaluator::TSSmoothDeformationEvaluator()
{
	context = NULL;
	settings = NULL;
}

TSSmoothDeformationEvaluator::~TSSmoothDeformationEvaluator()
{
}



AROptimizationContext *TSSmoothDeformationEvaluator::createOptContext() 
{
   return new TSDeformationContext(3);
}

void TSSmoothDeformationEvaluator::setup(AROptimizationContext *context, const ARSettings *settings) 
{
	if (!dynamic_cast<TSDeformationContext*>(context)) {
		throw ETypeMismatch("TSDeformationSolver::setup() - context does not have the correct dynamic type.");
	}
	this->context = (TSDeformationContext*)context;
	this->settings = settings;	
}

void TSSmoothDeformationEvaluator::beginQuery(float32 time) 
{
   this->time = time;
   if (this->time != time) {
      throw ERangeCheck("TSSmoothDeformationEvaluator::beginQuery() - the TS-evaluator currently supports integral time steps.");
   }
}




Vector3f TSSmoothDeformationEvaluator::getPosition(const ARConstraintAnchor &at)
{
   return context->getPositionSmoothed(time, at);
}

Vector3f TSSmoothDeformationEvaluator::getVelocity(const ARConstraintAnchor &at)
{
   return NULL_VECTOR3F;
}

Vector3f TSSmoothDeformationEvaluator::getAcceleration(const ARConstraintAnchor &at)
{
   return NULL_VECTOR3F;
}

Matrix3f TSSmoothDeformationEvaluator::getSpatialGradient(const ARConstraintAnchor &at)
{
   return context->getSpatialGradientSmoothed(time, at);
}


void TSSmoothDeformationEvaluator::endQuery() {}

