#ifndef SilhouetteImageEditorWidgetH 
#define SilhouetteImageEditorWidgetH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "SilhouetteImageEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace X4
{
class SilhouetteImage;

class X3DEFORMATION_API SilhouetteImageEditorWidget : public QWidget
{
	Q_OBJECT

private:

	SilhouetteImage	*	m_Object;
	QPixmap pm;

	///used to access buttons, etc. from QtDesigner
	Ui_SilhouetteImageEditorForm ui;

	card32 getPixelRGB(float32 v);


public:
	SilhouetteImageEditorWidget(QWidget * parent = NULL, Qt::WindowFlags f=0);
	~SilhouetteImageEditorWidget(void);

	void setup( SilhouetteImage * obj );

	/// update editor content with object data
	void updateEditor();

	void mousePressEvent(QMouseEvent* e);
/*	void mouseReleaseEvent(QMouseEvent* e);
	void mouseMoveEvent(QMouseEvent* e);
*/
	public slots:
		//void on_zoomSB_valueChanged(double val);
		void on_normalImageButton_clicked();

};

MAKE_CLASS_EDITOR( X3DEFORMATION_API , SilhouetteImage )


}

#endif