#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "BitVector8.h"
//---------------------------------------------------------------------------
// insert your includes here
//---------------------------------------------------------------------------
using namespace X4;



BitVector8::BitVector8(void)
{
	vec=0;
}




void X4::BitVector8::setBitTrue( card32 whichBit )
{
	switch(whichBit)
	{
	case 0:
		vec |= 1;
		break;
	case 1:
		vec |= 2;
		break;
	case 2:
		vec |= 4;
		break;
	case 3:
		vec |= 8;
		break;
	case 4:
		vec |= 16;
		break;
	case 5:
		vec |= 32;
		break;
	case 6:
		vec |= 64;
		break;
	case 7:
		vec |= 128;	
		break;


	default:
		{
			x4Assert(false);
		}
	}

}

bool X4::BitVector8::getBit( card32 whichBit )
{
	switch(whichBit)
	{
	case 0:
		return vec & 1;
	case 1:
		return vec & 2;
	case 2:
		return vec & 4;
	case 3:
		return vec & 8;
	case 4:
		return vec & 16;
	case 5:
		return vec & 32;
	case 6:
		return vec & 64;
	case 7:
		return vec & 128;	

	default:
		{
			x4Assert(false);
			return 0;
		}
	}


}

bool X4::BitVector8::allBitsTrue()
{
	return vec==255;
}



std::vector<card32> X4::BitVector8::getTrueBits()
{
	std::vector<card32> result;
	card8 vglBit=1;
	for (card32 i=0; i<8; i++)
	{
		if (vec&vglBit)
		{
			result.push_back(i);
		}
		vglBit<<=1;
	}
	return result;

}

X4::card32 X4::BitVector8::countTrueBits()
{
	card8 vglBit;
	card32 result=0;
	for(vglBit=0x80; vglBit!=0; vglBit>>=1) 
		if ((vglBit & vec) != 0) 
			result++;
	return result;
}

bool X4::BitVector8::allBitsFalse()
{
	return vec==0;
}

void X4::BitVector8::fromCard8( card8 init )
{
	vec=init;
}

void X4::BitVector8::setAllBitsTrue()
{
	vec=255;
}