//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "DeformationExperiments.h"
//---------------------------------------------------------------------------
#include "Linearalgebra.inline.h"
#include "Random.h"
#include "UnitTests.h"
#include "Timer.h"
//#include "fadbadTest.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------


//#include "adolc.h"
//
//static adouble testFunc(adouble x) {
//   return 3*x*x + 3*x + 5;
//}


//template <typename dtype>
//static dtype testVects(const StaticVector<dtype, 3> &pos, const StaticMatrix<dtype, 3,3 > &Q) {
//   StaticVector<dtype, 3> constant;
//   constant[0] = 1;
//   constant[1] = 2;
//   constant[2] = 3;
//   return (Q*pos)*pos + pos*constant + 5;
//}
//
//void X4::DeformationExperiments_testAutoDiff() {
//   {
//      adouble x;
//      adouble y;
//      double result;
//      trace_on(0);
//         x <<= 3.0;
//         y = testFunc(x);
//         y >>= result;
//      trace_off();
//      double grad;
//      double xpos = 3.0;
//      gradient(0, 1, &xpos, &grad);
//      debugOutput << result << " " << grad << "\n";
//   }
//   {
//      const card32 NUM_TESTS = 5000000;
//      Timer T;
//      
//      {
//         StaticMatrix<double, 3, 3> Q;
//         Q[0][0] = 1; Q[1][0] = 2; Q[2][0] = 3;
//         Q[0][1] = 2; Q[1][1] = 4; Q[2][1] = 5;
//         Q[0][2] = 4; Q[1][2] = 5; Q[2][2] = 6;
//         for (card32 i=0; i<NUM_TESTS; i++) {
//            StaticVector<double, 3> pos;
//            pos[0] = 1;
//            pos[1] = 2;
//            pos[2] = 3;
//            
//            double result = testVects<double>(pos, Q);
//            double res;
//            res = result;
//         }
//      }
//            
//      debugOutput << "time double: " << T.getDeltaValue() << "\n";
//            
//      StaticVector<adouble, 3> pos;
//      StaticMatrix<adouble, 3, 3> Q;
//      Q[0][0] = 1; Q[1][0] = 2; Q[2][0] = 3;
//      Q[0][1] = 2; Q[1][1] = 4; Q[2][1] = 5;
//      Q[0][2] = 4; Q[1][2] = 5; Q[2][2] = 6;
//      for (card32 i=0; i<NUM_TESTS/5000; i++) {
//         trace_on(0);
//         pos[0] <<= 1;
//         pos[1] <<= 2;
//         pos[2] <<= 3;
//         
//         adouble result = testVects<adouble>(pos, Q);
//         double res;
//         result >>=res;
//         trace_off();
//      }
//      
//      debugOutput << "time adouble traced: " << T.getDeltaValue()*5000 << "\n";
//
//      trace_on(0);
//      pos[0] <<= 1;
//      pos[1] <<= 2;
//      pos[2] <<= 3;
//      
//      adouble result = testVects<adouble>(pos, Q);
//      double res;
//      result >>=res;
//      trace_off();
//
//      Vector3d posv = makeVector3d(1,2,3);
//      Vector3d grad;
//      Matrix3d hessm;
//      std::vector<double*> hh(3,0);
//      hh[0] = &(hessm[0][0]);
//      hh[1] = &(hessm[1][0]);
//      hh[2] = &(hessm[2][0]);
//      gradient(0, 3, &(posv[0]), &(grad[0]));
//      debugOutput << res << " " << grad.toString() << "\n";
//      hessian(0, 3, &(posv[0]), &(hh[0]));
//      for (card32 i=0; i<3; i++) {
//         for (card32 j=0; j<3; j++) {
//            if (i>j) {
//               hessm[j][i] = hessm[i][j];
//            }
//         }
//      }
//      hessm /= 2;
//      debugOutput << hessm.toString() << "\n";
//
//      for (card32 i=0; i<NUM_TESTS/5000; i++) {
//         Vector3d posv = makeVector3d(1,2,3);
//         Vector3d grad;
//         Matrix3d hessm;
//         std::vector<double*> hh(3,0);
//         hh[0] = &(hessm[0][0]);
//         hh[1] = &(hessm[1][0]);
//         hh[2] = &(hessm[2][0]);
//         gradient(0, 3, &(posv[0]), &(grad[0]));
//         hessian(0, 3, &(posv[0]), &(hh[0]));
//         for (card32 i=0; i<3; i++) {
//            for (card32 j=0; j<3; j++) {
//               if (i>j) {
//                  hessm[j][i] = hessm[i][j];
//               }
//            }
//         }
//         hessm /= 2;
//      }
//      
//      debugOutput << "comp grad/hess: " << T.getDeltaValue()*5000 << "\n";
//   }
//}

void X4::DeformationExperiments_computeDistanceHistogram() 
{
   static const unsigned N = 10000;
   Vector2f pos[N];
   for (unsigned i=0; i<N; i++) {
      pos[i] = makeVector2f(rnd01(), rnd01());
   }
   static const unsigned BINS = 25;
   std::vector<float> histogramm(BINS+3, 0.0f);
   for (unsigned x=0; x<N; x++) {
      for (unsigned y=0; y<N; y++) {
         float32 d = norm(pos[x]-pos[y])/sqrt(2.0f);
         int i = (int)(d*BINS);
         histogramm[i]++;
      }
   }
   for (unsigned i=0; i<BINS; i++) {
      debugOutput << histogramm[i] << "\n";
   }
}


void X4::DeformationExperiments_registerExperiments() 
{
   UnitTests::addTest(DeformationExperiments_computeDistanceHistogram, "DeformationExperiments_computeDistanceHistogram");
}
