//---------------------------------------------------------------------------
#ifndef PCCRangeQueryTestH
#define PCCRangeQueryTestH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------

namespace X4 {

///
///   debug code to test and compare different range query algortihms
///
class X3DEFORMATION_API PCCRangeQueryTest : public PCCommand {
	X4_CLASS( PCCRangeQueryTest )
 private:
   std::string target;
   float32 radius;
   card32 numNeighbors;
   card32 index;
   card32 mode;
   card32 timingIterations;
   card32 numOctreePoints;
   float32 cellSizeFactor;
   card32 vectorPreReserve;
   
   void octreeParameterRun();
   void rangeParameterRun();
   void clean();
   
 public:
	PCCRangeQueryTest();

   virtual void execute(Scene *scene);

   ~PCCRangeQueryTest();
};

}

#endif