//---------------------------------------------------------------------------
#ifndef SurfelOptEvaluatorH
#define SurfelOptEvaluatorH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "ShapeEvaluator.h"
//---------------------------------------------------------------------------

namespace X4 {

class SurfelOptimizationContext;
class ARSettings;


///
///   this class evaluates the reconstructions computed with the SurfelOptimizer
///
class X3DEFORMATION_API SurfelOptEvaluator : public ShapeEvaluator {
	X4_CLASS( SurfelOptEvaluator )
 private:
   SurfelOptimizationContext *context;
   const ARSettings *settings;
   
 public:
	SurfelOptEvaluator();

   /// not used in evaluator
	virtual AROptimizationContext *createOptContext();
	/// bind context and settings
	virtual void setup(AROptimizationContext *context, const ARSettings *settings);
   /// compute reconstruction, return a copy with the result
   virtual PointCloud *evaluate();

   ~SurfelOptEvaluator();
};

}

#endif