//---------------------------------------------------------------------------
#ifndef SurfelOptimizationContextH
#define SurfelOptimizationContextH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "ARShapeOptimizationContext.h"
#include "SGESurfelGraph.h"
//---------------------------------------------------------------------------

namespace X4 {

class ARSettings;

/// 
///
///  TODO: write desription
///
class X3DEFORMATION_API SurfelOptimizationContext : public ARShapeOptimizationContext 
{
	X4_ABSTRACT_CLASS( SurfelOptimizationContext )

	private:
		PointSet* surfels;
		InCorePCTopologyGraph* topologyGraph;

	public:
		SurfelOptimizationContext();
		~SurfelOptimizationContext();

		/// initializes the shape optimization data structures from a candidate shape
		void initializeFromShape( SceneObject *obj, const ARSettings *params );

		inline PointSet* getSurfels(){ return surfels; }
		inline InCorePCTopologyGraph* getTopologyGraph(){ return topologyGraph; }

   
};

}

#endif