#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "DebugAnimationTools.h"
//---------------------------------------------------------------------------
#include "FeatureCorrespondence.h"
#include "GeometricFeature.h"
#include "RenderingTool.h"
//---------------------------------------------------------------------------
using namespace X4;


void X4::drawCorrespondenceSet( FeatureCorrespondenceSet * set, const Matrix4f &frame1, const Matrix4f &frame2 )
{
	glPushAttrib(GL_ALL_ATTRIB_BITS);
	glEnable( GL_DEPTH_TEST );
	glDepthMask(0);
	glEnable(GL_BLEND);
	glBlendFunc( GL_ONE, GL_ONE );

	glBegin(GL_LINES);
	for( unsigned i=0;i<set->m_Correspondences.size();i++ )
	{
		FeatureCorrespondence * fc = set->m_Correspondences[i];
		Vector3f p1 = shrink4To3( frame1 * expand3To4(fc->m_FeaturePoint[0]));
		Vector3f p2 = shrink4To3( frame2 * expand3To4(fc->m_FeaturePoint[1]));

		glColor3f(0.05f,0.2f,0.6f);
		glVertex3fv( p1.data());
		glVertex3fv( p2.data());
	}
	glEnd();
		
	glDepthMask(1);
	glPopAttrib();
}

void X4::drawFeatureSet( FeatureSet * set, const Matrix4f &frame, float size, RenderingTool * rt )
{
	glPushAttrib(GL_ALL_ATTRIB_BITS);
	glEnable( GL_DEPTH_TEST) ;
	glPushMatrix();
	glMultMatrixf(frame.data());

	glLineWidth(2.0f);
	glBegin( GL_LINES );
	glColor3f(1,0,0);

	for( unsigned i=0;i<set->m_Features.size();i++ )
	{
	/*	Vector3f tmp = set->m_Features[i]->m_Position + set->m_Features[i]->m_Normal * size;
		glVertex3fv( tmp.data());
		tmp = set->m_Features[i]->m_Position - set->m_Features[i]->m_Normal * size;
		glVertex3fv( tmp.data());*/
		rt->renderSphere(shrink4To3(frame*expand3To4(set->m_Features[i]->m_Position)),size);
	}
	glEnd();

	glPopMatrix();
	glPopAttrib();	
}