//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "SGDeformationNodeAR.h"
//---------------------------------------------------------------------------
#include "CopyObjectProperties.h"
#include "ARDeformationOptimizationContext.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



IMPLEMENT_X4_CLASS( SGDeformationNodeAR , 0 ) {
	BEGIN_CLASS_INIT( SGDeformationNodeAR );
   ADD_OBJECT_PROP(deformation, 0, ARDeformationOptimizationContext::getClass(), true)
}

// ----

SGDeformationNodeAR::SGDeformationNodeAR() {
   deformation = NULL;
}

SGDeformationNodeAR::~SGDeformationNodeAR() {
   delete deformation;
}

// ---

void SGDeformationNodeAR::setDeformation(ARDeformationOptimizationContext *v) {
   delete deformation; 
   deformation = v;
}

void SGDeformationNodeAR::removeDeformation() {
	deformation = NULL;
}

SGStateChanger *SGDeformationNodeAR::getNodeEntryStateChange(const SceneGraphState *state) {
   forget(state);
   return NULL;
}

max_platform_card SGDeformationNodeAR::getNumChildNodes(const SceneGraphState *state) const {
   forget(state);
   return 0;
}

SceneGraphNode *SGDeformationNodeAR::getChildNode(const SceneGraphState *state, max_platform_card i) {
   forget(state);
   forget(i);
   x4Assert(false);
   return NULL;
}

void SGDeformationNodeAR::removeChildNode(std::string name) {
   forget(name);
   x4Assert(false);
}

bool SGDeformationNodeAR::canAddChildNode() {
   return false;
}

bool SGDeformationNodeAR::addChildNode(SceneGraphNode *node) {
   forget(node);
   return false;
}
