//---------------------------------------------------------------------------
#ifndef SGDeformationNodeARH
#define SGDeformationNodeARH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "SceneGraphNode.h"
//---------------------------------------------------------------------------

namespace X4 {

class ARDeformationOptimizationContext;

///
///   this class just stores a ARDeformationOptimizationContext (to be able to directly put it into the scene graph)
///
class X3DEFORMATION_API SGDeformationNodeAR : public SceneGraphNode {
	X4_CLASS( SGDeformationNodeAR )
 private:
   ARDeformationOptimizationContext *deformation;
   
 public:
	SGDeformationNodeAR();

	ARDeformationOptimizationContext *getDeformation() const {return deformation;}
	/// ownership transferred to this node
	void setDeformation(ARDeformationOptimizationContext *v);
   /// sets deformation to NULL without deleting
	void removeDeformation();

   // --- inherited stuff (trivial behaviour)
   virtual SGStateChanger *getNodeEntryStateChange(const SceneGraphState *state);
   virtual max_platform_card getNumChildNodes(const SceneGraphState *state) const;
   virtual SceneGraphNode *getChildNode(const SceneGraphState *state, max_platform_card i);
   virtual void removeChildNode(std::string name);
   virtual bool canAddChildNode();
   virtual bool addChildNode(SceneGraphNode *node);

   ~SGDeformationNodeAR();
};

}

#endif