//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "SGEDeformationSequence.h"
//---------------------------------------------------------------------------
#include "CopyObjectProperties.h"
#include "SGListNode.h"
#include "SGObjectNode.h"
#include "SceneObject.h"
#include "StringHelper.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



IMPLEMENT_X4_CLASS( SGEDeformationSequence , 0 ) {
	BEGIN_CLASS_INIT( SGEDeformationSequence );
}

// ----

SGEDeformationSequence::SGEDeformationSequence() {
}

SGEDeformationSequence::~SGEDeformationSequence() {
}




bool SGEDeformationSequence::check(std::string &msg) const
{
	if (!SceneGraphEntity::check(msg)) return false;
	SceneGraphNode *node = getSceneGraphNode();
	SGListNode *list = dynamic_cast<SGListNode*>(node);
	if (!list) {
		msg = "path does not point to a list node (which is required for a deformation sequence)";
		return false;
	}
   mpcard n = list->getNumChildNodes(NULL);
   for (mpcard i=0; i<n; i++) {
		SceneGraphNode *node = list->getChildNode(NULL, i);
		if (node == NULL) {
			msg = std::string("list contains a NULL node; node index: ") + intToStr(i);
			return false;
		}
		SGObjectNode *on = dynamic_cast<SGObjectNode*>(node);
		if (!on) {
			msg = std::string("list contains a node that is not an SGObjectNode; node index: ") + intToStr(i);
			return false;
		}
		SceneObject *so = on->getSceneObject();
		if (!so) {
			msg = std::string("scene object is NULL in one of the SGObjectNodes in the list; node index: ") + intToStr(i);
			return false;
		}
	}
	return true;	
}

mpcard SGEDeformationSequence::getNumFrames() const {
   SGListNode *list = dynamic_cast<SGListNode*>(getSceneGraphNode());
   if (!list) {
      throw EInvalidState("SGEDeformationSequence::getSceneObject() - referenced node is not a list node.");
   }
   return list->getNumChildNodes(NULL);
}

