//---------------------------------------------------------------------------
#ifndef SGEVolumeGridDeformationSequenceH
#define SGEVolumeGridDeformationSequenceH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "SGEDeformationSequence.h"
//---------------------------------------------------------------------------

namespace X4 {

///   ba - 11/23/2007
///
///   Deformation sequence stored at meshless nodes
///
class X3DEFORMATION_API SGEMeshlessDeformationSequence : public SGEDeformationSequence {
	X4_CLASS( SGEMeshlessDeformationSequence )
 private:
   VertexDescriptor *deformationChannels;
   
 public:
	SGEMeshlessDeformationSequence();
	
	/// transfers ownership
	void setDescriptor(VertexDescriptor *vd);
    /// transfers ownership
   const VertexDescriptor *getDescriptor() const;

   virtual bool check(std::string &msg) const;
   SceneObject *getSceneObject(mpcard frame) const;
   UnstructuredInCorePointCloud *getDeformedNodePositions(mpcard frame) const;
   virtual SceneObjectIterator *createIterator(mpcard frame, SceneObjectIteratorType type) const;

   ~SGEMeshlessDeformationSequence();
};

}

#endif