//---------------------------------------------------------------------------
#ifndef SGEPointCloudH
#define SGEPointCloudH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "SGEShape.h"
//---------------------------------------------------------------------------

namespace X4 {

///
///   scene graph adaptor class for point clouds
///
class X3DEFORMATION_API SGEPointCloud : public SGEShape {
	X4_CLASS( SGEPointCloud )
 private:
    /// attribute channels the points in th point cloud are expected to have
    VertexDescriptor *pointChannels;

 public:
	SGEPointCloud();
	
	const VertexDescriptor *getPointChannels() const;
   void setPointChannels(VertexDescriptor *cn);

   virtual bool check(std::string &msg) const;

   /// get point cloud object
   PointCloud *getPointCloud() const;

   ~SGEPointCloud();
};

}

#endif