//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "SGERigidDeformationSequence.h"
//---------------------------------------------------------------------------
#include "SGListNode.h"
#include "SGTransformationNode.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



IMPLEMENT_X4_CLASS( SGERigidDeformationSequence , 0 ) {
	BEGIN_CLASS_INIT( SGERigidDeformationSequence );
}

// ----

SGERigidDeformationSequence::SGERigidDeformationSequence() {
}

SGERigidDeformationSequence::~SGERigidDeformationSequence() {
}




bool SGERigidDeformationSequence::check(std::string &msg) const 
{
	if (!SGEDeformationSequence::check(msg)) {
		return false;
	} else {
		SGListNode *list = dynamic_cast<SGListNode*>(getSceneGraphNode());
		if (!list) {
			msg = "path must point to a list node";
			return false;
		}
		for (card32 i=0; i<list->getNumChildNodes(NULL); i++) {
			SGTransformationNode *tn = dynamic_cast<SGTransformationNode*>(list->getChildNode(NULL, i));
			if (!tn) {
				msg = "list must contain transformation nodes only";
				return false;
			}
		}						 		
	}
	return true;
}

mpcard SGERigidDeformationSequence::getNumFrames() const 
{
	SGListNode *list = dynamic_cast<SGListNode*>(getSceneGraphNode());
	if (!list) {
		throw X4Exception("path must point to a list node");
	}
	return list->getNumChildNodes(NULL);
}

SGTransformationNode *SGERigidDeformationSequence::getTransformationNode(mpcard frame) 
{
	SGListNode *list = dynamic_cast<SGListNode*>(getSceneGraphNode());
	if (!list) {
		throw X4Exception("SGERigidDeformationSequence::getTransformationNode() - path must point to a list node");
	}
	SGTransformationNode *tn = dynamic_cast<SGTransformationNode*>(list->getChildNode(NULL, frame));
	if (!tn) {
   	throw X4Exception("SGERigidDeformationSequence::getTransformationNode() - transformation node not found.");
	}
	return tn;
}

Matrix4f SGERigidDeformationSequence::getTransformation(mpcard frame) 
{
   return getTransformationNode(frame)->getTransformation();
}
