//---------------------------------------------------------------------------
#ifndef SGERigidDeformationSequenceH
#define SGERigidDeformationSequenceH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "SGEDeformationSequence.h"
#include "LinearAlgebra.h"
//---------------------------------------------------------------------------

namespace X4 {

class SGTransformationNode;

///
///   scene graph storage for rigid deformation sequences
///
class X3DEFORMATION_API SGERigidDeformationSequence : public SGEDeformationSequence {
	X4_CLASS( SGERigidDeformationSequence )
 private:

 public:
	SGERigidDeformationSequence();

	virtual bool check(std::string &msg) const;

   virtual mpcard getNumFrames() const;
   
   virtual SGTransformationNode *getTransformationNode(mpcard frame);
   virtual Matrix4f getTransformation(mpcard frame);
   


   ~SGERigidDeformationSequence();
};

}

#endif