//---------------------------------------------------------------------------
#ifndef SGEShapeH
#define SGEShapeH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "SceneGraphEntity.h"
//---------------------------------------------------------------------------

namespace X4 {

///   mw - 09/27/2007
///
///   encapsulates scene graph representation of (ur-)shapes
///
///   additional assumptions:
///     - path points to a single SGObjectNode
///     - the scene object stored in this node is not NULL
class X3DEFORMATION_API SGEShape : public SceneGraphEntity {
	X4_CLASS( SGEShape )
 public:
	SGEShape();

	virtual bool check(std::string &msg) const;
	/// also includes transformation of SceneObject
	virtual Matrix4f getBaseTransform() const;

	/// get the scene object (i.e. the actual point cloud, mesh, volume or whatever)
	virtual SceneObject *getSceneObject() const;
	/// create an iterator to access the data
   virtual SceneObjectIterator *createIterator(SceneObjectIteratorType type) const;

   ~SGEShape();
};

}

#endif