//---------------------------------------------------------------------------
#ifndef SGEVolumeGridDeformationSequenceH
#define SGEVolumeGridDeformationSequenceH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "SGEDeformationSequence.h"
//---------------------------------------------------------------------------

namespace X4 {

class RegularInCoreVolume;

///   mw - 10/11/2007
///
///   Deformation sequence stored in voxel grids. 
///   Used in FDSolver to represent the deformation.
///
class X3DEFORMATION_API SGEVolumeGridDeformationSequence : public SGEDeformationSequence {
	X4_CLASS( SGEVolumeGridDeformationSequence )
 private:
   VertexDescriptor *volumeChannels;
   
 public:
	SGEVolumeGridDeformationSequence();
	
	/// transfers ownership
	void setDescriptor(VertexDescriptor *vd);
   /// transfers ownership
   const VertexDescriptor *getDescriptor() const;

   virtual bool check(std::string &msg) const;
   SceneObject *getSceneObject(mpcard frame) const;
   RegularInCoreVolume *getRegularInCoreVolume(mpcard frame) const;
   virtual SceneObjectIterator *createIterator(mpcard frame, SceneObjectIteratorType type) const;

   ~SGEVolumeGridDeformationSequence();
};

}

#endif