//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "SceneGraphEntity.h"
//---------------------------------------------------------------------------
#include "CopyObjectProperties.h"
#include "PointCloudTools.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



IMPLEMENT_X4_CLASS( SceneGraphEntity , 0 ) {
	BEGIN_CLASS_INIT( SceneGraphEntity );
	ADD_OBJECT_PROP(scene, 0, Scene::getClass(), false)
	ADD_STRING_PROP(path, 0)
}

// ----

SceneGraphEntity::SceneGraphEntity() {
}

void SceneGraphEntity::assign(const Object* obj, X4CopyContext *context) {
	copyObjectProperties(obj, this);
}

SceneGraphEntity::~SceneGraphEntity() {
}


// ----


Matrix4f SceneGraphEntity::getBaseTransform() const
{
	Matrix4f result;
	SceneGraphNode *node;
   getSGNodeTransformation(scene, path, result, node);
   if (node == NULL) {
		throw EInvalidState("SceneGraphEntity::getBaseTransform() - node not found. call check first to verify the SGE.");
   }
   return result;
}

bool SceneGraphEntity::check(std::string &msg) const
{
	Matrix4f result;
	SceneGraphNode *node;
   getSGNodeTransformation(scene, path, result, node);
   if (node == NULL) {
		msg = "node (path) not found in scene graph";
		return false;
   }
   return true;
}

void SceneGraphEntity::setup(Scene *s, std::string p)
{
	scene = s;
	path = p;
}

SceneGraphNode *SceneGraphEntity::getSceneGraphNode() const
{
	Matrix4f forget;
	SceneGraphNode *node;
   getSGNodeTransformation(scene, path, forget, node);
   if (node == NULL) {
		throw EInvalidState("SceneGraphEntity::getSceneGraphNode() - node (path) not found in scene graph.");
   }
	return node;
}
