//---------------------------------------------------------------------------
#ifndef ARInitOneFrameSequenceH
#define ARInitOneFrameSequenceH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace X4 {

class PointCloud;
class ShapeReconstruction;
class ARSettings;
class ARSequence;


///
///   This class creates animation sequences that contain only one frame
///   (i.e. an urshape and an identity deformation)
///
class X3DEFORMATION_API ARInitOneFrameSequence : public Persistent {
	X4_CLASS( ARInitOneFrameSequence )
 private:

 public:
	ARInitOneFrameSequence();

	virtual void assign(const Object* obj, X4CopyContext *context = NULL);

	ARSequence *createSequence(PointCloud *pc, ShapeReconstruction *reconstructor, ARSettings *settings);

   ~ARInitOneFrameSequence();
};

}

#endif