//---------------------------------------------------------------------------
#ifndef ARChangeUrshapeH
#define ARChangeUrshapeH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace X4 {

class ARDeformationOptimizationContext;
class PointCloud;
class DeformationSolver;
class ARSettings;


///
///   recomputes a new deformation sequence for a new urshape
///   which might have changed its sampling and its shape slightly 
///
class X3DEFORMATION_API ARChangeUrshape {
 public:
   static ARDeformationOptimizationContext *recomputeDeformation(
      PointCloud *newUrshape,
	   PointCloud *oldUrshape,								// added by pj
      /// needs to be bound to old urshape
      ARDeformationOptimizationContext *deformation,
      DeformationSolver *solver,
      ARSettings *settings
   );
};

}

#endif