//---------------------------------------------------------------------------
#ifndef ARConstraintsSourceH
#define ARConstraintsSourceH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------

namespace X4 {

class ARConstraintsInterface;
class ARTimeVariantConstraintsInterface;

///
///   this interface creates constraints from data
///
class X3DEFORMATION_API ARConstraintsSource {
 public:
   /// creates non-time dependent constraints only (if applicable, otherwise nothing happens)
   virtual void createConstraints(ARConstraintsInterface *receiver) = 0;
   /// creates all the rest (if applicable, otherwise nothing happens)
   virtual void createTimeDependentConstraints(ARTimeVariantConstraintsInterface *receiver) = 0;
   virtual ~ARConstraintsSource() {}
};

}

#endif