//---------------------------------------------------------------------------
#ifndef ARGlobalDeformationOptimizationH
#define ARGlobalDeformationOptimizationH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "AROptToolWithFeedback.h"
//---------------------------------------------------------------------------

namespace X4 {

class ARVisualizationSettings;
class ARSequence;
class ARSettings;
class DeformationSolver;
class ARPruneUnsupportedOutliers;


///
///   This class refits a given deformation function to data for many frames simultaneously
///
class X3DEFORMATION_API ARGlobalDeformationOptimization : public AROptToolWithFeedback {
 public:
	ARGlobalDeformationOptimization();
	virtual void glDrawFeedback(GLContext *glContext, ARVisualizationSettings *visSettings);	
	
	void globalOpt(
	   /// sequence to be optimized
	   ARSequence *seq, 
	   /// deformation optimizer
	   DeformationSolver *deformOpt, 
      /// input data points
      const std::vector<PointCloud*> &dataPoints,
      /// parameters
	   ARSettings *settings,
	   /// set this parameter to a non null pointer to count pts with little data support
	   ARPruneUnsupportedOutliers *unsupportedPtsCulling = NULL
	);
};

}

#endif