//---------------------------------------------------------------------------
#ifndef ARPruneUnsupportedOutliersH
#define ARPruneUnsupportedOutliersH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "X4Types.h"
//---------------------------------------------------------------------------
#include <vector>
//---------------------------------------------------------------------------

namespace X4 {
class ARSettings;

///
///   This class provides functionality to throw away points that have only very limited support by actual data points
///
class X3DEFORMATION_API ARPruneUnsupportedOutliers {
 private:
   const ARSettings *settings;
   card32 numFrames;
   std::vector<card32> numSupportedFrames;
   // later --- std::vector<bool> lastFrameSupported;
   //std::vector<card32> lastFrameNumConsSupp;
   //std::vector<card32> maxConsecutive;
   
 public:
   static void resetCounters(PointCloud *pc);

   ARPruneUnsupportedOutliers(const ARSettings *settings, card32 numFrames);
   void addNextFrame(PointCloud *pc);
   void getResult(std::vector<bool> &result);
};

}

#endif