//---------------------------------------------------------------------------
#ifndef ARSurfaceDeformationH
#define ARSurfaceDeformationH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
#include "Delegate.h"
//---------------------------------------------------------------------------

namespace X4 {

class ARDeformationOptimizationContext;
class DeformationSolver;
class PointCloud;
class ARConstraintsSource;
class ARSettings;

///
///   This class deforms a piece of surface according to given constraints.
///   Typically, the constraints are created from a second surface, leading to 
///   an ICP algorithm. Depending on the solver and its parameters, deformable
///   and rigid ICP can be implemented.
///
class X3DEFORMATION_API ARSurfaceDeformation {
 public:
	static ARDeformationOptimizationContext *deformOpt(
	   /// point cloud with topology to be deformed
	   PointCloud *shape,
	   /// deformation solver to be employed
	   DeformationSolver *solver,
	   /// constraints
	   ARConstraintsSource *constraints,
	   /// parameters
	   const ARSettings *settings,
	   /// user feedback (if necessary)
	   Delegate feedback = NULL
	);
};

}

#endif