//---------------------------------------------------------------------------
#ifndef ARTransfConstraintsToUrshapeH
#define ARTransfConstraintsToUrshapeH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "ARConstraintsInterface.h"
//---------------------------------------------------------------------------

namespace X4 {

class DeformationEvaluator;


///
///   adaptor class that transforms constraints into urshape domain (from deformed domain)
///
class X3DEFORMATION_API ARTransfConstraintsToUrshape : public ARConstraintsInterface {
 private:
   DeformationEvaluator *evaluator;
   ARConstraintsInterface *receiver;
   
 public:
   ARTransfConstraintsToUrshape(
      DeformationEvaluator *evaluator,
      ARConstraintsInterface *receiver
   );
	
	virtual void addGeneralConstraint(const GeneralARConstraint *c);
   virtual void addPositionConstraint(const PositionARConstraint *c);
	virtual void addHalfSpaceConstraint(const ARHalfSpaceConstraint *c);
	virtual void addSpatialDerivativeConstraint(const SpatialDerivativeARConstraint *c);
	virtual void addSimpleSpatialDerivativeConstraint(const SimpleSpatialDerivativeARConstraint *c);
};

}

#endif