//---------------------------------------------------------------------------
#ifndef ARUrshapeDeformationOptH
#define ARUrshapeDeformationOptH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "AROptToolWithFeedback.h"
//---------------------------------------------------------------------------
#include <vector>
//---------------------------------------------------------------------------


namespace X4 {
class ARSequence;
class PointCloud;
class DeformationSolver;
class ARSettings;

///
///   optimizes the urshape by deforming it, minimizing the residuals of the matches in the frames
///
class X3DEFORMATION_API ARUrshapeDeformationOpt : public AROptToolWithFeedback {
 public:
	ARUrshapeDeformationOpt();

	virtual void glDrawFeedback(GLContext *glContext, ARVisualizationSettings *visSettings);	

	PointCloud *optimizeUrshape(
	   /// sequence to be optimized
	   ARSequence *seq, 
	   /// shape optimizer
	   DeformationSolver *deformationSolver,
      /// input data points
      const std::vector<PointCloud*> &dataPoints,
      /// parameters
	   ARSettings *settings
   );

   ~ARUrshapeDeformationOpt();
};

}

#endif