//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "ARDataConstraintsSettings.h"
//---------------------------------------------------------------------------
#include "CopyObjectProperties.h"
#include "SeparatorClassProperty.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



IMPLEMENT_X4_CLASS( ARDataConstraintsSettings , 0 ) {
	BEGIN_CLASS_INIT( ARDataConstraintsSettings );
	ADD_SEPARATOR("geometry matching")
	ADD_BOOLEAN_PROP(useGeometry, 0)
	//ADD_STRING_VAR_ARRAY_PROP(geometryDataPaths, 0)
	ADD_SEPARATOR("feature matching")
	ADD_BOOLEAN_PROP(useFeatures, 0)
	ADD_STRING_VAR_ARRAY_PROP(featureCorrPaths, 0)
	ADD_SEPARATOR("photometric matching")
	ADD_BOOLEAN_PROP(usePhotoConsistency, 0)
	ADD_BOOLEAN_PROP(useOpticalFlow, 0)
	ADD_STRING_VAR_ARRAY_PROP(imageDataPaths, 0)
	ADD_SEPARATOR("silhouette constraints")
	ADD_BOOLEAN_PROP(useSilhouettes, 0)
	ADD_STRING_VAR_ARRAY_PROP(depthImagesPaths, 0)	
}

// ----

ARDataConstraintsSettings::ARDataConstraintsSettings() {
	useGeometry = true;
	//geometryDataPaths.push_back("root/data");

	useFeatures = false;
	featureCorrPaths.push_back("root/correspondences");

	usePhotoConsistency = false;
	useOpticalFlow = false;
	imageDataPaths.push_back("root/images0");
	imageDataPaths.push_back("root/images1");
	imageDataPaths.push_back("root/images2");
	imageDataPaths.push_back("root/images3");
	imageDataPaths.push_back("root/images4");
	imageDataPaths.push_back("root/images5");
	imageDataPaths.push_back("root/images6");
	imageDataPaths.push_back("root/images7");

	useSilhouettes = false;
	depthImagesPaths.push_back("root/images0");
	depthImagesPaths.push_back("root/images1");
	depthImagesPaths.push_back("root/images2");
	depthImagesPaths.push_back("root/images3");
	depthImagesPaths.push_back("root/images4");
	depthImagesPaths.push_back("root/images5");
	depthImagesPaths.push_back("root/images6");
	depthImagesPaths.push_back("root/images7");
}

void ARDataConstraintsSettings::setPresets(ARDefaultSettings::DataType presets) {
	// ...
}

void ARDataConstraintsSettings::assign(const Object* obj, X4CopyContext *context) {
	copyObjectProperties(obj, this);
}

ARDataConstraintsSettings::~ARDataConstraintsSettings() {
}



