//---------------------------------------------------------------------------
#ifndef PCCBoundaryDetector_H
#define PCCBoundaryDetector_H
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------


namespace X4 {


/// Detects boundary points and marks then in a channel
class X3DEFORMATION_API PCCBoundaryDetector : public PCCommand {
	X4_CLASS( PCCBoundaryDetector )
 private:
   card32 numNeighbors;
   float32 sigmaRel;
   float32 quantizeThreshold;

   bool quantize;
   bool boundaryTangents;

	// -- attribute boundaries

	/// find boundaries where attribute values change (instead of position boundaries)
	bool attributeBoundaries;
	/// only used if attribute mode is selected
	string boundaryChannel;

	// -- additional output
	bool createBoundaryPC;
	string boundaryPCName;
	float32 normalOffset;

   
 public:
	PCCBoundaryDetector();
	virtual void assign(const Object* obj, X4CopyContext *context = NULL);
   virtual void execute(Scene *scene);
   void detectBoundaries(PointCloud *pc, float32 sr = 1, float32 qt = 0.75, card32 nn = 20);
	~PCCBoundaryDetector();
};


}

#endif
