//---------------------------------------------------------------------------
#ifndef PCCTopologicalResampling_H
#define PCCTopologicalResampling_H
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------


namespace X4 {


/// resamples geometry and topology
class X3DEFORMATION_API PCCTopologicalResampling : public PCCommand {
	X4_CLASS( PCCTopologicalResampling )
 private:
   /// new sample spacing
   float32 sampleSpacing;
   /// relative radius (x maxDist) for new topology graph
   float32 relMaxConnectSpacing;
   /// maximum number of nearest neighbors for new topology graph
   card32 maxNumNeighbours;
 
 public:
	PCCTopologicalResampling();
	virtual void assign(const Object* obj, X4CopyContext *context = NULL);
	virtual void execute(Scene *scene);
	~PCCTopologicalResampling();
};


}

#endif
