#ifndef CameraParameterAttachmentH
#define CameraParameterAttachmentH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "AttachedData.h"
//---------------------------------------------------------------------------

namespace X4
{

/**
	plz comment your class
*/
class X3DEFORMATION_API CameraParameterAttachment : public AttachedData
{
	X4_CLASS( CameraParameterAttachment )

private:

	Matrix3f intrinsicMatrix;
	Matrix3f rotationMatrix;
	Vector3f translationVector;
	Matrix4f projectionMatrix;

public:
	CameraParameterAttachment(void);
	CameraParameterAttachment(Matrix3f intrinsicM,Matrix3f rotationM,	Vector3f translationV,Matrix4f projectionM);
	~CameraParameterAttachment(void);

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

	/// default container name
	static std::string getAttachmentName() {return "CameraParameterAttachment";}

	/// projects a point given in world coordinates onto the image
	Vector2f projectWorldtoImage(const Vector3f xyz);

	/// projects a points given in image coodinates into world coordinates
	Vector3f projectImageToWorld(const Vector3f &uvz);

};

}

#endif
