//---------------------------------------------------------------------------
#ifndef PCCDeformationH
#define PCCDeformationH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------

namespace X4 {

class DeformationSolver;
class DeformationEvaluator;
class ARSettings;

///
///   This class performs interactive deformations of objects
///   The class is meant to be a test-ui for deformation solvers
///
class X3DEFORMATION_API PCCDeformation : public PCCommand {
	X4_CLASS( PCCDeformation )
 private:
   std::string sourceNode;
   std::string targetNode;
   std::string constraintsNode;
   std::string deformationStorageNode_deprecated;
   bool transformNormals;
   ARSettings *settings;
   DeformationSolver *solver;
   DeformationEvaluator *evaluator_deprecated;
   	std::string matrixName;
	std::string bVecName; 

   // quick hack for debugging
   bool useExampleConstraints;

  public:     
   void initializeNodesFromSource();
   void clearAndInitFromSource();
   void executeWithExampleConstraints();
   void testTSSolver();
   void tuneSparseMatrixSolver();
   

	PCCDeformation();

	virtual void assign(const Object* obj, X4CopyContext *context = NULL);
	virtual void execute(Scene *scene);

   ~PCCDeformation();

   void setSourceNode( std::string name ) { sourceNode = name; }
};

}

#endif