//---------------------------------------------------------------------------
#ifndef PCCSetErrorQuadricsH
#define PCCSetErrorQuadricsH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------

namespace X4 {

	class SGListNode;

///
///   This class initializes the error quadric channel in data points
///
class X3DEFORMATION_API PCCSetErrorQuadrics : public PCCommand {
	X4_CLASS( PCCSetErrorQuadrics )

 public:
	PCCSetErrorQuadrics();

	virtual void assign(const Object* obj, X4CopyContext *context = NULL);
	virtual void execute(Scene *scene);

	float computeMedianPointDistance(SGListNode* node);

   ~PCCSetErrorQuadrics();

private:

	std::string		m_Path;
	Matrix3f		m_Quadric;
	bool			m_Rescale;		// compute median point distance medDist and scale quadrics with medDist
	bool			m_UseOldQuadric;
	float32		m_GlobalScale;	// all quadrics are scaled with globalScale (always)
	card32		m_NumRandomSamplesPerFrame;	// for median estimation
};

}

#endif