#ifndef PCIVisionConstraintsH
#define PCIVisionConstraintsH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "PCInteractionTool.h"
#include "CameraParameterAttachment.h"
//---------------------------------------------------------------------------

namespace X4
{
	class DepthImageHalfSpaceConstraintCreator;
/**
	plz comment your class
*/
class X3DEFORMATION_API PCIVisionConstraints : public PCInteractionTool
{
	X4_CLASS( PCIVisionConstraints )

private:
	
	//prop
	float32 m_depthTolerance;
	card32  m_volumeGridRes;
	card32  m_minCamShadowVote;

	
	//tmp
	PointSet* picturePointset;
	CameraParameterAttachment * camAtt;
		DepthImageHalfSpaceConstraintCreator* constrCreator;
	AAT DEPTH;


public:
	PCIVisionConstraints(void);
	~PCIVisionConstraints(void);

	void testShadowVolume();
	void testDepthImage();
	void testHSConstraints();

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

	virtual void keyDown(GeneralKey key) {}
	virtual void keyUp(GeneralKey key) {}

	virtual void mouseDown(int32 x, int32 y, MouseButtons buttonsState, Modifiers modifiersState){}
	virtual void mouseMoved(int32 x, int32 y) {}
	virtual void mouseUp(int32 x, int32 y, MouseButtons buttonsState, Modifiers modifiersState) {}
	virtual void areaResize(card32 width, card32 height) {}

	virtual void glDrawTool(GLContext *glContext);

};

}

#endif