//---------------------------------------------------------------------------
#ifndef VarianceHandle3DH
#define VarianceHandle3DH
//---------------------------------------------------------------------------
#include "x3deformation.h"
//---------------------------------------------------------------------------
#include "Handle3D.h"
//---------------------------------------------------------------------------

namespace X4 {

///   mw - sept 28 2007
///
///   Handle3D that can also display variance attributes as spheres
///
class X3DEFORMATION_API VarianceHandle3D : public Handle3D {
	X4_CLASS( VarianceHandle3D )
 private:
	std::vector<Line> varEntries;

 protected:
	/// uses line data type, but displays a sphere (same data structure)
	void addVarianceHandle(Line varHandle);

	static const Vector4f VARIANCE_HANDLE_COL;

 public:
	VarianceHandle3D();

	virtual void glDraw(GLContext *glContext);
	
	static VarianceHandle3D *makeVectorHandle(const Vector3f &initialPos1, const Vector3f &initialPos2, const float32 initialVariance);
	static VarianceHandle3D *makeGradHandle(const Vector3f &initialPos, const Matrix3f &initialGrad, 
														 const Vector3f &initialVariances);

   ~VarianceHandle3D();
};

}

#endif