SET_MODULE_TYPE_LOADABLE_MODULE
// modules that the new module is based on. expand as required.
ADD_DEPENDENCY("opencv")
ADD_DEPENDENCY("x4basics")
ADD_DEPENDENCY("x4core")
ADD_DEPENDENCY("x4interface")
ADD_DEPENDENCY("x4math")
ADD_DEPENDENCY("x4miscFoundation")
ADD_DEPENDENCY("x4tools")
ADD_DEPENDENCY("x4modules")
ADD_DEPENDENCY("x3geometry")
ADD_DEPENDENCY("x3openGL")
ADD_DEPENDENCY("x3sceneGraph")
ADD_DEPENDENCY("x3editor")
ADD_DEPENDENCY("x3rendering")
ADD_DEPENDENCY("x3foundation_private")
ADD_DEPENDENCY("x3editor2")

// add one or more authors (repeat command for multiple authors)
ADD_AUTHOR("Michael Wand")

// add the institution holding the copyright
ADD_INSTITUITION("Universiteit Utrecht")

// BSD is the default license. Choose carefully for your new module.
ADD_LICENSE("BSD")

// an icon for this module
ADD_ICON(":/images_x3deformation/images/x3deformation.png")

// Add classes here: format is "class", "baseClass". class.h is included
// ADD_CLASS("SomeNewClass", "Persistent")

// Alternative: specify file to include for this declaration
// ADD_CLASS_INC("SomeNewClass", "Persistent", "AHeaderWithManyClasses.h")

ADD_CLASS_INC("ARConstraintAnchor", "Persistent", "ARConstraints.h")
ADD_CLASS_INC("GeneralARConstraint", "Persistent", "ARConstraints.h")
    ADD_CLASS_INC("VectorValuedARConstraint", "GeneralARConstraint", "ARConstraints.h")
        ADD_CLASS_INC("PositionARConstraint", "VectorValuedARConstraint", "ARConstraints.h")
        ADD_CLASS_INC("VelocityVectorARConstraint", "VectorValuedARConstraint", "ARConstraints.h")
        ADD_CLASS_INC("InstantaneousVelocityARConstraint", "VectorValuedARConstraint", "ARConstraints.h")
        ADD_CLASS_INC("ARHalfSpaceConstraint", "VectorValuedARConstraint", "ARConstraints.h")
    ADD_CLASS_INC("MatrixValuedARConstraint", "GeneralARConstraint", "ARConstraints.h")
        ADD_CLASS_INC("SpatialDerivativeARConstraint", "MatrixValuedARConstraint", "ARConstraints.h")
        ADD_CLASS_INC("SimpleSpatialDerivativeARConstraint", "MatrixValuedARConstraint", "ARConstraints.h")

ADD_CLASS("Handle3D", "Persistent")
    ADD_CLASS("VarianceHandle3D", "Handle3D")
    ADD_CLASS_INC("ShapeMatchingHandle3D", "Handle3D", "PCIShapeMatching.h")
    ADD_CLASS_INC("ShapeMatchingPersistentHandles", "Persistent", "PCIShapeMatching.h")
ADD_CLASS("PCIDeformationConstraintEditor", "PCInteractionTool")
ADD_CLASS("SGDeformationConstraintsList", "SceneGraphNode")
ADD_CLASS("SGDeformationNodeAR", "SceneGraphNode")
ADD_CLASS("PCCDeformation", "PCCommand")
ADD_CLASS("PCCImportMPIIScannerASC", "PCCommand")
ADD_CLASS("PCIAnimationReconstruction2", "PCInteractionTool")
ADD_CLASS("PCIShapeMatching", "PCInteractionTool")

ADD_CLASS("PCCDataResampling", "PCCommand")
ADD_CLASS("PCCSetErrorQuadrics", "PCCommand")
ADD_CLASS("PCCBoundaryDetector", "PCCommand")
ADD_CLASS("PCCTopologicalResampling", "PCCommand")

ADD_CLASS("SceneGraphEntity", "Persistent")
    ADD_CLASS("SGEShape", "SceneGraphEntity")
        ADD_CLASS("SGEPointCloud", "SGEShape")
        ADD_CLASS("SGESurfelGraph", "SGEShape")
    ADD_CLASS("SGEDeformationSequence", "SceneGraphEntity")
        ADD_CLASS("SGEVolumeGridDeformationSequence", "SGEDeformationSequence")

ADD_CLASS("AROptimizationTool", "Persistent")
    ADD_CLASS("DeformationSolver", "AROptimizationTool")
        ADD_CLASS("FDDeformationSolver", "DeformationSolver")
        ADD_CLASS("MMDeformationSolver", "DeformationSolver")
        ADD_CLASS("RigidDeformationSolver", "DeformationSolver")
        ADD_CLASS("TSDeformationSolver", "DeformationSolver")
        ADD_CLASS("TSSmoothDeformationSolver", "DeformationSolver")
    ADD_CLASS("DeformationEvaluator", "AROptimizationTool")
        ADD_CLASS("FDDeformationEvaluator", "DeformationEvaluator")
        ADD_CLASS("TSDeformationEvaluator", "DeformationEvaluator")
        ADD_CLASS("TSSmoothDeformationEvaluator", "DeformationEvaluator")
        ADD_CLASS("RigidDeformationEvaluator", "DeformationEvaluator")
ADD_CLASS("MMTopology", "Persistent")
ADD_CLASS("MMNodes", "Persistent")
ADD_CLASS("MMNeighborContainer", "Persistent")
    ADD_CLASS("MMNode", "MMNeighborContainer")
ADD_CLASS("MMDeformations", "Persistent")
ADD_CLASS("AttachedMMDeformationContext", "AttachedData")
ADD_CLASS("AROptimizationContext", "Persistent")
    ADD_CLASS("ARDeformationOptimizationContext", "AROptimizationContext")
        ADD_CLASS("MMDeformationContext", "ARDeformationOptimizationContext")
            ADD_CLASS("RigidDeformationContext", "ARDeformationOptimizationContext")
            ADD_CLASS("FDDeformationContext", "ARDeformationOptimizationContext")
            ADD_CLASS("TSDeformationContext", "ARDeformationOptimizationContext")
    ADD_CLASS("ARShapeOptimizationContext", "AROptimizationContext")
        ADD_CLASS("SurfelOptimizationContext", "ARShapeOptimizationContext")
ADD_CLASS("MMSampler", "Persistent")
    ADD_CLASS("MMEdgeContractionSampler", "MMSampler")
    ADD_CLASS("MMTopologyGridSampler", "MMSampler")
    ADD_CLASS("MMGridSampler", "MMSampler")
    ADD_CLASS("MMFurthestPointSampler", "MMSampler")

ADD_CLASS("ARSettings", "Persistent")
ADD_CLASS("ARMergeSettings", "Persistent")
ADD_CLASS("ARPipelineOptions", "Persistent")
ADD_CLASS("ARDataConstraintsSettings", "Persistent")
ADD_CLASS("ARVisualizationSettings", "Persistent")
ADD_CLASS("ARGlobalOptSettings", "Persistent")
ADD_CLASS("BackendSettings", "Persistent")

ADD_CLASS("PCCNodesTools", "PCCommand")

ADD_CLASS("PCCImportDepthAnimation", "PCCommand")
ADD_CLASS("CameraParameterAttachment", "AttachedData")
ADD_CLASS("PCIVisionConstraints", "PCInteractionTool")

ADD_CLASS("ICPConstraints", "Persistent")

// Reconstruction
ADD_CLASS("PCCDeformationSurfaceReconstruction", "PCCommand")
ADD_CLASS("PCCNodeTest", "PCCommand")
ADD_CLASS("SurfelGraphInit2", "Persistent")
ADD_CLASS("ShapeReconstruction", "Persistent")
ADD_CLASS("SurfelOptimizer", "ShapeReconstruction")
ADD_CLASS("SurfelGraphTriangulator", "Persistent")
ADD_CLASS("SmallScaleReconstruction", "Persistent")

// rendering
ADD_CLASS("DebugAnimationRenderer", "Renderer")

ADD_CLASS("WeightFittingTest", "Persistent")

ADD_CLASS("PCIVisionTests", "PCInteractionTool")

ADD_CLASS("ARSequenceEvaluator", "Persistent")
    ADD_CLASS("ARPointCloudSeqEval", "ARSequenceEvaluator")

ADD_CLASS("PCCRangeQueryTest", "PCCommand")
ADD_CLASS("PCCRenameNode", "PCCommand")

ADD_CLASS("PCCRemoveSmallPatches", "PCCommand")

