#ifndef DebugRendererEditorWidgetH 
#define DebugRendererEditorWidgetH
//---------------------------------------------------------------------------
#include "x3editor.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "DebugRendererEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace X4
{
class DebugRenderer;

class X3EDITOR_API DebugRendererEditorWidget : public QWidget
{
	Q_OBJECT

private:

	DebugRenderer	*	m_DebugRenderer;
	Scene *m_scene;
	std::string				m_SelectedJob;

	///used to access buttons, etc. from QtDesigner
	Ui_DebugRenderer ui;

public:
	DebugRendererEditorWidget(QWidget * parent = NULL, Qt::WindowFlags f=0);
	~DebugRendererEditorWidget(void);

	void setup( DebugRenderer * obj, Scene *scene );

	/// update editor content with object data
	void updateEditor();

protected:

	virtual void focusInEvent ( QFocusEvent * event );
	virtual void enterEvent ( QEvent * event );
	virtual void showEvent ( QShowEvent * event );


public slots:

	void on_pbClearAllJobs_clicked();
	void on_pbClearSelectedJob_clicked();
	void on_bCurrentJobVisible_clicked();
	void on_pbConvertToMesh_clicked();
	void on_cbTimeInterval_clicked();
	void on_listRenderJobs_itemClicked ( QListWidgetItem * item );

};



}

#endif