#ifndef MacroEditorWidgetH
#define MacroEditorWidgetH
//---------------------------------------------------------------------------
#include "x3editor.h"
//---------------------------------------------------------------------------
#include <QMainWindow>
#include "X4Types.h"
//---------------------------------------------------------------------------
//this file is generated from the ui file by a custom buildstep, include it here
#include "x3editor\MacroEditorWidget_ui.h"
//---------------------------------------------------------------------------

namespace X4
{

class Scene;
class ObjectDictionary;
class ObjectDictionaryEditor;
class ObjectDictionaryEditorWidget;
class SceneEditorWidget;

class X3EDITOR_API MacroEditorWidget : public QMainWindow
{
	Q_OBJECT

public:
	MacroEditorWidget(Scene *scene, SceneEditorWidget *editorWidget);
	void update();
	~MacroEditorWidget();

   static bool getScriptRunning();
   static void repaintInScript();

private:
	Scene *scene;
	SceneEditorWidget *editorWidget;
   ObjectDictionary* dictionary;
   ObjectDictionaryEditor* dictionaryEditor;
   ObjectDictionaryEditorWidget* dictionaryEditorWidget;
   static bool scriptRunning;
   static SceneEditorWidget *activeEditorWidget;

private slots:
	void on_action_Load_triggered(bool checked);
	void on_action_Save_triggered(bool checked);
	void on_action_Update_triggered(bool checked);
	void on_BTExecute_clicked();

protected:
	///used to access buttons, etc. from QtDesigner
	Ui_MacroEditorWidget ui;
	
};

 
}

#endif
