//---------------------------------------------------------------------------
#ifndef MeshExporterH
#define MeshExporterH
//---------------------------------------------------------------------------
#include "x3editor.h"
//---------------------------------------------------------------------------
#include <fstream>
//---------------------------------------------------------------------------
#include "PointCloud.h"
#include "VertexDescriptor.h"
#include "PointCloudIterators.h"
//---------------------------------------------------------------------------


namespace X4 {


class X3EDITOR_API MeshExporter {
 private:
   PointCloud* pc;
   std::ofstream* outf;
   bool exportObjNormals;
   bool exportSmallTriangles;
   float32 smallTriangleSize;


 public:
   MeshExporter(PointCloud* pc, std::ofstream* outf);
   void exportPointCloud();
   void setExportObjNormals(bool b);
   void setExportObjSmallTriangles(bool b);

   void doExportSmallTriangles(PointCloud* pc, float32 size);
};

}
















#endif
