#ifndef MovieStudioWidgetH
#define MovieStudioWidgetH
//---------------------------------------------------------------------------
#include "x3editor.h"
//---------------------------------------------------------------------------
#include <QWidget>
#include "X4Types.h"
//---------------------------------------------------------------------------
//this file is generated from the ui file by a custom buildstep, include it here
#include "MovieStudioWidgetForm_ui.h"
//---------------------------------------------------------------------------

namespace X4
{

class SceneEditorWidget;

class MovieStudioWidget : public QWidget
{
	Q_OBJECT

private:
	SceneEditorWidget *sceneEd;
	QMenuBar* menuBar;


public:
	MovieStudioWidget(SceneEditorWidget *sceneEd);
	~MovieStudioWidget(void);

	// TODO: used in SceneEditorWidget
	inline std::string getFileNameString() { return qPrintable(ui.LEFileName->text()); }
	inline bool isMatchRealTime() { return ui.CBMatchRealTime->isChecked(); }
	inline bool isRecordPCIFrameEventsChecked() { return ui.CBRecordAtPCIFrameEvents->isChecked(); }
	inline bool isRecordEveryRepaintChecked() { return ui.CBRecordEveryRepaint->isChecked(); }
	inline bool isIncrSceneGraphTimeChecked() { return ui.CBIncrSceneGraphTime->isChecked(); }
	inline int getFrameRate() { return ui.SBFrameRate->value(); }
	inline int getMaxRepl() { return ui.SBMaxRepl->value(); }
	inline int getNumberOfFrames() { return ui.SBNumberOfFrames->value(); }
	inline bool isMainWinTimelineChecked() { return ui.CBMainWinTimeline->isChecked(); }
	card32 getImageFormat() {return ui.imageFormat->currentIndex();}
	card32 getOversampling() {return ui.cbOversampling->currentIndex();}


private slots:
	void sltOnlineHelp();
	void on_BTClose_clicked();
	void on_BTFileOpen_clicked();
	void on_CBMatchRealTime_stateChanged(int);
	void on_CBMainWinTimeline_stateChanged(int);
	void on_BTRecNow_clicked();
	void on_BTTimeNow_clicked();
	void on_imageFormat_currentIndexChanged(int);

protected:
	///used to access buttons, etc. from QtDesigner
	Ui_MovieStudioWidgetForm ui;
	/// function which is called if button RecNow or TimeNow clicked, starts movie recording or time measurement in SceneEditorWidget
	void BTRecOrTimeNowClicked(bool doRec);

	
};

 extern X3EDITOR_API MovieStudioWidget *movieStudioWidget;

}

#endif
