//---------------------------------------------------------------------------
#ifndef PCCAnimatedTriangleMeshSamplerH
#define PCCAnimatedTriangleMeshSamplerH
//---------------------------------------------------------------------------
#include "x3editor.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------

namespace X4 {

class SceneObject;

/// Sample an animated triangle mesh to an animated point cloud
class X3EDITOR_API PCCAnimatedTriangleMeshSampler : public PCCommand {
	private:
		static MetaClass *PCCAnimatedTriangleMeshSamplerMetaClass;
		static Object* newInstance();

		/// Name (incl. path) of source animation node
		std::string sourceNode;
		/// Name (incl. path) of destination animation node
		std::string destNode;
		/// Expected number of points in result
		card64 expNumPoints;

		float32 sampleSpacing;

	public:
		/// Constructor
		PCCAnimatedTriangleMeshSampler();

		/// Execute command
		virtual void execute(Scene *scene);

		/// sample poisson
		void samplePoission();

		/*** META CLASS MANAGEMENT ***/
		virtual const MetaClass *getInstanceClass() const;
		static const MetaClass *getClass();
		static void init(const MetaClass *parentClass);
		static void shutdown();	
};

}

#endif
 