#ifndef PCCAnimationImporterEditorWidgetH 
#define PCCAnimationImporterEditorWidgetH
//---------------------------------------------------------------------------
#include "x3editor.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "PCCAnimationImporterEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace X4
{
class PCCAnimationImporter;
class PointCloudImporterReader;


class X3EDITOR_API PCCAnimationImporterEditorWidget : public QWidget
{
	Q_OBJECT

private:

	PCCAnimationImporter	*	m_Object;

	///used to access buttons, etc. from QtDesigner
	Ui_PCCAnimationImporterEditorForm ui;

	void switchImporterToFileExtension(std::string);


public:
	PCCAnimationImporterEditorWidget(QWidget * parent = NULL, Qt::WindowFlags f=0);
	~PCCAnimationImporterEditorWidget(void);

	void setup( PCCAnimationImporter * obj );

	/// update editor content with object data
	void updateEditor();


private slots:
	void on_LEFileName_textEdited(QString);
	void on_LEFileName_editingFinished();
	void on_PBLoadFile_clicked();
	void on_CBImporterReader_currentIndexChanged(QString);
	void on_PBEdit_clicked();
	void on_LETarget_textEdited(QString);
	void on_LESwapFileName_textEdited(QString);
	void on_GBParametricWrite_toggled(bool);
	void on_cbRelativePath_toggled(bool);
	void on_cbOOC_toggled(bool);
	void on_LEParamCoordsChannel_textEdited(QString);
	void on_SBParamScaleX_valueChanged(double);
	void on_SBParamScaleY_valueChanged(double);
	void on_SBParamOffsetX_valueChanged(double);
	void on_SBParamOffsetY_valueChanged(double);
	void on_PBFramePCEditSubType_clicked();
	void on_cbEntireDirectory_toggled(bool);

};

MAKE_CLASS_EDITOR( X3EDITOR_API , PCCAnimationImporter )


}

#endif