//---------------------------------------------------------------------------
#ifndef PCCAutoAlignH
#define PCCAutoAlignH
//---------------------------------------------------------------------------
#include "x3editor.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
#include "Scene.h"
#include "PointCloud.h"
//---------------------------------------------------------------------------

namespace X4 {


class X3EDITOR_API PCCAutoAlign : public PCCommand {
private:
   static MetaClass *PCCAutoAlignMetaClass;
   static Object* newInstance();

protected:
	void levelParamUpdateFunc();

public:

   /// Center point clouds
   bool center;
   /// Rescale the point cloud
   bool rescale;
   /// Simply adjust camera settings
   bool adjustCamera;

	mpcard LevelParam;
	float32 GridWidth;
	bool readFromList;
	std::string sourceList;

   /// Constructor
   PCCAutoAlign();
   /// Execute command
   virtual void execute(Scene *scene);
   virtual void execute_at(PointCloud* pc);

	virtual void alignToGrid();
	virtual void alignToGrid(PointCloud* pc, mpcard index, mpcard numGridEntries);

	virtual void level();
	virtual void level(PointCloud* pc);


   /*--- META-CLASS ---*/
   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();
};


}

#endif
 