#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "PCCCopySelectionUnstructured.h"
//---------------------------------------------------------------------------
#include "CopyObjectProperties.h"
#include "ClassMethods.h"
#include "VertexArray.h"
#include "MHSelectionIteratorAdaptor.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------
IMPLEMENT_X4_CLASS( PCCCopySelectionUnstructured ,1)
{
	BEGIN_CLASS_INIT( PCCCopySelectionUnstructured );
    ADD_STRING_PROP(source, 0)
    ADD_STRING_PROP(target, 0)
}
//---------------------------------------------------------------------------

PCCCopySelectionUnstructured::PCCCopySelectionUnstructured(void)
{
    source = "root/pc1";
    target = "root/copyWillBeReplaced";
}

PCCCopySelectionUnstructured::~PCCCopySelectionUnstructured(void)
{
}

void PCCCopySelectionUnstructured::assign(const Object* obj, X4CopyContext *context)
{
    copyObjectProperties(obj,this);
}

void PCCCopySelectionUnstructured::execute( Scene *scene )
{
    PointCloud *sourcePC = getPointCloud(getScene(), source);
    if (!sourcePC) {
        throw X4Exception("PCCCopySelectionUnstructured::execute() - source not not found.");
    }
    PointCloudIterator *it = (PointCloudIterator*)sourcePC->createIterator(SOIT::CAP_BASIC_PC | SOIT::CAP_HIERARCHICAL);
    if (!it) {
        throw X4Exception("PCCCopySelectionUnstructured::execute() - cannot create iterator.");
    }

    UnstructuredInCorePointCloud *resultPC = new UnstructuredInCorePointCloud();
    resultPC->clearAndSetup(sourcePC->getDescr(),0);
    PointSet *resultPS = resultPC->getPointSet();

    MHSelectionIteratorAdaptor *selectedIt = new MHSelectionIteratorAdaptor(it, sourcePC->getDescr());

    BasicPointCloudIterator *basicSelIt = dynamic_cast<BasicPointCloudIterator*>(selectedIt);
    while (!basicSelIt->atEnd()) {
        resultPS->changeHeight(resultPS->getHeight()+1);
        basicSelIt->getVertex(resultPS->getDataPointer(resultPS->getHeight()-1));
        basicSelIt->next();
    }

    delete it;

    addOrReplacePointCloud(getScene(), target, resultPC);

}
