//---------------------------------------------------------------------------
#ifndef PCCDirectoryImporterH
#define PCCDirectoryImporterH
//---------------------------------------------------------------------------
#include "x3editor.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------


namespace X4 {

class PCCImporter;

///
///  this tool imports all files with certain extension (file ending) from a directory subtree
///
class X3EDITOR_API PCCDirectoryImporter : public PCCommand {
	X4_CLASS( PCCDirectoryImporter )
private:
   std::string directory;
   std::string fileEnding;
   PCCImporter *importer;
   bool ignoreExceptions;
   bool outputFiles;

   void recursiveCollect(std::string file);

public:
	PCCDirectoryImporter();

   virtual void assign(const Object *obj, X4CopyContext *context = NULL);
   virtual void execute(Scene *scene);

   void importHannover();
   void importUrbanChallenge();

	~PCCDirectoryImporter();
};

}

#endif