//---------------------------------------------------------------------------
#ifndef PCCEstimateSampleSpacingH
#define PCCEstimateSampleSpacingH
//---------------------------------------------------------------------------
#include "x3editor.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------


namespace X4 {

///
///  estimates sample spacing (=average distance to n nearest neighbor points)
///
class X3EDITOR_API PCCEstimateSampleSpacing : public PCCommand {
	X4_CLASS( PCCEstimateSampleSpacing )
private:
   card32 numNeighbors;
   
public:
	PCCEstimateSampleSpacing();

   virtual void assign(const Object *obj, X4CopyContext *context = NULL);

   virtual void execute(Scene *scene);

   /// estimate sample spacing, appends channel "sampleSpacing" (1f) if necessary
   static void estimateSampleSpacing(PointCloud * pc, card32 numNeighbors, bool showProgess=true);

	~PCCEstimateSampleSpacing();
};

}

#endif