#ifndef PCCImplicitMesherH
#define PCCImplicitMesherH
//---------------------------------------------------------------------------
#include "x3editor.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------

namespace X4
{

/**
	creates a triangle mesh for all/selected point clouds.
	defines a implicit function (signed distance) and uses marching cubes for
	triangulation (Hoppe92)
*/
class X3EDITOR_API PCCImplicitMesher : public PCCommand
{
	X4_CLASS( PCCImplicitMesher )

private:

	void triangulatePointCloud( Scene * scene, std::string pcName, bool lineMode );

	float		m_Sigma;
	card32		m_Resolution;
	float		m_GridSnapTolerance;
	bool		smoothNormals;
	float		smoothNormals_Sigma;
	float32  borderFactor;
	
	// line feature signed distance
	std::string		m_LineChannel;
	float32		m_IsoValue;
	bool simpleLineDistance;



public:
	PCCImplicitMesher(void);
	~PCCImplicitMesher(void);

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

	virtual void execute(Scene *scene);
	void meshLineFeatures();
	void transferCurvatureFromVolume();

};

}

#endif