#ifndef PCCImportVolumeDataH
#define PCCImportVolumeDataH
//---------------------------------------------------------------------------
#include "x3editor.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------

namespace X4
{

/**
	importer for raw volume data
*/
class X3EDITOR_API PCCImportVolumeData : public PCCommand
{
	X4_CLASS( PCCImportVolumeData )

private:

	std::string	m_FileName;
	std::string	m_PointCloudName;
	bool	m_MultiRes;
	bool	m_CreatePositionChannel;
	bool m_is16Bit;
public:
	PCCImportVolumeData(void);
	~PCCImportVolumeData(void);

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

	virtual void execute(Scene * scene);

	PointCloud* importAndAddToScene(std::string filename, Scene * scene);

};

}

#endif