#ifndef PCCImporterEditorWidgetH 
#define PCCImporterEditorWidgetH
//---------------------------------------------------------------------------
#include "x3editor.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "PCCImporterEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace X4
{

class PCCImporter;
class PointCloudImporterReader;


class X3EDITOR_API PCCImporterEditorWidget : public QWidget
{
	Q_OBJECT

private:

	PCCImporter	*	m_Object;

	///used to access buttons, etc. from QtDesigner
	Ui_PCCImporterEditorForm ui;

	void switchImporterToFileExtension(std::string);
	bool checkAndSetupMSColorDepthBMP(std::string s );


public:
	PCCImporterEditorWidget(QWidget * parent = NULL, Qt::WindowFlags f=0);
	~PCCImporterEditorWidget(void);

	void setup( PCCImporter * obj );

	/// update editor content with object data
	void updateEditor();


private slots:
	void on_LEFileName_textEdited(QString);
	void on_LEFileName_editingFinished();
	void on_PBLoadFile_clicked();
	void on_CBImporterReader_currentIndexChanged(QString);
	void on_PBEdit_clicked();
	void on_LETarget_textEdited(QString);
	void on_GBParametricWrite_toggled(bool);
	void on_LEParamCoordsChannel_textEdited(QString);
	void on_SBParamScaleX_valueChanged(double);
	void on_SBParamScaleY_valueChanged(double);
	void on_SBParamOffsetX_valueChanged(double);
	void on_SBParamOffsetY_valueChanged(double);

};


MAKE_CLASS_EDITOR( X3EDITOR_API , PCCImporter )


}

#endif