#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "PCCMeshImportOA.h"
//---------------------------------------------------------------------------
#include "CopyObjectProperties.h"
#include "ImportMeshOpenAsset.h"
#include "FileDialogs.h"
#include "ClassMethods.h"
//---------------------------------------------------------------------------
using namespace X4;

IMPLEMENT_X4_CLASS( PCCMeshImportOA ,0)
{
	BEGIN_CLASS_INIT( PCCMeshImportOA );
	ADD_NOARGS_METHOD(import);
}

PCCMeshImportOA::PCCMeshImportOA(void)
{
}

PCCMeshImportOA::~PCCMeshImportOA(void)
{
}

void PCCMeshImportOA::assign(const Object* obj, X4CopyContext *context)
{
	PCCommand::assign(obj,context);
	const PCCMeshImportOA * o = dynamic_cast<const PCCMeshImportOA*>(obj);
	x4Assert( o != NULL );

	copyObjectProperties(obj,this);
}

void PCCMeshImportOA::import() 
{
	m_Filename = FileDialogs::getOpenFileName(NULL,"open mesh","*.3ds;*.dae;*.xml;*.obj;*.off;*.smf;*.ply");
	if( m_Filename.empty() )
		return;
	execute(getScene());
}

void PCCMeshImportOA::execute(Scene *scene) 
{
	UnstructuredInCoreTriangleMesh * mesh = ImportMeshOpenAsset::import(m_Filename);
	if( !mesh )
	{
		message("import failed\n");
		return;
	}
	addPointCloud(scene,mesh,"mesh");
}
