#ifndef PCCPointCloudCreatorEditorWidgetH 
#define PCCPointCloudCreatorEditorWidgetH
//---------------------------------------------------------------------------
#include "x3editor.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "PCCPointCloudCreatorEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace X4
{
class PCCPointCloudCreator;

class X3EDITOR_API PCCPointCloudCreatorEditorWidget : public QWidget
{
	Q_OBJECT

private:

	PCCPointCloudCreator	*	m_Object;

	///used to access buttons, etc. from QtDesigner
	Ui_PCCPointCloudCreatorEditorForm ui;

public:
	PCCPointCloudCreatorEditorWidget(QWidget * parent = NULL, Qt::WindowFlags f=0);
	~PCCPointCloudCreatorEditorWidget(void);

	void setup( PCCPointCloudCreator * obj );

	/// update editor content with object data
	void updateEditor();


public slots:
	void on_LEName_textEdited(QString);
	void on_CBType_currentIndexChanged(int);
	void on_PBEditVD_clicked();
	void on_SBMaxNumObjectsPerLeaf_valueChanged(int);
	void on_SBMultiResGridSize_valueChanged(int);
	void on_SBAllocatorIndex_valueChanged(int);
	void on_SBMaxNodeInMem_valueChanged(int);

};

MAKE_CLASS_EDITOR( X3EDITOR_API , PCCPointCloudCreator )


}

#endif