//---------------------------------------------------------------------------
#ifndef PCCPointGeneratorH
#define PCCPointGeneratorH
//---------------------------------------------------------------------------
#include "x3editor.h"
//---------------------------------------------------------------------------
#include <string>
#include "PCCommand.h"
#include "LinearAlgebra.h"
#include "CmdObjGeneratePC.h"
//---------------------------------------------------------------------------

namespace X4 {

class X3EDITOR_API PCCPointGenerator : public PCCommand {
	X4_CLASS( PCCPointGenerator );

	private:
		/// Type of point cloud
		card32 type;
		/// Number of points
		card32 numPoints;
		/// Name
		std::string pcName;


		/// mesh parameters
		card32 m_Mesh_NumSegments;
		Vector3f m_Mesh_Box;


	public:
		/// Constructor
		PCCPointGenerator();
		/// Execute
		virtual void execute(Scene *scene);

		void createCylinderMesh();

};


}

#endif

