// vertex shader
// pointer loeschen
// assertions
// abfragen der AAT providesatribute(...)
// commando und undo redo an editor weiter geben

//---------------------------------------------------------------------------
#include "StdAfx.h"
#include "PCCVolumeGenerator.h"
#include "CopyObjectProperties.h"
#include "RegularVolume.inline.h"
#include "PointSet.inline.h"
#include "PointCloudTools.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------

#pragma warning (disable : 4018)

IMPLEMENT_X4_CLASS( PCCVolumeGenerator , 0 )
{
	BEGIN_CLASS_INIT( PCCVolumeGenerator );
	ADD_STRING_PROP( volumeName, 0 );
	ADD_CARD32_PROP( nVoxelsX,0 );
	ADD_CARD32_PROP( nVoxelsY,0 );
	ADD_CARD32_PROP( nVoxelsZ,0 );
}

PCCVolumeGenerator::PCCVolumeGenerator()
{
	volumeName = "volume1";
//	nVoxelsX = nVoxelsY = nVoxelsZ = 100;
	//nVoxelsX = 100;
	//nVoxelsY = 200;
	//nVoxelsZ = 100;
 	nVoxelsX = 10;
 	nVoxelsY = 10;
 	nVoxelsZ = 10;
//	nVoxelsX = 200;
//	nVoxelsY = 200;
//	nVoxelsZ = 200;
	bbLL = makeVector3f(-0.1f*nVoxelsX,-0.1f*nVoxelsY,-0.1f*nVoxelsZ);
	bbUR = makeVector3f( 0.1f*nVoxelsX, 0.1f*nVoxelsY, 0.1f*nVoxelsZ);
}

void PCCVolumeGenerator::assign(const Object* obj, X4CopyContext *context)
{
	copyObjectProperties(obj, this);
}

PCCVolumeGenerator::~PCCVolumeGenerator()
{
}

void PCCVolumeGenerator::execute(Scene *scene)
{
	VertexDescriptor vd;
//	vd.pushAttrib( mVAD( "position", 3, VAD::DATA_FORMAT_FLOAT32 ) );
	vd.pushAttrib( mVAD( "intensity", 1, VAD::DATA_FORMAT_FLOAT32 ) );
	
	RegularVolume* volume = new RegularVolume();
	BoundingBox3f bb = BoundingBox3f(bbLL,bbUR);

	volume->clearAndSetup(nVoxelsX, nVoxelsY, nVoxelsZ, &vd, bb);
//	AAT POSITION  = vd.getToken( "position" );
	AAT INTENSITY = vd.getToken( "intensity" );

//	Vector3f position;
	float32 intensity;
	for (size_t w = 0; w < volume->getWidth(); w++)
	{
		for (size_t h = 0; h < volume->getHeight(); h++)
		{
			for (size_t d = 0; d < volume->getDepth(); d++)
			{






//				wf = bbLL[0] + (w * (bbUR[0] - bbLL[0]) / (nVoxelsX-1));
//				hf = bbLL[1] + (h * (bbUR[1] - bbLL[1]) / (nVoxelsY-1));
//				df = bbLL[2] + (d * (bbUR[2] - bbLL[2]) / (nVoxelsZ-1));
//				position = makeVector3f(wf, hf, df);
/*
				if(	(abs(wf) < 0.6f) && (abs(hf) < 0.6f) && (abs(df) < 0.6f))
				{
				
//		if((abs((int)(w-volume->getWidth())) > 30)  && (w > 30) && (abs((int)(h-volume->getHeight())) > 20)  && (h > 20) && (abs((int)(d-volume->getDepth())) > 25)  && (d > 25))// &&
					//((abs(wf) > 0.4f) && (abs(hf) > 0.4f) && (abs(df) > 0.4f))	)
//				if((wf == 0.0f) && (hf == 0.0f) && (df == 0.0f))
				// sphere
				//if(wf*wf + hf*hf + df*df < 0.25)

					if( (abs(wf) < 0.3f) && (abs(hf) < 0.3f) && (abs(df) < 0.3f))
						intensity = 0.0f;
					else
						intensity = 1.0f;//(0.5f*sin(wf*M_PI*3+0)+0.5f) * (0.5f*sin(hf*M_PI*2+M_PI)+0.5f) * (0.5f*sin(df*M_PI*5+3*M_PI)+0.5f);
				}
				else
					intensity = 0.0f;
				//intensity = (0.5f*sin(wf*M_PI*3+2*M_PI)+0.5f) * (0.5f*sin(hf*M_PI*2+M_PI)+0.5f) * (0.5f*sin(df*M_PI*5+3*M_PI)+0.5f);
*/
				// cube for 100x100x100
//  				intensity = 0.0f;
//  				if(w>=25&&w<=75&&h>=25&&h<=75&&d>=25&&d<=75)
//  					intensity = 1.0f;
//  
//  				volume->setVoxel((card32)w, (card32)h, (card32)d, INTENSITY, intensity);

/*
				// 8 cubes 1 damaged for 100 100 100
				intensity = 0.0f;
				if(w>=10&&w<=40&&h>=10&&h<=40&&d>=10&&d<=40)
					intensity = 1.0f;
				if(w>=10&&w<=40&&h>=10&&h<=40&&d>=60&&d<=90)
					intensity = 1.0f;
				if(w>=10&&w<=40&&h>=60&&h<=90&&d>=10&&d<=40)
					intensity = 1.0f;
				if(w>=10&&w<=40&&h>=60&&h<=90&&d>=60&&d<=90)
					intensity = 1.0f;
				if(w>=60&&w<=90&&h>=10&&h<=40&&d>=10&&d<=40)
					intensity = 1.0f;
				if(w>=60&&w<=90&&h>=10&&h<=40&&d>=60&&d<=90)
					intensity = 1.0f;
				if(w>=60&&w<=90&&h>=60&&h<=90&&d>=10&&d<=40)
					intensity = 1.0f;
				if(w>=60&&w<=90&&h>=60&&h<=90&&d>=60&&d<=90)
					intensity = 1.0f;
				
				if(w==82  && h == 15 && d ==25)
					intensity = 0.0f;
				if(w==82  && h == 16 && d ==26)
					intensity = 0.0f;
				if(w==82  && h == 17 && d ==27)
					intensity = 0.0f;
				if(w==82  && h == 18 && d ==28)
					intensity = 0.0f;
				if(w==82  && h == 19 && d ==29)
					intensity = 0.0f;
				if(w==82  && h == 20 && d ==30)
					intensity = 0.0f;
				if(w==82  && h == 21 && d ==31)
					intensity = 0.0f;
				if(w==82  && h == 22 && d ==32)
					intensity = 0.0f;
				if(w==82  && h == 23 && d ==33)
					intensity = 0.0f;
				if(w==82  && h == 24 && d ==34)
					intensity = 0.0f;

				volume->setVoxel((card32)w, (card32)h, (card32)d, INTENSITY, intensity);

				continue;
*/












				// cuboid for 200x200x200
// 				intensity = 0.0f;
// 				if(w>=75&&w<=125&&h>=15&&h<=185&&d>=75&&d<=125)
// 					intensity = 1.0f;
// 
// 				volume->setVoxel((card32)w, (card32)h, (card32)d, INTENSITY, intensity);
// continue;				
				/*
				//Letter I1
				if(d >= 5 && d <= 55 && w >= 20 && w <= 30 && h >= 85 && h <= 155)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 5 && w <= 45 && h >= 85 && h <= 95)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 5 && w <= 45 && h >= 145 && h <= 155)
					intensity = 1.0f;

				//Letter E1
				if(d >= 5 && d <= 55 && w >= 55 && w <= 95 && h >= 145 && h <= 155)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 55 && w <= 95 && h >= 85 && h <= 95)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 55 && w <= 85 && h >= 115 && h <= 125)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 55 && w <= 65 && h >= 85 && h <= 155)
					intensity = 1.0f;

				//Letter E2
				if(d >= 5 && d <= 55 && w >= 105 && w <= 145 && h >= 145 && h <= 155)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 105 && w <= 145 && h >= 85 && h <= 95)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 105 && w <= 135 && h >= 115 && h <= 125)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 105 && w <= 115 && h >= 85 && h <= 155)
					intensity = 1.0f;

				//Letter E3
				if(d >= 5 && d <= 55 && w >= 155 && w <= 195 && h >= 145 && h <= 155)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 155 && w <= 195 && h >= 85 && h <= 95)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 155 && w <= 185 && h >= 115 && h <= 125)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 155 && w <= 165 && h >= 85 && h <= 155)
					intensity = 1.0f;

				//Letter V
				if(d >= 5 && d <= 55 && w >= 255 && w <= 265 && h >= 105 && h <= 155)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 285 && w <= 295 && h >= 105 && h <= 155)
					intensity = 1.0f;
				for(int kk = 0; kk <= 20; kk++)
				{
					if(d >= 5 && d <= 55 && w == 275+kk && h >= 85+kk && h <= 95+kk)
						intensity = 1.0f;
					if(d >= 5 && d <= 55 && w == 275-kk && h >= 85+kk && h <= 95+kk)
						intensity = 1.0f;
				}

				//Letter I2
				if(d >= 5 && d <= 55 && w >= 320 && w <= 330 && h >= 85 && h <= 155)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 305 && w <= 345 && h >= 85 && h <= 95)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 305 && w <= 345 && h >= 145 && h <= 155)
					intensity = 1.0f;

				//Letter S
				if(d >= 5 && d <= 55 && w >= 355 && w <= 395 && h >= 85 && h <= 95)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 355 && w <= 395 && h >= 115 && h <= 125)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 355 && w <= 395 && h >= 145 && h <= 155)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 355 && w <= 365 && h >= 115 && h <= 155)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 385 && w <= 395 && h >= 85 && h <= 125)
					intensity = 1.0f;

				//Letter W
				if(d >= 5 && d <= 55 && w >= 5 && w <= 15 && h >= 5 && h <= 75)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 35 && w <= 45 && h >= 5 && h <= 75)
					intensity = 1.0f;
				for(int kk = 0; kk <= 10; kk++)
				{
					if(d >= 5 && d <= 55 && w == 15+kk && h >= 5+kk && h <= 15+kk)
						intensity = 1.0f;
					if(d >= 5 && d <= 55 && w == 35-kk && h >= 5+kk && h <= 15+kk)
						intensity = 1.0f;
				}

				//Letter E4
				if(d >= 5 && d <= 55 && w >= 55 && w <= 95 && h >= 65 && h <= 75)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 55 && w <= 95 && h >= 5 && h <= 15)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 55 && w <= 85 && h >= 35 && h <= 45)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 55 && w <= 65 && h >= 5 && h <= 75)
					intensity = 1.0f;

				//Letter E5
				if(d >= 5 && d <= 55 && w >= 105 && w <= 145 && h >= 65 && h <= 75)
					intensity = 1.0f;										
				if(d >= 5 && d <= 55 && w >= 105 && w <= 145 && h >= 5 && h <= 15)
					intensity = 1.0f;										
				if(d >= 5 && d <= 55 && w >= 105 && w <= 135 && h >= 35 && h <= 45)
					intensity = 1.0f;										
				if(d >= 5 && d <= 55 && w >= 105 && w <= 115 && h >= 5 && h <= 75)
					intensity = 1.0f;

				//Letter K
				if(d >= 5 && d <= 55 && w >= 155 && w <= 165 && h >= 5 && h <= 75)
					intensity = 1.0f;
				for(int kk = 0; kk <= 30; kk++)
				{
					if(d >= 5 && d <= 55 && w >= 185-kk && w <= 195-kk && h == 5+kk )
						intensity = 1.0f;
					if(d >= 5 && d <= 55 && w >= 185-kk && w <= 195-kk && h == 75-kk )
						intensity = 1.0f;
				}






					
				//Number 2
				if(d >= 5 && d <= 55 && w >= 205 && w <= 245 && h >= 5 && h <= 15)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 205 && w <= 245 && h >= 35 && h <= 45)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 205 && w <= 245 && h >= 65 && h <= 75)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 205 && w <= 215 && h >= 5 && h <= 45)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 235 && w <= 245 && h >= 35 && h <= 75)
					intensity = 1.0f;

				//Number 01
				if(d >= 5 && d <= 55 && w >= 255 && w <= 295 && h >= 5 && h <= 15)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 255 && w <= 295 && h >= 65 && h <= 75)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 255 && w <= 265 && h >= 5 && h <= 75)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 285 && w <= 295 && h >= 5 && h <= 75)
					intensity = 1.0f;

				//Number 1
				if(d >= 5 && d <= 55 && w >= 305 && w <= 345 && h >= 5 && h <= 15)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 320 && w <= 330 && h >= 5 && h <= 75)
					intensity = 1.0f;
				for(int ll = 0; ll <= 15; ll++)
				{
					if(d >= 5 && d <= 55 && w == 305+ll && h >= 50+ll && h <= 60+ll)
						intensity = 1.0f;
				}

				//Number 02
				if(d >= 5 && d <= 55 && w >= 355 && w <= 395 && h >= 5 && h <= 15)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 355 && w <= 395 && h >= 65 && h <= 75)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 355 && w <= 365 && h >= 5 && h <= 75)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 385 && w <= 395 && h >= 5 && h <= 75)
					intensity = 1.0f;
*/




// VMVMVMVMVMVMVM
	intensity = 0.0f;
				//Letter V1
				if(d >= 5 && d <= 55 && w >= 30 && w <= 40 && h >= 105 && h <= 145)
				intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 60 && w <= 70 && h >= 105 && h <= 145)
				intensity = 1.0f;
				for(int kk = 0; kk <= 20; kk++)
				{
					if(d >= 5 && d <= 55 && w == 50+kk && h >= 85+kk && h <= 95+kk)
						intensity = 1.0f;
					if(d >= 5 && d <= 55 && w == 50-kk && h >= 85+kk && h <= 95+kk)
						intensity = 1.0f;
				}



				//Letter M
				if(d >= 5 && d <= 55 && w >= 80 && w <= 90 && h >= 85 && h <= 145)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 110 && w <= 120 && h >= 85 && h <= 145)
					intensity = 1.0f;
				for(int kk = 0; kk <= 10; kk++)
				{
					if(d >= 5 && d <= 55 && w == 90+kk && h <= 145-kk && h >= 135-kk)
						intensity = 1.0f;
					if(d >= 5 && d <= 55 && w == 110-kk && h <= 145-kk && h >= 135-kk)
						intensity = 1.0f;
				}




				//Letter V2
				if(d >= 5 && d <= 55 && w >= 130 && w <= 140 && h >= 105 && h <= 145)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 160 && w <= 170 && h >= 105 && h <= 145)
					intensity = 1.0f;
				for(int kk = 0; kk <= 20; kk++)
				{
					if(d >= 5 && d <= 55 && w == 150+kk && h >= 85+kk && h <= 95+kk)
						intensity = 1.0f;
					if(d >= 5 && d <= 55 && w == 150-kk && h >= 85+kk && h <= 95+kk)
						intensity = 1.0f;
				}



/*

				//Letter W
				if(d >= 5 && d <= 55 && w >= 5 && w <= 15 && h >= 85 && h <= 155)
				intensity = 0.55f;
				if(d >= 5 && d <= 55 && w >= 35 && w <= 45 && h >= 85 && h <= 155)
				intensity = 0.55f;
				if(d >= 5 && d <= 55 && w >= 20 && w <= 30 && h >= 95 && h <= 115)
					intensity = 0.55f;
				for(int kk = 0; kk <= 10; kk++)
				{
					if(d >= 5 && d <= 55 && w == 15+kk && h >= 85+kk && h <= 95+kk)
						intensity = 0.55f;
					if(d >= 5 && d <= 55 && w == 35-kk && h >= 85+kk && h <= 95+kk)
						intensity = 0.55f;
				}

				//Letter S
				if(d >= 5 && d <= 55 && w >= 55 && w <= 95 && h >= 85 && h <= 95)
					intensity = 0.55f;
				if(d >= 5 && d <= 55 && w >= 55 && w <= 95 && h >= 115 && h <= 125)
					intensity = 0.55f;
				if(d >= 5 && d <= 55 && w >= 55 && w <= 95 && h >= 145 && h <= 155)
					intensity = 0.55f;
				if(d >= 5 && d <= 55 && w >= 55 && w <= 65 && h >= 115 && h <= 155)
					intensity = 0.55f;
				if(d >= 5 && d <= 55 && w >= 85 && w <= 95 && h >= 85 && h <= 115)
					intensity = 0.55f;

				//Letter C
				if(d >= 5 && d <= 55 && w >= 105 && w <= 115 && h >= 85 && h <= 155)
					intensity = 0.55f;
				if(d >= 5 && d <= 55 && w >= 105 && w <= 145 && h >= 85 && h <= 95)
					intensity = 0.55f;
				if(d >= 5 && d <= 55 && w >= 105 && w <= 145 && h >= 145 && h <= 155)
					intensity = 0.55f;

				//Letter G
				if(d >= 5 && d <= 55 && w >= 155 && w <= 165 && h >= 85 && h <= 155)
					intensity = 0.55f;
				if(d >= 5 && d <= 55 && w >= 155 && w <= 195 && h >= 85 && h <= 95)
					intensity = 0.55f;
				if(d >= 5 && d <= 55 && w >= 155 && w <= 195 && h >= 145 && h <= 155)
					intensity = 0.55f;
				if(d >= 5 && d <= 55 && w >= 185 && w <= 195 && h >= 85 && h <= 115)
					intensity = 0.55f;
				if(d >= 5 && d <= 55 && w >= 175 && w <= 195 && h >= 115 && h <= 125)
					intensity = 0.55f;

*/

				//Number 2
				if(d >= 5 && d <= 55 && w >= 5 && w <= 45 && h >= 5 && h <= 15)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 5 && w <= 45 && h >= 35 && h <= 45)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 5 && w <= 45 && h >= 65 && h <= 75)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 5 && w <= 15 && h >= 5 && h <= 45)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 35 && w <= 45 && h >= 35 && h <= 75)
					intensity = 1.0f;

				//Number 0_1
				if(d >= 5 && d <= 55 && w >= 55 && w <= 95 && h >= 5 && h <= 15)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 55 && w <= 95 && h >= 65 && h <= 75)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 55 && w <= 65 && h >= 5 && h <= 75)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 85 && w <= 95 && h >= 5 && h <= 75)
					intensity = 1.0f;

				//Number 1_1
				if(d >= 5 && d <= 55 && w >= 105 && w <= 145 && h >= 5 && h <= 15)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 120 && w <= 130 && h >= 5 && h <= 75)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 105 && w <= 120 && h >= 65 && h <= 75)
					intensity = 1.0f;

				//Number 1_1
				if(d >= 5 && d <= 55 && w >= 155 && w <= 195 && h >= 5 && h <= 15)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 170 && w <= 180 && h >= 5 && h <= 75)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 155 && w <= 170 && h >= 65 && h <= 75)
					intensity = 1.0f;

// 				for(int ll = 0; ll <= 15; ll++)
// 				{
// 					if(d >= 5 && d <= 55 && w == 105+ll && h >= 50+ll && h <= 60+ll)
// 						intensity = 1.0f;
// 				}

				//Number 0_2
// 				if(d >= 5 && d <= 55 && w >= 155 && w <= 195 && h >= 5 && h <= 15)
// 				intensity = 1.0f;
// 				if(d >= 5 && d <= 55 && w >= 155 && w <= 195 && h >= 65 && h <= 75)
// 				intensity = 1.0f;
// 				if(d >= 5 && d <= 55 && w >= 155 && w <= 165 && h >= 5 && h <= 75)
// 				intensity = 1.0f;
// 				if(d >= 5 && d <= 55 && w >= 185 && w <= 195 && h >= 5 && h <= 75)
// 				intensity = 1.0f;


/*



				//Letter C
				if(d >= 5 && d <= 55 && w >= 30 && w <= 40 && h >= 85 && h <= 155)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 30 && w <= 70 && h >= 85 && h <= 95)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 30 && w <= 70 && h >= 145 && h <= 155)
					intensity = 1.0f;

				//Letter G
				if(d >= 5 && d <= 55 && w >= 80 && w <= 90 && h >= 85 && h <= 155)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 80 && w <= 120 && h >= 85 && h <= 95)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 80 && w <= 120 && h >= 145 && h <= 155)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 110 && w <= 120 && h >= 85 && h <= 115)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 100 && w <= 120 && h >= 115 && h <= 125)
					intensity = 1.0f;

				//Letter I
				if(d >= 5 && d <= 55 && w >= 145 && w <= 155 && h >= 85 && h <= 155)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 130 && w <= 170 && h >= 85 && h <= 95)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 130 && w <= 170 && h >= 145 && h <= 155)
					intensity = 1.0f;


				//Number 2
				if(d >= 5 && d <= 55 && w >= 5 && w <= 45 && h >= 5 && h <= 15)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 5 && w <= 45 && h >= 35 && h <= 45)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 5 && w <= 45 && h >= 65 && h <= 75)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 5 && w <= 15 && h >= 5 && h <= 45)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 35 && w <= 45 && h >= 35 && h <= 75)
					intensity = 1.0f;

				//Number 0
				if(d >= 5 && d <= 55 && w >= 55 && w <= 95 && h >= 5 && h <= 15)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 55 && w <= 95 && h >= 65 && h <= 75)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 55 && w <= 65 && h >= 5 && h <= 75)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 85 && w <= 95 && h >= 5 && h <= 75)
					intensity = 1.0f;

				//Number 11
				if(d >= 5 && d <= 55 && w >= 105 && w <= 145 && h >= 5 && h <= 15)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 120 && w <= 130 && h >= 5 && h <= 75)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 105 && w <= 130 && h >= 65 && h <= 75)
						intensity = 1.0f;

				//Number 11
				if(d >= 5 && d <= 55 && w >= 155 && w <= 195 && h >= 5 && h <= 15)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 170 && w <= 180 && h >= 5 && h <= 75)
					intensity = 1.0f;
				if(d >= 5 && d <= 55 && w >= 155 && w <= 180 && h >= 65 && h <= 75)
					intensity = 1.0f;
*/
				
				//				volume->setVoxel((card32)w, (card32)h, (card32)d, POSITION,  position);
				volume->setVoxel((card32)w, (card32)h, (card32)d, INTENSITY, intensity);
			}
		}
	}
	RegularInCoreVolume* RICvolume = new RegularInCoreVolume();
	RICvolume->setVoxels(volume);
	addSceneObject(scene,RICvolume,volumeName);
}