#ifndef PCICameraManagerEditorWidgetH 
#define PCICameraManagerEditorWidgetH
//---------------------------------------------------------------------------
#include "x3editor.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "PCICameraManagerEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace X4
{
class PCICameraManager;
class ClassSelectionDialog;

class X3EDITOR_API PCICameraManagerEditorWidget : public QWidget
{
	Q_OBJECT

private:

	PCICameraManager	*	m_Object;

	///used to access buttons, etc. from QtDesigner
	Ui_PCICameraManagerEditorForm ui;

	ClassSelectionDialog * m_ClassDlg;
	QWidget			*	m_CameraEditorWidget;
	ClassEditor		*	m_CameraEditor;

public:
	PCICameraManagerEditorWidget(QWidget * parent = NULL, Qt::WindowFlags f=0);
	~PCICameraManagerEditorWidget(void);

	void setup( PCICameraManager * obj );

	/// update editor content with object data
	void updateEditor();

public slots:

	void on_pbAdd_clicked();
	void on_pbAddPanCam_clicked();
	void on_pbEdit_clicked();
	void on_listCameras_currentTextChanged(const QString &);

};

MAKE_CLASS_EDITOR( X3EDITOR_API , PCICameraManager )


}

#endif