#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "PCIFilterToolEditorWidget.h"
//---------------------------------------------------------------------------
#include "PCIFilterTool.h"
//---------------------------------------------------------------------------
using namespace X4;

IMPLEMENT_CLASS_EDITOR( PCIFilterTool )

PCIFilterToolEditorWidget::PCIFilterToolEditorWidget(QWidget * parent, Qt::WindowFlags f)
:QWidget(parent,f)
{
	obj=NULL;
	//call ui.setupUi(this) to set up the layout from QtDesigner
	ui.setupUi(this);
	//Example: easy access to QtDesigner buttons, etc. by ui object
	//QWidget::connect(ui.loadButton,SIGNAL(clicked()),this,SLOT(sltLoadFile()));
	ui.attributeBox->addItem("color");
	ui.attributeBox->addItem("position");
	ui.attributeBox->addItem("normal");

}

PCIFilterToolEditorWidget::~PCIFilterToolEditorWidget(void)
{
}

void PCIFilterToolEditorWidget::setup( PCIFilterTool * obj )
{
	this->obj = obj;
}

void PCIFilterToolEditorWidget::updateEditor()
{
	switch(obj->mode)
	{
	case 0:
		ui.averageButton->setChecked(true);
		break;
	case 1:
		ui.medianButton->setChecked(true);
		break;
	case 2:
		ui.gaussButton->setChecked(true);
		break;
	default:
		break;
	}

	if(obj->use_kNN){
		ui.knnButton->setChecked(true);
		ui.knnCountBox->setEnabled(true);
		ui.attributeBox->setEnabled(true);
	}else{
		if(obj->use_Heightmap){
			ui.hightButton->setChecked(true);
			ui.attributeBox->setCurrentIndex(1);
			ui.attributeBox->setEnabled(false);
			ui.knnCountBox->setEnabled(true);
		}

		else{
			ui.geoButton->setChecked(true);
			ui.knnCountBox->setEnabled(false);
			ui.attributeBox->setEnabled(true);
		}
	}


	ui.knnCountBox->setValue(obj->kNN_numPoints);
	ui.strengthSpinBox->setValue(obj->strength);
	ui.attributeBox->setCurrentIndex(obj->channel);
	ui.brushBox->setValue(obj->size);

}

void PCIFilterToolEditorWidget::on_averageButton_clicked(){
	obj->mode=0;
}
void PCIFilterToolEditorWidget::on_medianButton_clicked(){
	obj->mode=1;
}

void PCIFilterToolEditorWidget::on_gaussButton_clicked(){
	obj->mode=2;
}

void PCIFilterToolEditorWidget::on_geoButton_clicked(){
	obj->use_kNN = false;
	obj->use_Heightmap = false;
	updateEditor();

}

void PCIFilterToolEditorWidget::on_knnButton_clicked(){
	obj->use_kNN = true;
	obj->use_Heightmap = false;
	updateEditor();

}

void PCIFilterToolEditorWidget::on_hightButton_clicked(){
	obj->use_kNN = false;
	obj->use_Heightmap = true;
	updateEditor();

}

void PCIFilterToolEditorWidget::on_knnCountBox_valueChanged(int v){
	obj->kNN_numPoints=v;
}

void PCIFilterToolEditorWidget::on_strengthSpinBox_valueChanged(double v){
	obj->strength=v;
}

void PCIFilterToolEditorWidget::on_attributeBox_currentIndexChanged(int v){
	if(!obj) return;
	obj->channel=v;
	updateEditor();
}

void PCIFilterToolEditorWidget::on_brushBox_valueChanged(int v){
	obj->size = v;
}

void PCIFilterToolEditorWidget::on_completeSceneButton_clicked(){
	obj->filterScene();
	ObjectViewsTable::update(obj->getScene());
}



#include "PCIFilterToolEditorWidget_moc.h"
