#ifndef PCIFilterToolEditorWidgetH 
#define PCIFilterToolEditorWidgetH
//---------------------------------------------------------------------------
#include "x3editor.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "PCIFilterToolEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace X4
{
class PCIFilterTool;

class X3EDITOR_API PCIFilterToolEditorWidget : public QWidget
{
	Q_OBJECT

private:

	PCIFilterTool	*	obj;

	///used to access buttons, etc. from QtDesigner
	Ui::PCIFilterToolEditorForm ui;

public:
	PCIFilterToolEditorWidget(QWidget * parent = NULL, Qt::WindowFlags f=0);
	~PCIFilterToolEditorWidget(void);

	void setup( PCIFilterTool * obj );

	/// update editor content with object data
	void updateEditor();

private slots:

	void on_averageButton_clicked();
	void on_medianButton_clicked();
	void on_gaussButton_clicked();
	void on_geoButton_clicked();
	void on_knnButton_clicked();
	void on_hightButton_clicked();
	void on_knnCountBox_valueChanged(int);
   void on_strengthSpinBox_valueChanged(double);
	void on_attributeBox_currentIndexChanged(int);
	void on_brushBox_valueChanged(int);
	void on_completeSceneButton_clicked();



};

MAKE_CLASS_EDITOR( X3EDITOR_API , PCIFilterTool )


}

#endif