#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "PCIMappingToolEditorWidget.h"
//---------------------------------------------------------------------------
#include "PCIMappingTool.h"
#include <QFileDialog>
//---------------------------------------------------------------------------
using namespace X4;

IMPLEMENT_CLASS_EDITOR( PCIMappingTool )

PCIMappingToolEditorWidget::PCIMappingToolEditorWidget(QWidget * parent, Qt::WindowFlags f)
:QWidget(parent,f)
{
	//call ui.setupUi(this) to set up the layout from QtDesigner
	ui.setupUi(this);
	//Example: easy access to QtDesigner buttons, etc. by ui object
	//QWidget::connect(ui.loadButton,SIGNAL(clicked()),this,SLOT(sltLoadFile()));
	ui.textureView->setPixmap(QPixmap(QString::fromUtf8("../images/LoadFile.bmp")));


		
}

PCIMappingToolEditorWidget::~PCIMappingToolEditorWidget(void)
{
}

void PCIMappingToolEditorWidget::setup( PCIMappingTool * obj )
{
	this->obj = obj;
}

void PCIMappingToolEditorWidget::updateEditor()
{
	ui.hightSpinBox->setValue( obj->scale);
	ui.brushBox->setValue(obj->size);


	ui.colorBox->setChecked(obj->col);
	ui.positionBox->setChecked(obj->pos);
	ui.normalBox->setChecked(obj->pnorm);

	ui.fadingBox->setChecked(obj->soft);
	ui.raiseBox->setChecked(obj->getDispMode());

	ui.colorBox->setEnabled(obj->load);
	ui.positionBox->setEnabled(obj->load);
	ui.normalBox->setEnabled(obj->load);

	if(obj->load){
		QImage* tmpBmp=obj->getBMP();
		if(tmpBmp){
			//t->Bitmap=tmpBmp;
			ui.textureView->setPixmap(QPixmap::fromImage(*tmpBmp));
			ui.fileNameLineEdit->setText(obj->fn.c_str());
	/*	}else{
			Image1->Picture=loadPic;
			EditName->Text="Texture was deleted";*/
		}
	}
}

void PCIMappingToolEditorWidget::on_loadButton_clicked(){
	QString s = QFileDialog::getOpenFileName(
		this,
		"Choose a file",
		"",
		"Images (*.png *.xpm *.jpg *.bmp);;All Files (*.*)");
	if (!s.isEmpty()){ 
		ui.textureView->setPixmap(QPixmap(s));
		obj->fn=(char*)qPrintable(s);
		obj->setPC((char*)qPrintable(s));
		obj->loadTexture((char*)qPrintable(s));
		ui.fileNameLineEdit->setText(s);
		obj->load=true;
	}
	this->updateEditor();
}

void PCIMappingToolEditorWidget::on_view3dButton_clicked(){
	obj->viewTex3D();
}

void PCIMappingToolEditorWidget::on_brushBox_valueChanged(int v){
	obj->size=v;
}

void PCIMappingToolEditorWidget::on_colorBox_clicked(){
	obj->col=ui.colorBox->isChecked();
}

void PCIMappingToolEditorWidget::on_positionBox_clicked(){
	obj->pos=ui.positionBox->isChecked();
}

void PCIMappingToolEditorWidget::on_normalBox_clicked(){
	obj->pnorm=ui.normalBox->isChecked();
}

void PCIMappingToolEditorWidget::on_raiseBox_clicked(){
	obj->setDispMode(ui.raiseBox->isChecked());
}

void PCIMappingToolEditorWidget::on_hightSpinBox_valueChanged(double v){
	obj->setDispScale(v);
}

void PCIMappingToolEditorWidget::on_fadingBox_clicked(){
	obj->soft=ui.fadingBox->isChecked();
}








#include "PCIMappingToolEditorWidget_moc.h"
