#ifndef PCIMappingToolEditorWidgetH 
#define PCIMappingToolEditorWidgetH
//---------------------------------------------------------------------------
#include "x3editor.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "PCIMappingToolEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace X4
{
class PCIMappingTool;

class X3EDITOR_API PCIMappingToolEditorWidget : public QWidget
{
	Q_OBJECT

private:

	PCIMappingTool	*	obj;

	///used to access buttons, etc. from QtDesigner
	Ui_PCIMappingToolEditorForm ui;

public:
	PCIMappingToolEditorWidget(QWidget * parent = NULL, Qt::WindowFlags f=0);
	~PCIMappingToolEditorWidget(void);

	void setup( PCIMappingTool * obj );

	/// update editor content with object data
	void updateEditor();


private slots:
	void on_loadButton_clicked();
	void on_view3dButton_clicked();
	void on_brushBox_valueChanged(int);
	void on_colorBox_clicked();
	void on_positionBox_clicked();
	void on_normalBox_clicked();
	void on_raiseBox_clicked();
	void on_hightSpinBox_valueChanged(double);
	void on_fadingBox_clicked();

};

MAKE_CLASS_EDITOR( X3EDITOR_API , PCIMappingTool )


}

#endif