#ifndef PCITransfEditEditorWidgetH 
#define PCITransfEditEditorWidgetH
//---------------------------------------------------------------------------
#include "x3editor.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "PCITransfEditEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace X4
{
class PCITransfEdit;

class X3EDITOR_API PCITransfEditEditorWidget : public QWidget
{
	Q_OBJECT

private:

	PCITransfEdit	*	m_TransfEdit;

	///used to access buttons, etc. from QtDesigner
	Ui_PCITransfEditEditorForm ui;

public:
	PCITransfEditEditorWidget(QWidget * parent = NULL, Qt::WindowFlags f=0);
	~PCITransfEditEditorWidget(void);

	void setup( PCITransfEdit * obj );

	/// update editor content with object data
	void updateEditor();

public slots:
	void sltTransfModeToggled(bool);
	void on_BTAffectClouds_clicked();
	void on_BTAffectPoints_clicked();
	void on_CBWorldCoordinates_stateChanged(int);
	void on_BTApplyDirectValues_clicked();
	void on_BTMovePivot_clicked(bool);
	void on_BTCenterOnSelectedClouds_clicked();
	void on_BTCenterOnSelectedPoints_clicked();
	void on_CBLockPivot_stateChanged(int);
	void on_CBStepwiseMoveBy_stateChanged(int);
	void on_CBStepwiseRotateBy_stateChanged(int);
	void on_SBMoveBy_valueChanged(double);
	void on_SBRotateBy_valueChanged(double);
	void on_CBShowWorldCS_stateChanged(int);
	void on_CBShowPivotCS_stateChanged(int);
	void on_SBWorldCSSize_valueChanged(double);
	void on_SBPivotCSSize_valueChanged(double);
	void on_BTGetTrans_clicked();
	void on_BTApplyTrans_clicked();

};

MAKE_CLASS_EDITOR( X3EDITOR_API , PCITransfEdit )


}

#endif


