//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "PCSceneMaterialBrowser.h"
//---------------------------------------------------------------------------
#include "Scene.h"
#include "PCSceneMaterialBrowserWidget.h"
#include "GLShaderMaterialEditorWidget.h"
//---------------------------------------------------------------------------
 
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



MetaClass* PCSceneMaterialBrowser::PCSceneMaterialBrowserMetaClass = NULL;

const MetaClass* PCSceneMaterialBrowser::getInstanceClass() const {
   return getClass();
}

Object* PCSceneMaterialBrowser::newInstance() {
   return new PCSceneMaterialBrowser;
}

const MetaClass* PCSceneMaterialBrowser::getClass() {
   if (PCSceneMaterialBrowserMetaClass == NULL) {
      PCSceneMaterialBrowserMetaClass = new MetaClass("PCSceneMaterialBrowser", "no description.",
                                       newInstance, sizeof(PCSceneMaterialBrowser));
   }
   return PCSceneMaterialBrowserMetaClass;
}

void PCSceneMaterialBrowser::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   PCSceneMaterialBrowserMetaClass->copyParentProperties();

}

void PCSceneMaterialBrowser::shutdown() {
   delete PCSceneMaterialBrowserMetaClass;
}


// --------------------------------------------

PCSceneMaterialBrowser::PCSceneMaterialBrowser()
{
//   edFrame = NULL;
   m_GLContext = NULL;
}



 QWidget * PCSceneMaterialBrowser::makeEditor( QWidget * parent, Object * obj )
{
   Scene *scene = dynamic_cast<Scene*>(obj);
   x4Assert(scene != NULL);
   x4Assert(m_GLContext != NULL );

   matEd= new PCSceneMaterialBrowserWidget(parent);

   matEd->setup( scene );
   matEd->setGLContext( m_GLContext );
   return matEd;
}


Object* PCSceneMaterialBrowser::getObject() {
   return matEd->getObject();
}

void PCSceneMaterialBrowser::apply() {
   matEd->apply();
}

void PCSceneMaterialBrowser::update() {
  matEd->update();
}

card32 PCSceneMaterialBrowser::getPreferredWidth() {
  
	 return  matEd->width();

}

card32 PCSceneMaterialBrowser::getPreferredHeight() {
	 return matEd->height();
}

// ----
