#ifndef PCSceneMaterialBrowserWidgetH 
#define PCSceneMaterialBrowserWidgetH
//---------------------------------------------------------------------------
#include "x3editor.h"
//---------------------------------------------------------------------------
#include "PCSceneMaterialBrowserForm_ui.h"
//---------------------------------------------------------------------------
#include <qTreeWidget>
//---------------------------------------------------------------------------

namespace X4
{
class Scene;
class GLContext;
class ClassSelectionDialog;
class MatTreeWidget;

class X3EDITOR_API PCSceneMaterialBrowserWidget :
	 public QWidget, private Ui::PCSceneMaterialBrowserForm //ui test (ab)
{
	 	Q_OBJECT

public:
	 PCSceneMaterialBrowserWidget(QWidget * parent = NULL, Qt::WindowFlags f=0);

private slots:
    void on_addButton_clicked();
    void on_editButton_clicked();
	 void treeWidget_itemDoubleClicked(QTreeWidgetItem*, int); 
    void on_loadButton_clicked();
    void on_saveButton_clicked();
	 void on_delButton_clicked();


public:
   Object* getObject();
   void apply();
   void update();
   void setup( Scene * );
   void setGLContext(GLContext * context) {m_GLContext = context;}



private:
	GLContext * m_GLContext;
	Scene *m_Scene;
	MatTreeWidget * treeWidget;

};

class X3EDITOR_API MatTreeWidget : public QTreeWidget
{
public:
	MatTreeWidget( QWidget * parent );

protected:
	virtual void mousePressEvent( QMouseEvent * e );
	virtual void mouseMoveEvent( QMouseEvent * e );
	QPoint	m_dragStartPosition;
	int		m_drawItemID;
};


}
#endif