//---------------------------------------------------------------------------
#ifndef PointCloudExporterH
#define PointCloudExporterH
//---------------------------------------------------------------------------
#include "x3editor.h"
//---------------------------------------------------------------------------
#include <fstream>
//---------------------------------------------------------------------------
#include "PointCloud.h"
#include "VertexDescriptor.h"
#include "PointCloudIterators.h"
//---------------------------------------------------------------------------

namespace X4 {


class X3EDITOR_API AttributeWriter {
  private:
    AAT attribToken;
    VAD attribDesc;

  public:
    AttributeWriter(VAD& attribDesc, AAT& attribToken);
    void writeAttrib(std::ofstream& outf, BasicPointCloudIterator* basicIt);
};

class X3EDITOR_API PointCloudExporter {
 private:
   PointCloud* pc;
   std::ofstream* outf;

 public:
   PointCloudExporter(PointCloud* pc, std::ofstream* outf);
   void exportPointCloud();
};

}

//---------------------------------------------------------------------------
#endif
