//---------------------------------------------------------------------------
#include "stdafx.h"
//---------------------------------------------------------------------------
#include "PointCloudImporterReader.h"
//---------------------------------------------------------------------------
#include "NumericalClassProperty.h"

#include "StringClassProperty.h"
#include "ObjectClassProperty.h"
#include "BooleanClassProperty.h"
//---------------------------------------------------------------------------
 
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



MetaClass* PointCloudImporterReader::PointCloudImporterReaderMetaClass = NULL;

const MetaClass* PointCloudImporterReader::getInstanceClass() const {
   return getClass();
}

const MetaClass* PointCloudImporterReader::getClass() {
   if (PointCloudImporterReaderMetaClass == NULL) {
      PointCloudImporterReaderMetaClass = new MetaClass("PointCloudImporterReader", "no description.",
                                       NULL, sizeof(PointCloudImporterReader));
   }
   return PointCloudImporterReaderMetaClass;
}

void PointCloudImporterReader::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   PointCloudImporterReaderMetaClass->copyParentProperties();
	BEGIN_CLASS_INIT( PointCloudImporterReader )
	ADD_CARD32_PROP(width, 0)
   SET_USER_EDIT( false )
	ADD_BOOLEAN_PROP(IKnowWidth, 0)
   SET_USER_EDIT( false )
	ADD_CARD32_PROP(height, 0)
   SET_USER_EDIT( false )
	ADD_BOOLEAN_PROP(IKnowHeight, 0)
   SET_USER_EDIT( false )
	ADD_OBJECT_PROP(myVD, 0, VertexDescriptor::getClass(), true)
	ADD_OBJECT_PROP(myTD, 0, VertexDescriptor::getClass(), true)
	ADD_BOOLEAN_PROP(ImportStarted, 0)
   SET_USER_EDIT( false )
	ADD_BOOLEAN_PROP(ImportFinished, 0)
   SET_USER_EDIT( false )
}

void PointCloudImporterReader::shutdown() {
   delete PointCloudImporterReaderMetaClass;
}

PointCloudImporterReader::PointCloudImporterReader() {

	width = 0;
   height = 0;
   IKnowWidth = false;
   IKnowHeight = false;
   ImportStarted = false;
   ImportFinished = false;

   myVD = NULL;
	myTD = NULL;
   buffer = NULL;
	tribuffer = NULL;
}

PointCloudImporterReader::~PointCloudImporterReader() {
   delete[] buffer;
   delete[] tribuffer;
   delete myVD;
	delete myTD;
}

void PointCloudImporterReader::assign(const Object* obj, X4CopyContext *context) {
   const PointCloudImporterReader *other = dynamic_cast<const PointCloudImporterReader*>(obj);
   x4Assert(other != NULL);

	this->width = other->width;
   this->height = other->height;
   this->IKnowWidth = other->IKnowWidth;
   this->IKnowHeight = other->IKnowHeight;
   this->ImportStarted = other->ImportStarted;
   this->ImportFinished = other->ImportFinished;

   if (other->myVD == NULL) {
      this->myVD = NULL;
   } else {
      this->myVD = (VertexDescriptor*)(other->myVD->copy(context));
   };

   if (other->myTD == NULL) {
      this->myTD = NULL;
   } else {
      this->myTD = (VertexDescriptor*)(other->myTD->copy(context));
   };

	delete[] buffer;
   if (other->buffer == NULL) {
      this->buffer = NULL;
   } else {
      this->buffer = new card8[myVD->getSize()];
   }

	delete[] tribuffer;
   if (other->tribuffer == NULL) {
      this->tribuffer = NULL;
   } else {
      this->tribuffer = new card8[myTD->getSize()];
   }
}

const VertexDescriptor* PointCloudImporterReader::getVertexDescriptor() {
   return myVD;
};

const VertexDescriptor* PointCloudImporterReader::getTriangleDescriptor() {
   return myTD;
};
