//---------------------------------------------------------------------------
#ifndef PointCloudImporterReaderBSMH
#define PointCloudImporterReaderBSMH
//---------------------------------------------------------------------------
#include "x3editor.h"
//---------------------------------------------------------------------------
#include "PointCloudImporterReader.h"
#include "VertexDescriptor.h"
//---------------------------------------------------------------------------

/// used internally by PointCloudImporterReaderBSM, declared in cpp file
class JDSimpleMesh;

namespace X4
{

/**
	Importer for James Diebel's BSM format
*/
class X3EDITOR_API PointCloudImporterReaderBSM : public PointCloudImporterReader
{
	X4_CLASS( PointCloudImporterReaderBSM )

private:
	JDSimpleMesh *mesh;
	card32 pointIndex, faceIndex;
	AAT aatVertexPosition;
	AAT aatVertexNormal;
	AAT aatVertexColor;
	AAT aatTriangleIndex;
	AAT aatTriangleNormal;
	VAD vadVertexPosition;
	VAD vadVertexNormal;
	VAD vadVertexColor;
	VAD vadTriangleIndex;
	VAD vadTriangleNormal;
	bool readTriangles;

public:
	PointCloudImporterReaderBSM(void);
	~PointCloudImporterReaderBSM(void);

   virtual bool beginImport(std::string filename, bool readTrianglesIfPossible=false);
   virtual const card8* getNextPoint();
	virtual const card8* getNextTriangle();
   virtual void endImport();
   virtual mpcard getWidth();
	virtual mpcard getHeight();
	virtual mpcard getProgressPercentage();
   virtual bool supportsTriangleImport();

};

}

#endif