#ifndef PointCloudImporterReaderCustomASCIIEditorWidgetH 
#define PointCloudImporterReaderCustomASCIIEditorWidgetH
//---------------------------------------------------------------------------
#include "x3editor.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "PointCloudImporterReaderCustomASCIIEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace X4
{
class PointCloudImporterReaderCustomASCII;

class X3EDITOR_API PointCloudImporterReaderCustomASCIIEditorWidget : public QWidget
{
	Q_OBJECT

private:

	PointCloudImporterReaderCustomASCII	*	m_Object;

	///used to access buttons, etc. from QtDesigner
	Ui_PointCloudImporterReaderCustomASCIIEditorForm ui;

	void setCBCommentMarkers(std::vector<std::string>);
	std::vector<std::string> getCBCommentMarkers();
	void setCBColumns(std::vector<card32>);
	std::vector<card32> getCBColumns();
	bool ColumnIsInColumnList(card32 col, std::vector<card32> colList);
	void setCBSeparator(std::string sep);
	bool presetChangedNotByUser;

	ClassEditor *vdEditor;
   QWidget *vdEditorWidget;

public:
	PointCloudImporterReaderCustomASCIIEditorWidget(QWidget * parent = NULL, Qt::WindowFlags f=0);
	~PointCloudImporterReaderCustomASCIIEditorWidget(void);

	void setup( PointCloudImporterReaderCustomASCII * obj );

	/// update editor content with object data
	void updateEditor();


protected slots:
	void sltCBPresetsCurrentIndexChanged(int);
	void on_SBWidth_valueChanged(int);
	void on_SBHeight_valueChanged(int);
	void on_SBIgnoreFirstLines_valueChanged(int);
	void on_CBCommentMarkers_currentIndexChanged(int);
	void on_BTRemoveLines_clicked();
	void on_CBColumns_currentIndexChanged(int);
	void on_BTRemoveColumns_clicked();
	void sltRadioButtonPressed();
	void on_BTGenerateSampleFile_clicked();
	void sltCBSeparatorCurrentIndexChanged(int);
};

MAKE_CLASS_EDITOR( X3EDITOR_API , PointCloudImporterReaderCustomASCII )


}

#endif