//---------------------------------------------------------------------------
#ifndef PointCloudImporterReaderVelodyneH
#define PointCloudImporterReaderVelodyneH
//---------------------------------------------------------------------------
#include "x3editor.h"
//---------------------------------------------------------------------------
#include "PointCloudImporterReader.h"
//---------------------------------------------------------------------------
#include <stdio.h>
//---------------------------------------------------------------------------

namespace X4 {

class LargeBinaryFile;

///
///   Universal Importer for Binary Files
///
class X3EDITOR_API PointCloudImporterReaderVelodyne : public PointCloudImporterReader {
	X4_CLASS( PointCloudImporterReaderVelodyne )
 private:
   card32 headerLength;
   VertexDescriptor *vertexDescriptor;

   // --- tmp state
   LargeBinaryFile *f;
   card8 *outBuffer;
   card8 *inBuffer;
   card32 pointSize;
   card32 positionOffset;
   card64 fileSize;
   card64 bytesRead;
   AAT posAAT;
   bool checkPos;
   bool positionIsFloat64;
   bool relativizePosition;
   Vector3d zeroPosition;
   bool zeroPositionInitialized; // TODO (daniel): Document how this field works
   
 public:
	PointCloudImporterReaderVelodyne();

	virtual void assign(const Object* obj, X4CopyContext *context = NULL);

   virtual bool beginImport( std::string filename, bool readTrianglesIfPossible=false );
   virtual const card8* getNextPoint();
	virtual const card8* getNextTriangle();
   virtual void endImport();

   virtual mpcard getWidth();
	virtual mpcard getHeight();

	virtual mpcard getProgressPercentage();

   virtual bool supportsTriangleImport();

   ~PointCloudImporterReaderVelodyne();
};

}

#endif