//---------------------------------------------------------------------------
#include "stdafx.h"
 
//---------------------------------------------------------------------------
#include "SceneCommandObjects.h"
//---------------------------------------------------------------------------
#include "FixedArrayClassProperty.h"
#include "StringClassProperty.h"
#include "ObjectClassProperty.h"
#include "PCCommand.h"
#include "Scene.h"
#include "SceneGraphState.h"
#include "EmbeddedObjectClassProperty.h"
#include "PointCloud.h"
#include "PointSet.h"
#include "PointSet.inline.h"
#include "PointCloudIterators.h"
#include "IteratorAdaptors.h"
#include "SelectionIteratorAdaptor.h"
#include "GeometricRange.h"
#include "GeometricRangeIteratorAdaptor.h"
#include "UnstructuredInCorePointCloud.h"
#include "VertexDescriptor.h"
#include "ObjectViewsTable.h"
#include "MathTools.h"
#include "MathTools.inline.h"
#include "DebugOutput.h"
//#include "HierarchicalInCorePointCloud.h"
//#include "HierarchicalOutOfCorePointCloud.h"
#include "SGLegacyPCSceneAdaptor.h"
#include "SceneGraphNode.h"
#include "PointCloudTools.h"
#include "SelectionTools.h"
#include "SGObjectNode.h"
#include "StandardSceneGraphIterator.h"
#include "SGIndexedAndByNameSceneGraphIteratorAdaptor.h"
#include "SGSceneObjectFilterAdaptor.h"
#include "BooleanClassProperty.h"
#include "VariableArrayClassProperty.h"
#include "CopyObjectProperties.h"
#include "SceneGraphState.h"
// xxx hierarchy removed: #include "SGAllocatorList.h"
#include "scene.h"
// xxx hierarchy removed: #include "MultiFileMultiObjectStreamMT.h"
//---------------------------------------------------------------------------
 
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



MetaClass* CmdObjDeletePCs::CmdObjDeletePCsMetaClass = NULL;

const MetaClass* CmdObjDeletePCs::getInstanceClass() const {
   return getClass();
}

Object* CmdObjDeletePCs::newInstance() {
   return new CmdObjDeletePCs;
}

const MetaClass* CmdObjDeletePCs::getClass() {
   if (CmdObjDeletePCsMetaClass==NULL) {
      CmdObjDeletePCsMetaClass = new MetaClass("CmdObjDeletePCs", "no description.",
                                  newInstance, sizeof(CmdObjDeletePCs));
   }
   return CmdObjDeletePCsMetaClass;
}



std::string CmdObjDeletePCs::getDPC(mpcard index) const {
   return m_deletedPCs[index];
}

void CmdObjDeletePCs::setDPC(mpcard index, std::string n) {
   m_deletedPCs[index] = n;
}

mpcard CmdObjDeletePCs::getNumDPC() const {
   return m_deletedPCs.size();
}
void CmdObjDeletePCs::setNumDPC(mpcard size) {
   m_deletedPCs.resize(size);
}

void CmdObjDeletePCs::pushDPC() {
   m_deletedPCs.push_back(std::string(""));
}

void CmdObjDeletePCs::popDPC() {
   m_deletedPCs.pop_back();
}


void CmdObjDeletePCs::init(const MetaClass *parentClass) {
	((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   CmdObjDeletePCsMetaClass->copyParentProperties();

	ADD_STRING_VAR_ARRAY_PROP( DeletedPointCloud, 0 );

/*   ArrayClassProperty<std::string> *dpcProp = new ArrayClassProperty<std::string>("m_deletedPCs", 1,
      (ArrayClassProperty<std::string>::ArrayGetPropertyMethod)getDPC,
      (ArrayClassProperty<std::string>::ArraySetPropertyMethod)setDPC,
      (ArrayClassProperty<std::string>::GetArraySizeMethod)getNumDPC,
      (ArrayClassProperty<std::string>::SetArraySizeMethod)setNumDPC,
      1,
      (ArrayClassProperty<std::string>::PushMethod)pushDPC,
      (ArrayClassProperty<std::string>::PopMethod)popDPC);
   CmdObjDeletePCsMetaClass->addProperty(dpcProp);*/
}

void CmdObjDeletePCs::shutdown() {
   delete CmdObjDeletePCsMetaClass;
}


// ----


MetaClass* CmdObjRenamePC::CmdObjRenamePCMetaClass = NULL;

const MetaClass* CmdObjRenamePC::getInstanceClass() const {
   return getClass();
}

Object* CmdObjRenamePC::newInstance() {
   return new CmdObjRenamePC;
}

const MetaClass* CmdObjRenamePC::getClass() {
   if (CmdObjRenamePCMetaClass==NULL) {
      CmdObjRenamePCMetaClass = new MetaClass("CmdObjRenamePC", "no description.",
                                  newInstance, sizeof(CmdObjRenamePC));
   }
   return CmdObjRenamePCMetaClass;
}

void CmdObjRenamePC::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   CmdObjRenamePCMetaClass->copyParentProperties();
	 BEGIN_CLASS_INIT(CmdObjRenamePC)
	 ADD_STRING_PROP(m_oldName , 0 );
	 SET_EDIT_READONLY( true ) 
	 ADD_STRING_PROP(m_newName , 0 );
}

void CmdObjRenamePC::shutdown() {
   delete CmdObjRenamePCMetaClass;
}


// ----


MetaClass* CmdObjPCCommand::CmdObjPCCommandMetaClass = NULL;

const MetaClass* CmdObjPCCommand::getInstanceClass() const {
   return getClass();
}

Object* CmdObjPCCommand::newInstance() {
   return new CmdObjPCCommand;
}

const MetaClass* CmdObjPCCommand::getClass() {
   if (CmdObjPCCommandMetaClass==NULL) {
      CmdObjPCCommandMetaClass = new MetaClass("CmdObjPCCommand", "no description.",
                                               newInstance, sizeof(CmdObjPCCommand));
   }
   return CmdObjPCCommandMetaClass;
}

void CmdObjPCCommand::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   CmdObjPCCommandMetaClass->copyParentProperties();
	 BEGIN_CLASS_INIT(CmdObjPCCommand)
	 ADD_OBJECT_PROP(m_cmd ,0, PCCommand::getClass(), true)
}

void CmdObjPCCommand::shutdown() {
   delete CmdObjPCCommandMetaClass;
}


// ----


MetaClass* CmdObjChangeView::CmdObjChangeViewMetaClass = NULL;

const MetaClass* CmdObjChangeView::getInstanceClass() const {
   return getClass();
}

Object* CmdObjChangeView::newInstance() {
   return new CmdObjChangeView;
}

const MetaClass* CmdObjChangeView::getClass() {
   if (CmdObjChangeViewMetaClass==NULL) {
      CmdObjChangeViewMetaClass = new MetaClass("CmdObjChangeView", "no description.",
                                  newInstance, sizeof(CmdObjChangeView));
   }
   return CmdObjChangeViewMetaClass;
}

void CmdObjChangeView::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 1);
   CmdObjChangeViewMetaClass->copyParentProperties();
	BEGIN_CLASS_INIT(CmdObjChangeView)
	ADD_BOOLEAN_PROP(setViewFrustum  , 0)
	ADD_EMBEDDED_OBJECT_PROP( cam, 0, Camera::getClass() );
	//SET_NAME( "Camera" );
	ADD_EMBEDDED_OBJECT_PROP( viewFrustum, 0, ViewFrustum::getClass() );
	//SET_NAME( "ViewFrustum" );
	ADD_EMBEDDED_OBJECT_PROP( old_cam, 0, Camera::getClass() );
	//SET_NAME( "old Camera" );
}

void CmdObjChangeView::shutdown() {
   delete CmdObjChangeViewMetaClass;
}


// ----


MetaClass* CmdObjChangePCFlags::CmdObjChangePCFlagsMetaClass = NULL;

const MetaClass* CmdObjChangePCFlags::getInstanceClass() const {
   return getClass();
}

Object* CmdObjChangePCFlags::newInstance() {
   return new CmdObjChangePCFlags;
}

const MetaClass* CmdObjChangePCFlags::getClass() {
   if (CmdObjChangePCFlagsMetaClass==NULL) {
      CmdObjChangePCFlagsMetaClass = new MetaClass("CmdObjChangePCFlags", "no description.",
                                  newInstance, sizeof(CmdObjChangePCFlags));
   }
   return CmdObjChangePCFlagsMetaClass;
}

void CmdObjChangePCFlags::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   CmdObjChangePCFlagsMetaClass->copyParentProperties();
BEGIN_CLASS_INIT(CmdObjChangePCFlags)
ADD_STRING_PROP(targetName , 0 );
ADD_CARD32_PROP(flags ,0)
ADD_CARD32_PROP(oldFlags ,0)
SET_EDIT_READONLY( true ) 
}

void CmdObjChangePCFlags::shutdown() {
   delete CmdObjChangePCFlagsMetaClass;
}


// ----


MetaClass* CmdObjChangeSelection::CmdObjChangeSelectionMetaClass = NULL;

const MetaClass* CmdObjChangeSelection::getInstanceClass() const {
   return getClass();
}

Object* CmdObjChangeSelection::newInstance() {
   return new CmdObjChangeSelection;
}

const MetaClass* CmdObjChangeSelection::getClass() {
   if (CmdObjChangeSelectionMetaClass==NULL) {
      CmdObjChangeSelectionMetaClass = new MetaClass("CmdObjChangeSelection", "no description.",
                                  newInstance, sizeof(CmdObjChangeSelection));
   }
   return CmdObjChangeSelectionMetaClass;
}


std::string CmdObjChangeSelection::getSel(mpcard index) const {
   return m_selection[index];
}
void CmdObjChangeSelection::setSel(mpcard index, std::string n) {
   m_selection[index] = n;
}
mpcard CmdObjChangeSelection::getNumSel() const {
   return m_selection.size();
}
void CmdObjChangeSelection::setNumSel(mpcard size) {
   m_selection.resize(size);
}
void CmdObjChangeSelection::pushSel() {
   m_selection.push_back(std::string(""));
}
void CmdObjChangeSelection::popSel() {
   m_selection.pop_back();
}


std::string CmdObjChangeSelection::getOSel(mpcard index) const {
   return m_oldSelection[index];
}
void CmdObjChangeSelection::setOSel(mpcard index, std::string n) {
   m_oldSelection[index] = n;
}
mpcard CmdObjChangeSelection::getNumOSel() const {
   return m_oldSelection.size();
}
void CmdObjChangeSelection::setNumOSel(mpcard size) {
   m_oldSelection.resize(size);
}
void CmdObjChangeSelection::pushOSel() {
   m_oldSelection.push_back(std::string(""));
}
void CmdObjChangeSelection::popOSel() {
   m_oldSelection.pop_back();
}

void CmdObjChangeSelection::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   CmdObjChangeSelectionMetaClass->copyParentProperties();
	ADD_STRING_VAR_ARRAY_PROP( Selection, 0 );
	ADD_STRING_VAR_ARRAY_PROP( OldSelection, 0 );

	//X4_missing 2 variable arrays
	/*
   CmdObjChangeSelectionMetaClass->addProperty(
      new ArrayClassProperty<std::string>("m_selection", 1,
      (ArrayClassProperty<std::string>::ArrayGetPropertyMethod)getSel,
      (ArrayClassProperty<std::string>::ArraySetPropertyMethod)setSel,
      (ArrayClassProperty<std::string>::GetArraySizeMethod)getNumSel,
      (ArrayClassProperty<std::string>::SetArraySizeMethod)setNumSel,
      1,
      (ArrayClassProperty<std::string>::PushMethod)pushSel,
      (ArrayClassProperty<std::string>::PopMethod)popSel)
   );
   ArrayClassProperty<std::string> *old_sel_prop =
      new ArrayClassProperty<std::string>("m_oldSelection", 1,
      (ArrayClassProperty<std::string>::ArrayGetPropertyMethod)getOSel,
      (ArrayClassProperty<std::string>::ArraySetPropertyMethod)setOSel,
      (ArrayClassProperty<std::string>::GetArraySizeMethod)getNumOSel,
      (ArrayClassProperty<std::string>::SetArraySizeMethod)setNumOSel,
      1,
      (ArrayClassProperty<std::string>::PushMethod)pushOSel,
      (ArrayClassProperty<std::string>::PopMethod)popOSel);
   old_sel_prop->setUserEdit(false);
   CmdObjChangeSelectionMetaClass->addProperty(old_sel_prop);
	*/
}

void CmdObjChangeSelection::shutdown() {
   delete CmdObjChangeSelectionMetaClass;
}



// ----------------------------------------


void CmdObjDeletePCs::setup(std::vector<std::string> deletedPCs) {
   m_deletedPCs = deletedPCs;
}

void CmdObjDeletePCs::doAction(Object *context) {
   Scene *scene = dynamic_cast<Scene*>(context); x4Assert(scene);
   bool success = true;
   SGLegacyPCSceneAdaptor sceneLA(scene);
   for (card32 i=0; i<m_deletedPCs.size(); i++) {
      int32 idx = sceneLA.getPointCloudIndex(m_deletedPCs[i]);
      if (idx == -1) {
         success = false;
         continue;
      }
      std::vector<card32> pcs; pcs.push_back(idx);
      sceneLA.deletePointClouds(pcs);
   }
   if (!success) {
      throw ECommandFailed("CmdObjDeletePCs - not all point clouds to be deleted have been found.");
   }

}

void CmdObjDeletePCs::undoAction(Object *context) {
   forget(context);
   throw ECannotUndo("CmdObjDeletePCs does not provide any undo.");
}

bool CmdObjDeletePCs::canUndo() {
   return false;
}


std::string CmdObjDeletePCs::getDescription() {
   std::string result = std::string("delete point clouds:");
   for (card32 i=0; i<m_deletedPCs.size(); i++) {
      result += std::string(" \"") + m_deletedPCs[i] + std::string("\"");
   }
   return result;
}


// --

void CmdObjRenamePC::setup(std::string oldName, std::string newName) {
   m_oldName = oldName;
   m_newName = newName;
}

void CmdObjRenamePC::doAction(Object *context) {
   Scene *scene = dynamic_cast<Scene*>(context); x4Assert(scene);

   SGLegacyPCSceneAdaptor sceneLA(scene);
   int32 idx = sceneLA.getPointCloudIndex(m_oldName);
   if (idx == -1) {
      throw ECommandFailed(std::string("CmdObjRenamePC::doAction() - object with name \"")+m_oldName+std::string("\" has not been found."));
   }
   sceneLA.getNode(idx)->setName(m_newName);
}

void CmdObjRenamePC::undoAction(Object *context) {
   Scene *scene = dynamic_cast<Scene*>(context); x4Assert(scene);

   SGLegacyPCSceneAdaptor sceneLA(scene);
   int32 idx = sceneLA.getPointCloudIndex(m_newName);
   if (idx == -1) {
      throw ECommandFailed(std::string("CmdObjRenamePC::undoAction() - object with name \"")+m_newName+std::string("\" has not been found."));
   }
   sceneLA.getNode(idx)->setName(m_oldName);
}

bool CmdObjRenamePC::canUndo() {
   return true;
}


std::string CmdObjRenamePC::getDescription() {
   return std::string("rename \"") + m_oldName + std::string("\" to \"") + m_newName + std::string("\"."); 
}


// ---

CmdObjPCCommand::CmdObjPCCommand() {
   m_cmd = NULL;
}

void CmdObjPCCommand::setup(const PCCommand *cmd) {
   m_cmd = (PCCommand*)(cmd->copy());
   m_cmd->setScene( cmd->getScene() );
   m_cmd->setCallback( cmd->getCallback() );
}

void CmdObjPCCommand::doAction(Object *context) {
   Scene *scene = dynamic_cast<Scene*>(context); x4Assert(scene);

   if (m_cmd == NULL) {
      throw ECommandFailed("CmdObjPCCommand::doAction - m_cmd == NULL.");
   } else {
      m_cmd->connectScene(scene, NULL, NULL);
      m_cmd->execute(scene);
   }
}

void CmdObjPCCommand::undoAction(Object *context) {
   forget(context);
   throw ECannotUndo("CmdObjPCCommand does not provide any undo.");
}

bool CmdObjPCCommand::canUndo() {
   return false;
}


std::string CmdObjPCCommand::getDescription() {
   if (m_cmd != NULL) {
      return std::string("Executing PCCommand on scene, type: ") + m_cmd->getInstanceClass()->getClassName();
   } else {
      return std::string("Executing PCCommand on scene, type: <NULL> (not yet setup).");
   }
}

CmdObjPCCommand::~CmdObjPCCommand() {
   delete m_cmd;
}


void CmdObjChangeView::setup(const ViewFrustum &vf, const Camera &cam, bool setViewFrustum) {
   this->viewFrustum = vf;
   this->cam = cam;
   this->setViewFrustum = setViewFrustum;
}

void CmdObjChangeView::doAction(Object *context) {
   Scene *scene = dynamic_cast<Scene*>(context); x4Assert(scene);
   old_vf = scene->getRootState()->staticState->viewFrustum;
   old_cam = scene->getRootState()->staticState->camera;
   if (setViewFrustum) {
      scene->getRootState()->staticState->viewFrustum.setZNearClip(viewFrustum.getZNearClip());
      scene->getRootState()->staticState->viewFrustum.setZFarClip(viewFrustum.getZFarClip());
      scene->getRootState()->staticState->viewFrustum.setVerticalFieldOfView(viewFrustum.getVerticalFieldOfView());
   }
   scene->getRootState()->staticState->camera = cam;
}

void CmdObjChangeView::undoAction(Object *context) {
   Scene *scene = dynamic_cast<Scene*>(context); x4Assert(scene);
   if (setViewFrustum) {
      scene->getRootState()->staticState->viewFrustum.setZNearClip(old_vf.getZNearClip());
      scene->getRootState()->staticState->viewFrustum.setZFarClip(old_vf.getZFarClip());
      scene->getRootState()->staticState->viewFrustum.setVerticalFieldOfView(old_vf.getVerticalFieldOfView());
   }
   scene->getRootState()->staticState->camera = old_cam;
}

bool CmdObjChangeView::canUndo() {
   return true;
}


std::string CmdObjChangeView::getDescription() {
   return "change camera / view frustum";
}

bool CmdObjChangeView::mergeCommand(const CommandObject *nextCmd) {
   if (nextCmd->getInstanceClass() == CmdObjChangeView::getClass()) {
      const CmdObjChangeView *nextCmdMyType = dynamic_cast<const CmdObjChangeView*>(nextCmd);
      x4Assert(nextCmdMyType != NULL);
      this->viewFrustum = nextCmdMyType->viewFrustum;
      this->cam = nextCmdMyType->cam;
      return true;
   } else {
      return false;
   }
}


// --


void CmdObjChangePCFlags::setup(card32 flags, std::string targetName) {
   this->flags = flags;
   this->targetName = targetName;
}

void CmdObjChangePCFlags::doAction(Object *context) {
   Scene *scene = dynamic_cast<Scene*>(context); x4Assert(scene);
   SGLegacyPCSceneAdaptor sceneLA(scene);
   int32 i = sceneLA.getPointCloudIndex(targetName);
   if (i == -1) throw ECommandFailed(std::string("CmdObjChangePCFlags::doAction - target ") + targetName + std::string(" not found."));
   SceneGraphNode *node = sceneLA.getNode(targetName);
   oldFlags = node->getFlags();
   node->setFlags(flags);
}

void CmdObjChangePCFlags::undoAction(Object *context) {
   Scene *scene = dynamic_cast<Scene*>(context); x4Assert(scene);
   SGLegacyPCSceneAdaptor sceneLA(scene);
   int32 i = sceneLA.getPointCloudIndex(targetName);
   if (i == -1) throw ECommandFailed(std::string("CmdObjChangePCFlags::undoAction - target ") + targetName + std::string(" not found."));
   SceneGraphNode *node = sceneLA.getNode(targetName);
   node->setFlags(oldFlags);
}

bool CmdObjChangePCFlags::canUndo() {
   return true;
}


std::string CmdObjChangePCFlags::getDescription() {
   char buffer[100];
   return std::string("change flags to ") + std::string(itoa(flags, buffer, 10)) + std::string(" for pc ") + targetName;
}


// --


void CmdObjChangeSelection::setup(std::vector<std::string> selection) {
   m_selection = selection;
}

void CmdObjChangeSelection::doAction(Object *context) {
   Scene *scene = dynamic_cast<Scene*>(context); x4Assert(scene);
   m_oldSelection = getSelection(scene);
   setSelection(scene, m_selection);
}

void CmdObjChangeSelection::setSelection(Scene *scene, const std::vector<std::string> &selection) {
	scene->getRootState()->staticState->selectedNodes.clear();
	for (unsigned i=0; i<selection.size(); i++) {
		scene->getRootState()->staticState->selectedNodes.insert(selection[i]);
	}
}


std::vector<std::string> CmdObjChangeSelection::getSelection(Scene *scene) {
   std::vector<std::string> result;

	set<std::string>::iterator pos = scene->getRootState()->staticState->selectedNodes.begin();
	set<std::string>::iterator end = scene->getRootState()->staticState->selectedNodes.end();
	while (pos != end) {
		result.push_back(*pos);
		++pos;
	}
   return result;
}

void CmdObjChangeSelection::undoAction(Object *context) {
   Scene *scene = dynamic_cast<Scene*>(context); x4Assert(scene);
   setSelection(scene, m_oldSelection);
}

bool CmdObjChangeSelection::canUndo() {
   return true;
}


std::string CmdObjChangeSelection::getDescription() {
   std::string result = "select PCs:";
   for (card32 i=0; i<m_selection.size(); i++) {
      result += " ";
      result += m_selection[i];
   }
   return result;
}


// ----


MetaClass* CmdObjApplyRegisterTransform::CmdObjApplyRegisterTransformMetaClass = NULL;

const MetaClass* CmdObjApplyRegisterTransform::getInstanceClass() const {
   return getClass();
}

Object* CmdObjApplyRegisterTransform::newInstance() {
   return new CmdObjApplyRegisterTransform;
}

const MetaClass* CmdObjApplyRegisterTransform::getClass() {
   if (CmdObjApplyRegisterTransformMetaClass==NULL) {
      CmdObjApplyRegisterTransformMetaClass = new MetaClass("CmdObjApplyRegisterTransform", "no description.",
                                  newInstance, sizeof(CmdObjApplyRegisterTransform));
   }
   return CmdObjApplyRegisterTransformMetaClass;
}



void CmdObjApplyRegisterTransform::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 1);
   CmdObjApplyRegisterTransformMetaClass->copyParentProperties();

   BEGIN_CLASS_INIT(CmdObjApplyRegisterTransform)
   ADD_FLOAT32_FIXED_ARRAY_PROP(d , 0 , 16, 3)
   ADD_FLOAT32_FIXED_ARRAY_PROP(u , 0 , 16, 3)
   ADD_STRING_PROP(target , 0 );
}


void CmdObjApplyRegisterTransform::shutdown() {
   delete CmdObjApplyRegisterTransformMetaClass;
}


void CmdObjApplyRegisterTransform::setup(Matrix4f do_trans,Matrix4f undo_trans,std::string pc,int iterations,int res)
{
   varRes=false;
   d=do_trans;
   u=undo_trans;
   target=pc;
   numIterations=iterations;
   gridRes=res;

}

void CmdObjApplyRegisterTransform::doAction(Object *context)
{
   Scene *scene = dynamic_cast<Scene*>(context); x4Assert(scene);
   SGLegacyPCSceneAdaptor sceneLA(scene);
   int32 i = sceneLA.getPointCloudIndex(target);
   if (i == -1) throw ECommandFailed(std::string("CmdObjApplyRegisterTransform::doAction - target ") + target + std::string(" not found."));
   PointCloud *pc = sceneLA.getPointCloud(target);
   pc->setTransformation(d);
}
void CmdObjApplyRegisterTransform::undoAction(Object *context)
{
   Scene *scene = dynamic_cast<Scene*>(context); x4Assert(scene);
   SGLegacyPCSceneAdaptor sceneLA(scene);
   int32 i = sceneLA.getPointCloudIndex(target);
   if (i == -1) throw ECommandFailed(std::string("CmdObjApplyRegisterTransform::doAction - target ") + target + std::string(" not found."));
   PointCloud *pc = sceneLA.getPointCloud(target);
   pc->setTransformation(u);
}
bool CmdObjApplyRegisterTransform::canUndo() {return true;};


std::string CmdObjApplyRegisterTransform::getDescription()
{
   char buffer[1000];
   std::string result="RegisterPC (";
   if (varRes)
      result+="various resolutions";
   else
   {
      result+=std::string(itoa(gridRes,buffer,10));
      result+="x";
      result+=std::string(itoa(gridRes,buffer,10));
   }
   result+=",";
   result+=std::string(itoa(numIterations,buffer,10));
   result+=" iterations)";
   return result;
   //ToDo: dock and dockee pointcloud names
}

bool CmdObjApplyRegisterTransform::mergeCommand(const CommandObject *nextCmd) {
   if (nextCmd->getInstanceClass() == CmdObjApplyRegisterTransform::getClass()) {
      const CmdObjApplyRegisterTransform *nextCmdMyType = dynamic_cast<const CmdObjApplyRegisterTransform*>(nextCmd);
      x4Assert(nextCmdMyType != NULL);
      if ((this->target==nextCmdMyType->target))
         {
            if (this->gridRes!= nextCmdMyType->gridRes)
               this->varRes=true;
            this->numIterations+=nextCmdMyType->numIterations;
            this->d=nextCmdMyType->d;
            return true;
         }
       else return false;

   } else
      return false;

}

