#ifndef SceneEditorOptionsH
#define SceneEditorOptionsH
//---------------------------------------------------------------------------
#include "x3editor.h"
//---------------------------------------------------------------------------
#include "AttachedData.h"
//---------------------------------------------------------------------------
#include "LinearAlgebra.h"
//---------------------------------------------------------------------------

namespace X4
{

/**
	holds scene editor options ( backgroundcolor, 
*/
class X3EDITOR_API SceneEditorOptions : public AttachedData
{
	X4_CLASS( SceneEditorOptions )

private:

	
	Vector3f		m_BackGroundColor;
	MetaClass	  * m_DefaultCameraClass;
	bool			m_UseSoftwareVertexBuffers;
	bool			m_UseBBSelection;
	int32			m_RedrawDelay;
	MetaClass	  * m_DefaultPCI;
	MetaClass	  * m_DefaultPCC;

public:
	SceneEditorOptions(void);
	~SceneEditorOptions(void);


	// -----------------------------
	// properties access
	Vector3f		getBackGroundColor() const { return m_BackGroundColor; }
	void setBackGroundColor( const Vector3f &col ) { m_BackGroundColor = col; }

	MetaClass * getDefaultCameraClass() const {return m_DefaultCameraClass;}
	void setDefaultCameraClass(MetaClass * mc){m_DefaultCameraClass = mc;}

	MetaClass * getDefaultPCI() const { return m_DefaultPCI; }
	void setDefaultPCI(MetaClass * val) { m_DefaultPCI = val; }

	MetaClass * getDefaultPCC() const { return m_DefaultPCC; }
	void setDefaultPCC(MetaClass * val) { m_DefaultPCC = val; }

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

	bool getUseSoftwareVertexBuffers() const {return m_UseSoftwareVertexBuffers;}
	void setUseSoftwareVertexBuffers(bool v) {m_UseSoftwareVertexBuffers=v;}

	int32 getRedrawDelay() const {return m_RedrawDelay;}
	void setRedrawDelay(int32 v) {m_RedrawDelay=v;}

	bool getUseBBSelection() const {return m_UseBBSelection;}
	void setUseBBSelection(bool v) {m_UseBBSelection=v;}


};

}

#endif