//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "SceneGraphEditor.h"
//---------------------------------------------------------------------------
#include "Scene.h"
#include "SceneGraphEditorWidget.h"
//---------------------------------------------------------------------------
 
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



MetaClass* SceneGraphEditor::SceneGraphEditorMetaClass = NULL;

const MetaClass* SceneGraphEditor::getInstanceClass() const {
	return getClass();
}

Object* SceneGraphEditor::newInstance() {
	return new SceneGraphEditor;
}

const MetaClass* SceneGraphEditor::getClass() {
	if (SceneGraphEditorMetaClass == NULL) {
		SceneGraphEditorMetaClass = new MetaClass("SceneGraphEditor", "no description.",
			newInstance, sizeof(SceneGraphEditor));
	}
	return SceneGraphEditorMetaClass;
}

void SceneGraphEditor::init(const MetaClass *parentClass) {
	((MetaClass*)getClass())->init(parentClass);
	SceneGraphEditorMetaClass->copyParentProperties();
	
}

void SceneGraphEditor::shutdown() {
   delete SceneGraphEditorMetaClass;
}


// --------------------------------------------

SceneGraphEditor::SceneGraphEditor()
{
   sgEd = NULL;
}



 QWidget * SceneGraphEditor::makeEditor( QWidget * parent, Object * obj )
{
   this->obj = obj;
   sgEd = new SceneGraphEditorWidget(parent, (Scene*)obj);
	// not safe - legacy code
	//ObjectViewsTable::bindView(obj, this);
   return sgEd;
}


Object* SceneGraphEditor::getObject() {
   return obj;
}

void SceneGraphEditor::apply() {

}

void SceneGraphEditor::update() {
  sgEd->update();
}

card32 SceneGraphEditor::getPreferredWidth() {
  
	 return  sgEd->width();

}

card32 SceneGraphEditor::getPreferredHeight() {
	 return sgEd->height();
}

SceneGraphEditor::~SceneGraphEditor()
{
	// not safe - legacy code
	// ObjectViewsTable::releaseView(obj, this);
}
