//---------------------------------------------------------------------------
#ifndef SceneGraphEditorH
#define SceneGraphEditorH
//---------------------------------------------------------------------------
#include "x3editor.h"
//---------------------------------------------------------------------------
#include "SceneClassEditors.h"
//---------------------------------------------------------------------------

namespace X4 {

class GLContext;
class SceneGraphEditorWidget;


class X3EDITOR_API SceneGraphEditor : public SceneClassEditor {
 private:
   static MetaClass *SceneGraphEditorMetaClass;
   static Object* newInstance();

   SceneGraphEditorWidget * sgEd;
	Object *obj;

 public:
   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   // -----------------------------
   SceneGraphEditor();

	virtual QWidget * makeEditor( QWidget * parent, Object * obj );
   virtual Object* getObject();
   virtual void apply();
   virtual void update();
   virtual card32 getPreferredWidth();
   virtual card32 getPreferredHeight();

	~SceneGraphEditor();

};


}

#endif
