//---------------------------------------------------------------------------
#include "stdafx.h"
//---------------------------------------------------------------------------
#include "TestRenderer.h"
//---------------------------------------------------------------------------
 
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



MetaClass* TestRenderer::TestRendererMetaClass = NULL;

const MetaClass* TestRenderer::getInstanceClass() const {
   return getClass();
}

Object* TestRenderer::newInstance() {
   return new TestRenderer;
}

const MetaClass* TestRenderer::getClass() {
   if (TestRendererMetaClass==NULL) {
      TestRendererMetaClass = new MetaClass("TestRenderer", "no description.",
                                  newInstance, sizeof(TestRenderer));
   }
   return TestRendererMetaClass;
}

void TestRenderer::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   TestRendererMetaClass->copyParentProperties();
	BEGIN_CLASS_INIT(TestRenderer)
}

void TestRenderer::shutdown() {
   delete TestRendererMetaClass;
}


// ----


TestRenderer::TestRenderer() {

}


void TestRenderer::connect(Scene* scene, GLContext* ctxt) {
   Renderer::connect(scene, ctxt);

}


void TestRenderer::render(card32 viewportWidth, card32 viewportHeight) {

   Scene *scene = getScene();
   glPushAttrib(GL_ALL_ATTRIB_BITS);

			  
	 QColor green= QColor::fromCmykF(0, 1.0, 1.0, 0.0);
	// QColor trolltechPurple = QColor::fromCmykF(0.39, 0.39, 0.0, 0.0);


	 //glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	 glShadeModel(GL_FLAT);
	 glEnable(GL_DEPTH_TEST);
	 //glEnable(GL_CULL_FACE);

	 glColor3f(green.redF(), green.greenF(), green.blueF());

	 drawTestObjekt();


   glPopAttrib();

}


void TestRenderer::disconnect(GLContext* ctxt) {

}


void TestRenderer::drawTestObjekt(){
	 glBegin(GL_QUADS);
		  GLdouble x1 = +0.06;
		  GLdouble y1 = -0.14;
		  GLdouble x2 = +0.14;
		  GLdouble y2 = -0.06;
		  GLdouble x3 = +0.08;
		  GLdouble y3 = +0.00;
		  GLdouble x4 = +0.30;
		  GLdouble y4 = +0.22;

		  quad(x1, y1, x2, y2, y2, x2, y1, x1);
		  quad(x3, y3, x4, y4, y4, x4, y3, x3);

		  extrude(x1, y1, x2, y2);
		  extrude(x2, y2, y2, x2);
		  extrude(y2, x2, y1, x1);
		  extrude(y1, x1, x1, y1);
		  extrude(x3, y3, x4, y4);
		  extrude(x4, y4, y4, x4);
		  extrude(y4, x4, y3, x3);

		  const double Pi = 3.14159265358979323846;
		  const int NumSectors = 200;

		  for (int i = 0; i < NumSectors; ++i) {
				double angle1 = (i * 2 * Pi) / NumSectors;
				GLdouble x5 = 0.30 * sin(angle1);
				GLdouble y5 = 0.30 * cos(angle1);
				GLdouble x6 = 0.20 * sin(angle1);
				GLdouble y6 = 0.20 * cos(angle1);

				double angle2 = ((i + 1) * 2 * Pi) / NumSectors;
				GLdouble x7 = 0.20 * sin(angle2);
				GLdouble y7 = 0.20 * cos(angle2);
				GLdouble x8 = 0.30 * sin(angle2);
				GLdouble y8 = 0.30 * cos(angle2);

				quad(x5, y5, x6, y6, x7, y7, x8, y8);

				extrude(x6, y6, x7, y7);
				extrude(x8, y8, x5, y5);
		  }
	 glEnd();

}

void TestRenderer::quad(GLdouble x1, GLdouble y1, GLdouble x2, GLdouble y2,
							  GLdouble x3, GLdouble y3, GLdouble x4, GLdouble y4)
{

	 glVertex3d(x1, y1, -0.05);
	 glVertex3d(x2, y2, -0.05);
	 glVertex3d(x3, y3, -0.05);
	 glVertex3d(x4, y4, -0.05);

	 glVertex3d(x4, y4, +0.05);
	 glVertex3d(x3, y3, +0.05);
	 glVertex3d(x2, y2, +0.05);
	 glVertex3d(x1, y1, +0.05);

}

void TestRenderer::extrude(GLdouble x1, GLdouble y1, GLdouble x2, GLdouble y2)
{

	 glVertex3d(x1, y1, +0.05);
	 glVertex3d(x2, y2, +0.05);
	 glVertex3d(x2, y2, -0.05);
	 glVertex3d(x1, y1, -0.05);
}

