#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "XrtGLWidget.h"
//---------------------------------------------------------------------------
#include "Scene.h"
#include "SelectionTools.h"
//---------------------------------------------------------------------------
using namespace X4;


XrtGLWidget::XrtGLWidget(QWidget* parent)
:QGLWidget(parent)
{
	setMouseTracking(true);
	setAcceptDrops(true);

}

XrtGLWidget::~XrtGLWidget(void)
{
}


void XrtGLWidget::initializeGL()
{
}

void XrtGLWidget::paintGL()
{
	 emit sigRepaint();
}

void XrtGLWidget::resizeGL(int width, int height)
{
	 emit sigResize(QSize(width,height));
}

void XrtGLWidget::mousePressEvent(QMouseEvent *event)
{
	m_dragStartPosition = event->pos();
	 emit sigMousePress(event);
	 //updateGL();
	QGLWidget::mousePressEvent(event);
}

void XrtGLWidget::mouseReleaseEvent (QMouseEvent * event){
	emit sigMouseRelease(event);
	//updateGL();
	QGLWidget::mouseReleaseEvent(event);
}

void X4::XrtGLWidget::wheelEvent( QWheelEvent * event )
{
	emit sigWheelEvent(event);
	QGLWidget::wheelEvent(event);
}

void XrtGLWidget::mouseMoveEvent(QMouseEvent *e)
{ 
	e->accept();
	emit sigMouseMove(e);
	//updateGL();
/*
	if ((e->buttons() & Qt::LeftButton && (e->modifiers() & Qt::AltModifier)))
	{
		if ((e->pos() - m_dragStartPosition).manhattanLength()
			 < QApplication::startDragDistance())
		{

			std::string pc = getClickedCloud( m_dragStartPosition.x(), m_dragStartPosition.y(),
				width(),height(), &scene->getRootState()->staticState->camera, 
				&scene->getRootState()->staticState->viewFrustum, scene );

			QDrag *drag = new QDrag(this);
			QMimeData *mimeData = new QMimeData;

			QByteArray pointCloudName( pc.c_str() );
			mimeData->setData("text/plain", pointCloudName);
			drag->setMimeData(mimeData);

			Qt::DropAction dropAction = drag->start(Qt::CopyAction | Qt::MoveAction);
		}
	}*/
	//QGLWidget::mouseMoveEvent(e);
}

GLContext * XrtGLWidget::getContext(){
	 makeCurrent();
	 x4Assert(wglGetCurrentDC());  x4Assert(wglGetCurrentContext());
	 return new GLContext(wglGetCurrentDC(),wglGetCurrentContext(),NULL,this);
}


void XrtGLWidget::dragEnterEvent(QDragEnterEvent *event)
{
	if (event->mimeData()->hasFormat("X4/material"))
		event->acceptProposedAction();
}

void XrtGLWidget::dropEvent(QDropEvent *event)
{
	emit sigDropEvent( (QMimeData*)event->mimeData(), event->pos() );
	event->acceptProposedAction();
}


#include "XrtGLWidget_moc.h"



