#include "StdAfx.h"

#include "x3editor.h"

#include <TaggingMacros.h>
#include <X4Types.h>

#include "x3editor_rcc.h"

using namespace X4;

#include "x3editor.init.cpp"
#include "SceneClassEditors.h"
#include "SceneGraphEditor.h"
#include "PCSceneMaterialBrowser.h"
#include "SceneEditorWidget.h"
#include "SceneEditorOptionsEditorWidget.h"
#include "PCIDrawingToolEditorWidget.h"
#include "PCISelectionToolEditorWidget.h"
#include "PCITransfEditEditorWidget.h"
#include "PCIFilterToolEditorWidget.h"
#include "PCIMappingToolEditorWidget.h"
#include "PCICameraManagerEditorWidget.h"
#include "PCCPointCloudCreatorEditorWidget.h"
#include "PCCImporterEditorWidget.h"
#include "PCCAnimationImporterEditorWidget.h"
#include "PointCloudImporterReaderCustomASCIIEditorWidget.h"

#include <QtCore\qmetatype.h>


BEGIN_INIT_MODULE
    qInitResources();

// scene editors
SceneClassEditor::init(ClassEditor::getClass());
SceneGraphEditor::init(SceneClassEditor::getClass());
PCSceneMaterialBrowser::init(SceneClassEditor::getClass());	

// register PCSceneEditor as application for Scene
SceneEditor::init(ClassEditor::getClass());
((GUIDescriptor * )Scene::getClass()->getGUIDescriptor())->addClassEditor(
	SceneEditor::getClass(), true);

SceneEditorOptionsEditor::init(ClassEditor::getClass());
((GUIDescriptor * )SceneEditorOptions::getClass()->getGUIDescriptor())->addClassEditor(
	SceneEditorOptionsEditor::getClass(), true);


// PCI Editors
PCIDrawingToolEditor::init(ClassEditor::getClass());
((GUIDescriptor * )PCIDrawingTool::getClass()->getGUIDescriptor())->addClassEditor(
	PCIDrawingToolEditor::getClass(), true);

PCISelectionToolEditor::init(ClassEditor::getClass());
((GUIDescriptor * )PCISelectionTool::getClass()->getGUIDescriptor())->addClassEditor(
	PCISelectionToolEditor::getClass(), true);

PCITransfEditEditor::init(ClassEditor::getClass());
((GUIDescriptor * )PCITransfEdit::getClass()->getGUIDescriptor())->addClassEditor(
	PCITransfEditEditor::getClass(), true);

PCIFilterToolEditor::init(ClassEditor::getClass());
((GUIDescriptor * )PCIFilterTool::getClass()->getGUIDescriptor())->addClassEditor(
	PCIFilterToolEditor::getClass(), true);

PCIMappingToolEditor::init(ClassEditor::getClass());
((GUIDescriptor * )PCIMappingTool::getClass()->getGUIDescriptor())->addClassEditor(
	PCIMappingToolEditor::getClass(), true);

PCICameraManagerEditor::init(ClassEditor::getClass() );
((GUIDescriptor * )PCICameraManager::getClass()->getGUIDescriptor())->addClassEditor(
	PCICameraManagerEditor::getClass(), true);


PCCPointCloudCreatorEditor::init(ClassEditor::getClass());
((GUIDescriptor * )PCCPointCloudCreator::getClass()->getGUIDescriptor())->addClassEditor(
	PCCPointCloudCreatorEditor::getClass(), true);

// Importer Editors
PCCImporterEditor::init(ClassEditor::getClass());
((GUIDescriptor * )PCCImporter::getClass()->getGUIDescriptor())->addClassEditor(
	PCCImporterEditor::getClass(), true);

PCCAnimationImporterEditor::init(ClassEditor::getClass());
((GUIDescriptor * )PCCAnimationImporter::getClass()->getGUIDescriptor())->addClassEditor(
	PCCAnimationImporterEditor::getClass(), true);

PointCloudImporterReaderCustomASCIIEditor::init(ClassEditor::getClass());
((GUIDescriptor * )PointCloudImporterReaderCustomASCII::getClass()->getGUIDescriptor())->addClassEditor(
	PointCloudImporterReaderCustomASCIIEditor::getClass(), true);


	qRegisterMetaType<OperatorNoArgs*>("OperatorNoArgs*");
END_INIT_MODULE 

BEGIN_SHUTDOWN_MODULE
END_SHUTDOWN_MODULE 

BEGIN_X4_LOADABLE_MODULE(x3editor)
	#include "x3editor.tags.h"
END_X4_LOADABLE_MODULE(x3editor)


