SET_MODULE_TYPE_LOADABLE_MODULE

ADD_DEPENDENCY("opencv")
ADD_DEPENDENCY("x4basics")
ADD_DEPENDENCY("x4core")
ADD_DEPENDENCY("x4interface")
ADD_DEPENDENCY("x4math")
ADD_DEPENDENCY("x4miscFoundation")
ADD_DEPENDENCY("x4tools")
ADD_DEPENDENCY("x4modules")
ADD_DEPENDENCY("x3geometry")
ADD_DEPENDENCY("x3openGL")
ADD_DEPENDENCY("x3rendering")
ADD_DEPENDENCY("x3sceneGraph")

ADD_AUTHOR("Michael Wand")
ADD_AUTHOR("Martin Bokeloh")
ADD_AUTHOR("Art Tevs")
ADD_AUTHOR("Alexander Berner")
ADD_AUTHOR("Mark Hoffman")
ADD_AUTHOR("Benjamin Maier")
ADD_AUTHOR("Arno Fleck")

ADD_INSTITUITION("WSI/GRIS, Tbingen University")
ADD_INSTITUITION("MPI Informatik Saarbrcken")

ADD_LICENSE("BSD")

// an icon for this module
ADD_ICON(":/images_x3editor/images/x3editor.png")

ADD_CLASS("OnSceneChangeCallback", "Persistent")
ADD_CLASS_INC("CmdObjChangePCFlags", "CommandObject", "SceneCommandObjects.h")
ADD_CLASS_INC("CmdObjChangeSelection", "CommandObject", "SceneCommandObjects.h")
ADD_CLASS_INC("CmdObjChangeSelectionOnClick", "CommandObject", "CmdObjSelection.h")
ADD_CLASS_INC("CmdObjChangeView", "CommandObject", "SceneCommandObjects.h")
ADD_CLASS_INC("CmdObjDeletePCs", "CommandObject", "SceneCommandObjects.h")
ADD_CLASS_INC("CmdObjDrawOnClick", "CommandObject", "CmdObjDrawOnClick.h")
ADD_CLASS_INC("CmdObjFilter", "CommandObject", "CmdObjFilter.h")
ADD_CLASS_INC("CmdObjLoadMap", "CommandObject", "CmdObjMappingOnClick.h")
ADD_CLASS_INC("CmdObjMappingOnClick", "CommandObject", "CmdObjMappingOnClick.h")
ADD_CLASS_INC("CmdObjPCCommand", "CommandObject", "SceneCommandObjects.h")
ADD_CLASS_INC("CmdObjPointCloudOperations", "CommandObject", "CmdObjPointCloudOperations.h")
ADD_CLASS_INC("CmdObjRenamePC", "CommandObject", "SceneCommandObjects.h")
ADD_CLASS_INC("CmdObjSelectionByAttribute", "CommandObject", "SceneCommandObjects.h")
ADD_CLASS_INC("CmdObjSelectionByButton", "CommandObject", "SceneCommandObjects.h")
ADD_CLASS_INC("CmdObjSelectionOnArea", "CommandObject", "SceneCommandObjects.h")
ADD_CLASS_INC("CmdObjSpecialDraw", "CommandObject", "CmdObjSpecialDraw.h")
ADD_CLASS_INC("CmdObjTransfEdit", "CommandObject", "CmdObjTransfEdit.h")
ADD_CLASS_INC("CmdObjApplyRegisterTransform", "CommandObject", "SceneCommandObjects.h")
ADD_CLASS_INC("CmdObjGeneratePC", "CommandObject", "SceneCommandObjects.h")
ADD_CLASS_INC("CO_SGAddNode", "CommandObject", "SceneGraphCmdObjs.h")
ADD_CLASS_INC("CO_SGDeleteNode", "CommandObject", "SceneGraphCmdObjs.h")
ADD_CLASS_INC("CO_SGMoveNode", "CommandObject", "SceneGraphCmdObjs.h")
ADD_CLASS_INC("CO_SGMoveSelection", "CommandObject", "SceneGraphCmdObjs.h")
ADD_CLASS_INC("CO_SGGroupSelection", "CommandObject", "SceneGraphCmdObjs.h")
ADD_CLASS_INC("CO_SGUnGroupSelection", "CommandObject", "SceneGraphCmdObjs.h")
ADD_CLASS_INC("CO_SGChangeSelection", "CommandObject", "SceneGraphCmdObjs.h")
ADD_CLASS_INC("CmdObjAppendFields", "CommandObject", "SceneCommandObjects.h")
ADD_CLASS_INC("CmdObjConvertType", "CommandObject", "SceneCommandObjects.h")
ADD_CLASS_INC("CmdObjSGChangeDefaultTraversalMode", "CommandObject", "SceneCommandObjects.h")
ADD_CLASS_INC("CmdObjGrowSelectionByNormal", "CommandObject", "SceneCommandObjects.h")
ADD_CLASS("PCCommand", "Persistent")
ADD_CLASS("PCCAttributeModifier", "PCCommand")
ADD_CLASS("PCCAutoAlign", "PCCommand")
ADD_CLASS("PCCComputeFlags", "PCCommand")
ADD_CLASS("PCCParametricResampling", "PCCommand")
ADD_CLASS("PCCPointCloudCreator", "PCCommand")
ADD_CLASS("PCCPointGenerator", "PCCommand")
ADD_CLASS("PCCTriangleMeshSampler", "PCCommand")
ADD_CLASS("PCCAnimatedTriangleMeshSampler", "PCCommand")
ADD_CLASS("PCCImporter", "PCCommand")
ADD_CLASS("PCCAnimationImporter", "PCCImporter")
ADD_CLASS("PCCSwapChannels", "PCCommand")
ADD_CLASS("PCCSetMaterial", "PCCommand")
ADD_CLASS("PCCImplicitMesher", "PCCommand")
ADD_CLASS("PCCResampler", "PCCommand")
ADD_CLASS("PCCPointNoise", "PCCommand")
ADD_CLASS("PCCEstimateSampleSpacing", "PCCommand")
ADD_CLASS("PCCDirectoryImporter", "PCCommand")
ADD_CLASS("PCCConvToSwapAllOOC", "PCCommand")
ADD_CLASS("PCCSortListNode", "PCCommand")
ADD_CLASS("PCCAnimRename", "PCCommand")
ADD_CLASS("PCCImportVolumeData", "PCCommand")
ADD_CLASS("PCCImportAnalyze", "PCCommand")
ADD_CLASS("PCCVolumeGenerator", "PCCommand")
ADD_CLASS("PCCNormalEstimatorPCA", "PCCommand")	
// ADD_CLASS("PCCProjectImage", "PCCommand")	
ADD_CLASS("PCCMeshImportOA", "PCCommand")
ADD_CLASS("PointCloudImporterAdder", "Persistent")
ADD_CLASS_INC("PointCloudImporterAdderParametricDynamic", "PointCloudImporterAdder", "PointCloudImporterAdder.h")
ADD_CLASS_INC("PointCloudImporterAdderDynamic", "PointCloudImporterAdder", "PointCloudImporterAdder.h")
ADD_CLASS_INC("PointCloudImporterAdderMesh", "PointCloudImporterAdder", "PointCloudImporterAdder.h")
ADD_CLASS("PointCloudImporterReader", "Persistent")
ADD_CLASS("PointCloudImporterReader2DImages", "PointCloudImporterReader")
ADD_CLASS("PointCloudImporterReader2DImagesPlusAlpha", "PointCloudImporterReader")
ADD_CLASS("PointCloudImporterReaderMSDepthBMP", "PointCloudImporterReader")
ADD_CLASS("PointCloudImporterReaderCustomASCII", "PointCloudImporterReader")
ADD_CLASS("PointCloudImporterReaderCustomASCII_vmr_oakland_v2", "PointCloudImporterReader")
ADD_CLASS("PointCloudImporterReaderCustomASCII_standard", "PointCloudImporterReader")
ADD_CLASS("PointCloudImporterReaderSMFOBJ", "PointCloudImporterReader")
ADD_CLASS("PointCloudImporterReaderPLY", "PointCloudImporterReader")
ADD_CLASS("PointCloudImporterReaderPLY_IQmulus_TerraMobilita", "PointCloudImporterReader")
ADD_CLASS("PointCloudImporterReaderPLY_Paris_rue_Madame", "PointCloudImporterReader")
ADD_CLASS("PointCloudImporterReaderVRML", "PointCloudImporterReader")
ADD_CLASS("PointCloudImporterReaderBSM", "PointCloudImporterReader")
ADD_CLASS("PointCloudImporterReaderOFF", "PointCloudImporterReader")
ADD_CLASS("PointCloudImporterReaderCustom3DScan", "PointCloudImporterReader")
ADD_CLASS("PointCloudImporterReaderBinary", "PointCloudImporterReader")
ADD_CLASS("PointCloudImporterReaderVelodyne", "PointCloudImporterReader")
ADD_CLASS_INC("ImportMeshToSceneHelper", "Persistent", "PointCloudImporterAdder.h")
ADD_CLASS("PCInteractionTool", "Persistent")
ADD_CLASS("PCInteractionToolThreaded", "PCInteractionTool")
ADD_CLASS("PCICameraController", "PCInteractionTool")
ADD_CLASS("PCICameraManager", "PCInteractionTool")
ADD_CLASS("PCIDrawingTool", "PCInteractionTool")
ADD_CLASS("PCIFilterTool", "PCInteractionTool")
ADD_CLASS("PCIMappingTool", "PCInteractionTool")
ADD_CLASS("PCISelectionTool", "PCInteractionTool")
ADD_CLASS("PCIPointInfo", "PCInteractionTool")
ADD_CLASS("PCITransfEdit", "PCInteractionTool")
ADD_CLASS("XGRTEvent", "Persistent")
ADD_CLASS_INC("ModeChangeEvent", "XGRTEvent", "XGRTEvent.h")
ADD_CLASS_INC("SpecifiedModeChangeEvent", "XGRTEvent", "XGRTEvent.h")
ADD_CLASS_INC("CommandObjectEvent", "XGRTEvent", "XGRTEvent.h")
ADD_CLASS_INC("StringEvent", "XGRTEvent", "XGRTEvent.h")
ADD_CLASS("SceneInterface", "AttachedData")
ADD_CLASS_INC("SceneToolbar", "Persistent", "SceneInterface.h")
ADD_CLASS_INC("SceneToolbarElement", "Persistent", "SceneInterface.h")
ADD_CLASS_INC("SceneToolButton", "SceneToolbarElement", "SceneInterface.h")
ADD_CLASS_INC("SceneToolbarCheckBox", "SceneToolbarElement", "SceneInterface.h")
ADD_CLASS_INC("ToolbarSplitter", "SceneToolbarElement", "SceneInterface.h")
ADD_CLASS("SceneEditorOptions", "AttachedData")
ADD_CLASS("TestRenderer", "Renderer")


