//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "GLImageLensCorrection.h"
//---------------------------------------------------------------------------
#include "LinearAlgebra.inline.h"
//---------------------------------------------------------------------------

using namespace X4;

MetaClass* GLImageLensCorrection::GLImageLensCorrectionMetaClass = NULL;

const MetaClass* GLImageLensCorrection::getInstanceClass() const {
   return getClass();
}

Object* GLImageLensCorrection::newInstance() {
   return new GLImageLensCorrection;
}

const MetaClass* GLImageLensCorrection::getClass() {
   if (GLImageLensCorrectionMetaClass==NULL) {
      GLImageLensCorrectionMetaClass = new MetaClass("GLImageLensCorrection", "no description.",
                                  newInstance, sizeof(GLImageLensCorrection));
   }
   return GLImageLensCorrectionMetaClass;
}

void GLImageLensCorrection::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   GLImageLensCorrectionMetaClass->copyParentProperties();
}

void GLImageLensCorrection::shutdown() {
   delete GLImageLensCorrectionMetaClass;
}


// ----



Vector2f GLImageLensCorrection::calculateWarpCoords( const Vector2f x, const Vector2i dim )
{
   Vector2f xc = x - makeVector2f( dim[0], dim[1] ) / 2;
   float radius = norm( xc ) / (float)norm(dim);
   xc *= 0.5f + exp( - radius );

   return xc + makeVector2f( dim[0], dim[1] ) / 2;
}
