//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "ImportSwissRangerData.h"
//---------------------------------------------------------------------------
#include "ImportTools.h"
//---------------------------------------------------------------------------
#include <fstream>
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



IMPLEMENT_X4_CLASS( ImportSwissRangerData ,0)
{
	BEGIN_CLASS_INIT( ImportSwissRangerData );
}

ImportSwissRangerData::ImportSwissRangerData()
{
   pos = 0;
   myVD = new VertexDescriptor();
   myVD->pushAttrib(mVAD("position",   3, VAD::DATA_FORMAT_FLOAT32));
   myVD->pushAttrib(mVAD("intensity",  1, VAD::DATA_FORMAT_FLOAT32));
   myVD->pushAttrib(mVAD("confidence", 1, VAD::DATA_FORMAT_FLOAT32));
}

ImportSwissRangerData::~ImportSwissRangerData() {
   delete myVD;
}


bool ImportSwissRangerData::beginImport(std::string filename, bool readTrianglesIfPossible) {
   ImportFinished = false;
   pos=0;
   points.resize(SIZE_X*SIZE_Y);
   std::ifstream in(filename.c_str());
	if (!in.good()) { 
		warning("ImportSwissRangerData::beginImport()\nError opening file \"" + filename + "\"."); 
		return false;
	};
/*
   skipToEOL(in);
   for (card32 y=0; y<SIZE_Y; y++) {
      for (card32 x=0; x<SIZE_X; x++) {
         in >> points[x+SIZE_X*y].pos[2];
      }
   }
   skipToEOL(in);
   skipToEOL(in);
   for (card32 y=0; y<SIZE_Y; y++) {
      for (card32 x=0; x<SIZE_X; x++) {
         in >> points[x+SIZE_X*y].pos[1];
      }
   }
   skipToEOL(in);
   skipToEOL(in);
   for (card32 y=0; y<SIZE_Y; y++) {
      for (card32 x=0; x<SIZE_X; x++) {
         in >> points[x+SIZE_X*y].pos[0];
      }
   }
   skipToEOL(in);
   skipToEOL(in);
   for (card32 y=0; y<SIZE_Y; y++) {
      for (card32 x=0; x<SIZE_X; x++) {
         in >> points[x+SIZE_X*y].intensity;
      }
   }
   */


	skipToEOL(in);
	for (card32 y=0; y<SIZE_Y; y++) {
		for (card32 x=0; x<SIZE_X; x++) {
			in >> points[x+SIZE_X*y].pos[2];
		}
	}

	skipToEOL(in);
	skipToEOL(in);
	for (card32 y=0; y<SIZE_Y; y++) {
		for (card32 x=0; x<SIZE_X; x++) {
			in >> points[x+SIZE_X*y].pos[0];
		}
	}

	skipToEOL(in);
	skipToEOL(in);
	for (card32 y=0; y<SIZE_Y; y++) {
		for (card32 x=0; x<SIZE_X; x++) {
			in >> points[x+SIZE_X*y].pos[1];
		}
	}
	skipToEOL(in);
	skipToEOL(in);
	for (card32 y=0; y<SIZE_Y; y++) {
		for (card32 x=0; x<SIZE_X; x++) {
			in >> points[x+SIZE_X*y].intensity;
		}
	}
	skipToEOL(in);
	skipToEOL(in);
	for (card32 y=0; y<SIZE_Y; y++) {
		for (card32 x=0; x<SIZE_X; x++) {
			in >> points[x+SIZE_X*y].confidence;
		}
	}

   return true;
}

const card8* ImportSwissRangerData::getNextPoint() {
   if (pos >= SIZE_X*SIZE_Y) {
      if (pos == SIZE_X*SIZE_Y) ImportFinished = true;
      return NULL;
   } else {
      //Vector3f raw = points[pos].pos;
      //float32 x = raw[0];
      //float32 y = raw[1];
      //float32 d = raw[2];
      //raw[2] = sqrt(d*d-sqrt(x*x + y*y));
      //points[pos].pos = raw;
      return (card8*)&(points[pos++]);
   }
}

const card8* ImportSwissRangerData::getNextTriangle() {
   return NULL;
}

void ImportSwissRangerData::endImport() {}

mpcard ImportSwissRangerData::getWidth() {
   return SIZE_X;
}

mpcard ImportSwissRangerData::getHeight() {
   return SIZE_Y;
}

mpcard ImportSwissRangerData::getProgressPercentage() {
   return (mpcard)((float32)pos/(float32)(SIZE_X*SIZE_Y)*100.0f);
}

bool ImportSwissRangerData::supportsTriangleImport() {
   return false;
}

