//---------------------------------------------------------------------------
#include "stdafx.h"

//---------------------------------------------------------------------------
#include "LegacyClassNameTranslation.h"
//---------------------------------------------------------------------------
#include "Tools.h"
#include "MetaClass.h"
#include "Persistent.h"
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------




std::map<std::string, const MetaClass*> LegacyClassNameTranslation::translations;


void LegacyClassNameTranslation::registerTranslation(std::string legacyClassName, const MetaClass *currentClass) {
   x4Assert(translations.find(legacyClassName) == translations.end());
   x4Assert(!MetaClass::isClassRegistered(legacyClassName));
   translations.insert(pair<std::string, const MetaClass*>(legacyClassName, currentClass));
}

const MetaClass *LegacyClassNameTranslation::getCurrentClass(std::string legacyClassName) {
   if (translations.find(legacyClassName) == translations.end()) return NULL;
   return translations.find(legacyClassName)->second;
}


