//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "LocalGeometryUncertainty.h"
//---------------------------------------------------------------------------
#include "BooleanClassProperty.h"
#include "TopologyTools.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



IMPLEMENT_X4_ABSTRACT_CLASS( LocalGeometryUncertainty ,0 )
{
	BEGIN_CLASS_INIT( LocalGeometryUncertainty );
	ADD_BOOLEAN_PROP( in2d, 0 )
}

static std::string descrTechniques(card32 i) {
	if (i == 0) return "TECHNIQUE_SMALLEST_EV";
	if (i == 1) return "TECHNIQUE_EV_RATIO";
	return "unknown";
}


IMPLEMENT_X4_ABSTRACT_CLASS( LGULeastSquarePlanePCA ,0 )
{
	BEGIN_CLASS_INIT( LGULeastSquarePlanePCA );
	ADD_CARD32_PROP_UPDATE_DESCR( technique, 0, NULL, descrTechniques, 2 , NULL)
}

// ----


LocalGeometryUncertainty::LocalGeometryUncertainty() {
	in2d = true;
}

// --

LGULeastSquarePlanePCA::LGULeastSquarePlanePCA() {
	technique = TECHNIQUE_EV_RATIO;
}

float32 LGULeastSquarePlanePCA::compute(const PointList &points) {
	return computePlaneUncertainty(points, getIn2D(), technique == TECHNIQUE_EV_RATIO);
}

