//---------------------------------------------------------------------------
#ifndef LocalGeometryUncertaintyH
#define LocalGeometryUncertaintyH
//---------------------------------------------------------------------------
#include "x3editor2.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace X4 {

/**
	This class computes the uncertainty associated with fitting a simple geometric model to a set of points.
	This class is an abstract base class.
*/
class X3EDITOR2_API LocalGeometryUncertainty : public Persistent {
	X4_ABSTRACT_CLASS( LocalGeometryUncertainty )

 public:
	typedef std::vector<Vector3f> PointList;

 private:
	bool in2d;

 public:
	LocalGeometryUncertainty();
	bool getIn2D() {return in2d;}
	virtual float32 compute(const PointList &points) = 0;
};



class X3EDITOR2_API LGULeastSquarePlanePCA : public LocalGeometryUncertainty {
	X4_CLASS( LGULeastSquarePlanePCA )
	
 public:
	static const card32 TECHNIQUE_SMALLEST_EV = 0;
	static const card32 TECHNIQUE_EV_RATIO = 1;
	
 private:
	card32 technique;
	
 public:
	LGULeastSquarePlanePCA();
	virtual float32 compute(const PointList &points);
};


}

#endif