#ifndef PCCBilateralSmoothingH
#define PCCBilateralSmoothingH
//---------------------------------------------------------------------------
#include "x3editor2.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------

namespace X4
{

/**
	ooc bilateral smoothing - don't use this with fries
*/
class X3EDITOR2_API PCCBilateralSmoothing : public PCCommand
{
	X4_CLASS( PCCBilateralSmoothing )

private:

	float32		m_SigmaEuklid;
	float32		m_SigmaPlane;
	float32		m_SigmaPointToPlane;
	
	card64		m_OOC_MaxNumPointsPerPart;
	
	std::string		m_DestHierarchicalPointCloud;
	float32		m_OutlierThreshold;
	bool			m_CalculateNormals;
	card32		m_CalcNormals_NumPoints;


	void traversePointCloud( PointCloud * pc, SceneObjectIterator * iter, SceneObjectIterator *destIter );
	void processPointInNode( PointCloud * pc, SceneObjectIterator * iter, SceneObjectIterator *destIter );
	void gatherPoints(SceneObjectIterator * sourceIter, const BoundingBox3f &bb, SceneObjectIterator *destIter );

public:
	PCCBilateralSmoothing(void);
	~PCCBilateralSmoothing(void);

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

	virtual void execute(Scene * scene);

	void smooth( PointCloud * pc );
	void hierarchicalSmoothing( PointCloud * pc, PointCloud * destPC );

};

}

#endif