//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "PCCDeleteFrames.h"
//---------------------------------------------------------------------------
#include "CopyObjectProperties.h"
#include "SGListNode.h"
#include "PointCloudTools.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



IMPLEMENT_X4_CLASS( PCCDeleteFrames , 0 ) {
	BEGIN_CLASS_INIT( PCCDeleteFrames );
   ADD_STRING_PROP(targetList, 0)
   ADD_CARD32_PROP(keepEveryNth, 0)
}

// ----

PCCDeleteFrames::PCCDeleteFrames() {
   targetList = "root/data";
   keepEveryNth = 3;
}

PCCDeleteFrames::~PCCDeleteFrames() {
}


void PCCDeleteFrames::execute(Scene *scene) 
{
   SGListNode *l = dynamic_cast<SGListNode*>(getSceneGraphNodeByName(scene, targetList));
   if (!l) {
      warning("PCCDeleteFrames::execute() - no target (list) node found.");
      return;
   }
   if (l->getNumChildNodes(NULL) > 0) {
      for (mpint i=l->getNumChildNodes(NULL)-1; i>=0; i--) {
         if (i%keepEveryNth != 0) {
            l->removeNode(i);
         }
      }
   }
}
