//---------------------------------------------------------------------------
#ifndef PCCImportBMP2DCloudH
#define PCCImportBMP2DCloudH
//---------------------------------------------------------------------------
#include "x3editor2.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------

namespace X4 {


/// convertes an PointCloud into a ParametricPointCloud with random point order
class X3EDITOR2_API PCCImportBMP2DCloud : public PCCommand {
 private:
   static MetaClass *PCCImportBMP2DCloudMetaClass;
   static Object* newInstance();

   /// filename to import from
   std::string filename;
   /// destination - a new point cloud will be created here
   std::string destFolder;
   /// if set, light pixels are added as points, otherwise, dark pixels are treated as points
   bool darkBackground;
   /// if true, the model is extruded in z direction
   bool extrudeZ;

 public:
   PCCImportBMP2DCloud();

   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   virtual void execute(Scene *scene);

};


}

#endif
 