#ifndef PCCKMeansClusteringH
#define PCCKMeansClusteringH
//---------------------------------------------------------------------------
#include "x3editor2.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------

namespace X4
{

/**
	computes a k-means clustering of the input point cloud
	test class to test KMeansClustering in foundation/math
*/
class X3EDITOR2_API PCCKMeansClustering : public PCCommand
{
	X4_CLASS( PCCKMeansClustering )

private:
	/// input point cloud
	std::string input;
	/// output point cloud (will be cleared)
	std::string output;
	/// number of clusters
	card32 numClusters;
	/// write color in input point cloud
	bool colorizeInput;
	/// internal parameter - number of random inits for KMC
	card32 numTrials;
	
public:
	PCCKMeansClustering();

   virtual void execute(Scene *scene);

	~PCCKMeansClustering(void);
};

}

#endif