#ifndef PCCLevelSetExtractorH
#define PCCLevelSetExtractorH
//---------------------------------------------------------------------------
#include "x3editor2.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------

namespace X4
{
class UnstructuredInCoreTriangleMesh;
class VolumeObject;

/**
	extracts level sets from volume data
*/
class X3EDITOR2_API PCCLevelSetExtractor : public PCCommand
{
	X4_CLASS( PCCLevelSetExtractor )

private:

	float32	m_IsoValue;
	
	
	
public:
	PCCLevelSetExtractor(void);
	~PCCLevelSetExtractor(void);

	struct TEvalContext
	{
		BasicPointCloudIterator * bIt;
		VolumetricIterator * vIt;
		AAT aat;
		Vector3f scalePos;
		Vector3f addPos;
	};

	virtual void assign(const Object* obj, X4CopyContext *context = NULL);

	static UnstructuredInCoreTriangleMesh * createTriangleMesh(VolumeObject * pc, float isoValue);

	virtual void execute(Scene * scene);

};

}

#endif