//---------------------------------------------------------------------------
#ifndef PCCMLSHoleFiller_H
#define PCCMLSHoleFiller_H
//---------------------------------------------------------------------------
#include "x3editor2.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------


namespace X4 {


/// this class fills up models with holes using MLS projection
class X3EDITOR2_API PCCMLSHoleFiller : public PCCommand {
	X4_CLASS( PCCMLSHoleFiller )
 private:
   float32 fillRadius;
   float32 fitRadius;
   float32 sampleGrid;
   bool selectedOnly;
   bool quadraticPrec;
   float32 markSampleSpacing;
   card32 markSamSpNumNeighbors;
   float32 maxRelResiduum;
   
   void markLowDensityPoints();
   void markOutliers();
   void clearSelection();
   
 public:
	PCCMLSHoleFiller();
	virtual void assign(const Object* obj, X4CopyContext *context = NULL);
   virtual void execute(Scene *scene);
	~PCCMLSHoleFiller();
};


}

#endif
