//---------------------------------------------------------------------------
#ifndef PCCNoisySamplingH
#define PCCNoisySamplingH
//---------------------------------------------------------------------------
#include "x3editor2.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------

namespace X4 {

class PCCNoisySampling : public PCCommand {
	X4_CLASS(PCCNoisySampling)
 
 private:
	/// number of samples per selected point cloud (small deviations possible due to randomization)
	card32 expectedNumSamples;
	/// number of additional outliers distributed uniformly in 2x bounding box area
	card32 numOutliers;
	/// include (2d) noise in xy direction?
	bool noiseXY;
	/// include noise in z direction?
	bool noiseZ;
	/// gaussian nosie in absolute coordinates
	float32 noiseStdDeviation;
	/// name of new point cloud (will be created)
	std::string targetName;

	void createPoint(Vector3f pos, PointSet *ps);

 public:
	PCCNoisySampling();
	
	virtual void execute(Scene *scene);

};

}

#endif