//---------------------------------------------------------------------------
#ifndef PCCParametricDerivativeEstimatorH
#define PCCParametricDerivativeEstimatorH
//---------------------------------------------------------------------------
#include "x3editor2.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
#include "LinearAlgebra.h"
#include "VertexDescriptor.h"
//---------------------------------------------------------------------------

namespace X4 {

class ModifyablePointCloudIterator;
class ParametricPointCloudIterator;
class Scene;
class PointCloud;


class X3EDITOR2_API PCCParametricDerivativeEstimator : public PCCommand {
 private:
   static MetaClass *PCCParametricDerivativeEstimatorMetaClass;
   static Object* newInstance();

   bool estimateNormals;
   bool estimateTangents;
   bool normalizeNormals;
   bool normalizeTangents;
   bool invalidateOutliers;
   float32 outlierFactor;

   bool checkNormalTangentsChannels(Scene *scene, card32 pointCloudIndex, PointCloud* &pc);
   inline void setAttribs(ModifyablePointCloudIterator *it, ParametricPointCloudIterator *paramIt,
                          const card32 x, const card32 y, const Vector3f normal, const Vector3f tangentU, const Vector3f tangent,
                          const AAT NORMAL, const AAT TANGENT_U, const AAT TANGENT_VV);

 public:
   PCCParametricDerivativeEstimator();

   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   virtual void execute(Scene *scene);

};


}

#endif
 