//---------------------------------------------------------------------------
#ifndef PCCParametricPointSpriteCreatorH
#define PCCParametricPointSpriteCreatorH
//---------------------------------------------------------------------------
#include "x3editor2.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------

namespace X4 {


/// convertes an PointCloud into a ParametricPointCloud with random point order
class X3EDITOR2_API PCCParametricPointSpriteCreator : public PCCommand {
 private:
   static MetaClass *PCCParametricPointSpriteCreatorMetaClass;
   static Object* newInstance();

   /// source point cloud (any type)
   std::string source;
   /// destination - must be parametric point cloud
   std::string dest;
   /// reorder points randomly?
   bool randomPermutation;

 public:
   PCCParametricPointSpriteCreator();

   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   virtual void execute(Scene *scene);

};


}

#endif
 