//---------------------------------------------------------------------------
#ifndef PCCPlayCameraPathH
#define PCCPlayCameraPathH
//---------------------------------------------------------------------------
#include "x3editor2.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------

namespace X4 {

class CameraController;

extern double X3EDITOR2_API GLOBAL_VAR_PCCPlayCameraPath_avPtsInPath;
extern double X3EDITOR2_API GLOBAL_VAR_PCCPlayCameraPath_avNodesInPath;


///
///   renders several frames using a specified camera controller (e.g. path controller)
///   useful for scripting rendering examples
///
class X3EDITOR2_API PCCPlayCameraPath : public PCCommand {
	X4_CLASS( PCCPlayCameraPath )
 private:
   CameraController *camCtrl;
   float32 startTime;
   float32 endTime;
   card32 numFrames;
   bool outputTiming;
   
   void loadCameraController();
   void saveCameraController();

 public:
	PCCPlayCameraPath();

	virtual void assign(const Object* obj, X4CopyContext *context = NULL);
	virtual void execute(Scene *scene);

   ~PCCPlayCameraPath();
};

}

#endif