//---------------------------------------------------------------------------
#ifndef PCCPointsToSplatsH
#define PCCPointsToSplatsH
//---------------------------------------------------------------------------
#include "x3editor2.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------

namespace X4 {

/**
	This command converts a point cloud with sample spacing (estimated) into a mesh with little tangential discs, for example, for rendering purpose.
*/
class X3EDITOR2_API PCCPointsToSplats : public PCCommand
{
	X4_CLASS( PCCPointsToSplats )

 private:
// 	string sourcePC;        // source point cloud
 	string outputPostfix;      // string appended to output triangle mesh name
	card32	numVertices;	// number of vertices along disc boundary (default = 6)
	float32	scaleFactor;	// additional scale factor for overlap control (default = 1.0)

 public:
	PCCPointsToSplats();

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);
	virtual void execute(Scene *scene);

	~PCCPointsToSplats();
};

}

#endif