//---------------------------------------------------------------------------
#ifndef PCCRochusKapelleH
#define PCCRochusKapelleH
//---------------------------------------------------------------------------
#include "x3editor2.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------

namespace X4
{

/**
	importer specifically for the "Rochus Kapelle" data set from zf
*/
class X3EDITOR2_API PCCRochusKapelle : public PCCommand {
	X4_CLASS( PCCRochusKapelle )
 private:
	std::string targetNode;
	std::string dataSetDir;
	std::string bucketTempFileName;
	bool normalizeIntensity;
	bool storeCameraPos;
	float32 bucketsSideLength;
	bool useBuckets;

	void setNamesAndInitialTransformations( Matrix4f * reg, std::string * fname ) ;
	
 public:
	PCCRochusKapelle();

   virtual void execute(Scene *scene);
   void importToSeparatePCs();


};

}

#endif