//---------------------------------------------------------------------------
#ifndef PCCsmoothingH
#define PCCsmoothingH
//---------------------------------------------------------------------------
#include "x3editor2.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
#include "Scene.h"
#include "ProgressWindow.h"
//---------------------------------------------------------------------------

namespace X4 {

class X3EDITOR2_API PCCSmoothing : public PCCommand 
{
	X4_CLASS( PCCSmoothing )

	public:
		/// Point cloud name
		std::string pcName;
		/// Number of neighbors used
		card32 numNeighbors;
		/// use topology
		bool useTopology;
		/// laplacian smooth
		bool useLaplacian;
		/// num iterations
		card32 numIterations;
	public:
		/// Constructor
		PCCSmoothing();
		/// Destructor
		~PCCSmoothing();

		/// Execute command
		virtual void execute( Scene *scene );
		/// Connect to scene
		void connectScene( Scene *scene, OnSceneChangeCallback *onChange, QWidget *sceneEditorWidget );
		/// execute at specific pc
		virtual void execute_at( Scene *scene, PointCloud* pc );
};


}

#endif
 