//---------------------------------------------------------------------------
#ifndef PCCUnifyNormalsH
#define PCCUnifyNormalsH
//---------------------------------------------------------------------------
#include "x3editor2.h"
#include "LinearAlgebra.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------

namespace X4 {

class X3EDITOR2_API PCCUnifyNormals : public PCCommand 
{
	X4_CLASS( PCCUnifyNormals )
	private:
		card32 m_numNearestPoints;		/// Number of nearest points considered
		bool recolorUnifiedNormals;		/// if true points are colored yellow while unifying normals
		bool useImprovedAlgorithm;		/// Apply improved algorithm

	public:
		PCCUnifyNormals();
		~PCCUnifyNormals();
		virtual void execute(Scene *scene);

	struct myPoint {
		Vector3f position;
		float32 priority;
	};
};

inline bool operator<(const PCCUnifyNormals::myPoint &e1, const PCCUnifyNormals::myPoint &e2) 
{
	if (e1.priority<e2.priority) return true;
	else return false;
};

}

#endif
