//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "PCIImageEditingEditorWidget.h"
//---------------------------------------------------------------------------
#include "PCIImageEditing.h"
#include "StringHelper.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



IMPLEMENT_CLASS_EDITOR( PCIImageEditing )

PCIImageEditingEditorWidget::PCIImageEditingEditorWidget(QWidget * parent, Qt::WindowFlags f)
:QWidget(parent,f)
{
	//call ui.setupUi(this) to set up the layout from QtDesigner
	pciImgEd=0;
	toolEditor=NULL;
	toolEditorWidget=NULL;
	ui.setupUi(this);
	ui.cPropTool->collectClasses("PCImageTool") ;

	QVBoxLayout* tl=new QVBoxLayout;
 tl->setMargin(0);
 tl->setSpacing(0);
 ui.frameToolEd->setLayout(tl);
 //Example: easy access to QtDesigner buttons, etc. by ui object
 //QWidget::connect(ui.loadButton,SIGNAL(clicked()),this,SLOT(sltLoadFile()));

}

PCIImageEditingEditorWidget::~PCIImageEditingEditorWidget(void)
{
	delete toolEditor;
}

void PCIImageEditingEditorWidget::setup( PCIImageEditing * obj )
{
	pciImgEd = obj;
}

void PCIImageEditingEditorWidget::updateEditor()
{
}

void PCIImageEditingEditorWidget::on_editTarget_textChanged()
{
	pciImgEd->setTargetNode( ui.editTarget->text().toLatin1().constData() );
	pciImgEd->setChannel( qString2STLString(ui.comboChannel->currentText()) );
	pciImgEd->redrawScene();

}

void PCIImageEditingEditorWidget::on_comboChannel_editTextChanged(const QString &text)
{
	pciImgEd->setTargetNode( ui.editTarget->text().toLatin1().constData() );
	pciImgEd->setChannel( qString2STLString(text) );
	pciImgEd->redrawScene();
}

void PCIImageEditingEditorWidget::on_spinZoom_valueChanged(double d)
{
	pciImgEd->zoom = d;
	pciImgEd->redrawScene();
}

void PCIImageEditingEditorWidget::on_spinScale_valueChanged(double d)
{
	pciImgEd->scale = d;
	pciImgEd->redrawScene();
}

void PCIImageEditingEditorWidget::on_spinPanX_valueChanged(double d)
{
	pciImgEd->pan[0] = d;
	pciImgEd->redrawScene();

}

void PCIImageEditingEditorWidget::on_spinPanY_valueChanged(double d)
{
	pciImgEd->pan[1] = d;
	pciImgEd->redrawScene();
}

void PCIImageEditingEditorWidget::on_spinOffset_valueChanged(double d)
{
	pciImgEd->offset = d;
	pciImgEd->redrawScene();
}

void PCIImageEditingEditorWidget::on_checkFlipY_stateChanged(int state)
{
	pciImgEd->flipY = state;
}

void PCIImageEditingEditorWidget::on_cPropTool_currentIndexChanged(QString v)
{


	if (pciImgEd==NULL) return;
	std::string  s = v.toLatin1().constData();
	const MetaClass *newToolClass = MetaClass::getClassByName(s);

	if (toolEditor != NULL) {
		;
		delete toolEditor;
		toolEditor = NULL;
	}

	if (toolEditorWidget != NULL) {
		ui.frameToolEd->layout()->removeWidget(toolEditorWidget);
		delete toolEditorWidget;
	}
	toolEditorWidget = NULL;

	
	delete pciImgEd->currentTool;
	pciImgEd->currentTool = NULL;


	if (newToolClass == NULL || newToolClass->isAbstract()) return;

	pciImgEd->setTool((PCImageTool*)(newToolClass->newInstance()));

	pciImgEd->currentTool->areaResize(pciImgEd->width, pciImgEd->height);

	const MetaClass *newToolEditorClass = newToolClass->getGUIDescriptor()->getDefaultClassEditor();

	if (newToolEditorClass == NULL || newToolEditorClass->isAbstract()) return;

	toolEditor = (ClassEditor*)(newToolEditorClass->newInstance());
	toolEditorWidget = toolEditor->makeEditor(ui.frameToolEd, pciImgEd->currentTool);

	//toolEditorWidget->setParent(ui.frameToolEd);
	ui.frameToolEd->layout()->addWidget(toolEditorWidget);
	toolEditorWidget->show();
	toolEditor->update();


}



#include "PCIImageEditingEditorWidget_moc.h"
