#ifndef PCIImageEditingEditorWidgetH 
#define PCIImageEditingEditorWidgetH
//---------------------------------------------------------------------------
#include "x3editor2.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "PCIImageEditingEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace X4
{

class PCIImageEditing;

class X3EDITOR2_API PCIImageEditingEditorWidget : public QWidget
{
	Q_OBJECT

private:

	PCIImageEditing *pciImgEd;

	///used to access buttons, etc. from QtDesigner
	Ui_PCIImageEditingEditorForm ui;
	ClassEditor *toolEditor;
	QWidget *toolEditorWidget;

public:
	PCIImageEditingEditorWidget(QWidget * parent = NULL, Qt::WindowFlags f=0);
	~PCIImageEditingEditorWidget(void);

	void setup( PCIImageEditing * obj );

	/// update editor content with object data
	void updateEditor();

	public slots:
		void  on_editTarget_textChanged();
		void  on_comboChannel_editTextChanged(const QString &text);
		void  on_spinZoom_valueChanged(double);
		void  on_spinPanX_valueChanged(double);
		void  on_spinPanY_valueChanged(double);
		void  on_spinScale_valueChanged(double);
		void  on_spinOffset_valueChanged(double);
		void  on_checkFlipY_stateChanged(int);
		void on_cPropTool_currentIndexChanged(QString);

	
};

MAKE_CLASS_EDITOR( X3EDITOR2_API , PCIImageEditing )


}

#endif