#ifndef PCIManualAlignmentH
#define PCIManualAlignmentH
//---------------------------------------------------------------------------
#include "x3editor2.h"
//---------------------------------------------------------------------------
#include "PCInteractionTool.h"
//---------------------------------------------------------------------------

namespace X4
{
class FSIcp;

/**
	align two point clouds manually
*/
class X3EDITOR2_API PCIManualAlignment : public PCInteractionTool
{
	X4_CLASS( PCIManualAlignment )

private:

	std::vector<Vector3f>		m_PointList1;
	std::vector<Vector3f>		m_PointList2;

	PointCloud			*	m_PC1;
	PointCloud			*	m_PC2;
	FSIcp					*	m_ICP;
	card32					m_NumICPPoints;
	bool						m_WriteResiduals;

public:
	PCIManualAlignment(void);
	~PCIManualAlignment(void);

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

	virtual void keyDown(GeneralKey key) {}
	virtual void keyUp(GeneralKey key) {}

	virtual void mouseDown(int32 x, int32 y, MouseButtons buttonsState, Modifiers modifiersState);
	virtual void mouseMoved(int32 x, int32 y) {}
	virtual void mouseUp(int32 x, int32 y, MouseButtons buttonsState, Modifiers modifiersState) {}
	virtual void areaResize(card32 width, card32 height) {}

	virtual void glDrawTool(GLContext *glContext);

	void clear();
	void align();
	void icp();
	void basePlaneAlignment();


};

}

#endif