//---------------------------------------------------------------------------
#ifndef PCIRegisterTextureH
#define PCIRegisterTextureH
//---------------------------------------------------------------------------
#include "x3editor2.h"
//---------------------------------------------------------------------------
#include "PCInteractionTool.h"
#include "LinearAlgebra.h"
#include "ObjectClassProperty.h"
#include "Scene.h"
#include "SceneGraphState.h"
#include "DebugOutput.h"
#include "PointCloud.h"
#include "PointCloudIterators.h"
#include "ParametricInCorePointCloud.h"
#include "ManualImageFeatures.h"
#include "ManualImageFeaturesEditorWidget.h"

//---------------------------------------------------------------------------


namespace X4 {
   

	//class PCIRegisterTextureWidget;
class X3EDITOR2_API PCIRegisterTexture : public PCInteractionTool {
	X4_CLASS(PCIRegisterTexture);

 private:

   ManualImageFeatures* imgFeatures;
   ManualImageFeaturesEditorWidget* imgFeatureWidget;

   Matrix4f t;
   Matrix4f calibrateCamera();
   void colorCloud(Matrix4f,PointCloud *);

 public:

	
	std::vector<Vector3f> objPoints;
	std::vector<Vector2i> estPoints;
	IMPLEMENT_VAR_ARRAY_METHODS_STL(objPoints)
     bool calib;
	float* trans;
	float* camera;
	float* rot;
  
   
   int current;
   int w,h;
   int iw,ih;
   float32 s;

   PCIRegisterTexture();
   void calibrate();
   void colorPoints();
   void openFeatureWidget();
   Matrix4f getCameraMatrix();
   std::vector<Vector3f> getObjPoints();
   void setCameraMatrix(Matrix4f cam);
   void execute();

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

   virtual void mouseDown(int32 x, int32 y, MouseButtons buttonsState, Modifiers modifiersState);
   virtual void mouseMoved(int32 x, int32 y);
   virtual void mouseUp(int32 x, int32 y, MouseButtons buttonsState, Modifiers modifiersState);
   virtual void areaResize(card32 width, card32 height);

   virtual void keyPressed(char key);
   virtual void keyDown(GeneralKey key);
   virtual void keyUp(GeneralKey key);

   virtual void glDrawTool(GLContext *glContext);
   //virtual void redrawScene() {if (onChange != NULL) {onChange->changed(PCI_CHANGE_VIEW);}}
};



}

#endif

