//---------------------------------------------------------------------------
#ifndef PCISurfaceReconstructionIOH
#define PCISurfaceReconstructionIOH
//---------------------------------------------------------------------------
#include "x3editor2.h"
//---------------------------------------------------------------------------

namespace X4 {

/// 
class X3EDITOR2_API PCISurfaceReconstructionIO : public PCInteractionTool
{
	X4_CLASS( PCISurfaceReconstructionIO )

	private:
		std::string sourcePC;
		std::string destPC;
		void PwnPtsExport(QString filename, bool writeNormals);

	public:
		void exportToPWN();
		void exportToPTS();
		void exportToNPTS();
		void exportToPoints();
		void importFromPoly();

	public:
		/*** CLASS MANAGEMENT ***/
		PCISurfaceReconstructionIO();
		~PCISurfaceReconstructionIO();

		/*** PCINTERACTION ***/
		virtual void assign(const Object* obj, X4CopyContext *context = NULL){};
		virtual void mouseDown(int32 x, int32 y, MouseButtons buttonsState, Modifiers modifiersState){};
		virtual void mouseMoved(int32 x, int32 y){};
		virtual void mouseUp(int32 x, int32 y, MouseButtons buttonsState, Modifiers modifiersState){};
		virtual void areaResize(card32 width, card32 height){};
		virtual void keyDown(GeneralKey key){};
		virtual void keyUp(GeneralKey key){};
		virtual void activateTool(){};
		virtual void deactivateTool(){};
		virtual void glDrawTool(GLContext *glContext){};
		void redraw(){ redrawScene(); }
};

}

#endif