#ifndef PCITopologyAnalyzerEditorWidgetH 
#define PCITopologyAnalyzerEditorWidgetH
//---------------------------------------------------------------------------
#include "x3editor2.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "PCITopologyAnalyzerEditorWidget_ui.h"
//---------------------------------------------------------------------------

namespace X4
{

class PCITopologyAnalyzer;

class X3EDITOR2_API PCITopologyAnalyzerEditorWidget : public QWidget
{
	Q_OBJECT

private:

	PCITopologyAnalyzer	*	m_Object;

	///used to access buttons, etc. from QtDesigner
	Ui_PCITopologyAnalyzerEditorForm ui;

	void computeViz(bool compare);

protected:
	virtual void resizeEvent(QResizeEvent *ev);

public:
	PCITopologyAnalyzerEditorWidget(QWidget * parent = NULL, Qt::WindowFlags f=0);
	~PCITopologyAnalyzerEditorWidget(void);

	void setup( PCITopologyAnalyzer * obj );

	/// update editor content with object data
	void updateEditor();
 
 public slots:
	void on_pushButtonRecompute_clicked();
	void on_pushButtonCompare_clicked();
	void on_spinBoxSelectedPoint_valueChanged(int i);
	void on_doubleSpinBoxImageGain_valueChanged(double d);
	void on_doubleSpinBoxImageOffset_valueChanged(double d);
	void on_spinBoxQuantization_valueChanged(int i);
	void on_lineEditTarget_textChanged (const QString &text);
	void on_dsbEpsilon_valueChanged(double d);
	void on_radioButtonMeanSquare_clicked(bool checked);
	void on_radioButtonRobustStat_clicked(bool checked);
	void on_radioButtonKernel_clicked(bool checked);
	void on_spinBoxExpNumPts_valueChanged(int i);
	void on_doubleSpinBoxSigma_valueChanged(double d);
	void on_pushButtonLinkVariance_clicked();
	void on_pushButtonLocalVariance_clicked();
};

MAKE_CLASS_EDITOR( X3EDITOR2_API , PCITopologyAnalyzer )


}

#endif