//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "SGAllocatorList.h"
//---------------------------------------------------------------------------
#include "MultiObjectStream.h"
#include "ObjectClassProperty.h"
#include "ObjectListProperty.h"
#include "StringHelper.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



IMPLEMENT_X4_CLASS( SGAllocatorList ,0)
{
	BEGIN_CLASS_INIT( SGAllocatorList );
	ADD_OBJECT_LIST_PROP( allocators, 0, MultiObjectStream::getClass() )
}

void SGAllocatorList::addallocators( Object * obj ) {
	allocators.push_back((MultiObjectStream*)obj);
}
void SGAllocatorList::deleteallocatorss( card32 begin, card32 end ) {
	for (card32 i=begin; i<end; i++) {
		delete allocators[i];
	}
	allocators.erase(allocators.begin()+begin, allocators.begin()+end);
}

Object *SGAllocatorList::getallocators( card32 index ) {
	return allocators[index];
}

void SGAllocatorList::moveallocators( card32 oldPos, card32 newPos ) {
	swap(allocators[oldPos], allocators[newPos]);
}

card32 SGAllocatorList::getNumallocatorss() {
	return (card32)allocators.size();
}


std::string SGAllocatorList::getallocatorsName(card32 index) {
	return std::string("allocators #") + intToStr(index);
}


//---


SGAllocatorList::~SGAllocatorList() {
	for (card32 i=0; i<allocators.size(); i++) {
		delete allocators[i];
	}
}

void SGAllocatorList::assign(const Object* obj, X4CopyContext *context)
{
	Persistent::assign(obj,context);
	const SGAllocatorList *other = dynamic_cast<const SGAllocatorList*>(obj);
	x4Assert(other != NULL);
	if (other == NULL) return;
	for (card32 i=0; i<allocators.size(); i++) {
		delete allocators[i];
	}
	allocators.clear();
	for (card32 i=0; i<other->allocators.size(); i++) {
		allocators.push_back((MultiObjectStream*)other->allocators[i]->copy(context));
	}
}

void X4::SGAllocatorList::hackRemoveAllocatorReferences()
{
	for( mpcard i = 0; i < allocators.size(); i++)  allocators[i] = NULL; allocators.clear();
}