//---------------------------------------------------------------------------
#ifndef AllocatorListH
#define AllocatorListH
//---------------------------------------------------------------------------
#include "x3editor2.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------
#include <vector>
//---------------------------------------------------------------------------

namespace X4 {

class MultiObjectStream;

/**
	List of allocators (used by StaticSceneGraphState to provide allocators for out-of-core-nodes)
*/
class X3EDITOR2_API SGAllocatorList : public Persistent {
	X4_CLASS( SGAllocatorList )

private:
   std::vector<MultiObjectStream*> allocators;

   void addallocators( Object * obj );
   void deleteallocatorss( card32 begin, card32 end );
   Object * getallocators( card32 index );
   void moveallocators( card32 oldPos, card32 newPos );
   card32 getNumallocatorss();
   std::string getallocatorsName(card32 index );

public:
   virtual void assign(const Object* obj, X4CopyContext *context = NULL);
	
	inline card32 getNumAllocators() {return (card32)allocators.size();}
	inline MultiObjectStream* getAllocator(card32 i) {x4Assert(i<allocators.size()); return allocators[i];}
	inline void addAllocator(MultiObjectStream *a) {allocators.push_back(a);}
	
	void hackRemoveAllocatorReferences();;
	
	~SGAllocatorList(void);

};

}

#endif