//---------------------------------------------------------------------------
#ifndef SurfaceElementStructureAttachmentH
#define SurfaceElementStructureAttachmentH
//---------------------------------------------------------------------------
#include "x3editor2.h"
//---------------------------------------------------------------------------
#include "AttachedData.h"
#include "RenderableObject.h"
#include "ObjectListProperty.h"
#include "SurfaceElements.h"
#include "SurfaceElementsViewers.h"
//---------------------------------------------------------------------------

namespace X4 {

class SurfaceElementViewer;
class SEVContext;

/**
   Container for surface elements
*/
class X3EDITOR2_API SurfaceElementStructureAttachment : public AttachedData, public RenderableObject {
	X4_CLASS( SurfaceElementStructureAttachment )

 private:
   SurfaceElementViewer *viewers;
   SEVContext *context;
 
   std::vector<SurfaceElement*> m_points;
   std::vector<SurfaceElement*> m_regions;
   IMPLEMENT_OBJECT_LIST_METHODS_STL(points, SurfaceElement)
   IMPLEMENT_OBJECT_LIST_METHODS_STL(regions, SurfaceElement)

 public:
	SurfaceElementStructureAttachment();
	
   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

   std::vector<SurfaceElement*> &getPoints() {delete viewers; viewers=NULL; return m_points;}
   std::vector<SurfaceElement*> &getRegions() {delete viewers; viewers=NULL; return m_regions;}

   void deleteRegions(SurfaceElement* region);

   virtual void renderGL(SceneObject *obj);

   /// for debugging
   virtual std::string toString();

	~SurfaceElementStructureAttachment();
};

}

#endif