//---------------------------------------------------------------------------
#ifndef SurfaceElementsInteractionContextH
#define SurfaceElementsInteractionContextH
//---------------------------------------------------------------------------
#include "x3editor2.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace X4 {

class Scene;
class PCISurfaceElementInteractionTool;
class SurfaceElementViewer;


/**
  Interaction context: global variables for interaction process
*/
class X3EDITOR2_API SurfaceElementsInteractionContext : public Persistent {
	X4_ABSTRACT_CLASS( SurfaceElementsInteractionContext )
 public:
   Scene *scene;
   Matrix4f projectionMatrix;
   PCISurfaceElementInteractionTool *currentTool;
   SurfaceElementViewer *viewerHierarchy;
   int32 width;
   int32 height;
   float32 pickDistance;
   float32 worldSpaceSnap;
 
	SurfaceElementsInteractionContext();
			
   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

   /// helper function for picking
   void rayQuery(Vector3f pos, int32 x, int32 y, float32 &depth, float32 &screenDist);

	~SurfaceElementsInteractionContext();
};





}

#endif