//---------------------------------------------------------------------------
#ifndef SurfaceElementsPolyMeshSegmentationH
#define SurfaceElementsPolyMeshSegmentationH
//---------------------------------------------------------------------------
#include "x3editor2.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace X4 {

class Scene;
class SurfaceElementMeshPolygon;
class SurfaceElementPolygon;
class UnstructuredInCoreTriangleMesh;
class InCorePCTopologyGraph;


/**
  cuts mesh into parts according to polygons
*/
class X3EDITOR2_API SurfaceElementsPolyMeshSegmentation : public Persistent {
	X4_ABSTRACT_CLASS( SurfaceElementsPolyMeshSegmentation )
 private:
   /// straight connections or along crease lines?
   bool curvatureAware;
   /// new_distance = dist/(curv + ncb)
   float32 nonCurvatureBias;
   
 public:
	SurfaceElementsPolyMeshSegmentation();
			
   SurfaceElementMeshPolygon *cutMesh(UnstructuredInCorePointCloud *mesh, InCorePCTopologyGraph *tg, SurfaceElementPolygon *poly);

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

	~SurfaceElementsPolyMeshSegmentation();
};





}

#endif