SET_MODULE_TYPE_LOADABLE_MODULE
// modules that the new module is based on. expand as required.
ADD_DEPENDENCY("opencv")
ADD_DEPENDENCY("x4basics")
ADD_DEPENDENCY("x4core")
ADD_DEPENDENCY("x4interface")
ADD_DEPENDENCY("x4math")
ADD_DEPENDENCY("x4miscFoundation")
ADD_DEPENDENCY("x4tools")
ADD_DEPENDENCY("x4modules")
ADD_DEPENDENCY("x3geometry")
ADD_DEPENDENCY("x3openGL")
ADD_DEPENDENCY("x3sceneGraph")
ADD_DEPENDENCY("x3editor")
ADD_DEPENDENCY("x3rendering")
ADD_DEPENDENCY("x3foundation_private")

// add one or more authors (repeat command for multiple authors)
ADD_AUTHOR("Michael Wand")

// add the institution holding the copyright
ADD_INSTITUITION("Universiteit Utrecht")

// BSD is the default license. Choose carefully for your new module.
ADD_LICENSE("BSD")

// an icon for this module
ADD_ICON(":/images_x3editor2/images/x3editor2.png")

// Add classes here: format is "class", "baseClass". class.h is included
// ADD_CLASS("SomeNewClass", "Persistent")

// Alternative: specify file to include for this declaration
// ADD_CLASS_INC("SomeNewClass", "Persistent", "AHeaderWithManyClasses.h")

// PCCommands

ADD_CLASS("PCCComputeTopology", "PCCommand")
ADD_CLASS("PCCImportBMP2DCloud", "PCCommand")
ADD_CLASS("PCCNoisySampling", "PCCommand")
ADD_CLASS("PCCParametricDerivativeEstimator", "PCCommand")
ADD_CLASS("PCCParametricDerivator", "PCCommand")
ADD_CLASS("PCCParametricPointCloudGenerator", "PCCommand")
ADD_CLASS("PCCParametricPointSpriteCreator", "PCCommand")
//	PCCTriangulator", "PCCommand")
ADD_CLASS("PCCKMeansClustering", "PCCommand")
ADD_CLASS("PCCLargeTestScene", "PCCommand")
ADD_CLASS("PCCRochusKapelle", "PCCommand")
ADD_CLASS("PCCNormalTools", "PCCommand")
ADD_CLASS("PCCGridResampler", "PCCommand")
//ADD_CLASS("PCCCreateOOCTestScene", "PCCommand")

ADD_CLASS("PCCUnifyNormals", "PCCommand")
ADD_CLASS("PCCSmoothing", "PCCommand")
ADD_CLASS("PCCImportGeo", "PCCommand")
ADD_CLASS("PCCPlayCameraPath", "PCCommand")
//ADD_CLASS("PCCDownsampleRndOOC", "PCCommand") 
ADD_CLASS("PCCBilateralSmoothing", "PCCommand")
//ADD_CLASS("LegacyClassNameTranslation::registerTranslation("PCCDownsample", PCCDownsampleRndOOC")
ADD_CLASS("PCCRemoveOutliers", "PCCommand")
ADD_CLASS("PCCNormalizeAnimation", "PCCommand")
ADD_CLASS("PCCDeleteFrames", "PCCommand")
ADD_CLASS("PCCTwist", "PCCommand")
ADD_CLASS("PCCImportMPIStructuredLight", "PCCommand")
ADD_CLASS("PCCTestKNNPerformance", "PCCommand")
ADD_CLASS("PCCExportTopology", "PCCommand")
ADD_CLASS("PCCLevelSetExtractor", "PCCommand")
ADD_CLASS("PCCApplySOTransformation", "PCCommand")
ADD_CLASS("PCCRegisterICP", "PCCommand")
ADD_CLASS("PCCMLSHoleFiller", "PCCommand")

// Interactive tools
ADD_CLASS("PCIImageEditing", "PCInteractionTool")
ADD_CLASS("PCIRegisterPC", "PCInteractionTool")
//ADD_CLASS("PCIRegisterTexture", "PCInteractionTool")
ADD_CLASS("PCITopologyComputation", "PCInteractionTool")
ADD_CLASS("PCI2DPointPainter", "PCInteractionTool")
ADD_CLASS_INC("PointPainterCmdObj", "CommandObject", "PCI2DPointPainter.h")
ADD_CLASS("PCITriangleMesh", "PCInteractionTool")
//ADD_CLASS("PCIBenchTool", "PCInteractionTool")
//PCITriangleMeshTool", " PCInteractionTool")
ADD_CLASS("PCISurfaceReconstructionIO", "PCInteractionTool")
ADD_CLASS("PCITestMLSRenderer", "PCInteractionTool")
ADD_CLASS("PCIManualAlignment", "PCInteractionTool")

// Misc
//ADD_CLASS("PCImageTool", "Persistent")
ADD_CLASS_INC("PCIPatchMatchingTest", "PCImageTool", "PCImageTools.h")
ADD_CLASS_INC("PCITImagePaint", "PCImageTool", "PCImageTools.h")
ADD_CLASS("ImportSwissRangerData", "PointCloudImporterReader")

//   GLImageLensCorrection", " GLImageWarper")

//ADD_CLASS("LocalGeometryModelStatistics", "Persistent")
ADD_CLASS_INC("LGMSPlaneModel", "LocalGeometryModelStatistics", "LocalGeometryModelStatistics.h")
ADD_CLASS_INC("LGMSLeastSquaresPlaneModel", "LGMSPlaneModel", "LocalGeometryModelStatistics.h")
ADD_CLASS_INC("LGMSKernelPlaneModel", "LGMSPlaneModel", "LocalGeometryModelStatistics.h")
ADD_CLASS_INC("LGMSKernelLineEntropyPlaneModel", "LGMSPlaneModel", "LocalGeometryModelStatistics.h")
ADD_CLASS_INC("HoughTransformCornerDetector", "Persistent", "HoughTransformProcessing.h")
ADD_CLASS_INC("HTCornerDetectorFiniteDiff", "HoughTransformCornerDetector", "HoughTransformProcessing.h")
ADD_CLASS_INC("HTPickMaximum", "HoughTransformCornerDetector", "HoughTransformProcessing.h")
ADD_CLASS_INC("HTConvexSegmentation", "HoughTransformCornerDetector", "HoughTransformProcessing.h")
ADD_CLASS("LocalGeometryUncertainty", "Persistent")
ADD_CLASS_INC("LGULeastSquarePlanePCA", "LocalGeometryUncertainty", "LocalGeometryUncertainty.h")
ADD_CLASS("TopologyEstimator", "Persistent")

ADD_CLASS("LocalModelAttachment", "AttachedData")

// surface elements editor
ADD_CLASS_INC("SurfaceElement", "Persistent", "SurfaceElements.h")
ADD_CLASS_INC("SurfaceElementPoint", "SurfaceElement", "SurfaceElements.h")
ADD_CLASS_INC("SurfaceElementVertex", "SurfaceElementPoint", "SurfaceElements.h")
ADD_CLASS_INC("SurfaceElementFreePoint", "SurfaceElementPoint", "SurfaceElements.h")
ADD_CLASS_INC("SurfaceElementPolygonPoint", "SurfaceElementFreePoint", "SurfaceElements.h")
ADD_CLASS_INC("SurfaceElementAbstractPolygon", "SurfaceElement", "SurfaceElements.h")
ADD_CLASS_INC("SurfaceElementPolygon", "SurfaceElementAbstractPolygon", "SurfaceElements.h")
ADD_CLASS_INC("SurfaceElementPolygonAnnotated", "SurfaceElement", "SurfaceElements.h")

ADD_CLASS_INC("SurfaceElementViewer", "Object", "SurfaceElementsViewers.h")
ADD_CLASS_INC("SurfaceElementViewerPointAsSphere", "SurfaceElementViewer", "SurfaceElementsViewers.h")
ADD_CLASS_INC("SurfaceElementViewerList", "SurfaceElementViewer", "SurfaceElementsViewers.h")
ADD_CLASS_INC("SEVContext", "Persistent", "SurfaceElementsViewers.h")

ADD_CLASS_INC("SurfaceElementController", "Object", "SurfaceElementsControllers.h")
ADD_CLASS_INC("SurfaceElementControllerSelection", "SurfaceElementController", "SurfaceElementsControllers.h")
ADD_CLASS_INC("SurfaceElementControllerPolygonVertices", "SurfaceElementController", "SurfaceElementsControllers.h")

ADD_CLASS("SurfaceElementEditingEventDispatcher", "Object")
ADD_CLASS("SurfaceElementsInteractionContext", "Persistent")

ADD_CLASS_INC("PCISurfaceElementInteractionTool", "PCInteractionTool", "SurfaceElementsInteractionTools.h")
ADD_CLASS_INC("PCISESelection", "PCISurfaceElementInteractionTool", "SurfaceElementsInteractionTools.h")
ADD_CLASS_INC("PCISEPointSelection", "PCISESelection", "SurfaceElementsInteractionTools.h")
ADD_CLASS_INC("PCISEPolygonRegionTool", "PCISESelection", "SurfaceElementsInteractionTools.h")

ADD_CLASS("SurfaceElementStructureAttachment", "AttachedData")

ADD_CLASS("SurfaceElementsPolyMeshSegmentation", "Persistent")

ADD_CLASS("PCCPointsToSplats", "PCCommand")