#pragma once

//---------------------------------------------------------------------------
#include "x3fastSparseMath.h"
//---------------------------------------------------------------------------

namespace X4
{

class X3FASTSPARSEMATH_API FastDMatrix
{

	float *data;
	size_t numColumns;
	size_t numRows;

public:
	FastDMatrix(void);
	~FastDMatrix(void);

	void setDimension(size_t columns, size_t rows);
	void setZero();
	inline void addValue(const size_t &col, const size_t &row, const float &value){
		data[col*numRows + row] += value;
	}
	inline void setValue(const size_t &col, const size_t &row, const float &value){
		data[col*numRows + row] = value;
	}
	inline float& getValue(const size_t &col, const size_t &row){
		return data[col*numRows + row];
	}
	float  biggestValue() const;
	size_t countNonZeros() const;
	size_t getNumEntries() const;
	float  sumAllValues()  const;

};

}
