//---------------------------------------------------------------------------
#include "stdafx.h"
 
//---------------------------------------------------------------------------
#include "ABS_Framework.h"
//---------------------------------------------------------------------------
#include "NumericalClassProperty.h"
#include "NumericalClassProperty.inline.h"
#include "StringClassProperty.h"
#include "ObjectClassProperty.h"
#include "ObjectListProperty.h"
#include "GLImage.h"
#include "GLRenderTextureCache.h"
#include "Scene.h"
#include <algorithm>
//---------------------------------------------------------------------------
 
//---------------------------------------------------------------------------
using namespace X4;

MetaClass* ABS_ParameterDescriptor::ABS_ParameterDescriptorMetaClass = NULL;

const MetaClass* ABS_ParameterDescriptor::getInstanceClass() const {
   return getClass();
}

Object* ABS_ParameterDescriptor::newInstance() {
   return new ABS_ParameterDescriptor;
}

const MetaClass* ABS_ParameterDescriptor::getClass() {
   if (ABS_ParameterDescriptorMetaClass==NULL) {
      ABS_ParameterDescriptorMetaClass = new MetaClass("ABS_ParameterDescriptor", "no description.",
                                  newInstance, sizeof(ABS_ParameterDescriptor));
   }
   return ABS_ParameterDescriptorMetaClass;
}

void ABS_ParameterDescriptor::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   ABS_ParameterDescriptorMetaClass->copyParentProperties();

   BEGIN_CLASS_INIT( ABS_ParameterDescriptor );
   ADD_FLOAT32_PROP(m_MinValue , 0 );
   ADD_FLOAT32_PROP(m_MaxValue , 0 );
   ADD_FLOAT32_PROP(m_MaxStep , 0 );
   ADD_FLOAT32_PROP(m_DefaultValue , 0 );
   ADD_STRING_PROP(m_Name , 0 );

}

void ABS_ParameterDescriptor::shutdown() {
   delete ABS_ParameterDescriptorMetaClass;
}


// ----

MetaClass* ABS_ParameterDescriptorVector::ABS_ParameterDescriptorVectorMetaClass = NULL;

const MetaClass* ABS_ParameterDescriptorVector::getInstanceClass() const {
   return getClass();
}

Object* ABS_ParameterDescriptorVector::newInstance() {
   return new ABS_ParameterDescriptorVector;
}

const MetaClass* ABS_ParameterDescriptorVector::getClass() {
   if (ABS_ParameterDescriptorVectorMetaClass==NULL) {
      ABS_ParameterDescriptorVectorMetaClass = new MetaClass("ABS_ParameterDescriptorVector", "no description.",
                                  newInstance, sizeof(ABS_ParameterDescriptorVector));
   }
   return ABS_ParameterDescriptorVectorMetaClass;
}

void ABS_ParameterDescriptorVector::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   ABS_ParameterDescriptorVectorMetaClass->copyParentProperties();

	ADD_OBJECT_LIST_PROP( Parameter, 0, ABS_ParameterDescriptor::getClass() );

}

void ABS_ParameterDescriptorVector::shutdown() {
   delete ABS_ParameterDescriptorVectorMetaClass;
}


// ----

MetaClass* ABS_ImageSynthesizer::ABS_ImageSynthesizerMetaClass = NULL;

const MetaClass* ABS_ImageSynthesizer::getInstanceClass() const {
   return getClass();
}

const MetaClass* ABS_ImageSynthesizer::getClass() {
   if (ABS_ImageSynthesizerMetaClass==NULL) {
      ABS_ImageSynthesizerMetaClass = new MetaClass("ABS_ImageSynthesizer", "no description.",
                                  NULL, sizeof(ABS_ImageSynthesizer));
   }
   return ABS_ImageSynthesizerMetaClass;
}

void ABS_ImageSynthesizer::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   ABS_ImageSynthesizerMetaClass->copyParentProperties();
}

void ABS_ImageSynthesizer::shutdown() {
   delete ABS_ImageSynthesizerMetaClass;
}


// ----

MetaClass* ABS_Comparator::ABS_ComparatorMetaClass = NULL;

const MetaClass* ABS_Comparator::getInstanceClass() const {
   return getClass();
}

const MetaClass* ABS_Comparator::getClass() {
   if (ABS_ComparatorMetaClass==NULL) {
      ABS_ComparatorMetaClass = new MetaClass("ABS_Comparator", "no description.",
                                  NULL, sizeof(ABS_Comparator));
   }
   return ABS_ComparatorMetaClass;
}

void ABS_Comparator::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   ABS_ComparatorMetaClass->copyParentProperties();
}

void ABS_Comparator::shutdown() {
   delete ABS_ComparatorMetaClass;
}


// ----

MetaClass* ABS_Analysator::ABS_AnalysatorMetaClass = NULL;

const MetaClass* ABS_Analysator::getInstanceClass() const {
   return getClass();
}


const MetaClass* ABS_Analysator::getClass() {
   if (ABS_AnalysatorMetaClass==NULL) {
      ABS_AnalysatorMetaClass = new MetaClass("ABS_Analysator", "no description.",
                                  NULL, sizeof(ABS_Analysator));
   }
   return ABS_AnalysatorMetaClass;
}

void ABS_Analysator::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   ABS_AnalysatorMetaClass->copyParentProperties();
}

void ABS_Analysator::shutdown() {
   delete ABS_AnalysatorMetaClass;
}


// ----

MetaClass* ABS_Framework::ABS_FrameworkMetaClass = NULL;

const MetaClass* ABS_Framework::getInstanceClass() const {
   return getClass();
}

Object* ABS_Framework::newInstance() {
   return new ABS_Framework;
}

const MetaClass* ABS_Framework::getClass() {
   if (ABS_FrameworkMetaClass==NULL) {
      ABS_FrameworkMetaClass = new MetaClass("ABS_Framework", "no description.",
                                  newInstance, sizeof(ABS_Framework));
   }
   return ABS_FrameworkMetaClass;
}

void ABS_Framework::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   ABS_FrameworkMetaClass->copyParentProperties();
}

void ABS_Framework::shutdown() {
   delete ABS_FrameworkMetaClass;
}


// ----


void ABS_ParameterDescriptorVector::addParameter( Object * obj )
{
   ABS_ParameterDescriptor * param = dynamic_cast<ABS_ParameterDescriptor*>(obj);
   x4Assert( param != NULL );
   x4Assert( !parameterExists( param->getName() ) );

   m_Parameters.push_back( param );
}

void ABS_ParameterDescriptorVector::deleteParameters( card32 begin, card32 end )
{
   x4Assert( begin <= end );
   x4Assert( end <= m_Parameters.size() );

   if( begin == end )
      return;
}

Object * ABS_ParameterDescriptorVector::getParameter( card32 index )
{
   x4Assert( index < m_Parameters.size() );
   return m_Parameters[index];
}

void ABS_ParameterDescriptorVector::moveParameter( card32 oldPos, card32 newPos )
{
   x4Assert( oldPos < m_Parameters.size() );
   x4Assert( newPos < m_Parameters.size() );
   ABS_ParameterDescriptor * tmp = m_Parameters[oldPos];
   m_Parameters.erase( m_Parameters.begin() + oldPos );
   m_Parameters.insert( m_Parameters.begin() + newPos, tmp );
}


std::string ABS_ParameterDescriptorVector::getParameterName(card32 index )
{
   x4Assert( index < m_Parameters.size() );
   return m_Parameters[index]->getName();
}


card32 ABS_ParameterDescriptorVector::getParameterIndex( const std::string &name )
{
   x4Assert( parameterExists( name ) );
   for( card32 i=0;i<m_Parameters.size();i++ )
   {
      if( m_Parameters[i]->getName() == name )
      {
         return i;
      }
   }
   x4Assert( false );
   return 0;
}

float ABS_ParameterDescriptorVector::getMaxValue( card32 index )
{
   x4Assert( index < m_Parameters.size() );
   return m_Parameters[index]->getMaxValue();
}

float ABS_ParameterDescriptorVector::getMinValue( card32 index )
{
   x4Assert( index < m_Parameters.size() );
   return m_Parameters[index]->getMinValue();
}

float ABS_ParameterDescriptorVector::getMaxStep( card32 index )
{
   x4Assert( index < m_Parameters.size() );
   return m_Parameters[index]->getMaxStep();
}

float ABS_ParameterDescriptorVector::getDefaultValue( card32 index )
{
   x4Assert( index < m_Parameters.size() );
   return m_Parameters[index]->getDefaultValue();
}

bool ABS_ParameterDescriptorVector::parameterExists( const std::string &name )
{
   for( card32 i=0;i<m_Parameters.size();i++ )
   {
      if( m_Parameters[i]->getName() == name )
      {
         return true;
      }
   }
   return false;
}

void ABS_ParameterDescriptorVector::addAndSetupParameter( std::string name, float minV, float maxV, float maxStep, float defaultValue )
{
   ABS_ParameterDescriptor * desc = new ABS_ParameterDescriptor;
   desc->setup( minV, maxV, maxStep, defaultValue, name );
   addParameter( desc );
}






void ABS_ParameterVector::setup( ABS_ParameterDescriptorVector * pdv )
{
   m_Data.resize( pdv->getNumParameters() );
   for( card32 i=0;i<pdv->getNumParameters();i++ )
   {
      m_Data[i] = pdv->getDefaultValue( i );
   }
}

bool ABS_ParameterVector::readParameter( ABS_ParameterDescriptorVector * pdv, std::string name, float &param )
{
   if( !pdv->parameterExists( name )  )
      return false;
   param = m_Data[ pdv->getParameterIndex( name ) ];
   return true;
}

bool ABS_ParameterVector::writeParameter(  ABS_ParameterDescriptorVector * pdv, std::string name, float param )
{
   if( !pdv->parameterExists( name )  )
      return false;
   m_Data[ pdv->getParameterIndex( name ) ] = param;
   return true;
}

void ABS_Analysator::sortInputVectors()
{
   sort( m_InputVectors.begin(), m_InputVectors.end() );
}

ABS_Framework::ABS_Framework()
{
   m_PDV = new ABS_ParameterDescriptorVector;
   m_Analysator = NULL;
   m_Synthesizer = NULL;
   m_Comparator = NULL;

   m_ReferenceImage = NULL;

   m_NumSamples = 10;
}

ABS_Framework::~ABS_Framework()
{
   delete m_PDV;
   delete m_Analysator;
   delete m_Synthesizer;
   delete m_Comparator;
}

void ABS_Framework::calculateIteration(GLRenderTextureCache *cache, Scene * scene)
{
   x4Assert( m_PDV != NULL );
   x4Assert( m_Analysator != NULL );
   x4Assert( m_Synthesizer != NULL );
   x4Assert( m_Comparator != NULL );
   x4Assert( m_ReferenceImage != NULL );

   // TODO: allow NPOT textures ( -> GLImageSummarizer )
   x4Assert( m_ReferenceImage->isPowerOfTwo() );
   x4Assert( m_ReferenceImage->isSquare() );

   // init modules
   m_Comparator->setReferenceImage( m_ReferenceImage );
   m_Synthesizer->setPDV( m_PDV );
   m_Analysator->setPDV( m_PDV );

   // generate samples
   m_Analysator->generateNewVectors( m_NumSamples );

   std::vector<ABS_ParameterVector> samples;

   for( card32 i=0;i<m_Analysator->getNumOutputVectors();i++ )
   {
      ABS_ParameterVector sample = m_Analysator->getOutputVector(i);

      // setup destination image
      GLImage * testImage = new GLImage;
      testImage->setup( cache, m_ReferenceImage );

      // synthesize image
      m_Synthesizer->execute( cache, testImage, scene, &sample );

      // enqueue in comparator
      m_Comparator->addCompareImage( testImage, cache );

      // release rendertexture by deleting image
      delete testImage;

      samples.push_back( sample );
   }

   // finish comparing
   m_Comparator->execute( cache );

   // write sample results
   x4Assert( samples.size() == m_Comparator->getNumResults() );
   for( card32 i=0;i<samples.size();i++ )
   {
      samples[i].setResultValue( m_Comparator->getResult(i) );
   }

   // report results to analysator
   m_Analysator->clearInputVectors();
   for( card32 i=0;i<samples.size();i++ )
   {
       m_Analysator->addInputVector( samples[i] );
   }


}


