//---------------------------------------------------------------------------
#include "stdafx.h"
 
//---------------------------------------------------------------------------
#include <windows.h>
#include <mmsystem.h>
#include "ABS_ImageSynth.h"
//---------------------------------------------------------------------------
#include "GLImage.h"
#include "LinearAlgebra.inline.h"
//---------------------------------------------------------------------------
 
//---------------------------------------------------------------------------
using namespace X4;

void TestImageSynthesizer::execute( GLRenderTextureCache * cache, GLImage * destImage, Scene * scene,
   ABS_ParameterVector * params  )
{
   destImage->activate();
   glClearColor(0,0,0,1);
   glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

   glPushAttrib( GL_ALL_ATTRIB_BITS );


   float rotX = 0.0f;
   float rotY = 0.0f;
   float rotZ = 0.0f;

   float posX = 0.0f;
   float posY = 0.0f;
   float posZ = 0.0f;

   params->readParameter( m_PDV, "rotX", rotX );
   params->readParameter( m_PDV, "rotY", rotY );
   params->readParameter( m_PDV, "rotZ", rotZ );
   params->readParameter( m_PDV, "posX", posX );
   params->readParameter( m_PDV, "posY", posY );
   params->readParameter( m_PDV, "posZ", posZ );

   glMatrixMode( GL_PROJECTION );
   glLoadIdentity();
   gluPerspective( 90.0f, 1.0f, 0.01f, 10.0f );
   glMatrixMode( GL_MODELVIEW );
   glLoadIdentity();
   gluLookAt( 0,0,-4,0,0,0,0,1,0);
   glTranslatef( -posX, -posY, -posZ );
   glRotatef( rotZ, 0,0,1 );
   glRotatef( rotY, 0,1,0 );
   glRotatef( rotX, 1,0,0 );

   drawRect( makeVector3f(-1,-1,-1), makeVector3f(2,0,0), makeVector3f(0,2,0), makeVector3f(1,0,0) );
   drawRect( makeVector3f(-1,-1,-1), makeVector3f(0,2,0), makeVector3f(0,0,2), makeVector3f(0,1,0) );
   drawRect( makeVector3f(-1,-1,-1), makeVector3f(2,0,0), makeVector3f(0,0,2), makeVector3f(0,0,1) );
   drawRect( makeVector3f( 1, 1, 1), makeVector3f(-2,0,0), makeVector3f(0,-2,0), makeVector3f(0,1,1) );
   drawRect( makeVector3f( 1, 1, 1), makeVector3f(0,-2,0), makeVector3f(0,0,-2), makeVector3f(1,1,0) );
   drawRect( makeVector3f( 1, 1, 1), makeVector3f(-2,0,0), makeVector3f(0,0,-2), makeVector3f(1,0,1) );

   glPopAttrib();
   destImage->deactivate();
}

void TestImageSynthesizer::drawRect( Vector3f origin, Vector3f a, Vector3f b, Vector3f color )
{
   Vector3f tmp1 = origin+a;
   Vector3f tmp2 = origin+b;
   Vector3f tmp3 = origin+a+b;
   glBegin( GL_QUADS );
      glColor3fv( &color[0] );
      glVertex3fv( &origin[0]);
      glVertex3fv( &tmp1[0] );
      glVertex3fv( &tmp3[0] );
      glVertex3fv( &tmp2[0] );
   glEnd();
}
