//---------------------------------------------------------------------------
#include "stdafx.h"
 
//---------------------------------------------------------------------------
#include "ABS_SimpleComparator.h"
//---------------------------------------------------------------------------
#include "GLImageSummarizer.h"
#include "GLImageCombiner.h"
#ifndef _DEBUG
#include "LinearAlgebra.inline.h"
#endif
//---------------------------------------------------------------------------
 
//---------------------------------------------------------------------------
using namespace X4;

MetaClass* ABS_SimpleComparator::ABS_SimpleComparatorMetaClass = NULL;

const MetaClass* ABS_SimpleComparator::getInstanceClass() const {
   return getClass();
}

Object* ABS_SimpleComparator::newInstance() {
   return new ABS_SimpleComparator;
}

const MetaClass* ABS_SimpleComparator::getClass() {
   if (ABS_SimpleComparatorMetaClass==NULL) {
      ABS_SimpleComparatorMetaClass = new MetaClass("ABS_SimpleComparator", "no description.",
                                  newInstance, sizeof(ABS_SimpleComparator));
   }
   return ABS_SimpleComparatorMetaClass;
}

void ABS_SimpleComparator::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   ABS_SimpleComparatorMetaClass->copyParentProperties();
}

void ABS_SimpleComparator::shutdown() {
   delete ABS_SimpleComparatorMetaClass;
}


// ----

ABS_SimpleComparator::ABS_SimpleComparator()
{
   m_DifferenceOperator = new GLImageCombiner;
   m_DifferenceOperator->setNumInputImages(2);
   m_DifferenceOperator->setOutputFormat( GLImageOperator::OF_Float16 );
   m_DifferenceOperator->setCombineOp( "0 = dot( (I0.xyz-I1.xyz),(I0.xyz-I1.xyz) );" );

   m_Summarizer = new GLImageSummarizer( GLImageSummarizer::Mode_Sum );

}

ABS_SimpleComparator::~ABS_SimpleComparator()
{
   delete m_DifferenceOperator;
   delete m_Summarizer;
}

card32 ABS_SimpleComparator::addCompareImage( GLImage * img, GLRenderTextureCache * cache )
{
   m_Summarizer->addImage( img, cache );

 //porting: this function had no return value!
   x4Assert(false);
	return 0;
  //end porting
}

void ABS_SimpleComparator::execute( GLRenderTextureCache * cache )
{
   m_Summarizer->execute( cache );

   m_Results.clear();
   for( card32 i=0;i<m_Summarizer->getNumResults();i++ )
      m_Results.push_back( m_Summarizer->getResult(i)[0] );
}
