//---------------------------------------------------------------------------
#ifndef ABS_SimpleComparatorH
#define ABS_SimpleComparatorH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
//---------------------------------------------------------------------------
#include "ABS_Framework.h"
//---------------------------------------------------------------------------

namespace X4
{

class GLImageCombiner;
class GLImageSummarizer;

class X3FOUNDATION_PRIVATE_API ABS_SimpleComparator : public ABS_Comparator
{
private:
   static MetaClass *ABS_SimpleComparatorMetaClass;
   static Object* newInstance();

   GLImageCombiner *    m_DifferenceOperator;
   GLImageSummarizer *  m_Summarizer;

public:
   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   ABS_SimpleComparator();
   ~ABS_SimpleComparator();

   /// adds image to compare-queue and returns the result-index
   /// Don't save a pointer to img !!!!
   virtual card32 addCompareImage( GLImage * img, GLRenderTextureCache * cache );

   /// compares all remaining images and publishes result
   virtual void execute( GLRenderTextureCache * cache );


};


}

#endif
 