//---------------------------------------------------------------------------
#ifndef AbstractNDTCellH
#define AbstractNDTCellH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
//---------------------------------------------------------------------------
#include "LinearAlgebra.h"
#include "Persistent.h"
#include "BoundingBox.h"
//---------------------------------------------------------------------------

namespace X4 {

/// Cell structure in the grid
class X3FOUNDATION_PRIVATE_API AbstractNDTCell : public Persistent
{
	X4_CLASS( AbstractNDTCell )

	protected:		
		BoundingBox3f bbox;
		Vector3i index3D;
		Vector3f color;
		bool valid;

	public:
		AbstractNDTCell();
		inline void setColor( const Vector3f& color ){ this->color = color; }
		inline Vector3f getColor() const { return color; }
		inline void setBBox( const BoundingBox3f& bbox ){ this->bbox = bbox; }
		inline BoundingBox3f getBBox() const { return bbox; }
		inline void setIndex3D( const Vector3i index3D ){ this->index3D = index3D; }
		inline Vector3i getIndex3D() const { return index3D; }
		inline void setValid( const bool b ){ valid = b; }
		inline bool getValid() const { return valid; }
};

}

#endif