//---------------------------------------------------------------------------
#ifndef AttachedFloatSignaturesH
#define AttachedFloatSignaturesH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
//---------------------------------------------------------------------------
#include "AttachedData.h"
//---------------------------------------------------------------------------

namespace X4 {

class X3FOUNDATION_PRIVATE_API AttachedFloatSignatures: public AttachedData
{
	X4_CLASS( AttachedFloatSignatures )

	
public:
	AttachedFloatSignatures(void);
	~AttachedFloatSignatures(void);

	std::vector<DVectorF> descriptors;

	std::vector< DVectorF > distances;

	void computeDistanceTable();
	float32 getDistance(const mpcard &a, const mpcard &b) const;
	bool hasPrecomputedDistances() const {return distances.size() == descriptors.size();}

	void assign(const Object* obj, X4CopyContext *context = NULL);
	void write(OutputObjectStream *s) const;
	void read(InputObjectStream *s);
};


class X3FOUNDATION_PRIVATE_API AttachedFloatVector: public AttachedData
{
	X4_CLASS( AttachedFloatVector )
public:
	AttachedFloatVector(void);
	~AttachedFloatVector(void);

	std::vector<float> data;

	void assign(const Object* obj, X4CopyContext *context = NULL);
	void write(OutputObjectStream *s) const;
	void read(InputObjectStream *s);
};

class X3FOUNDATION_PRIVATE_API AttachedCard32Vector: public AttachedData
{
	X4_CLASS( AttachedCard32Vector )
public:
	AttachedCard32Vector(void);
	~AttachedCard32Vector(void);

	std::vector<card32> data;

	void assign(const Object* obj, X4CopyContext *context = NULL);
	void write(OutputObjectStream *s) const;
	void read(InputObjectStream *s);
};

class X3FOUNDATION_PRIVATE_API AttachedInt32Vector: public AttachedData
{
	X4_CLASS( AttachedInt32Vector )
public:
	AttachedInt32Vector(void);
	~AttachedInt32Vector(void);

	std::vector<int32> data;

	void assign(const Object* obj, X4CopyContext *context = NULL);
	void write(OutputObjectStream *s) const;
	void read(InputObjectStream *s);
};

}


#endif

