#ifndef BRDFShaderMaterialH
#define BRDFShaderMaterialH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
//---------------------------------------------------------------------------
#include "GLShaderMaterial.h"
#include "BRDFAttachment.h"
//---------------------------------------------------------------------------

namespace X4
{

	/**
	* Material class to render point clouds with attached BRDF data.
	*/
	class X3FOUNDATION_PRIVATE_API BRDFShaderMaterial : public GLShaderMaterial
	{
		X4_CLASS( BRDFShaderMaterial )

	protected:

		// method is executed right after the shader was bound, so here we can attach textures and so on
		virtual void setShaderParameters(Scene * scene, SceneObject * obj,
			SceneObjectIterator *iter, GLContext * context, MemoryManager * mm);

	public:
		BRDFShaderMaterial(void);
		virtual ~BRDFShaderMaterial(void);

		virtual void assign(const Object* obj, X4CopyContext *context = NULL);

	};

}

#endif