#ifndef CurvatureEstimatorH
#define CurvatureEstimatorH

#include "Persistent.h"
#include "PointCloud.h"
#include "UnstructuredInCoreTriangleMesh.h"

#include "x3foundation_private.h"

namespace X4
{

/*
 * Estimate principle curvatures for each point in point set 
 *
 * Required: 
 * - polyScale (1f)   MonomialFitter
 * - coeffs    (6f)
 *
 * Output:
 * - curv0     (1f)
 * - curv1     (1f)
 */
class X3FOUNDATION_PRIVATE_API CurvatureEstimator : public Persistent
{	
	private:

	public:

		/// Estimate curvature
		static void estimateCurvature( PointSet* ps, const float32 epsilon );

		/// Estimate curvature
		static void estimateCurvature( PointCloud* pc, const float32 epsilon );

};

}

#endif