#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "EyeCandyEditorWidget.h"
//---------------------------------------------------------------------------
#include "EyeCandy.h"
//---------------------------------------------------------------------------
using namespace X4;

IMPLEMENT_CLASS_EDITOR( EyeCandy )

EyeCandyEditorWidget::EyeCandyEditorWidget(QWidget * parent, Qt::WindowFlags f)
:QWidget(parent,f)
{
	//call ui.setupUi(this) to set up the layout from QtDesigner
	ui.setupUi(this);
	//Example: easy access to QtDesigner buttons, etc. by ui object
	//QWidget::connect(ui.loadButton,SIGNAL(clicked()),this,SLOT(sltLoadFile()));

}

EyeCandyEditorWidget::~EyeCandyEditorWidget(void)
{
}

void EyeCandyEditorWidget::setup( EyeCandy * obj )
{
	m_Object = obj;
}

void EyeCandyEditorWidget::updateEditor()
{
	ui.cbHemisphere->setCheckState( m_Object->getHemisphereLight()?
		Qt::Checked:Qt::Unchecked );
	ui.cbSelectedPointsAsLS ->setCheckState( m_Object->getSelectedPointsAsLightSource()?
		Qt::Checked:Qt::Unchecked );
	ui.cbIndirectLight->setCheckState( m_Object->getIndirectLight()?
		Qt::Checked:Qt::Unchecked );

	ui.sBrightness->setValue( m_Object->getBrightness() * ui.sBrightness->maximum());
	ui.sGamma->setValue( m_Object->getGamma() * ui.sGamma->maximum());
	ui.sHemisphereStrength->setValue( m_Object->getLightStrength() * ui.sHemisphereStrength->maximum());
	ui.sNumPhotons->setValue( m_Object->getNumPhotons() * ui.sNumPhotons->maximum());
	ui.sNumSamples->setValue( m_Object->getNumSamples() * ui.sNumSamples->maximum());
	ui.sOffset->setValue( m_Object->getOffset() * ui.sOffset->maximum());

}

#include "EyeCandyEditorWidget_moc.h"

void EyeCandyEditorWidget::on_pbPrecomputeLight_clicked() 
{
	m_Object->sampleScene();
}

void EyeCandyEditorWidget::on_cbHemisphere_clicked() 
{
	m_Object->setHemisphereLight( ui.cbHemisphere->isChecked());
}

void EyeCandyEditorWidget::on_cbSelectedPointsAsLS_clicked() 
{
	m_Object->setSelectedPointsAsLightSource( ui.cbSelectedPointsAsLS->isChecked());
}

void EyeCandyEditorWidget::on_cbIndirectLight_clicked() 
{
	m_Object->setIndirectLight( ui.cbIndirectLight->isChecked());
}

void EyeCandyEditorWidget::on_sBrightness_valueChanged(int i) 
{
	m_Object->setBrightness( (float)i / ui.sBrightness->maximum());
}

void EyeCandyEditorWidget::on_sGamma_valueChanged(int i) 
{
	m_Object->setGamma( (float)i / ui.sGamma->maximum());
}

void EyeCandyEditorWidget::on_sHemisphereStrength_valueChanged(int i) 
{
	m_Object->setLightStrength( (float)i / ui.sHemisphereStrength->maximum());
}

void EyeCandyEditorWidget::on_sNumPhotons_valueChanged(int i) 
{
	m_Object->setNumPhotons( (float)i / ui.sNumPhotons->maximum());
}

void EyeCandyEditorWidget::on_sNumSamples_valueChanged(int i) 
{
	m_Object->setNumSamples( (float)i / ui.sNumSamples->maximum());
}

void EyeCandyEditorWidget::on_sOffset_valueChanged(int i) 
{
	m_Object->setOffset( (float)i / ui.sOffset->maximum());
}
