#ifndef EyeCandyEditorWidgetH 
#define EyeCandyEditorWidgetH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "EyeCandyEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace X4
{

class EyeCandy;

class X3FOUNDATION_PRIVATE_API EyeCandyEditorWidget : public QWidget
{
	Q_OBJECT

private:

	EyeCandy	*	m_Object;

	///used to access buttons, etc. from QtDesigner
	Ui_EyeCandyEditorForm ui;

public:
	EyeCandyEditorWidget(QWidget * parent = NULL, Qt::WindowFlags f=0);
	~EyeCandyEditorWidget(void);

	void setup( EyeCandy * obj );

	/// update editor content with object data
	void updateEditor();

public slots:
	void on_pbPrecomputeLight_clicked();
	void on_cbHemisphere_clicked();
	void on_cbSelectedPointsAsLS_clicked();
	void on_cbIndirectLight_clicked();
	void on_sBrightness_valueChanged(int);
	void on_sGamma_valueChanged(int);
	void on_sHemisphereStrength_valueChanged(int);
	void on_sNumPhotons_valueChanged(int);
	void on_sNumSamples_valueChanged(int);
	void on_sOffset_valueChanged(int);


};

MAKE_CLASS_EDITOR( X3FOUNDATION_PRIVATE_API , EyeCandy )


}

#endif