#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "FFTWrapper.h"

#include "X4Exception.h"
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
using namespace X4;

FFTWrapper * X4::MainFFTWrapper = new FFTWrapper;

FFTWPlan1D::FFTWPlan1D()
{
	width = 0;
	in = NULL;
	out = NULL;
	plan = NULL;
}

FFTWPlan1D::~FFTWPlan1D()
{
	//if( width > 0 )
	//{
	//	fftwf_destroy_plan(plan);

	//	fftwf_free(in);
	//	fftwf_free(out);			
	//}
}

void FFTWPlan1D::setup( card32 w, bool forward )
{
	//width = w;
 //  in = (fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex) * width);
 //  out = (fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex) * width);

 //  plan = fftwf_plan_dft_1d( width, in, out, forward?FFTW_FORWARD:FFTW_BACKWARD, FFTW_ESTIMATE );
}


FFTWrapper::FFTWrapper(void)
{
}

FFTWrapper::~FFTWrapper(void)
{
	deletePlans();
}


void FFTWrapper::deletePlans() 
{
	while( !m_Plans.empty() )
	{
		delete m_Plans.begin()->second;
		m_Plans.erase( m_Plans.begin() );
	}
	
	while( !m_Plan2D.empty() )
	{
		delete m_Plan2D.begin()->second;
		m_Plan2D.erase( m_Plan2D.begin() );
	}
}

FFTWPlan1D* FFTWrapper::getPlan( card32 width, bool forward ) 
{
	card32 hash_value = width + (forward?31999:0);
	if( m_Plans.find( hash_value ) == m_Plans.end() )
	{
		FFTWPlan1D * plan = new FFTWPlan1D;
		plan->setup( width, forward );
		m_Plans[hash_value] = plan;
	}
	return m_Plans[hash_value];
}

X4::FFTWPlan2D::FFTWPlan2D()
{
	width = 0;
	in = NULL;
	out = NULL;
	plan = NULL;	
}

X4::FFTWPlan2D::~FFTWPlan2D()
{
	//if( width > 0 )
	//{
	//	fftwf_destroy_plan(plan);

	//	fftwf_free(in);
	//	fftwf_free(out);			
	//}
}

void X4::FFTWPlan2D::setup( card32 w, card32 h,bool forward )
{
	//width = w;
	//height = h;
	//in = (fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex) * width * height);
	//out = (fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex) * width * height);

	//plan = fftwf_plan_dft_2d( width, height, in, out, forward?FFTW_FORWARD:FFTW_BACKWARD, FFTW_ESTIMATE );
}

FFTWPlan2D* X4::FFTWrapper::getPlan( card32 width, card32 height,bool forward )
{
	card32 hash_value = width * 32001 + height + (forward?31999:0);
	if( m_Plan2D.find( hash_value ) == m_Plan2D.end() )
	{
		FFTWPlan2D * plan = new FFTWPlan2D;
		plan->setup( width,height,forward);
		m_Plan2D[hash_value] = plan;
	}
	FFTWPlan2D * ret = m_Plan2D[hash_value];
	if( ret->width != width || ret->height != height)
		throw X4Exception("FFTWrapper::getPlan() - Collision!");
	return ret;
}