#ifndef FFTWrapperH
#define FFTWrapperH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
//---------------------------------------------------------------------------
#include "fftw_include.h"
//---------------------------------------------------------------------------

namespace X4
{

class X3FOUNDATION_PRIVATE_API FFTWPlan1D
{
public:
	FFTWPlan1D();
	~FFTWPlan1D();

	void setup( card32 w, bool forward );
	
	card32 width;
	fftwf_complex *in;
	fftwf_complex *out;
	fftwf_plan plan;
};

class X3FOUNDATION_PRIVATE_API FFTWPlan2D
{
public:
	FFTWPlan2D();
	~FFTWPlan2D();

	void setup( card32 w, card32 h, bool forward );

	card32 width;
	card32 height;
	fftwf_complex *in;
	fftwf_complex *out;
	fftwf_plan plan;
};

/**
	holds fftw plans and offers some basic fft transformation routines (some day...)
*/
class X3FOUNDATION_PRIVATE_API FFTWrapper 
{

private:

	void deletePlans();
	std::map<card32,FFTWPlan1D*> m_Plans;
	std::map<card32,FFTWPlan2D*> m_Plan2D;

public:
	FFTWrapper(void);
	~FFTWrapper(void);

	void clearPlans() {deletePlans();}
	FFTWPlan1D* getPlan( card32 width, bool forward=true );
	FFTWPlan2D* getPlan( card32 width, card32 height, bool foward);


};

extern X3FOUNDATION_PRIVATE_API FFTWrapper * MainFFTWrapper;

}

#endif