#ifndef FeatureClusteringH
#define FeatureClusteringH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace X4
{
class PointCloud;
class FeatureSet;
/**
	clustering of feature sets into different feature classes
*/
class X3FOUNDATION_PRIVATE_API FeatureClustering : public Persistent
{
	X4_CLASS( FeatureClustering )

private:


public:
	FeatureClustering(void);
	~FeatureClustering(void);

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

	/// transform features into a nD domain using pca from signatures
	void pcaTransform( PointCloud * pc, card32 numDimensions, std::vector<DVectorF> &transformedSet, FeatureSet * fs = NULL );

	/// transform features into 3D domain using pca from signatures, returns result in a point cloud
	PointCloud * pcaTransform3D( PointCloud * pc, FeatureSet * fs = NULL );

};

}

#endif