//---------------------------------------------------------------------------
#ifndef GLImageCombinerH
#define GLImageCombinerH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
//---------------------------------------------------------------------------
#include "GLImageOperator.h"
//---------------------------------------------------------------------------
#include <string>

namespace X4
{

class GLShaderMaterial;


class X3FOUNDATION_PRIVATE_API GLImageCombiner : public GLImageMaterialOperator
{
private:

   static MetaClass *GLImageCombinerMetaClass;
   static Object* newInstance();

   std::string               m_CombineOp;

public:

   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   GLImageCombiner();
   ~GLImageCombiner();

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

   virtual GLImage * execute(GLRenderTextureCache * cache);
   virtual void execute(GLRenderTextureCache * cache, GLImage * outputImage, card32 x, card32 y ){x4Assert(false);}

   std::string getCombineOp() const { return m_CombineOp; }
   void setCombineOp( std::string op ) {m_CombineOp = op; m_Modified = true; }

   void loadTemplates();


protected:

   virtual void modify( std::string &vsTemplate, std::string &psTemplate );
};


}

#endif
