//---------------------------------------------------------------------------
#ifndef GLImageFilterH
#define GLImageFilterH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
//---------------------------------------------------------------------------
#include "GLImageOperator.h"
//---------------------------------------------------------------------------
#include <string>

namespace X4
{

class FilterMask;

class X3FOUNDATION_PRIVATE_API GLImageFilter : public GLImageMaterialOperator
{
private:
   static MetaClass *GLImageFilterMetaClass;
   static Object* newInstance();

   std::string      m_PostProcess;
   bool        m_NormalizeMask;
   FilterMask  *  m_FilterMask;

public:
   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   GLImageFilter();
   ~GLImageFilter();

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

   virtual GLImage * execute(GLRenderTextureCache * cache);
   virtual void execute(GLRenderTextureCache * cache, GLImage * outputImage, card32 x, card32 y ){x4Assert(false);}

   std::string getPostProcess() const { return m_PostProcess; }
   void setPostProcess( std::string pp ) {m_PostProcess = pp; m_Modified = true; }

   bool getNormalizeMask() const { return m_NormalizeMask; }
   void setNormalizeMask(bool b) { m_NormalizeMask = b; m_Modified = true;}

   bool getModified() const {return m_Modified;}
   void setModified( bool b ) {m_Modified = true; forget(b); }

   FilterMask * getFilterMask() {return m_FilterMask;}
   void setFilterMask( FilterMask * fm );

   void loadTemplates();


protected:

   virtual void modify( std::string &vsTemplate, std::string &psTemplate );


};




}

#endif
 