//---------------------------------------------------------------------------
#ifndef GLImageReducerH
#define GLImageReducerH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
//---------------------------------------------------------------------------
#include "GLImageOperator.h"
//---------------------------------------------------------------------------
#include <string>
//---------------------------------------------------------------------------

namespace X4
{

class X3FOUNDATION_PRIVATE_API GLImageReducer : public GLImageMaterialOperator
{
private:
   static MetaClass *GLImageReducerMetaClass;
   static Object* newInstance();

   std::string m_ReduceOp;

public:
   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   GLImageReducer();
   ~GLImageReducer();

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

   virtual GLImage * execute(GLRenderTextureCache * cache);
   virtual void execute(GLRenderTextureCache * cache, GLImage * outputImage, card32 x, card32 y );

   std::string getReduceOp() const { return m_ReduceOp; }
   void setReduceOp( std::string op ) {m_ReduceOp = op; m_Modified = true; }

   void loadTemplates();

protected:

   virtual void modify( std::string &vsTemplate, std::string &psTemplate );



};



}

#endif
 