//---------------------------------------------------------------------------
#ifndef GridBasedSphericalRangeQueryH
#define GridBasedSphericalRangeQueryH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
//---------------------------------------------------------------------------
#include "VertexDescriptor.h"
#include "SparseGrid.h"
#include "GridQuery.h"
//---------------------------------------------------------------------------

namespace X4 {

///
///   retrieves all points within a given distances using a grid data structure
///
class X3FOUNDATION_PRIVATE_API GridBasedSphericalRangeQuery {
 private:
   const PointSet *ps;
   AAT positionAAT;
   float32 queryRadius;
   float32 queryRadiusQuad;
   GridQuery<float32, int32, 3, int32> query;
   
 public:
	GridBasedSphericalRangeQuery(const PointSet *ps, float32 queryRadius);
   void getIndices(const Vector3f &targetPoint, std::vector<int32> &result);
};


}

#endif