#ifndef GridBuilderH
#define GridBuilderH

#include <assert.h>
#include "AbstractGrid.h"
#include "NDTCell.h"
#include "Persistent.h"
#include "Transformation.h"

namespace X4{

class X3FOUNDATION_PRIVATE_API GridBuilder : public Persistent
{
	X4_CLASS( GridBuilder )

	private:
		float32 maxEigenValueRatio;				// Minimum ration between largest and smallest eigenValue of covariance matrix
		float32 minPointsPerCellScale;			// Min number of points in a cell to be valid
		Vector3f maxEigenValueFactors;			// Scaling of the eigenvalues relative to the max eigenvalue in the grid
		card32 minPointsPerCell;

	public:
		GridBuilder();
		~GridBuilder();

		//void setupGrid( AbstractGrid* grid, PointSet* ps );
		void fillGrid( AbstractGrid* grid, PointSet* ps, const Matrix3f& R = IDENTITY3F, const Vector3f& t = NULL_VECTOR3F );
};

}

#endif