#ifndef HDRLightprobeSamplingEditorWidgetH 
#define HDRLightprobeSamplingEditorWidgetH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "HDRLightprobeSamplingEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace X4
{

class HDRLightprobeSampling;

class MouseEmittingLabel : public QLabel
{
	Q_OBJECT
public:
	MouseEmittingLabel(QWidget * parent = NULL);
protected:

	void mouseMoveEvent(QMouseEvent *event);
	void mouseReleaseEvent(QMouseEvent *event);

signals:
	void sigMouseMove(QMouseEvent *event);
	void sigMouseRelease(QMouseEvent *event);

};

class X3FOUNDATION_PRIVATE_API HDRLightprobeSamplingEditorWidget : public QWidget
{
	Q_OBJECT

private:

	HDRLightprobeSampling	*	m_Object;
	MouseEmittingLabel	*	m_ImageLabel;
	QColor	m_PaintColor;
	bool	m_Changed;

	///used to access buttons, etc. from QtDesigner
	Ui_HDRLightprobeSamplingEditorForm ui;

public:
	HDRLightprobeSamplingEditorWidget(QWidget * parent = NULL, Qt::WindowFlags f=0);
	~HDRLightprobeSamplingEditorWidget(void);

	void setup( HDRLightprobeSampling * obj );

	/// update editor content with object data
	void updateEditor();

public slots:

	void on_pbLoadImage_clicked();
	void on_dExposure_valueChanged(double);
	void on_iNumSamples_valueChanged(int);
	void on_pbSample_clicked();
	void on_bSampleFullSphere_clicked();
	void on_pbResetLightprobe_clicked();
	void on_dInterpGray_valueChanged(double);
	void on_pbPaintColor_clicked();



	void sltMouseMove(QMouseEvent *event);
	void sltMouseRelease(QMouseEvent *event);

signals:

	void sigObjectChanged();


};

MAKE_CLASS_EDITOR( X3FOUNDATION_PRIVATE_API , HDRLightprobeSampling )


}

#endif