#ifndef HQRLightH
#define HQRLightH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace X4
{

/**
	define a lightsource for the high quality renderer
*/
class X3FOUNDATION_PRIVATE_API HQRLight : public Persistent
{
	X4_CLASS( HQRLight )

private:

	std::string		m_CameraName;
	Vector3f		m_Color;
	card32		m_NumSamples;
	float32		m_Size;
	float32		m_Strength;



public:
	HQRLight(void);
	~HQRLight(void);

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

	std::string getCameraName() const {return m_CameraName;}
	void setCameraName(std::string v) {m_CameraName=v;}

	Vector3f getColor() const {return m_Color;}
	void setColor(Vector3f v) {m_Color=v;}

	card32 getNumSamples() const {return m_NumSamples;}
	void setNumSamples(card32 v) {m_NumSamples=v;}

	float32 getSize() const {return m_Size;}
	void setSize(float32 v) {m_Size=v;}

	float32 getStrength() const {return m_Strength;}
	void setStrength(float32 v) {m_Strength=v;}

};

}

#endif