#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "ImportanceSampling.h"
#include "CopyObjectProperties.h"
#include "ObjectListProperty.h"
#include "Random.h"
#include <random.h>
#include <time.h>
#include <float.h>

//---------------------------------------------------------------------------
using namespace X4;

/*
IMPLEMENT_X4_CLASS(ImportanceSampler, 0)
{
	BEGIN_CLASS_INIT(ImportanceSampler);

	ADD_OBJECT_LIST_PROP(Samples, 0, ImportanceSample::getClass());
}

IMPLEMENT_X4_CLASS(ImportanceSample, 0)
{
	BEGIN_CLASS_INIT(ImportanceSample);

	ADD_FLOAT64_PROP(m_SampleProbability, 0);
	ADD_FLOAT64_PROP(m_SampleProbabilitySum, 0);
	ADD_CARD32_PROP (m_SampleID, 0);
}

//---------------------------------------------------------------------------
void ImportanceSample::assign(const Object* obj, X4CopyContext *context)
{	
	const ImportanceSample* o = dynamic_cast<const ImportanceSample*>(obj);
	copyObjectProperties(obj,this);

	m_UserData = o->m_UserData;
}*/

//---------------------------------------------------------------------------
ImportanceSampler::ImportanceSampler()
{
	// initialize the generator
	//m_RandomGen.seed((unsigned int)time(NULL));
}


//---------------------------------------------------------------------------
ImportanceSampler::~ImportanceSampler()
{

}

//---------------------------------------------------------------------------
card32 ImportanceSampler::addSample(ImportanceSample* sample)
{
   sample->m_SampleID = card32(m_Samples.size());

   m_Samples.push_back(sample);
   if (m_Weights.size() == 0) m_Weights.push_back(pair<unsigned,float>((unsigned)m_Samples.size()-1, sample->getProbability()));
   else m_Weights.push_back(pair<unsigned, float>((unsigned)m_Samples.size()-1, sample->getProbability() + m_Weights[m_Weights.size()-1].second));

   return sample->m_SampleID;
}

//---------------------------------------------------------------------------
void ImportanceSampler::recomputeWeights()
{
	m_Weights.clear();
	m_Weights.resize(m_Samples.size());

	if (m_Samples.size() > 0)
	{
		m_Weights[0].second = m_Samples[0]->getProbability();
		m_Weights[0].first = 0;
		for (unsigned i=1; i < m_Samples.size(); i++)
		{
			m_Weights[i].second = m_Samples[i]->getProbability() + m_Weights[i-1].second;
			m_Weights[i].first  = i;
		}
	}
}

//---------------------------------------------------------------------------
void ImportanceSampler::removeSample(card32 id)
{
   for (SampleList::iterator it=m_Samples.begin(); it != m_Samples.end(); )
      if ((*it)->m_SampleID == id)
         it = m_Samples.erase(it);
      else
         it ++;

   recomputeWeights();
}

//---------------------------------------------------------------------------
ImportanceSample* ImportanceSampler::binarySearch(double val, mpint low, mpint high, double totalWeight)
{
	if (high <= low) return m_Samples[low];
	mpint mid = low + ((high - low) / 2);
	double midValue = m_Weights[mid].second / totalWeight;
	if (midValue > val)
		return binarySearch(val, low, mid - 1, totalWeight);
	else if (midValue < val)
		return binarySearch(val, mid + 1, high, totalWeight);
	else

	return m_Samples[mid];
}

//---------------------------------------------------------------------------
ImportanceSample* ImportanceSampler::sample(bool getJustTheBest)
{
	if (m_Samples.size() == 0) return NULL;

	// if just hte best, then linear
	if (getJustTheBest)
	{
		double maxValue = DBL_MIN;
		ImportanceSample* maxSample = NULL;

		for (unsigned i=0; i < m_Samples.size(); i++)
		{
			ImportanceSample* it = m_Samples[i];
			if (it->getProbability() > maxValue) {maxValue = it->getProbability(); maxSample = it; }
		}
		return maxSample;
	}

	// do linear search
	double val = double(rnd01()) * m_Weights[m_Samples.size()-1].second;

	// use linear search to find the correct one
	unsigned id = 0;
	for (unsigned i=0; i < m_Weights.size(); i++)
		if (val < m_Weights[i].second) return m_Samples[m_Weights[i].first];

	return NULL;
	//return m_Samples[random((card32)m_Samples.size()-1)];
	// if sample then binary search
	//return binarySearch(rnd01(), 0, m_Samples.size()-1, m_Weights[m_Samples.size()-1]);

    /*if (m_Samples.size() == 0) return NULL;
    if (m_Samples.size() == 1) return m_Samples[0];
   
    // if we have to normalize the data
    double maxValue = DBL_MIN, minValue = DBL_MAX;
    double sampleSum = 0;
    ImportanceSample* maxSample = NULL;

	for (unsigned i=0; i < m_Samples.size(); i++)
    {
        ImportanceSample* it = m_Samples[i];
        //if (it->getProbability() < minValue) minValue = it->getProbability();
        if (it->getProbability() > maxValue) {maxValue = it->getProbability(); maxSample = it; }
        sampleSum += it->getProbability();
        //it->m_SampleProbabilitySum = sampleSum;
    }
    if (getJustTheBest && maxSample) return maxSample;
   
    // find a random value between minValue and maxValue
	//std::tr1::uniform_int<double> dist(0, sampleSum);

	//double val = dist(m_RandomGen);
    double val = double(rnd01()) * sampleSum;

    // use linear search to find the correct one
	for (int i=0; i < (int)m_Samples.size(); i++)
	{
		if (val < m_Samples[i]->getProbability()) return m_Samples[i];
		val -= m_Samples[i]->getProbability();
	}

    return maxSample;*/
}

