#ifndef IntrinsicWaveDescriptorH
#define IntrinsicWaveDescriptorH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
//---------------------------------------------------------------------------
#include "LocalDescriptor.h"
//---------------------------------------------------------------------------

namespace X4
{
	class HierarchicalKNNIterator;
	class UnstructuredInCoreTriangleMesh;
/**
	plz comment your class
*/
class X3FOUNDATION_PRIVATE_API IntrinsicWaveDescriptor : public LocalDescriptor
{
	X4_CLASS( IntrinsicWaveDescriptor )

private:
	/// setup descriptor
	virtual void beginSignatureComputations(UnstructuredInCorePointCloud * upc);

	/// compute local signature for point
	virtual LocalSignature * computeSignature(const Vector3f &point, const Vector3f &normal, float size, UnstructuredInCorePointCloud * upc);



	/// cleanup
	virtual void endSignatureComputations();

	HierarchicalKNNIterator *knnIt;
	UnstructuredInCoreTriangleMesh* tri;




public:
	IntrinsicWaveDescriptor(void);
	~IntrinsicWaveDescriptor(void);

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);


   /// compute wave signature for point index
   static DVectorF getWaveSignature(mpcard pointIndex, float size, UnstructuredInCoreTriangleMesh * upc);
   static std::vector<DVectorF> getWaveSignaturesForAll( float size, UnstructuredInCoreTriangleMesh * upc, const std::vector<card32>& selected = std::vector<card32>());
};

}

#endif