#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "InverseDistanceWeighting.h"
//---------------------------------------------------------------------------
using namespace X4;


//---------------------------------------------------------------------------
InverseDistanceWeighting::InverseDistanceWeighting(unsigned dim) : 
   m_dim(dim)
{

}

//---------------------------------------------------------------------------
InverseDistanceWeighting::~InverseDistanceWeighting()
{

}

//---------------------------------------------------------------------------
DVectorF InverseDistanceWeighting::interpolateUseGauss(float sigma)
{
   if (m_samples.size() == 0) return DVectorF();
   
   float sum = 0.0f;
   std::vector<float> w(m_samples.size(), 0.0f); 
  
   // we use the inverse distance weighting method based on gauss
   for (unsigned i=0; i < m_samples.size(); i++)
   {
      float d = m_samples[i].second;
      w[i] = exp(-d / (sigma * sigma));
      sum += w[i];
   }

   // compute new value
   DVectorF result;
   result.setZero();
   
   for (unsigned i=0; i < m_samples.size(); i++)
   {
      result = m_samples[i].first * w[i];
   }
   result /= sum;
   
   return result;
}


