#ifndef MLSSmoothH
#define MLSSmoothH

#include "x3foundation_private.h"
#include "Persistent.h"
#include "PointCloud.h"

namespace X4
{

#define MLS_NUM_BASIS_FUNCTIONS 6

/*
 * Apply MLS-similar smoothing to point set/cloud
 *
 * Required: 
 * - position  (3f)
 * - normal    (3f)   NormalEstimator, NormalUnifier
 * - tangent_u (3f)   TangentEstimator
 * - tangent_v (3f)   
 * - coeffs    (6f)   MonomialFitter
 * - polyScale (1f)
 *
 * Output:
 * Move points
*/
class X3FOUNDATION_PRIVATE_API MLSSmooth : public Persistent
{	
	private:

	public:

		/// Smooth point set
		static void smooth( PointSet* ps, const float32 h );

		/// Smooth point cloud
		static void smooth( PointCloud* pc, const float32 h );

};

}

#endif