#ifndef MeshGeodesicsH
#define MeshGeodesicsH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
#include "geodesic_algorithm_exact.h"
//---------------------------------------------------------------------------

namespace X4
{
	class UnstructuredInCoreTriangleMesh;
/**
	plz comment your class
*/
class X3FOUNDATION_PRIVATE_API MeshGeodesics : public Persistent
{
	X4_CLASS( MeshGeodesics )

private:
	geodesic::Mesh myMesh;

	int32 m_SubdivisionLevel;

public:
	MeshGeodesics(void);
	~MeshGeodesics(void);

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

   //! Set level (0 > exact, 0=dijsktra, 1..N=subdivision)
   void setSubdivisionLevel(int level) { m_SubdivisionLevel = level;}
   int getSubdivisionLevel() { return m_SubdivisionLevel; }

   static void testGeodesics();
   void initializeFromUnstructuredInCoreTriangleMesh(UnstructuredInCoreTriangleMesh * mesh);

   //float32 getGeodesicDistance(Vector3f pointA, Vector3f pointB); todo
   float32 getGeodesicDistance(mpcard pointA, mpcard pointB, std::vector<Vector3f>* path = NULL);
   std::vector<float32> getGeodesicDistances(mpcard pointA, const std::vector<mpcard>& pointB, std::vector<std::vector<Vector3f> >* path = NULL);
};

}

#endif