//---------------------------------------------------------------------------
#ifndef Monomial2DH
#define Monomial2DH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
//---------------------------------------------------------------------------

namespace X4 {

class X3FOUNDATION_PRIVATE_API Monomial2D
{
	private:
		static const card32 NUM_BASIS_FUNS = 3;
		static const card32 MIN_NUM_POINTS = 5;

	public:	

		Monomial2D();
		~Monomial2D();

		static void computeCoeffs( const std::vector<Vector2f> &points,
			StaticVector<float32, 3> &coeffs,
			float32 gaussianWindowVariance = -1 );
		static float32 evaluate( const StaticVector<float32,3> &coeffs,
			const float32 &u );
};

}

#endif