#ifndef MonomialFitterH
#define MonomialFitterH

#include "x3foundation_private.h"
#include "Persistent.h"
#include "PointCloud.h"
#include "UnstructuredInCoreTriangleMesh.h"

namespace X4
{

/*
 * Fit a 2nd order monomial
 *
 * Required: 
 * - position  (3f)
 * - normal    (3f)   NormalEstimator, NormalUnifier
 * - tangent_u (3f)   TangentEstimator
 * - tangent_v (3f)   
 * 
 * Output:
 * - coeffs    (6f)
 * - polyScale (1f)
 *
 */
class X3FOUNDATION_PRIVATE_API MonomialFitter : public Persistent
{	
	private:

	public:

		/// Fit monomial
		static void fitMonomial( PointSet* ps, const float32 epsilon );

		/// Fit monomial
		static void fitMonomial( PointCloud* pc, const float32 epsilon );

};

}

#endif