//---------------------------------------------------------------------------
#ifndef NDTCellH
#define NDTCellH
//---------------------------------------------------------------------------
#include "LinearAlgebra.h"
#include "Persistent.h"
#include "AbstractNDTCell.h"
//---------------------------------------------------------------------------

namespace X4 {

/// Cell structure in the grid
class X3FOUNDATION_PRIVATE_API NDTCell : public AbstractNDTCell
{
	X4_CLASS( NDTCell )

	private:
		Vector3f mean;
		Matrix3f invSigma;
		Vector3f eigenValues;
		Matrix3f eigenVectors;
		
	public:
		NDTCell();
		inline void setMean( const Vector3f& mean ){ this->mean = mean; }
		inline Vector3f getMean() const { return mean; }
		inline void setInvSigma( const Matrix3f& invSigma ) { this->invSigma = invSigma; }
		inline Matrix3f getInvSigma() const { return invSigma; }
		inline void setEigenValues( const Vector3f eigenValues ){ this->eigenValues = eigenValues; }
		inline Vector3f getEigenValues() const { return eigenValues; }
		inline void setEigenVectors( const Matrix3f eigenVectors ){ this->eigenVectors = eigenVectors; }
		inline Matrix3f getEigenVectors() const { return eigenVectors; }
};

}

#endif