#ifndef PCCImportGothicH
#define PCCImportGothicH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------

namespace X4
{

/**
	imports a height field from a bitmap
	applies 'gothic style' borders and computes normals
*/
class X3FOUNDATION_PRIVATE_API PCCImportGothic : public PCCommand
{
	X4_CLASS( PCCImportGothic )

private:

	std::string	m_Filename;
	float		m_Height;
	float		m_Radius;
	float		m_Perc_One;

	float arcFunction(float x);
	Vector3f arcFunctionNormal(float x, Vector2f dir);
	void importLKVK();

public:
	PCCImportGothic(void);
	~PCCImportGothic(void);

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

	virtual void execute(Scene *scene);

	void createScene1();
};

}

#endif