#ifndef PCCPoissionSamplingH
#define PCCPoissionSamplingH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
//---------------------------------------------------------------------------

namespace X4
{
class PointCloud;

/**
	poission disk resampler, applies mls smoothing, computes normals
*/
class X3FOUNDATION_PRIVATE_API PCCPoissionSampling : public PCCommand
{
	X4_CLASS( PCCPoissionSampling )

private:

	float32	m_MaxSamplingSpacing;
	float32	m_RelativeNormalSigma;
	bool		m_CreateOCCPointCloud;
	std::string	m_OCCFileName;

public:
	PCCPoissionSampling(void);
	~PCCPoissionSampling(void);

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);
	virtual void execute(Scene * scene);

	/// creates a resampled copy of point cloud 'pc' using poission disk sampling
	/// computes normals with sigma m_MaxSamplingSpacing*m_RelativeNormalSigma
	/// flips orientation of normals towards cameraPos
	PointCloud * resampleAndComputeNormals( PointCloud * pc, const Vector3f &cameraPos );


};

}

#endif