//---------------------------------------------------------------------------
#ifndef PCCRegistrationH
#define PCCRegistrationH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
#include "Scene.h"
#include "ICP.h"
#include "NDT.h"
#include "RenderingTool.h"
#include "RegistrationDebug.h"
//---------------------------------------------------------------------------

#define NDT_CELL_TYPE 0
#define COLOR_NDT_CELL_TYPE 1

namespace X4 {

class X3FOUNDATION_PRIVATE_API PCCRegistration : public PCCommand 
{
	X4_CLASS( PCCRegistration )

	private:
		/*** GENERAL ***/
		card32 mode;
		card32 gridCellType;
		std::string basePCName;
		std::string registerPCName;
		int32 numIterations;
		int32 maxNumIterations;
		Registerizer* registerizer;
		RegistrationDebug* regDebug;
		float32 convergenceChange;
		bool writeFrames;

		void exportData();

	public:
		PCCRegistration();
		~PCCRegistration();

		void setNDT();
		void setICP();

		void setup();
		void step();
		void nSteps();

		void printNDTStats();

		virtual void execute( Scene *scene );
		void connectScene( Scene *scene, OnSceneChangeCallback *onChange, QWidget *sceneEditorWidget );
		virtual void glDrawTool( GLContext *glContext );
};


}

#endif
 