//---------------------------------------------------------------------------
#ifndef PCCTopologyPreservingResamplingH
#define PCCTopologyPreservingResamplingH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
//---------------------------------------------------------------------------
#include "PCCommand.h"
#include "UnstructuredInCorePointCloud.h"
#include "Scene.h"
//---------------------------------------------------------------------------

namespace X4 {

   class X3FOUNDATION_PRIVATE_API PCCTopologyPreservingResampling : public PCCommand 
   {
      X4_CLASS( PCCTopologyPreservingResampling )

   private:
      float32 m_Spacing;
      float32 m_ReconnectFactor;
      
   public:
      PCCTopologyPreservingResampling();
      ~PCCTopologyPreservingResampling();
      void execute( Scene *scene );

      void resamplePC(UnstructuredInCorePointCloud* pc);

      float32 getSpacing() const {return m_Spacing;}
      void setSpacing(float32 newSpacing){ m_Spacing = newSpacing;}
      
      float32 getReconnectFactor() const { return m_ReconnectFactor; }
      void setReconnectFactor(float32 f) { m_ReconnectFactor = f; }

   };


}

#endif
