#ifndef PCIAnimFeaturesH
#define PCIAnimFeaturesH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
//---------------------------------------------------------------------------
#include "PCInteractionTool.h"
//---------------------------------------------------------------------------

namespace X4
{
	class FeaturePointDetector;
	class RenderingTool;

/**
	preprocessing tools for animated scene (resample, smoothing & features)
*/
class X3FOUNDATION_PRIVATE_API PCIAnimFeatures : public PCInteractionTool
{
	X4_CLASS( PCIAnimFeatures )

private:

	// properties
	FeaturePointDetector		*	m_FeaturePointDetector;
	bool								m_ShowFeaturePoints;
	float32							m_FeatureSize;


	// members
	RenderingTool				*	m_RenderingTool;

public:
	PCIAnimFeatures(void);
	~PCIAnimFeatures(void);

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

	/// precompute features for every genericswapalloutofcore point cloud
	void precomputeFeatures();

	/// resample and smooth every genericswapalloutofcore point cloud
	void preprocessAnimation();

	/// create a ground truth channel for a sequence of frames
	void createGroundTruthChannel();


	// interaction tool interface
	virtual void keyDown(GeneralKey key) {}
	virtual void keyUp(GeneralKey key) {}

	virtual void mouseDown(int32 x, int32 y, MouseButtons buttonsState, Modifiers modifiersState) {}
	virtual void mouseMoved(int32 x, int32 y) {}
	virtual void mouseUp(int32 x, int32 y, MouseButtons buttonsState, Modifiers modifiersState) {}
	virtual void areaResize(card32 width, card32 height) {}

	virtual void glDrawTool(GLContext *glContext);

};

}

#endif