#ifndef PCISHREC2010H
#define PCISHREC2010H
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
//---------------------------------------------------------------------------
#include "PCInteractionTool.h"
//---------------------------------------------------------------------------

namespace X4
{
	class UnstructuredInCoreTriangleMesh;

class BaricentricMeshCoordinates{

	std::vector<int32> partOfFace;
	std::vector<int32> vertexABC;

public:

	BaricentricMeshCoordinates(UnstructuredInCoreTriangleMesh *);
	std::string getShrecStringForVertex(mpcard index);

	static Vector3f getAbsoluteCoordinateOfBaricentricMeshCoord(mpcard triangleIndex, Vector3f bCoords, UnstructuredInCoreTriangleMesh* mesh);


};

/**
	outputs the SHREC2010 format
*/
class X3FOUNDATION_PRIVATE_API PCISHREC2010 : public PCInteractionTool
{
	X4_CLASS( PCISHREC2010 )

private:
	void writeSHRECOutput();
	void readCorrFile();
	std::string nullPose;
	std::string corrPose;
	std::string outputFile;



public:
	PCISHREC2010(void);
	~PCISHREC2010(void);


   virtual void mouseDown(int32 x, int32 y, MouseButtons buttonsState, Modifiers modifiersState){}
   virtual void mouseMoved(int32 x, int32 y){}
   virtual void mouseUp(int32 x, int32 y, MouseButtons buttonsState, Modifiers modifiersState){}
   virtual void areaResize(card32 width, card32 height){}

   virtual void keyDown(GeneralKey key){}
   virtual void keyUp(GeneralKey key){}

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

   virtual void glDrawTool(GLContext *glContext){}

};

}

#endif