#ifndef PCITestGeometricFeaturesH
#define PCITestGeometricFeaturesH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
//---------------------------------------------------------------------------
#include "PCInteractionTool.h"
//---------------------------------------------------------------------------

namespace X4
{

class FeaturePointDetector;
class LocalICP;

///
///	test tool for geometric features and descriptors
///
class X3FOUNDATION_PRIVATE_API PCITestGeometricFeatures : public PCInteractionTool
{
	X4_CLASS( PCITestGeometricFeatures )

private:

	FeaturePointDetector	*	m_Detector;
	LocalICP * m_icp;
	std::string	m_DestAttribute;
	card32	m_NumTestsPerAmplitude;
	bool		m_ViewTests;

	/// returns the first selected point cloud or, if nothing is selected, the first point cloud
	PointCloud * getPC();
	std::vector<PointCloud*> getSelectedPointClouds();
	void debugDrawPointCloud( PointCloud * pc, std::string name);

public:
	PCITestGeometricFeatures(void);
	~PCITestGeometricFeatures(void);

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

	virtual void keyDown(GeneralKey key) {}
	virtual void keyUp(GeneralKey key) {}

	virtual void mouseDown(int32 x, int32 y, MouseButtons buttonsState, Modifiers modifiersState);
	virtual void mouseMoved(int32 x, int32 y) {}
	virtual void mouseUp(int32 x, int32 y, MouseButtons buttonsState, Modifiers modifiersState) {}
	virtual void areaResize(card32 width, card32 height) {}

	void noiseFeatureTest();
	void noiseFeatureTest_MultipleScales();
	void noiseFeatureTest_Guskov();
	void multipleScanTest();
	void geodeticTest();
	void computeSlipage();
	void testWithAlignedScans();
	void testApproximateAlignment();


};

}
      
#endif