#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "PointCloudAttributes.h"
#include "PointCloudTools.h"
#include "ClassMethods.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------

IMPLEMENT_X4_CLASS( PointCloudAttributes, 0 )
{
	BEGIN_CLASS_INIT( PointCloudAttributes )
	ADD_NOARGS_METHOD( checkPosition3f )
	ADD_NOARGS_METHOD( checkColor3f )
	ADD_NOARGS_METHOD( checkNormal3f )
	ADD_NOARGS_METHOD( checkFlags1i )
	ADD_NOARGS_METHOD( checkTangentU3f )
	ADD_NOARGS_METHOD( checkTangentV3f )
	ADD_NOARGS_METHOD( checkCoeffs3f )
	ADD_NOARGS_METHOD( checkCoeffs6f )
	ADD_NOARGS_METHOD( checkPolyScale1f )
	ADD_NOARGS_METHOD( checkCurv01f )
	ADD_NOARGS_METHOD( checkCurv11f )
}

PointCloudAttributes::PointCloudAttributes()
{
	scene = NULL;
	pcName = NULL;
}

PointCloudAttributes::~PointCloudAttributes()
{

}

void PointCloudAttributes::checkPosition3f()
{
	if ( scene == NULL ) return;
	if ( pcName == NULL ) return;
	checkAttribute( scene, *pcName, "position", 3, VAD::DATA_FORMAT_FLOAT32 );
}

void PointCloudAttributes::checkColor3f()
{
	if ( scene == NULL ) return;
	if ( pcName == NULL ) return;
	checkAttribute( scene, *pcName, "color", 3, VAD::DATA_FORMAT_FLOAT32 );
}

void PointCloudAttributes::checkNormal3f()
{
	if ( scene == NULL ) return;
	if ( pcName == NULL ) return;
	checkAttribute( scene, *pcName, "normal", 3, VAD::DATA_FORMAT_FLOAT32 );
}

void PointCloudAttributes::checkFlags1i()
{
	if ( scene == NULL ) return;
	if ( pcName == NULL ) return;
	checkAttribute( scene, *pcName, "flags", 1, VAD::DATA_FORMAT_INT32 );
}

void PointCloudAttributes::checkTangentU3f()
{
	if ( scene == NULL ) return;
	if ( pcName == NULL ) return;
	checkAttribute( scene, *pcName, "tangent_u", 3, VAD::DATA_FORMAT_FLOAT32 );
}

void PointCloudAttributes::checkTangentV3f()
{
	if ( scene == NULL ) return;
	if ( pcName == NULL ) return;
	checkAttribute( scene, *pcName, "tangent_v", 3, VAD::DATA_FORMAT_FLOAT32 );
}

void PointCloudAttributes::checkCoeffs3f()
{
	if ( scene == NULL ) return;
	if ( pcName == NULL ) return;
	checkAttribute( scene, *pcName, "coeffs", 3, VAD::DATA_FORMAT_FLOAT32 );
}

void PointCloudAttributes::checkCoeffs6f()
{
	if ( scene == NULL ) return;
	if ( pcName == NULL ) return;
	checkAttribute( scene, *pcName, "coeffs", 6, VAD::DATA_FORMAT_FLOAT32 );
}

void PointCloudAttributes::checkPolyScale1f()
{
	if ( scene == NULL ) return;
	if ( pcName == NULL ) return;
	checkAttribute( scene, *pcName, "polyScale", 1, VAD::DATA_FORMAT_FLOAT32 );
}

void PointCloudAttributes::checkCurv01f()
{
	if ( scene == NULL ) return;
	if ( pcName == NULL ) return;
	checkAttribute( scene, *pcName, "curv0", 1, VAD::DATA_FORMAT_FLOAT32 );
}

void PointCloudAttributes::checkCurv11f()
{
	if ( scene == NULL ) return;
	if ( pcName == NULL ) return;
	checkAttribute( scene, *pcName, "curv1", 1, VAD::DATA_FORMAT_FLOAT32 );
}