#ifndef PointCloudAttributesH
#define PointCloudAttributesH

#include "x3foundation_private.h"
#include "Persistent.h"
#include "PointCloud.h"
#include "PointCloudProcessingDefinitions.h"
#include "Scene.h"

namespace X4
{

/* Helper class allows to easily set required attributes */
class X3FOUNDATION_PRIVATE_API PointCloudAttributes : public Persistent
{	
	X4_CLASS( PointCloudAttributes )

	private:
		Scene* scene;
		std::string* pcName;

	public:
		PointCloudAttributes();
		~PointCloudAttributes();

		inline void setup( Scene* scene, std::string* pcName ){ this->scene = scene; this->pcName = pcName; }

		void checkPosition3f();
		void checkColor3f();
		void checkNormal3f();
		void checkFlags1i();
		void checkTangentU3f();
		void checkTangentV3f();
		void checkCoeffs3f();
		void checkCoeffs6f();
		void checkPolyScale1f();
		void checkCurv01f();
		void checkCurv11f();

};

}

#endif