#ifndef RegistrationDebugH
#define RegistrationDebugH

#include "Persistent.h"
#include "Registerizer.h"
#include "RenderingTool.h"
#include "NDT.h"
#include "ICPOctree.h"
#include "RegistrationRenderer.h"

namespace X4{

/// Debugging and visualization functionality for the registration tools
class X3FOUNDATION_PRIVATE_API RegistrationDebug : public Persistent
{
	X4_CLASS( RegistrationDebug ) 

	private:
		Registerizer* registerizer;
		RenderingTool* rt;
		float32 renderScale;
		bool showDataStructure;				// Octree/Grid
		bool showBBox;						// Show base ps bounding box
		int32 monitorGrid;					// Grid index to be displayed; -1 for all
		RegistrationRenderer* rr;
		Vector4f dataStructureColor;

		//void renderTreeNode( const ColorRegistrationNode* node );
		//void getNodes( std::vector<ColorRegistrationNode*>& nodes, card32 colorRegistrationLevel, ColorRegistrationNode* node );
		//void renderGridLevel( MultiResolutionGrid<ColorRegistrationCell>* mrGrid, const card32 level );
		//void renderGridLevel( MultiResolutionGrid<NDTCell>* mrGrid, const card32 level );
		
	public:
		RegistrationDebug();
		~RegistrationDebug();

		void renderGL();

		/*** MEMBER ACCESS ***/
		inline void setRegisterizer( Registerizer* registerizer ){ 
			this->registerizer = registerizer; 
		}
};



}

#endif