//---------------------------------------------------------------------------
#ifndef RegistrationRendererH
#define RegistrationRendererH
//---------------------------------------------------------------------------
#include "ICPOctree.h"
#include "ICPOctreeNode.h"
#include "AbstractGrid.h"
#include "RenderingTool.h"
//---------------------------------------------------------------------------

namespace X4 {

/// Containing all rendering functionality
class X3FOUNDATION_PRIVATE_API RegistrationRenderer
{
	private:
		RenderingTool* rt;

	public:
		RegistrationRenderer();
		RegistrationRenderer( RenderingTool* rt );
		~RegistrationRenderer();
		void renderOctreeNode( ICPOctreeNode* node ) const;
		void renderGrid( 
			AbstractGrid* grid, 
			const Vector4f& color,
			const float32 renderScale ) const;
		void renderNDTCell( 
			AbstractNDTCell* cell,
			const float32 ndtScale, 
			const Vector4f& color, 
			const float32 s = 1.0f,
			const Vector3f& t =  NULL_VECTOR3F ) const;
};

}

#endif