//---------------------------------------------------------------------------
#ifndef RotationVectorH
#define RotationVectorH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
//---------------------------------------------------------------------------

namespace X4 {

/// Quaternion representation
class X3FOUNDATION_PRIVATE_API RotationVector
{
	private:
		float32 v[3];

	public:
		/// Constructors
		RotationVector();
		RotationVector( float32 v0, float32 v1, float32 v2);

		Matrix3f getRotMat() const;		
		static RotationVector fromRotMat(Matrix3f R);

		// Operators
		float32& operator[]( const card32 i ) { return v[i]; }
		float32 operator[]( const card32 i ) const { return v[i]; }

		/// Print to console
		void println() const;
		
};

}

#endif