#ifndef SamplingSpacingEstimatorH
#define SamplingSpacingEstimatorH
#include "x3foundation_private.h"
#include "Persistent.h"
#include "PointSet.h"
#include "PointCloud.h"

namespace X4
{

/*
 * Estimate sampling spacing in point cloud based on nearest neighbors
 *
 * Required: 
 * - position        (3f)
 * 
 * Output:
 * - samplingSpacing (1f)
 *
*/
class X3FOUNDATION_PRIVATE_API SamplingSpacingEstimator : public Persistent
{	
	private:

	public:

		/// Estimate sampling spacing in point set; saved in 'samplingSpacing' channel
		static void estimateSamplingSpacing( PointSet* ps );

		/// Estimate sampling spacing in point set; saved in 'samplingSpacing' channel
		static void estimateSamplingSpacing( PointCloud* pc );

		// Estimate avg. sampling for point set
		static float32 estimateAvgSamplingSpacing( PointSet* ps );


};

}

#endif