#ifndef TangentsEstimatorH
#define TangentsEstimatorH
#include "x3foundation_private.h"
#include "Persistent.h"
#include "PointCloud.h"

namespace X4
{
/*
 * Estimate tangents based on normals in a point cloud
 *
 * Required: 
 * - position        (3f)
 *
 * Output:
 * - tangent_u       (3f) Output
 * - tangent_v       (3f) Output
*/
class X3FOUNDATION_PRIVATE_API TangentsEstimator : public Persistent
{	
	private:

	public:

		// Create a orthogonal coordinate system around a given normal
		static void computeTangents( const Vector3f normal, Vector3f& tangent_u, Vector3f& tangent_v );

		/// Estimate tangents point set
		static void estimateTangents( PointSet* ps );

		/// Estimate tangents in point cloud
		static void estimateTangents( PointCloud* pc );
};

}

#endif