//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "Timerable.h"
#include <time.h>
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------

Timerable::Timerable()
{
	resetTimings();
}

Timerable::~Timerable()
{
}

void Timerable::resetTimings()
{
	startTime = -1;
	accumulatedTime = 0;
	numTasks = 0;
}

void Timerable::startTask()
{
	startTime = clock();
}

void Timerable::endTask()
{
	accumulatedTime += float32 ( ( clock() - startTime ) / CLK_TCK );
	numTasks++;
}

float32 Timerable::getAvgTaskTime()
{ 
	if ( numTasks > 0 )
		return accumulatedTime / float32( numTasks ); 
	else
		return 0;
}