//---------------------------------------------------------------------------
#ifndef TimerableH
#define TimerableH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
//---------------------------------------------------------------------------

namespace X4 {

class X3FOUNDATION_PRIVATE_API Timerable
{
	protected:
		float32 startTime;
		float32 accumulatedTime;
		card32 numTasks;

		void startTask();
		void endTask();

	public:
		Timerable();
		~Timerable();	

		void resetTimings();
		float32 getAvgTaskTime();
		inline card32 getNumTasks(){ return numTasks; }
};

}

#endif