//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "VSTree.h"
#include "ObjectClassProperty.h"
#include "SeparatorClassProperty.h"
#include "ClassMethods.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------

IMPLEMENT_X4_CLASS( VSTree, 0 )
{
	BEGIN_CLASS_INIT( VSTree )
	ADD_OBJECT_PROP( root, 0, VSTreeNode::getClass(), true )
}

VSTree::VSTree()
{
	root = NULL;
}

VSTree::~VSTree()
{
}

void VSTree::clear()
{
	if ( root != NULL ){
		root->clear();
		delete root;
		root = NULL;
	}
}

void VSTree::setup( VSTreeNode* root  )
{
	clear();
	this->root = root;
}

void VSTree::loadTreeFixSNode( VSTreeNode* node, VSTreeTNode* parentTNode )
{
	if ( node == NULL ) return;
	VSTreeVNode* vNode = dynamic_cast<VSTreeVNode*>( node );
	VSTreeTNode* tNode = dynamic_cast<VSTreeTNode*>( node );
	VSTreeSNode* sNode = dynamic_cast<VSTreeSNode*>( node );
	if ( vNode != NULL ){
		if ( vNode->hasChildren() ){
			for ( unsigned int cIndex = 0; cIndex < 8; cIndex++ ){
				loadTreeFixSNode( vNode->getChild( cIndex ), parentTNode );
			}
		}
	} else if ( tNode != NULL ){
		loadTreeFixSNode( tNode->getChild(), tNode );
	} else if ( sNode != NULL ){
		sNode->setParentTNode( parentTNode );
		if ( sNode->hasChildren() ){
			for ( unsigned int cIndex = 0; cIndex < 4; cIndex++ ){
				loadTreeFixSNode( sNode->getChild( cIndex ), parentTNode );
			}
		}
	}
}

void VSTree::write( OutputObjectStream* s ) const
{
	Persistent::write( s );
}

void VSTree::read( InputObjectStream* s ) 
{
	Persistent::read( s );
	loadTreeFixSNode( root, NULL );
}