//---------------------------------------------------------------------------
#ifndef VSTreeH
#define VSTreeH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
#include "Persistent.h"
#include "VSTreeVNode.h"
#include "VSTreeTNode.h"
#include "VSTreeSNode.h"
//---------------------------------------------------------------------------

namespace X4 {

/** 
 * Implementation of a VS-Tree [Volume-Surface Trees, 
 * T. Boubekeur, W Heidrich, X. Granier, C. Schlick, Proceedings EG'06] 
 */
class X3FOUNDATION_PRIVATE_API VSTree : public Persistent
{
	X4_CLASS( VSTree )

	private:
		VSTreeNode* root;			// Root node of tree

		// Required to reassign t-node as parent to s-nodes; called automatically after load
		void loadTreeFixSNode( VSTreeNode* node, VSTreeTNode* tNode );
		void write( OutputObjectStream* s ) const;
		void read( InputObjectStream* s ) ;

	public:
		VSTree();
		~VSTree();

		void clear();
		void setup( VSTreeNode* root );

		inline VSTreeNode* getRoot() { return root; }

};
}

#endif