//---------------------------------------------------------------------------
#ifndef VSTreeIteratorsH
#define VSTreeIteratorsH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
#include "Persistent.h"
#include "VSTree.h"
#include "VSTreeVNode.h"
#include "VSTreeTNode.h"
#include "VSTreeSNode.h"
#include "FifoStack.h"
//---------------------------------------------------------------------------

namespace X4 {

/** Iterator for serialization of the nodes of a VS-Tree **/
class VSTreeIterator
{
	private:
		VSTree* tree;
		FifoStack<VSTreeNode*> stack;

	public:
		void setup( VSTree* tree );		// Init iterator with new tree
		void reset();					// Reset to root node
		bool atEnd();					// Check for last node
		VSTreeNode* next();				// Return current node, advance iterator
};
}

#endif