//---------------------------------------------------------------------------
#ifndef VSTreeNodeH
#define VSTreeNodeH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace X4 {

/** Parent class for all nodes in a VS-Tree **/
class X3FOUNDATION_PRIVATE_API VSTreeNode : public Persistent
{
	X4_ABSTRACT_CLASS( VSTreeNode )

	protected:
		Vector4f color;			/// Color attribute; debugging
		card32 id;				/// Unique id of node; assigned during build; do not alter

	public:
		VSTreeNode(){ color = makeVector4f( rand()%100/100.0f, rand()%100/100.0f, rand()%100/100.0f, 1.0f ); }
		inline Vector4f getColor(){ return color; }
		virtual void clear() = 0;
		inline void setID( const card32 id ){ this->id = id; }
		inline card32 getID() const { return id; }
};
}

#endif