//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "VSTreeSNode.h"
#include "ObjectClassProperty.h"
#include "VSTreeTNode.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------

IMPLEMENT_X4_CLASS( VSTreeSNode, 0 )
{
	BEGIN_CLASS_INIT( VSTreeSNode )
	ADD_VECTOR2F_PROP( bbox.lowerCorner, 0 )
	ADD_VECTOR2F_PROP( bbox.upperCorner, 0 )
	ADD_OBJECT_PROP( sNodes[0], 0, VSTreeSNode::getClass(), true )
	ADD_OBJECT_PROP( sNodes[1], 0, VSTreeSNode::getClass(), true )
	ADD_OBJECT_PROP( sNodes[2], 0, VSTreeSNode::getClass(), true )
	ADD_OBJECT_PROP( sNodes[3], 0, VSTreeSNode::getClass(), true )
	ADD_CARD32_VAR_ARRAY_PROP( indices, 0 )
}

VSTreeSNode::VSTreeSNode()
{
	for ( unsigned int cIndex = 0; cIndex < 4; cIndex++ )
		sNodes[cIndex] = NULL;
	parentTNode = NULL;
	bbox = BoundingBox2f( makeVector2f( -1,-1 ), makeVector2f( 1,1 ) );
	indices.clear();
}

VSTreeSNode::~VSTreeSNode()
{
	clear();
}

void VSTreeSNode::clear()
{
	for ( unsigned int cIndex = 0; cIndex < 4; cIndex++ )
		if ( sNodes[cIndex] != NULL ){
			sNodes[cIndex]->clear();
			delete sNodes[cIndex];
			sNodes[cIndex] = NULL;
		}
}

Matrix3f VSTreeSNode::getT() const
{
	VSTreeTNode* parent = dynamic_cast<VSTreeTNode*>( parentTNode );
	if ( parent != NULL ) return parent->getT();
	else return IDENTITY3F;
}

Vector3f VSTreeSNode::getCenter() const
{
	VSTreeTNode* parent = dynamic_cast<VSTreeTNode*>( parentTNode );
	if ( parent != NULL ) return parent->getCenter();
	else return NULL_VECTOR3F;
}