//---------------------------------------------------------------------------
#ifndef VSTreeTNodeH
#define VSTreeTNodeH
//---------------------------------------------------------------------------
#include "x3foundation_private.h"
#include "Persistent.h"
#include "VSTreeNode.h"
//---------------------------------------------------------------------------

namespace X4 {

/** Implementation of the t-node (crossing volume -> surface) in a VS-Tree **/
class X3FOUNDATION_PRIVATE_API VSTreeTNode : public VSTreeNode
{
	X4_CLASS( VSTreeTNode )

	private: 
		Matrix3f T;				/// Local coordinate system
		Vector3f center;		/// Center of nodes points
		VSTreeNode* child;		/// Child node

	public:
		VSTreeTNode();
		~VSTreeTNode();

		void clear();

		inline void setCenter( const Vector3f& center ){ this->center = center; }
		inline Vector3f getCenter(){ return center; };
		inline void setT( const Matrix3f& T ){ this->T = T; }
		inline Matrix3f getT(){ return T; }
		inline VSTreeNode* getChild(){ return child; }
		inline void setChild( VSTreeNode* child ){ this->child = child; }

	};
}

#endif