//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "VSTreeVNode.h"
#include "ObjectClassProperty.h"
#include "SeparatorClassProperty.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------

IMPLEMENT_X4_CLASS( VSTreeVNode, 0 )
{
	BEGIN_CLASS_INIT( VSTreeVNode )
	ADD_SEPARATOR( "V-Node" )
	ADD_VECTOR2F_PROP( bbox.lowerCorner, 0 )
	ADD_VECTOR2F_PROP( bbox.upperCorner, 0 )
	ADD_OBJECT_PROP( children[0], 0, VSTreeNode::getClass(), true )
	ADD_OBJECT_PROP( children[1], 0, VSTreeNode::getClass(), true )
	ADD_OBJECT_PROP( children[2], 0, VSTreeNode::getClass(), true )
	ADD_OBJECT_PROP( children[3], 0, VSTreeNode::getClass(), true )
	ADD_OBJECT_PROP( children[4], 0, VSTreeNode::getClass(), true )
	ADD_OBJECT_PROP( children[5], 0, VSTreeNode::getClass(), true )
	ADD_OBJECT_PROP( children[6], 0, VSTreeNode::getClass(), true )
	ADD_OBJECT_PROP( children[7], 0, VSTreeNode::getClass(), true )
	ADD_CARD32_VAR_ARRAY_PROP( indices, 0 )
}

VSTreeVNode::VSTreeVNode()
{
	for ( unsigned int cIndex = 0; cIndex < 8; cIndex++ )
		children[cIndex] = NULL;
	bbox = BoundingBox3f( makeVector3f( -1,-1,-1 ), makeVector3f( 1,1,1 ) );
	indices.clear();
}

VSTreeVNode::~VSTreeVNode()
{
	clear();
}

void VSTreeVNode::clear()
{
	for ( unsigned int cIndex = 0; cIndex < 8; cIndex++ )
		if ( children[cIndex] != NULL ){
			children[cIndex]->clear();
			delete children[cIndex];
			children[cIndex] = NULL;
		}
	indices.clear();
}