SET_MODULE_TYPE_LOADABLE_MODULE
// modules that the new module is based on. expand as required.
ADD_DEPENDENCY("opencv")
ADD_DEPENDENCY("x4basics")
ADD_DEPENDENCY("x4core")
ADD_DEPENDENCY("x4interface")
ADD_DEPENDENCY("x4math")
ADD_DEPENDENCY("x4miscFoundation")
ADD_DEPENDENCY("x4tools")
ADD_DEPENDENCY("x4modules")
ADD_DEPENDENCY("x3geometry")
ADD_DEPENDENCY("x3openGL")
ADD_DEPENDENCY("x3sceneGraph")
ADD_DEPENDENCY("x3editor")
ADD_DEPENDENCY("x3rendering")

// add one or more authors (repeat command for multiple authors)
ADD_AUTHOR("Michael Wand")

// add the institution holding the copyright
ADD_INSTITUITION("Universiteit Utrecht")

// BSD is the default license. Choose carefully for your new module.
ADD_LICENSE("BSD")

// an icon for this module
ADD_ICON(":/images_x3foundation_private/images/x3foundation_private.png")

// Add classes here: format is "class", "baseClass". class.h is included
// ADD_CLASS("SomeNewClass", "Persistent")

// Alternative: specify file to include for this declaration
// ADD_CLASS_INC("SomeNewClass", "Persistent", "AHeaderWithManyClasses.h")

ADD_CLASS("UniformPointCloudResampling", "Persistent")

// Registration
ADD_CLASS("Transformation", "Persistent")
ADD_CLASS("AbstractGrid", "Persistent")
ADD_CLASS("AbstractNDTCell", "Persistent")
ADD_CLASS("NDTCell", "AbstractNDTCell")
ADD_CLASS("RegularGrid", "AbstractGrid")
ADD_CLASS("Registerizer", "Persistent")
ADD_CLASS("ICP", "Registerizer")
ADD_CLASS("NDT", "Registerizer")
ADD_CLASS("RegistrationDebug", "Persistent")
ADD_CLASS("GridBuilder", "Persistent")
ADD_CLASS("ICPOctree", "Persistent")
ADD_CLASS("ICPOctreeNode", "Persistent")
ADD_CLASS("FSIcp", "Persistent")
ADD_CLASS_INC("RansacRegistration", "Persistent", "Ransac.h")
ADD_CLASS_INC("RansacSolution", "Persistent","Ransac.h")
//
////ImportanceSampler", "Persistent"));
////ImportanceSample", "Persistent"));
//
//// Rendering
ADD_CLASS("HQRLight", "Persistent")
ADD_CLASS("HDRLightprobeSampling", "Persistent")
ADD_CLASS_INC("HQRSettings", "Persistent", "HighQualityRenderer.h")
ADD_CLASS("MultiPassRenderer", "Renderer")
ADD_CLASS("HighQualityRenderer", "MultiPassRenderer")
ADD_CLASS("EyeCandy", "Renderer")
ADD_CLASS("TronRenderer", "Renderer")
ADD_CLASS("BRDFAttachment", "TextureAttachment")
ADD_CLASS_INC("BRDFContainer", "AttachedData", "BRDFAttachment.h")
ADD_CLASS("BRDFShaderMaterial", "GLShaderMaterial")
ADD_CLASS_INC("HighQualityRendererEditor", "ClassEditor", "HighQualityRendererEditorWidget.h")

ADD_CLASS("GLImageOperator", "Persistent")
ADD_CLASS("GLImageCombiner", "GLImageOperator")
ADD_CLASS("GLImageFilter", "GLImageOperator")
ADD_CLASS("GLImageReducer", "GLImageOperator")
ADD_CLASS("GLImageWarper", "GLImageOperator")

ADD_CLASS_INC("ABS_ParameterDescriptor", "Persistent", "ABS_Framework.h")
ADD_CLASS_INC("ABS_ParameterDescriptorVector", "Persistent", "ABS_Framework.h")
ADD_CLASS_INC("ABS_Comparator", "Persistent", "ABS_Framework.h")
ADD_CLASS("ABS_SimpleComparator", "ABS_Comparator")
ADD_CLASS_INC("ABS_Analysator", "Persistent", "ABS_Framework.h")
ADD_CLASS_INC("ABS_ImageSynthesizer", "Persistent" , "ABS_Framework.h")
ADD_CLASS("ABS_Framework", "Persistent")
//
//// geometric features
ADD_CLASS("FeaturePointDetector", "Persistent")
ADD_CLASS("MultiScaleFeatureDetector", "FeaturePointDetector")
ADD_CLASS("SlippageFeatureDetector", "FeaturePointDetector")
ADD_CLASS("LocalDescriptor", "Persistent")
ADD_CLASS("LDHistogram", "LocalDescriptor")
ADD_CLASS_INC("ScaleSpaceDescriptor", "LocalDescriptor", "MultiScaleFeatureDetector.h")
ADD_CLASS("LDCentroidDescriptor", "LocalDescriptor")
ADD_CLASS_INC("SlippageDescriptor", "LocalDescriptor", "SlippageFeatureDetector.h")
ADD_CLASS("LDCorrelation", "LocalDescriptor")
ADD_CLASS("IntrinsicWaveDescriptor", "LocalDescriptor")
ADD_CLASS_INC("LocalSignature", "Persistent", "LocalDescriptor.h")
ADD_CLASS_INC("FloatVectorSignature", "LocalSignature", "LocalDescriptor.h")
ADD_CLASS_INC("ScaleSpaceSignature", "LocalSignature", "MultiScaleFeatureDetector.h")
ADD_CLASS_INC("LDCentroidSignature", "LocalSignature", "LDCentroidDescriptor.h")
ADD_CLASS_INC("SlippageSignature", "LocalSignature", "SlippageFeatureDetector.h")
ADD_CLASS_INC("LDCorrelationSignature", "LocalSignature", "LDCorrelation.h")
ADD_CLASS("GeometricFeature", "Persistent")
ADD_CLASS_INC("FeatureSet", "AttachedData", "GeometricFeature.h")
ADD_CLASS("PCITestGeometricFeatures", "PCInteractionTool")
ADD_CLASS("PCIRigidRegistration", "PCInteractionTool")
ADD_CLASS("SpectralCorrespondenceValidation", "Persistent")
ADD_CLASS("FeatureMatching", "Persistent")
ADD_CLASS("FeatureCorrespondence", "Persistent")
ADD_CLASS_INC("FeatureCorrespondenceSet", "AttachedData", "FeatureCorrespondence.h")
ADD_CLASS("LocalICP", "Persistent")
ADD_CLASS("LineFeature", "Persistent")
ADD_CLASS_INC("LineFeatureSet", "AttachedData", "LineFeature.h")
ADD_CLASS_INC("LineFeatureDetector", "Persistent", "LineFeature.h")
ADD_CLASS("PointToLineAlignment", "Persistent")
ADD_CLASS("PCIAnimFeatures", "PCInteractionTool")
ADD_CLASS("MLSProjector", "Persistent")
ADD_CLASS("SpinImageDescriptor", "LocalDescriptor")
ADD_CLASS_INC("SpinImageSignature", "LocalSignature", "SpinImageDescriptor.h")
ADD_CLASS_INC("SampledLandmarkDescriptor", "LocalDescriptor", "SampledLandmarkDetector.h")
ADD_CLASS("SampledLandmarkDetector", "FeaturePointDetector")
ADD_CLASS("AttachedFloatSignatures", "AttachedData")
ADD_CLASS_INC("AttachedFloatVector", "AttachedData", "AttachedFloatSignatures.h")
ADD_CLASS_INC("AttachedCard32Vector", "AttachedData", "AttachedFloatSignatures.h")
ADD_CLASS_INC("AttachedInt32Vector", "AttachedData", "AttachedFloatSignatures.h")
ADD_CLASS("PCAGeneral", "Persistent")

ADD_CLASS("PCHOCDescriptor", "Persistent")
//
// Commands
ADD_CLASS("PCCRegistration", "PCCommand")
ADD_CLASS("PCCSurfaceTools", "PCCommand")
ADD_CLASS("PCCCacheOptimizer", "PCCommand")
ADD_CLASS("PCCResampleByCurvature", "PCCommand")
ADD_CLASS("PCCTopologyPreservingResampling", "PCCommand")
ADD_CLASS("PCCPoissionSampling", "PCCommand")
ADD_CLASS("PCCImportGothic", "PCCommand")
ADD_CLASS("PCCSurfaceReconTools", "PCCommand")
ADD_CLASS("PCCSimplification", "PCCommand")
//
// Point cloud processing
ADD_CLASS("TensorVoting", "Persistent") 
ADD_CLASS("PCIPointCloudProcessing", "PCInteractionTool")
ADD_CLASS("PointCloudProcessingRenderer", "Persistent")
ADD_CLASS("PointCloudAttributes", "Persistent")
ADD_CLASS("MultiResolutionPC", "Persistent")
//
////UnitTests::addTest(Monomials2ndOrder_unitTest, "Monomials2ndOrder_unitTest()") // comment out by CL @ 2014/02/17
//
// VS-Tree
ADD_CLASS("VSTreeNode", "Persistent")
ADD_CLASS("VSTreeSNode", "VSTreeNode")
ADD_CLASS("VSTreeTNode", "VSTreeNode")
ADD_CLASS("VSTreeVNode", "VSTreeNode")
ADD_CLASS("VSTree", "Persistent")
ADD_CLASS("VSTreeOperations", "Persistent")
ADD_CLASS("VSTreeRenderer", "Persistent")
//
//// MainFFTWrapper = new FFTWrapper; // comment out by CL @ 2014/02/17
//
ADD_CLASS("PCIMeshGeodesics", "PCInteractionTool")
ADD_CLASS("PCISHREC2010", "PCInteractionTool")

ADD_CLASS("UnstructuredInCorePointCloudManifold", "DiscreteManifold")
ADD_CLASS("UnstructuredInCoreTriangleMeshManifold", "UnstructuredInCorePointCloudManifold")
ADD_CLASS_INC("ManifoldCorrespondence", "Persistent", "ManifoldCorrespondences.h")
ADD_CLASS_INC("ManifoldCorrespondenceSet", "AttachedData", "ManifoldCorrespondences.h")
ADD_CLASS("LandmarkCoordinate", "Persistent")

ADD_CLASS("PCIPoissonReconstruction", "PCInteractionTool")
//DVectorFObject", "Persistent"));
//DVectorIObject", "Persistent"));

ADD_CLASS("OOBBox3f", "Persistent")
ADD_CLASS("RigidMotion", "Persistent")

ADD_CLASS("LBase", "Persistent")
ADD_CLASS_INC("LBaseSetTranSet", "Persistent", "LBaseSet.h")
ADD_CLASS("LBaseSet", "AttachedData")

