//---------------------------------------------------------------------------
#ifndef GaussianPointCloudSmootherH
#define GaussianPointCloudSmootherH
//---------------------------------------------------------------------------
#include "x3geometry.h"
//---------------------------------------------------------------------------
#include "PointCloudSmoother.h"
//---------------------------------------------------------------------------

namespace X4 {


class X3GEOMETRY_API GaussianPointCloudSmoother : public PointCloudSmoother {
   X4_CLASS(GaussianPointCloudSmoother)
 public:
   enum { TYPE_GAUSS = 0,
          TYPE_COS };
          
 private:
   /// how low-pass am i?
   float32 stdDevPerGridCell;
   card32 type;

   float32 computeGaussianWeight(float32 x, float32 sigma) const;

   UnstructuredInCorePointCloud * downsamplePointCloud(
      UnstructuredInCorePointCloud * input, 
      float32 currentGridSpacing, 
      float32 smoothingFactor) const;

 protected:
   float32 getStdDevPerGridCell() const {return stdDevPerGridCell;}

 public:
   GaussianPointCloudSmoother();
   
   virtual UnstructuredInCorePointCloud *createSmoothed(
      UnstructuredInCorePointCloud *input, 
      float32 currentGridSpacing, 
      float32 smoothingFactor) const;
};



}

#endif
