#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "ImageDisplayer.h"
//---------------------------------------------------------------------------
#include "ImageDisplayerWidget.h"
#include "Tools.h"
#include "StringHelper.h"
#include "EventDisplayer.h"
#include "EventDisplayerBaseWidget.h"
//---------------------------------------------------------------------------
using namespace X4;

IMPLEMENT_X4_CLASS( ImageDisplayer ,0)
{
	BEGIN_CLASS_INIT( ImageDisplayer );
}

ImageDisplayer::ImageDisplayer() {
	widget = NULL;
	imgNumber = 0;
}

QWidget *ImageDisplayer::createSpecialWidget(QWidget *parent) {
	widget = new ImageDisplayerWidget(parent);
	return widget;
}

void ImageDisplayer::displayEvent(const EventDisplayerEvent *e, const char *logfile) {
	if (widget == NULL) return;
   {
      const DisplayPointSet *dps = dynamic_cast<const DisplayPointSet*>(e);
      if (dps != NULL) {
			widget->displayPointSet(dps->ps, dps->showChannel);
		}
	}
	{
      const DisplayQImage *dqi = dynamic_cast<const DisplayQImage*>(e);
      if (dqi != NULL) {
			widget->displayQImage(dqi->image);
		}
   }
	{
      const Display2DRegularData *dqi = dynamic_cast<const Display2DRegularData*>(e);
      if (dqi != NULL) {
			widget->display2DRegularData(dqi->image);
		}
   }
		const DisplayRGBAFloat32Image *dfi = dynamic_cast<const DisplayRGBAFloat32Image*>(e);
		if (dfi != NULL) {
			widget->displayRGBAFloat32Image(dfi->image);
		}
   {
   }
	{
      const ChangeZoom *z = dynamic_cast<const ChangeZoom*>(e);
      if (z != NULL) {
			widget->changeZoom(z->zoomFactor);
		}
   }
	{
      const ChangeMapping *m = dynamic_cast<const ChangeMapping*>(e);
      if (m != NULL) {
			widget->changeMapping(m->offset, m->scale, m->gamma);
		}
   }
   if (logfile != NULL) {
      try {
			card32 format = widget->getLoggingFormat();
			std::string ext;
			if (format == ImageDisplayerWidget::JPG) {
				ext = ".jpg";
			} else {
				ext = ".png";
			}
			std::string filename;
			for (card32 i=0; i<1000; i++) {
				filename = logfile;
				filename += std::string(".image.") + fillNumberStringWithZeros(intToStr(imgNumber++),5) + ext;
				if (!FileExists(filename.c_str())) break;
			}
			QPixmap pix = widget->getCurrentImage();
			pix.save(filename.c_str(), (format==ImageDisplayerWidget::JPG)?"JPG":"PNG");
      } catch (...) {
      }
   }
	if (baseWidget) baseWidget->setValue("");
}

ImageDisplayer::~ImageDisplayer() {}

void X4::DOutput_TalkToPointCloudProject_Impl::displayRGBAFloatImage( RGBAFloat32Image * image, std::string name )
{
	ImageDisplayer::DisplayRGBAFloat32Image ev(image);
	debugOutput.displayEvent( ImageDisplayer::getClass(), name, &ev);
}

void X4::DOutput_TalkToPointCloudProject_Impl::displayQImage( QImage * image, std::string name )
{
	ImageDisplayer::DisplayQImage ev(image);
	debugOutput.displayEvent( ImageDisplayer::getClass(), name, &ev);
}