//---------------------------------------------------------------------------
#ifndef InCoreVolumeH
#define InCoreVolumeH
//---------------------------------------------------------------------------
#include "x3geometry.h"
//---------------------------------------------------------------------------
#include "VolumeObject.h"
#include "BoundingBox.h"
//---------------------------------------------------------------------------


namespace X4 {

class RegularVolume;
class VertexDescriptor;

///
///  abstract base class for all in core volume scene objects
///
class X3GEOMETRY_API InCoreVolume : public VolumeObject {
	X4_ABSTRACT_CLASS( InCoreVolume )
private:

public:
	InCoreVolume() {}

   virtual void clearAndSetup(card32 width, card32 height, card32 depth, const VertexDescriptor *descr) = 0;
   virtual void clearAndSetup(card32 width, card32 height, card32 depth, const VertexDescriptor *descr, const BoundingBox3f &bb) = 0;
   virtual const RegularVolume *getVoxels() const = 0;
   virtual void setVoxels(RegularVolume *v) = 0;
   virtual RegularVolume *getVoxels() = 0;

	~InCoreVolume() {}
};

}

#endif