//---------------------------------------------------------------------------
#ifndef MHSelectionIteratorAdaptorH
#define MHSelectionIteratorAdaptorH
//---------------------------------------------------------------------------
#include "x3geometry.h"
//---------------------------------------------------------------------------
#include "HierarchicalIteratorAdaptor.h"
//---------------------------------------------------------------------------

namespace X4 {

class X3GEOMETRY_API MHSelectionIteratorAdaptor : public HierarchicalIteratorAdaptor
{
 protected:

   protected:
   AAT FLAGS;


   virtual bool pointMeetsCond()
   {
      return ((m_base->get1i(FLAGS)) & PF_FLAG_SELECTED);
   }

   virtual bool nodeMeetsCond()
   {
      card64 count;
      bool ok=m_hr->getNodeInfo(HierarchicalIterator::niFlaggedInSubtree, &PF_FLAG_SELECTED, &count);

      x4Assert(ok);
      return (count>0);
   }


 public:
   MHSelectionIteratorAdaptor(PointCloudIterator* native, const VertexDescriptor *vd);
   ~MHSelectionIteratorAdaptor();

};


}





//---------------------------------------------------------------------------
#endif
