//---------------------------------------------------------------------------
#ifndef MultiScalePointCloudParametersH
#define MultiScalePointCloudParametersH
//---------------------------------------------------------------------------
#include "x3geometry.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace X4 {

/// Class that describes the parameters for creating multi-scale point clouds
class X3GEOMETRY_API MultiScalePCParams : public Persistent {
   X4_CLASS(MultiScalePCParams)
 public:
   /// grid size for the first grid in the multi-res hierarchy
   float32 baseGridSpacing;
   /// factor between consecutive grids
   float32 levelFactor;
   /// number of multi-resolution levels
   /// you will get levels {0,1,...,numLevels}
   /// Level zero is the original data set
   float32 numLevels;
   
   MultiScalePCParams();
   
   virtual void assign(const Object* obj, X4CopyContext *context);
};




}

#endif
