//---------------------------------------------------------------------------
#ifndef PointCloudSmootherH
#define PointCloudSmootherH
//---------------------------------------------------------------------------
#include "x3geometry.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace X4 {

class UnstructuredInCorePointCloud;


class X3GEOMETRY_API PointCloudSmoother : public Persistent {
   X4_ABSTRACT_CLASS(PointCloudSmoother)
 public:
   /// this method creates a smoothed point cloud from an original one
   /// the parameter currentGridSpacing describes the sample spacing of the input
   /// the resulting targetGridSpacing must be larger than the current one and depends
   /// on the smoothing factor targetGridSpacing = currentGridSpacing * smoothingFactor
   virtual UnstructuredInCorePointCloud *createSmoothed(
      UnstructuredInCorePointCloud *input, 
      float32 currentGridSpacing, 
      float32 smoothingFactor) const = 0;
};



}

#endif
