//---------------------------------------------------------------------------
#ifndef PointFlagsH
#define PointFlagsH
//---------------------------------------------------------------------------
#include "x3geometry.h"
//---------------------------------------------------------------------------

namespace X4 {


/// type for flags channel in point clouds
typedef int32 PointFlagsType;

/// invalid point, should be ignored by all operations
const PointFlagsType PF_FLAG_INVALID = 1;
/// point has been selected
const PointFlagsType PF_FLAG_SELECTED = 2;
/// point has been modified (recently) by a tool
const PointFlagsType PF_FLAG_MODIFIED = 4;
/// point has been marked (custom uses by different tools)
const PointFlagsType PF_FLAG_MARK_1 = 8;

/// number of flags
const card32 MAX_NUM_POINT_FLAGS = 4;

/// flags which can be queried hierarchically (the number of flagged points can be determined for subtrees)
const card32 MAX_POINT_FLAGS_TRACKED_IN_HIERARCHY = 2;
/// mask that for all flag bits that are counted in hierarchies
const card32 HIERARCHY_FLAGS_MASK = 3;

}


#endif

