//---------------------------------------------------------------------------
#ifndef PointSetToolsH
#define PointSetToolsH
//---------------------------------------------------------------------------
#include "x3geometry.h"
//---------------------------------------------------------------------------
#include "X4Types.h"
//---------------------------------------------------------------------------
#include <vector>
//---------------------------------------------------------------------------

namespace X4 {

   class PointSet;
   namespace PointSetTools {
		///
		///   a set of tools to process point sets 
		///   (put in an additional file rather than 
		///   PointSet.h to avoid frequent recompiling)
		///

		/// remove all points from the set that do not have a boolean tag of "true" in keep
		/// (if keep is smaller than ps->getNumEntries(), false is assumed for all other points)
		void X3GEOMETRY_API removePoints(PointSet *ps, const std::vector<bool> &keep);
   }

   using namespace PointSetTools;
}

#endif