#ifndef PolygonTriangulationH
#define PolygonTriangulationH
//---------------------------------------------------------------------------
#include "x3geometry.h"
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

namespace X4
{

/**
	triangulation tools for complex polygons
*/
class X3GEOMETRY_API PolygonTriangulation 
{

public:

	/// triangularization of a complex polygon. edges are specified
	/// by successive vertices edge = (edges[i*2] to edges[i*2+1])
	/// make sure that (edges[i*2+1] - edges[i*2]).crossProduct(polyNormal) faces inside
	/// and with inside I mean probably outside. try it on one polygon :-)
	/// IMPORTANT: edges is NOT a line strip but a redundant set of points!
	static std::vector<Vector3f> triangularizeComplexPolygon( const std::vector<Vector3f> &edges, const Vector3f polyNormal );

private:

	/// returns (v,0) as Vector3f
	static Vector3f expand2To3Custom(const Vector2f &v, float x2);
};

}

#endif