#ifndef ScatteredDataInterpolationH
#define ScatteredDataInterpolationH
//---------------------------------------------------------------------------
#include "x3geometry.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------
#include "TemplatedImage.h"

namespace X4
{
	class PointSet;

/**
	creates images from scattered data points
*/
class X3GEOMETRY_API ScatteredDataInterpolation : public Persistent
{
	X4_ABSTRACT_CLASS( ScatteredDataInterpolation )

private:

public:
	ScatteredDataInterpolation(void);
	~ScatteredDataInterpolation(void);

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);
	
	/// creates an image from scattered data points (ps) using attribute(channel,componentNumber)
	/// expects an attribute 'param_pos' (2f) in pointset
	virtual TemplatedImage<float> * createImage( card32 imageSize, PointSet * ps, std::string channel, card32 componentNumber) = 0;


};

}

#endif