//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "SceneObjectIterator.h"
//---------------------------------------------------------------------------
#include "LinearAlgebra.inline.h"
#include "BoundingBox.inline.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



MetaClass* SceneObjectIterator::SceneObjectIteratorMetaClass = NULL;

const MetaClass* SceneObjectIterator::getInstanceClass() const {
   return getClass();
}

Object* SceneObjectIterator::newInstance() {
   return new SceneObjectIterator;
}

const MetaClass* SceneObjectIterator::getClass() {
   if (SceneObjectIteratorMetaClass==NULL) {
      SceneObjectIteratorMetaClass = new MetaClass("SceneObjectIterator", "no description.",
                                  newInstance, sizeof(SceneObjectIterator));
   }
   return SceneObjectIteratorMetaClass;
}

void SceneObjectIterator::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   SceneObjectIteratorMetaClass->copyParentProperties();
}

void SceneObjectIterator::shutdown() {
   delete SceneObjectIteratorMetaClass;
}

SceneObjectIterator::SceneObjectIterator()// : objectMutex(QMutex::Recursive)
{
	objectMutex = NULL;
}

SceneObjectIterator::~SceneObjectIterator()
{
	delete objectMutex;
}

void SceneObjectIterator::lockObject()
{
	if( !objectMutex)
		objectMutex = new QMutex(QMutex::Recursive);
	objectMutex->lock();
}

void SceneObjectIterator::unlockObject()
{
	objectMutex->unlock();
}


// ----

