//---------------------------------------------------------------------------
#ifndef StandardChannelsH
#define StandardChannelsH
//---------------------------------------------------------------------------
#include "x3geometry.h"
//---------------------------------------------------------------------------
#include "VertexDescriptor.h"
//---------------------------------------------------------------------------

namespace X4 {

//
// --- this module defines a set of standard attribute channels used in most of the rest of the system
//


// --- vertex attributes
const	std::string VERTEX_CHANNEL_NAME_POSITION              = "position";  // (3f)

const std::string VERTEX_CHANNEL_NAME_FLAGS                 = "flags";		 // (1i)
const std::string VERTEX_CHANNEL_NAME_NORMAL                = "normal";	 // (3f)
const std::string VERTEX_CHANNEL_NAME_COLOR                 = "color";     // (3f)
const std::string VERTEX_CHANNEL_NAME_INTENSITY             = "intensity"; // (1f)

const std::string VERTEX_CHANNEL_NAME_TANGENT_U             = "tangent_u"; // (3f)
const std::string VERTEX_CHANNEL_NAME_TANGENT_V             = "tangent_v"; // (3f)

const std::string VERTEX_CHANNEL_NAME_SAMPLESPACING         = "sampleSpacing"; // (1f)
const std::string VERTEX_CHANNEL_NAME_COVARIANCE            = "covariance";    // (6f)
const std::string VERTEX_CHANNEL_NAME_LOCALMODELUNCERTAINTY = "localModelUncertainty"; // (1f)

const std::string VERTEX_CHANNEL_NAME_REFERENCE_POSITION	 = "ref_position"; // (3f)

extern X3GEOMETRY_API const VAD VERTEX_CHANNEL_VAD_POSITION;
extern X3GEOMETRY_API const VAD VERTEX_CHANNEL_VAD_FLAGS;
extern X3GEOMETRY_API const VAD VERTEX_CHANNEL_VAD_NORMAL;
extern X3GEOMETRY_API const VAD VERTEX_CHANNEL_VAD_COLOR;
extern X3GEOMETRY_API const VAD VERTEX_CHANNEL_VAD_INTENSITY;
extern X3GEOMETRY_API const VAD VERTEX_CHANNEL_VAD_TANGENT_U;
extern X3GEOMETRY_API const VAD VERTEX_CHANNEL_VAD_TANGENT_V;
extern X3GEOMETRY_API const VAD VERTEX_CHANNEL_VAD_SAMPLESPACING;
extern X3GEOMETRY_API const VAD VERTEX_CHANNEL_VAD_COVARIANCE;
extern X3GEOMETRY_API const VAD VERTEX_CHANNEL_VAD_LOCALMODELUNCERTAINTY;
extern X3GEOMETRY_API const VAD VERTEX_CHANNEL_VAD_REFERENCE_POSITION;


// --- triangle face attributes
const std::string TRIANGLE_CHANNEL_NAME_INDEX = "index";   // (3i)

extern X3GEOMETRY_API const VAD TRIANGLE_CHANNEL_VAD_INDEX;


// --- topology graph edge attributes
const std::string TOPGRAPH_CHANNEL_NAME_VINDEX = "vindex"; // (2i)
const std::string TOPGRAPH_CHANNEL_NAME_COLOR  = "color";  // (4f)

extern X3GEOMETRY_API const VAD TOPGRAPH_CHANNEL_VAD_VINDEX;
extern X3GEOMETRY_API const VAD TOPGRAPH_CHANNEL_VAD_COLOR;


// --- some simple templates
extern X3GEOMETRY_API const VertexDescriptor POSITION_FLAGS_VDESCR;
extern X3GEOMETRY_API const VertexDescriptor POSITION_NORMAL_FLAGS_VDESCR;
extern X3GEOMETRY_API const VertexDescriptor POSITION_NORMAL_COLOR_FLAGS_VDESCR;

extern X3GEOMETRY_API const VertexDescriptor INDEX_TRI_DESCR;

extern X3GEOMETRY_API const VertexDescriptor VINDEX_TOPEDGE_DESCR;
extern X3GEOMETRY_API const VertexDescriptor VINDEX_COLOR_TOPEDGE_DESCR;


}

#endif