//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "TopologyGraphTools.h"
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------


X3GEOMETRY_API std::vector<set<int> > X4::getTopologyGraphComponents( InCorePCTopologyGraph* tg ) {
	std::vector<std::vector<int> > ret;

	std::vector<bool> done;
//	VertexArray vert(pc);

	done.resize(tg->getNumVertices(), false);
	for( int i1 = 0; i1 < (int)done.size(); ++ i1 ) {
		if( done[i1] )
			continue;

		ret.push_back( std::vector<int>() );
		std::vector<int> todo;
		todo.push_back(i1);
		while( !todo.empty() ) {
			int cur = todo.back();
			todo.pop_back();

			if( done[cur] ) 
				continue;

			ret.back().push_back(cur);
			done[cur] = true;

			for( PointCloudTopologyGraph::VertexIndex i3 = 0; i3 < tg->getNumAdjacentVertices(cur); ++ i3 ) {
				int other = tg->getAdjacentVertex(cur, i3);
				if( done[other] ) 
					continue;

				todo.push_back(other);
			}
		}
	}

	std::vector<set<int> > ret2;
	for( int i1 = 0; i1 < (int)ret.size(); ++ i1 )
		ret2.push_back( set<int>( ret[i1].begin(), ret[i1].end() ) );

	return ret2;
}

