#ifndef VertexDescriptorEditorWidgetH 
#define VertexDescriptorEditorWidgetH
//---------------------------------------------------------------------------
#include "x3geometry.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include <vector>
#include <string>
#include "X4Types.h"
#include "x3geometry/VertexDescriptorEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace X4
{

class VertexDescriptor;

class X3GEOMETRY_API VertexDescriptorEditorWidget : public QWidget
{
	Q_OBJECT

private:
	///used to access buttons, etc. from QtDesigner
	Ui_VertexDescriptorEditorForm ui;

	VertexDescriptor	*	m_VertexDescriptor;

   static const card8 FORMAT_FLOAT32 = 0;
   static const card8 FORMAT_CARD8   = 1;
   static const card8 FORMAT_INT32   = 2;
   static const card8 FORMAT_CARD32 = 3;
   struct VAttrib
   {
       std::string  name;
       card8   numComp;
       card8   dataFormat;
   };
   std::vector<VAttrib>   m_InternalVD;

	/// InvertalVD -> VertexDescriptor + ListView
	void internalApply();
   /// add attrib to InternalVD + ListView
	void internalAdd( const std::string &name, card8 numComp, card8 dataFormat );
	/// delete attrib from InternalVD
	void internalDelete( card32 index);

	void addListItem( card32 index, const std::string &name, card8 numComp, card8 dataFormat );


public:
	VertexDescriptorEditorWidget(QWidget * parent = NULL, Qt::WindowFlags f=0);
	~VertexDescriptorEditorWidget(void);

	void setup( VertexDescriptor * obj );

	/// update editor content with object data
	void updateEditor();


public slots:
	void on_BTAdd_clicked();
	void on_BTDelete_clicked();
	void on_BTUp_clicked();
	void on_BTDown_clicked();


};

MAKE_CLASS_EDITOR( X3GEOMETRY_API , VertexDescriptor )


}

#endif

