#include "StdAfx.h"

#include "x3geometry.h"

#include <TaggingMacros.h>
#include <X4Types.h>

#include "x3geometry_rcc.h"

#include "GenericSwapAllOutOfCorePointCloud.h"
#include "VertexDescriptor.h"
#include "VertexDescriptorEditorWidget.h"
#include "DebugOutput.h"
#include "ImageDisplayer.h"
#include "ModuleEvents.h"

using namespace X4;

#include "x3geometry.init.cpp"


static void geometryPreShutdownEvent() {
	GenericSwapAllOutOfCorePointCloud::finalShutdownCache();
}


BEGIN_INIT_MODULE
   ModuleEvents::addPreShutdownEvent(&geometryPreShutdownEvent);
	qInitResources();
	doutput_talkToPointCloudProject = new DOutput_TalkToPointCloudProject_Impl;
	((GUIDescriptor * )VertexDescriptor::getClass()->getGUIDescriptor())->addClassEditor(
		VertexDescriptorEditor::getClass(), true);
END_INIT_MODULE 

BEGIN_SHUTDOWN_MODULE
END_SHUTDOWN_MODULE 

BEGIN_X4_LOADABLE_MODULE(x3geometry)
	#include "x3geometry.tags.h"
END_X4_LOADABLE_MODULE(x3geometry)


