SET_MODULE_TYPE_LOADABLE_MODULE

ADD_DEPENDENCY("opencv")
ADD_DEPENDENCY("x4basics")
ADD_DEPENDENCY("x4core")
ADD_DEPENDENCY("x4interface")
ADD_DEPENDENCY("x4math")
ADD_DEPENDENCY("x4miscFoundation")
ADD_DEPENDENCY("x4tools")
ADD_DEPENDENCY("x4modules")

ADD_AUTHOR("Michael Wand")
ADD_AUTHOR("Martin Bokeloh")
ADD_AUTHOR("Art Tevs")
ADD_AUTHOR("Alexander Berner")
ADD_AUTHOR("Mark Hoffman")
ADD_AUTHOR("Benjamin Maier")
ADD_AUTHOR("Arno Fleck")

ADD_INSTITUITION("WSI/GRIS, Tbingen University")
ADD_INSTITUITION("MPI Informatik Saarbrcken")

ADD_LICENSE("BSD")

// an icon for this module
ADD_ICON(":/images_x3geometry/images/x3geometry.png")

// Add classes here: format is "class", "baseClass". class.h is included
// ADD_CLASS("SomeNewClass", "Persistent")

// Alternative: specify file to include for this declaration
// ADD_CLASS_INC("SomeNewClass", "Persistent", "AHeaderWithManyClasses.h")


// ---------------------------------------------------------------------------------
//					Class Registration ( no Editors ! )
// ---------------------------------------------------------------------------------
ADD_CLASS_INC("PointCloudIterator", "Object", "PointCloudIterators.h")
ADD_CLASS("PointSetIterator", "PointCloudIterator")
ADD_CLASS_INC("BasicParametricInCorePointCloudIterator", "PointSetIterator", "ParametricInCorePointCloud.h")
ADD_CLASS("PointSet", "Persistent")
ADD_CLASS("VertexDescriptor", "Persistent")
ADD_CLASS("RegularVolume", "Persistent")
ADD_CLASS("SceneObject", "Persistent")
ADD_CLASS("PointCloud", "SceneObject")
ADD_CLASS("ParametricInCorePointCloud", "PointCloud")
ADD_CLASS("UnstructuredInCorePointCloud", "PointCloud")
ADD_CLASS("UnstructuredInCoreTriangleMesh", "UnstructuredInCorePointCloud")
ADD_CLASS("VolumeObject", "PointCloud")
ADD_CLASS("InCoreVolume", "VolumeObject")
ADD_CLASS("RegularInCoreVolume", "InCoreVolume")
ADD_CLASS("MultiResolutionInCoreVolume", "InCoreVolume")
ADD_CLASS("GenericSwapAllOutOfCorePointCloud", "PointCloud")
ADD_CLASS("MultiScalePointCloud", "PointCloud")
ADD_CLASS("MultiScaleInCorePointCloud", "MultiScalePointCloud")
ADD_CLASS_INC("MultiScalePCParams", "Persistent", "MultiScalePointCloudParameters.h")
ADD_CLASS("PointCloudSmoother", "Persistent")
ADD_CLASS("GaussianPointCloudSmoother", "Persistent")
ADD_CLASS("PointCloudTopologyGraph", "Persistent")
ADD_CLASS("InCorePCTopologyGraph", "PointCloudTopologyGraph")
ADD_CLASS("TopologyAttachment", "AttachedData")
ADD_CLASS("AttachedIndexedOctree", "AttachedData")
ADD_CLASS("ScatteredDataInterpolation", "Persistent")
ADD_CLASS("SplatPullPushInterpolation", "ScatteredDataInterpolation")
ADD_CLASS_INC("ManifoldPoint", "Persistent", "DiscreteManifold.h")
ADD_CLASS_INC("DiscreteManifoldPoint", "ManifoldPoint", "DiscreteManifold.h")
ADD_CLASS_INC("ManifoldPointList", "AttachedData", "DiscreteManifold.h")
ADD_CLASS("Manifold", "SceneObject")
ADD_CLASS("DiscreteManifold", "Manifold")


