//---------------------------------------------------------------------------
#include "stdafx.h"
//---------------------------------------------------------------------------
#include "GLEventDisplayer.h"
//---------------------------------------------------------------------------
#include "GLEventDisplayerWidget.h"
#include "DebugOutput.h"
#include "PointSet.h"
#include "PointSet.inline.h"
#include "VertexDescriptor.h"
#include "Random.h"
#include "GLHelper.h"
#include "RegularVolume.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



IMPLEMENT_X4_CLASS( GLEventDisplayer ,0)
{
	BEGIN_CLASS_INIT( GLEventDisplayer );
}																		   

IMPLEMENT_X4_ABSTRACT_CLASS(GLEventObject, 0) 
{
}


// ----


GLEventDisplayer::GLEventDisplayer()
{
	widget = NULL;
}

QWidget *GLEventDisplayer::createSpecialWidget(QWidget *parent) {
	widget = new GLEventDisplayerWidget(parent);
	return widget;
}

void GLEventDisplayer::displayEvent(const EventDisplayerEvent *e, const char *logfile) {
	if (widget == NULL) return;
   {
      const SetNewGLEventObject *sne = dynamic_cast<const SetNewGLEventObject*>(e);
      if (sne != NULL) {
			widget->setGLEventObject(sne->glevo, sne->updateDataOnly);
		}
	}
	
}

GLEventDisplayer::~GLEventDisplayer() {}



#include "GLEventDisplayer_moc.h"
