//---------------------------------------------------------------------------
#include "stdafx.h"

//---------------------------------------------------------------------------
#include "GLObject.h"
//---------------------------------------------------------------------------
#include "GLContext.h"
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



GLObject::GLObject( GLContext * context )
{
   m_Context = context;
   m_ContextPosition = context->addObject( this );
}

GLObject::~GLObject()
{
   if( m_Context )
      m_Context->removeObject( m_ContextPosition );
}

GLContext * GLObject::getRootContext()
{
   return m_Context->getRootContext();
}

bool GLObject::isCompatible( GLContext * context )
{
   if( m_Context == NULL )
      return false;

   return m_Context->isCompatible( context );
}

void GLObject::callOnDeleteContext()
{
   onDeleteContext();
   m_Context = NULL;
}


 
