//---------------------------------------------------------------------------
#ifndef GLPointCloudDisplayerH
#define GLPointCloudDisplayerH
//---------------------------------------------------------------------------
#include "x3openGL.h"
//---------------------------------------------------------------------------
#include "GLEventDisplayer.h"
#include "Object.h"
//---------------------------------------------------------------------------
#include "x3openGL/GLPointCloudDisplayerConfig_ui.h"
//---------------------------------------------------------------------------


namespace X4 {

class GLPointCloudDisplayerConfig;
class PointSet;

class X3OPENGL_API GLPointCloudDisplayer : public GLEventObject {
	X4_CLASS(GLPointCloudDisplayer)
 private:
	PointSet *ps;
	bool showCoords;
	
 public:
	/// ownership transfered to the event object
	GLPointCloudDisplayer(PointSet *ps = NULL);
	
	PointSet *getPointSet() {return ps;}

	virtual BoundingBox3f getBoundingBox();
	virtual void drawGL(QGLWidget *widget, Camera &cam);
	virtual GLEventConfiguration *createConfigWindow(QWidget *parent);
	virtual void updateData(GLEventObject *other);

	virtual ~GLPointCloudDisplayer();
 friend class GLPointCloudDisplayerConfig;
};

class X3OPENGL_API GLPointCloudDisplayerConfig : public GLEventConfiguration {
	Q_OBJECT
 private:
	Ui_GLPointCloudDisplayerConfig ui;
 private slots:
   void on_cbShowCoords_stateChanged(int);
 public:
	GLPointCloudDisplayerConfig(QWidget *parent, GLEventObject *obj);
};


}

#endif
