#ifndef CurvatureDirectionsMaterialH
#define CurvatureDirectionsMaterialH
//---------------------------------------------------------------------------
#include "x3rendering.h"
//---------------------------------------------------------------------------
#include "DirectionsMaterial.h"
//---------------------------------------------------------------------------

namespace X4
{

/**
	plz comment your class
*/
class X3RENDERING_API CurvatureDirectionsMaterial : public DirectionsMaterial
{
	X4_CLASS( CurvatureDirectionsMaterial )

private:
	std::string curv2Channel;
	Vector4f positiveColor;
	Vector4f negativeColor;
	float32  lineWidth;
	bool rotateAroundNormal;
	float32 maxLen;
	
public:
	CurvatureDirectionsMaterial(void);
	~CurvatureDirectionsMaterial(void);

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

   virtual void draw(Scene *scene, SceneGraphState *state, SceneObject *obj,
	   SceneObjectIterator *iter, GLContext *context, MemoryManager * mm = NULL,
	   const int32 includeFlags = 0, const int32 excludeFlags = PF_FLAG_INVALID );

};

}

#endif