#ifndef ECPhotonTracerH
#define ECPhotonTracerH
//---------------------------------------------------------------------------
#include "x3rendering.h"
//---------------------------------------------------------------------------
#include "Persistent.h"
//---------------------------------------------------------------------------

namespace X4
{
/**
make an educated guess :-)
*/
class X3RENDERING_API ECPhoton
{
public:
	Vector3f	m_Position;
	Vector3f	m_SurfaceDir;
	Vector3f	m_Color;
};

	
class UnstructuredInCorePointCloud;
class StandardSceneGraphIterator;

/**
	computes photon distribution for a given point cloud
*/
class X3RENDERING_API ECPhotonTracer : public Persistent
{
	X4_CLASS( ECPhotonTracer )

private:

	UnstructuredInCorePointCloud	*	m_UPC;
	std::vector<ECPhoton>	m_InitialPhotons;

	Vector3f diceBounceDirection( const Vector3f &surfaceNormal) const;
	Vector3f getUniformDistributedRandomDirection(const Vector3f &surfaceNormal) const;

public:
	ECPhotonTracer(void);
	~ECPhotonTracer(void);

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

   void setup(UnstructuredInCorePointCloud * upc);

   void addWhiteHemisphere( const Vector3f &upVector, mpcard numSamples);
   void addInitialPhoton( const ECPhoton &p ) {m_InitialPhotons.push_back(p);}
   void addSelectedPointsAsLightSource(StandardSceneGraphIterator * sceneIt, mpcard numSamples, float sampleSize);

	std::vector<ECPhoton>	compute();

};

}

#endif