//---------------------------------------------------------------------------
#ifndef GLSimpleVolumeMaterialH
#define GLSimpleVolumeMaterialH
//---------------------------------------------------------------------------
#include "x3rendering.h"
//---------------------------------------------------------------------------
#include "GLMaterial.h"
#include "AttachedData.h"
//---------------------------------------------------------------------------

namespace X4 {

class GLVolumeRenderer2DSlices;
class Tex2dVolumeRenderer;


///
///   simple volume renderer material
///
class X3RENDERING_API GLSimpleVolumeMaterial : public GLMaterial {
	X4_CLASS( GLSimpleVolumeMaterial )
 private:
   GLVolumeRenderer2DSlices *renderer;
   
 public:
	GLSimpleVolumeMaterial();

	virtual void assign(const Object* obj, X4CopyContext *context = NULL);

   virtual void draw( Scene *scene, SceneGraphState *state, SceneObject *obj,
      SceneObjectIterator *iter, GLContext *context, MemoryManager *mm = NULL,
      const int32 includeFlags = 0, const int32 excludeFlags = PF_FLAG_INVALID );

   ~GLSimpleVolumeMaterial();
};


class TextureStackAttachment : public AttachedData {
   X4_CLASS(TextureStackAttachment)
 public:
   Tex2dVolumeRenderer *texStack;
   float32 minVal;
   float32 maxVal;
   std::string channel;
};

}

#endif