#include "StdAfx.h"
//---------------------------------------------------------------------------
#include "GLVolumeRaycastMaterialEditorWidget.h"
//---------------------------------------------------------------------------
#include "GLVolumeRaycastMaterial.h"
//---------------------------------------------------------------------------
#include "ShaderEditorWidget.h"
#include "VertexDescriptorEditorWidget.h"
#include "InterpFunctionTextureAttachment.h"
#include "InterpFunctionTextureAttachmentRGB.h"
#include "Shader.h"
//---------------------------------------------------------------------------
using namespace X4;

IMPLEMENT_CLASS_EDITOR( GLVolumeRaycastMaterial )

GLVolumeRaycastMaterialEditorWidget::GLVolumeRaycastMaterialEditorWidget(QWidget * parent, Qt::WindowFlags f)
:QWidget(parent,f)
{
	//call ui.setupUi(this) to set up the layout from QtDesigner
	ui.setupUi(this);
	//Example: easy access to QtDesigner buttons, etc. by ui object
	//QWidget::connect(ui.loadButton,SIGNAL(clicked()),this,SLOT(sltLoadFile()));

	m_ShaderEditorPS = NULL;
	m_VertexDescriptorEditor = NULL;
	m_RaycastMaterial = NULL;

	QVBoxLayout* tl=new QVBoxLayout;
	tl->setMargin(0);
	tl->setSpacing(0);
	ui.framePixelShader->setLayout(tl);

	QVBoxLayout* t2=new QVBoxLayout;
	t2->setMargin(0);
	t2->setSpacing(0);
	ui.frameTransferAlpha->setLayout(t2);

	QVBoxLayout* t3=new QVBoxLayout;
	t3->setMargin(0);
	t3->setSpacing(0);
	ui.frameTransferColor->setLayout(t3);
}

GLVolumeRaycastMaterialEditorWidget::~GLVolumeRaycastMaterialEditorWidget(void)
{
	delete m_ShaderEditorPS;
	delete m_VertexDescriptorEditor;
	delete m_TransferFunctionAlphaEditor;
	delete m_TransferFunctionColorEditor;
}

void GLVolumeRaycastMaterialEditorWidget::setup( GLVolumeRaycastMaterial * obj )
{
	m_RaycastMaterial = obj;


	m_VertexDescriptorEditor = new VertexDescriptorEditor;
	m_VertexDescriptorEditorWidget = (VertexDescriptorEditorWidget *)m_VertexDescriptorEditor->makeEditor( this,
		 m_RaycastMaterial->m_ElementDescriptor);
	m_VertexDescriptorEditorWidget->setParent(ui.frameED);

	m_ShaderEditorPS = new ShaderEditor;
	m_ShaderEditorWidgetPS = (ShaderEditorWidget *)m_ShaderEditorPS->makeEditor( ui.framePixelShader, m_RaycastMaterial->m_PixelShader );
	m_ShaderEditorWidgetPS->setObjectName("PS_Memo");
	//m_ShaderEditorWidgetPS->setTestContext( m_TestContext );
	ui.framePixelShader->layout()->addWidget(m_ShaderEditorWidgetPS);

	m_TransferFunctionAlphaEditor = createDefaultEditor(m_RaycastMaterial->m_TransferFunctionAlpha,ui.frameTransferAlpha);
	m_TransferFunctionColorEditor = createDefaultEditor(m_RaycastMaterial->m_TransferFunctionColor,ui.frameTransferColor);


	updateEditor();
}

void GLVolumeRaycastMaterialEditorWidget::updateEditor()
{
}

#include "GLVolumeRaycastMaterialEditorWidget_moc.h"

ClassEditor * X4::GLVolumeRaycastMaterialEditorWidget::createDefaultEditor( Object * obj, QWidget * widget )
{
	const MetaClass * mc = obj->getInstanceClass();
	ClassEditor * ret = (ClassEditor *)mc->getGUIDescriptor()->getDefaultClassEditor()->newInstance();
	QWidget * w = ret->makeEditor(widget,obj);
	widget->layout()->addWidget(w);
	return ret;
}