#ifndef GLVolumeRaycastMaterialEditorWidgetH 
#define GLVolumeRaycastMaterialEditorWidgetH
//---------------------------------------------------------------------------
#include "x3rendering.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "GLVolumeRaycastMaterialEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace X4
{

class GLVolumeRaycastMaterial;
class Shader;
class ShaderEditor;
class ShaderEditorWidget;
class VertexDescriptorEditor;
class VertexDescriptorEditorWidget;
class GLContext;
class ClassEditor;

class X3RENDERING_API GLVolumeRaycastMaterialEditorWidget : public QWidget
{
	Q_OBJECT

private:

	GLVolumeRaycastMaterial	*	m_RaycastMaterial;

	ShaderEditor				* m_ShaderEditorPS;
	VertexDescriptorEditor	* m_VertexDescriptorEditor;
	ShaderEditorWidget		* m_ShaderEditorWidgetPS;
	VertexDescriptorEditorWidget * m_VertexDescriptorEditorWidget;

	ClassEditor					* m_TransferFunctionAlphaEditor;
	ClassEditor					* m_TransferFunctionColorEditor;

	///used to access buttons, etc. from QtDesigner
	Ui_GLVolumeRaycastMaterialEditorForm ui;

	ClassEditor *  createDefaultEditor( Object * obj, QWidget * widget );

public:
	GLVolumeRaycastMaterialEditorWidget(QWidget * parent = NULL, Qt::WindowFlags f=0);
	~GLVolumeRaycastMaterialEditorWidget(void);

	void setup( GLVolumeRaycastMaterial * obj );

	/// update editor content with object data
	void updateEditor();


};

MAKE_CLASS_EDITOR( X3RENDERING_API , GLVolumeRaycastMaterial )


}

#endif