#ifndef InterpFunctionTextureAttachmentRGBH
#define InterpFunctionTextureAttachmentRGBH
//---------------------------------------------------------------------------
#include "x3rendering.h"
//---------------------------------------------------------------------------
#include "MaterialAttachment.h"
//---------------------------------------------------------------------------

namespace X4
{
class InterpFunctionTextureAttachment;
class InterpFunctionTextureAttachmentRGBEditorWidget;

/**
	combines three interpolation function into a rgb texture
*/
class X3RENDERING_API InterpFunctionTextureAttachmentRGB : public TextureAttachment
{
	X4_CLASS( InterpFunctionTextureAttachmentRGB )

private:

	InterpFunctionTextureAttachment * m_Functions[3];
	card32		m_TextureResolution;

	friend		InterpFunctionTextureAttachmentRGBEditorWidget;


public:
	InterpFunctionTextureAttachmentRGB(void);
	~InterpFunctionTextureAttachmentRGB(void);

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

   virtual card32 getTextureType() const  {return TYPE_2D; }
   virtual GLTexture * createGLTexture(GLContext * context);

   std::vector<card32> createImage( card32 dimX, card32 dimY );

   void setHistogram( const std::vector<float> &histogram);

	bool isDirty() const;
	void setDirty(bool b);


};

}

#endif