//---------------------------------------------------------------------------
#ifndef LCFiltersH
#define LCFiltersH
//---------------------------------------------------------------------------
#include "x3rendering.h"
//---------------------------------------------------------------------------
#include "LCTraversal.h"
//---------------------------------------------------------------------------

namespace X4 {



// ---- lc-filters

class X3RENDERING_API LCProjectiveClassification : public LCNodeFilter {
 public:
   virtual void filterNode(card32 &currentClassification, LCState *state, SceneObjectIterator *node);
};

class X3RENDERING_API LCViewFrustumCulling : public LCNodeFilter {
 public:
   virtual void filterNode(card32 &currentClassification, LCState *state, SceneObjectIterator *node);
};

class X3RENDERING_API LCNonPresentNodesCulling : public LCNodeFilter {
 public:
   virtual void filterNode(card32 &currentClassification, LCState *state, SceneObjectIterator *node);
};


// ---- lc-processors

class X3RENDERING_API LCDrawBoxesNodeProcessor : public LCNodeProcessor {
 public:
   virtual void processNode(LCState *state, SceneObjectIterator *node);
};

class X3RENDERING_API LCDrawInnerBoxesNodeProcessor : public LCNodeProcessor {
 public:
   virtual void processNode(LCState *state, SceneObjectIterator *node);
};


/*class X3RENDERING_API LCSimpleDrawPointsNodeProcessor : public LCNodeProcessor {
 public:
   virtual void processNode(LCState *state, SceneObjectIterator *node);
};*/


class X3RENDERING_API LCDrawPointsMaterial : public LCNodeProcessor {
 public:
   virtual void processNode(LCState *state, SceneObjectIterator *node);
};

class X3RENDERING_API LCDrawPointsMaterialNoStateChange : public LCNodeProcessor {
 public:
   virtual void processNode(LCState *state, SceneObjectIterator *node);
};

class X3RENDERING_API LCDrawCloudSelection : public LCNodeProcessor {
 public:
   virtual void processNode(LCState *state, SceneObjectIterator *node);
};

class X3RENDERING_API LCDrawPointSelection : public LCNodeProcessor {
 public:
   virtual void processNode(LCState *state, SceneObjectIterator *node);
};

class X3RENDERING_API LCStatisticsOutput : public LCStateProcessor {
 public:
   virtual void processState(LCState *state);
};


}

#endif
