//---------------------------------------------------------------------------
#include "stdafx.h"
 
//---------------------------------------------------------------------------
#include "MaterialParameter.h"
//---------------------------------------------------------------------------
#include "NumericalClassProperty.h"

#include "FixedArrayClassProperty.h"
#include "StringClassProperty.h"
#include "BooleanClassProperty.h"
#include "ObjectClassProperty.h"
#include "AttachedData.h"
#include "GLContext.h"
#include "GLShader.h"
#include "GLTexture.h"
#include "GLMaterial.h"
#include "GLShaderMaterial.h"
#include "GLAttachments.h"
#include "Scene.h"
#include "SceneObject.h"
#include "SceneObjectIterator.h"
#include "MaterialAttachment.h"
#include "MemoryManager.h"
#include "MaterialAttachment.h"
#include "RenderTextureAttachment.h"
#include "SceneGraphState.h"
#include "DebugOutput.h"
#ifndef _DEBUG
#include "LinearAlgebra.inline.h"
#endif
//---------------------------------------------------------------------------
 
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



MetaClass* MaterialParameter::MaterialParameterMetaClass = NULL;

const MetaClass* MaterialParameter::getInstanceClass() const {
   return getClass();
}

const MetaClass* MaterialParameter::getClass() {
   if (MaterialParameterMetaClass==NULL) {
      MaterialParameterMetaClass = new MetaClass("MaterialParameter", "no description.",
                                  NULL, sizeof(MaterialParameter));
   }
   return MaterialParameterMetaClass;
}

void MaterialParameter::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   MaterialParameterMetaClass->copyParentProperties();
	BEGIN_CLASS_INIT(MaterialParameter)
	ADD_STRING_PROP(m_Name,0)
	ADD_BOOLEAN_PROP(m_UseGlobalFirst,0)
	ADD_BOOLEAN_PROP(m_UseDefault,0)
		
}

void MaterialParameter::shutdown() {
   delete MaterialParameterMetaClass;
}


// ----

MetaClass* MPMatrix4x4::MPMatrix4x4MetaClass = NULL;

const MetaClass* MPMatrix4x4::getInstanceClass() const {
   return getClass();
}

Object* MPMatrix4x4::newInstance() {
   return new MPMatrix4x4;
}

const MetaClass* MPMatrix4x4::getClass() {
   if (MPMatrix4x4MetaClass==NULL) {
      MPMatrix4x4MetaClass = new MetaClass("MPMatrix4x4", "no description.",
                                  newInstance, sizeof(MPMatrix4x4));
   }
   return MPMatrix4x4MetaClass;
}

void MPMatrix4x4::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   MPMatrix4x4MetaClass->copyParentProperties();
	BEGIN_CLASS_INIT(MPMatrix4x4)
	ADD_CARD32_PROP(m_Index,0)
	ADD_FLOAT32_FIXED_ARRAY_PROP(m_DefaultMatrix,0 , 16, 4)
}

void MPMatrix4x4::shutdown() {
   delete MPMatrix4x4MetaClass;
}


// ----



MetaClass* MPVector4::MPVector4MetaClass = NULL;

const MetaClass* MPVector4::getInstanceClass() const {
   return getClass();
}

Object* MPVector4::newInstance() {
   return new MPVector4;
}

const MetaClass* MPVector4::getClass() {
   if (MPVector4MetaClass==NULL) {
      MPVector4MetaClass = new MetaClass("MPVector4", "no description.",
                                  newInstance, sizeof(MPVector4));
   }
   return MPVector4MetaClass;
}

void MPVector4::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   MPVector4MetaClass->copyParentProperties();
	BEGIN_CLASS_INIT(MPVector4)
	ADD_CARD32_PROP(m_Index,0)
	ADD_FLOAT32_FIXED_ARRAY_PROP(m_DefaultVector,0 , 4, 4)
   ADD_BOOLEAN_PROP(m_ClampMin ,0)
	ADD_FLOAT32_FIXED_ARRAY_PROP(m_MinVector ,0 , 4, 4)
   ADD_BOOLEAN_PROP(m_ClampMax ,0)
	ADD_FLOAT32_FIXED_ARRAY_PROP(m_MaxVector ,0 , 4, 4)
}

void MPVector4::shutdown() {
   delete MPVector4MetaClass;
}


// ----

MetaClass* MPTexture::MPTextureMetaClass = NULL;

const MetaClass* MPTexture::getInstanceClass() const {
   return getClass();
}

Object* MPTexture::newInstance() {
   return new MPTexture;
}

const MetaClass* MPTexture::getClass() {
   if (MPTextureMetaClass==NULL) {
      MPTextureMetaClass = new MetaClass("MPTexture", "no description.",
                                  newInstance, sizeof(MPTexture));
   }
   return MPTextureMetaClass;
}

void MPTexture::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 1);
   MPTextureMetaClass->copyParentProperties();
	BEGIN_CLASS_INIT(MPTexture)
	ADD_CARD32_PROP(m_TextureStage,0)
	ADD_STRING_PROP(m_DefaultTextureName,0)
	ADD_OBJECT_PROP(m_DefaultTexture,1, TextureAttachment::getClass(), true );

}

void MPTexture::shutdown() {
   delete MPTextureMetaClass;
}


// ----

MetaClass* MPSingleFloat::MPSingleFloatMetaClass = NULL;

const MetaClass* MPSingleFloat::getInstanceClass() const {
   return getClass();
}

Object* MPSingleFloat::newInstance() {
   return new MPSingleFloat;
}

const MetaClass* MPSingleFloat::getClass() {
   if (MPSingleFloatMetaClass==NULL) {
      MPSingleFloatMetaClass = new MetaClass("MPSingleFloat", "no description.",
                                  newInstance, sizeof(MPSingleFloat));
   }
   return MPSingleFloatMetaClass;
}

void MPSingleFloat::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION + 0);
   MPSingleFloatMetaClass->copyParentProperties();
	BEGIN_CLASS_INIT(MPSingleFloat)
	ADD_FLOAT32_PROP(m_Minimum,0)
	ADD_FLOAT32_PROP(m_Maximum,0)
	ADD_FLOAT32_PROP(m_Interpolator,0)

}

void MPSingleFloat::shutdown() {
   delete MPSingleFloatMetaClass;
}

IMPLEMENT_X4_CLASS(MPMieRayleighParameter,0)
{
	BEGIN_CLASS_INIT(MPMieRayleighParameter);

	ADD_FLOAT32_PROP(m_HG,0);
	ADD_FLOAT32_PROP(m_Inscattering,0);
	ADD_FLOAT32_PROP(m_Rayleigh,0);
	ADD_FLOAT32_PROP(m_Mie,0);
	ADD_FLOAT32_PROP(m_SunPhi,0);
	ADD_FLOAT32_PROP(m_SunTheta,0);
}


// ----

AttachedData * MaterialParameter::getData( GLMaterial * mat, Scene * scene, SceneObject * obj,
      SecondaryDataStructureIterator * iter )
{
   if( m_Name.length() == 0 )
      return NULL;

   AttachedData * ret = NULL;
   if( !m_UseGlobalFirst )
   {
      if( iter ) {
			AttachedDataContainer *attachments = iter->lockAttachments();
         ret = attachments->getData( m_Name );
         // todo: not ooc safe!
         iter->unlockAttachments();
      }
      if( ret )
         return ret;

      if( obj )
         ret = obj->getAttachments()->getData( m_Name );
      if( ret )
         return ret;

      if( scene )
         ret = scene->getAttachments()->getData( m_Name );

   }
   else
   {
      if( scene )
         ret = scene->getAttachments()->getData( m_Name );
      if( ret )
         return ret;

      if( obj )
         ret = obj->getAttachments()->getData( m_Name );
      if( ret )
         return ret;

      if( iter ) {
			AttachedDataContainer *attachments = iter->lockAttachments();
         ret = attachments->getData( m_Name );
         // todo: not ooc safe!
         iter->unlockAttachments();
      }
   }

   forget(mat);
   return ret;
}

void MaterialParameter::assign(const Object* obj, X4CopyContext *context)
{
   MaterialParameter * p = (MaterialParameter*)obj;
   m_Name = p->m_Name;
   m_UseGlobalFirst = p->m_UseGlobalFirst;
   m_UseDefault = p->m_UseDefault;
   forget(context);
}

void MPMatrix4x4::assign(const Object* obj, X4CopyContext *context )
{
   MaterialParameter::assign( obj, context );

   MPMatrix4x4 * p = (MPMatrix4x4*)obj;
   memcpy( m_DefaultMatrix, p->m_DefaultMatrix, sizeof(float32)*4*4 );
   m_Index = p->m_Index;
}

void MPMatrix4x4::set( GLMaterial * mat, Scene * scene, SceneObject * obj,
      SceneObjectIterator * iter, GLContext * context, MemoryManager * mm )
{
   GLShaderMaterial * shMat = dynamic_cast<GLShaderMaterial*>(mat);
   x4Assert( shMat != NULL );

   SecondaryDataStructureIterator * dataIter =
      dynamic_cast<SecondaryDataStructureIterator *>( iter );
   x4Assert( dataIter != NULL );

   Matrix4fAttachment * matAttachment = dynamic_cast<Matrix4fAttachment*>( getData( mat, scene, obj, dataIter ) );

   Matrix4f matrix = IDENTITY4F;

   if( matAttachment != NULL )
   {
		matrix = matAttachment->getMatrix();
      shMat->getGLVertexShader(context)->setMatrix4f( getName(), m_Index, &matrix[0][0]);
      shMat->getGLPixelShader(context)->setMatrix4f( getName(), m_Index, &matrix[0][0] );
   }
   else
   {
      if( getUseDefault() )
      {
         shMat->getGLVertexShader(context)->setMatrix4f( getName(), m_Index, m_DefaultMatrix );
         shMat->getGLPixelShader(context)->setMatrix4f( getName(), m_Index, m_DefaultMatrix );
      }
		else
		{
	      shMat->getGLVertexShader(context)->setMatrix4f( getName(), m_Index, &matrix[0][0] );
		   shMat->getGLPixelShader(context)->setMatrix4f( getName(), m_Index, &matrix[0][0] );
		}
	}

   forget(scene);
   forget(obj);
   forget(iter);
   forget(context);
   forget(mm);
}

void MPVector4::assign(const Object* obj, X4CopyContext *context )
{
   MaterialParameter::assign( obj, context );
   MPVector4 * p = (MPVector4*)obj;
   m_Index = p->m_Index;
   m_ClampMin = p->m_ClampMin;
   m_ClampMax = p->m_ClampMax;
   memcpy( m_DefaultVector, p->m_DefaultVector, sizeof(float32)*4 );
   memcpy( m_MinVector, p->m_MinVector, sizeof(float32)*4 );
   memcpy( m_MaxVector, p->m_MaxVector, sizeof(float32)*4 );

}

void MPVector4::set( GLMaterial * mat, Scene * scene, SceneObject * obj,
      SceneObjectIterator * iter, GLContext * context, MemoryManager * mm )
{
   GLShaderMaterial * shMat = dynamic_cast<GLShaderMaterial*>(mat);
   x4Assert( shMat != NULL );

   SecondaryDataStructureIterator * dataIter =
      dynamic_cast<SecondaryDataStructureIterator *>( iter );
   x4Assert( dataIter != NULL );

   Vector4fAttachment * vecAttachment = dynamic_cast<Vector4fAttachment*>( getData( mat, scene, obj, dataIter ) );

   ShaderConstant vec( getName(), m_Index, 4 );
   bool setConstant = true;
	Vector4f param;
	card32 numComponentsUsed = 4;

   if( vecAttachment != NULL )
   {
       vec.setData( &vecAttachment->getVector()[0] );
		 param = vecAttachment->getVector();
		 numComponentsUsed = vecAttachment->getNumComponentsUsed();
   }
   else
   {
      if( getUseDefault() )
      {
          vec.setData( m_DefaultVector );
			 param = makeVector4f(m_DefaultVector[0], m_DefaultVector[1],
				 m_DefaultVector[2],m_DefaultVector[3]);
      }
      else
         setConstant = false;
   }

   if( setConstant )
   {
      GLShaderCG *vs,*ps;
		vs = dynamic_cast<GLShaderCG*>(shMat->getGLVertexShader(context));
		ps = dynamic_cast<GLShaderCG*>(shMat->getGLPixelShader(context));

		if( vs != NULL )
			vs->setParameterxf( getName(), numComponentsUsed, &param[0] );
		else
			shMat->getGLVertexShader(context)->setConstant( vec );
   
		if( ps != NULL )
			ps->setParameterxf( getName(), numComponentsUsed, &param[0] );
		else
			shMat->getGLPixelShader(context)->setConstant( vec );

   }
   forget(context);
   forget(mm);
}

MPTexture::~MPTexture()
{
	delete m_DefaultTexture;
}


void MPTexture::assign(const Object* obj, X4CopyContext *context)
{
   MaterialParameter::assign( obj, context );
   MPTexture * tex = (MPTexture*)obj;
   m_DefaultTextureName = tex->m_DefaultTextureName;
   m_TextureStage = tex->m_TextureStage;
   //m_AttachmentContainer->clear();
	delete m_DefaultTexture;
	m_DefaultTexture = NULL;
	if( tex->m_DefaultTexture )
	{
		m_DefaultTexture = (TextureAttachment*)tex->m_DefaultTexture->copy();
	}
}

void MPTexture::set( GLMaterial * mat, Scene * scene, SceneObject * obj,
      SceneObjectIterator * iter, GLContext * context, MemoryManager * mm )
{
   SecondaryDataStructureIterator * dataIter =
      dynamic_cast<SecondaryDataStructureIterator *>( iter );


	AttachedData * data = getData( mat, scene, obj, dataIter );
	if( (data==NULL) && getUseDefault() )
	{
		data = scene->getAttachments()->getData( m_DefaultTextureName );
	}

	RenderTextureAttachment * rta = dynamic_cast<RenderTextureAttachment*>(data);
   TextureAttachment * texAtt = dynamic_cast<TextureAttachment*>( data );

	if( rta )
	{
		// simple bind render texture
		// no context check done here
		rta->bind( m_TextureStage );
		return;
	}

	if( texAtt == NULL )
	{
       texAtt = m_DefaultTexture;

	}

   if( texAtt )
   {
      //texAtt->update();

      // try to reuse existing gl texture
      std::string texID = GLTextureAttachment::generateID( context->getRootContext(), "" );
      GLTextureAttachment * glTexAtt = dynamic_cast<GLTextureAttachment*>(
         texAtt->fetchData( texID ) );


      if( glTexAtt )
      {
         // bind existing gl texture
         x4Assert( glTexAtt->getTexture() );
         glTexAtt->getTexture()->bind( m_TextureStage );
      }
      else
      {
         // create gl texture & bind it
         glTexAtt = new GLTextureAttachment;

         GLTexture * texture = texAtt->createGLTexture( context );
         glTexAtt->setupTA( texture, "", mm, true );
         texAtt->attachData( glTexAtt );

         texture->bind( m_TextureStage );
      }


	  GLShaderMaterial * shMat = dynamic_cast<GLShaderMaterial*>(mat);
	  if (shMat)
	  {
		  GLShaderCG *vs,*ps;
		  vs = dynamic_cast<GLShaderCG*>(shMat->getGLVertexShader(context));
		  ps = dynamic_cast<GLShaderCG*>(shMat->getGLPixelShader(context));

		  card32 numComponentsUsed = 2;
		  
		  GLTexture2D* tex2D = dynamic_cast<GLTexture2D*>(glTexAtt->getTexture());
		  GLTextureRect* texRect = NULL;
          GLTexture3D* tex3D = NULL;


		  if (tex2D == NULL)
			texRect = dynamic_cast<GLTextureRect*>(glTexAtt->getTexture());

		  if (texRect == NULL)
			  tex3D = dynamic_cast<GLTexture3D*>(glTexAtt->getTexture());

		  std::vector<float> param(4);

		  if (tex2D)
		  {
				numComponentsUsed = 2;
				param[0] = tex2D->getWidth();
				param[1] = tex2D->getHeight();
		  }else if (texRect)
		  {
			  numComponentsUsed = 2;
			  param[0] = texRect->getWidth();
			  param[1] = texRect->getHeight();
		  }else if (tex3D)
		  {
			  numComponentsUsed = 3;
			  param[0] = tex3D->getWidth();
			  param[1] = tex3D->getHeight();
			  param[2] = tex3D->getDepth();
		  }


		  if( vs != NULL )
		  {
			  vs->setParameterxf( getName() + "_size", numComponentsUsed, &param[0] );
		  }

		  if( ps != NULL )
		  {
			  ps->setParameterxf( getName() + "_size", numComponentsUsed, &param[0] );
		  }
	  }

   }

}

void MPSingleFloat::set( GLMaterial * mat, Scene * scene, SceneObject * obj,
      SceneObjectIterator * iter, GLContext * context, MemoryManager * mm )
{
   GLShaderMaterial * shMat = dynamic_cast<GLShaderMaterial*>(mat);
   x4Assert( shMat != NULL );

   GLShaderCG * vs = dynamic_cast<GLShaderCG*>( shMat->getGLVertexShader(context) );
   GLShaderCG * ps = dynamic_cast<GLShaderCG*>( shMat->getGLPixelShader(context) );

   float value = m_Minimum + m_Interpolator * (m_Maximum - m_Minimum);

   if( vs )
      vs->setParameter1f( getName(), value );
   if( ps )
      ps->setParameter1f( getName(), value );

   forget(scene);
   forget(obj);
   forget(iter);
   forget(mm);
}



X4::MPMieRayleighParameter::MPMieRayleighParameter()
{
	m_ScatteringParameter.m_SunIntensity = 100.0f;
	m_Rayleigh = 1.0f;
	m_Mie = 0.1f;
	m_HG = 0.8f;
	m_Inscattering = 0.1f;
	m_SunPhi = 45.0f;
	m_SunTheta = 0.0f;

}


void X4::MPMieRayleighParameter::calculateScatteringConstants()
{
	// Reference: ATI DX SDK - Scattering demo

	const float pi = 3.14159265358f;
	const float n = 1.003f; // refractive index
	const float N = 2.545e25f;
	const float pn = 0.035f;

	float fLambda[3],fLambda2[3], fLambda4[3];
	fLambda[0]  = 1/650e-9f; // red // note 650e-9 m = 650nm.
	fLambda[1]  = 1/570e-9f;	// green
	fLambda[2]  = 1/475e-9f; // blue
	for (int i=0; i < 3; i++)
	{
		fLambda2[i] = fLambda[i]*fLambda[i];
		fLambda4[i] = fLambda2[i]*fLambda2[i];
	}
	Vector3f vLambda2 = makeVector3f(fLambda2[0],fLambda2[1],fLambda2[2]);
	Vector3f vLambda4 = makeVector3f(fLambda4[0],fLambda4[1],fLambda4[2]);

	// Rayleigh scattering constants.
	float fTemp = pi*pi*(n*n-1)*(n*n-1)*(6+3*pn)/(6-7*pn)/N;
	float fBeta = 8*fTemp*pi/3;
	m_ScatteringParameter.m_vBetaRay = vLambda4 * fBeta;

	float fBetaDash = fTemp/2;
	m_ScatteringParameter.m_vBetaDashRay = vLambda4 * fBetaDash;

	// Mie scattering constants.
	const float T = 2.0f;
	float c = (6.544*T - 6.51)*1e-17; // from page 57 of my thesis.
	float fTemp2 = 0.434*c*(2*pi)*(2*pi)*0.5f;
	m_ScatteringParameter.m_vBetaDashMie = vLambda2 * fTemp2;

	float K[3] = {0.685f, 0.679f, 0.670f}; // from pg 64 of my thesis.
	float fTemp3 = 0.434f*c*pi*(2*pi)*(2*pi);
	Vector3f vBetaMieTemp = makeVector3f(K[0]*fLambda2[0],K[1]*fLambda2[1], K[2]*fLambda2[2]);
	m_ScatteringParameter.m_vBetaMie = vBetaMieTemp * fTemp3;


	float sunTheta = min( 90.0f, m_SunPhi );
	float sunPhi = m_SunTheta;

	// compute sun attenuation

	float theta = sunTheta / 180.0f * M_PI;
	float phi = sunPhi / 180.0f * M_PI;
	float y = cos(theta );
	float x = sin(theta) * cos(phi);
	float z = sin(theta) * sin(phi);

	m_ScatteringParameter.m_SunDirection = makeVector3f(x,y,z);


	// This function taken from source available on 99 sig paper web page.
	// http://www.cs.utah.edu/vissim/papers/sunsky/code/RiSunConstants.C

	float nTurbidity = 2;

	/*float*/ fBeta = 0.04608365822050f * nTurbidity - 0.04586025928522f;
	float fTauR, fTauA, fTau[3];
	float tmp = (float)(93.885f-sunTheta);
	float divider = (cos(theta) + 0.15f*pow(tmp,(float)-1.253f));
	float m = 1.0/divider;  // Relative Optical Mass

	int i;
	//    float fLambda[3]; 
	fLambda[0] = 0.65f;	// red (in um.)
	fLambda[1] = 0.57f;	// green (in um.)
	fLambda[2] = 0.475f;	// blue (in um.)


	for(i = 0; i < 3; i++)
	{
		// Rayleigh Scattering
		// Results agree with the graph (pg 115, MI) */
		// lambda in um.
		fTauR = exp( -m * 0.008735f * pow(fLambda[i], float(-4.08f)));

		// Aerosal (water + dust) attenuation
		// beta - amount of aerosols present 
		// alpha - ratio of small to large particle sizes. (0:4,usually 1.3)
		// Results agree with the graph (pg 121, MI) 
		const float fAlpha = 1.3f;
		fTauA = exp(-m * fBeta * pow(fLambda[i], -fAlpha));  // lambda should be in um


		fTau[i] = fTauR * fTauA; 

	}

	m_ScatteringParameter.m_SunAttenuation = makeVector3f(fTau[0], fTau[1], fTau[2]);

}

void X4::MPMieRayleighParameter::set( GLMaterial * glmat, Scene * scene, SceneObject * obj, SceneObjectIterator * iter, GLContext * context, MemoryManager * mm )
{
	GLShaderMaterial * mat = dynamic_cast<GLShaderMaterial*>(glmat);
	if( !mat )
		return;

	calculateScatteringConstants();

	Vector3f sunDir;
	float phi = m_SunPhi / 180.0f * M_PI;
	float theta = m_SunTheta / 180.0f * M_PI + M_PI / 2.0f;
	sunDir[1] = cos( phi );
	sunDir[0] = sin( phi ) * cos( theta );
	sunDir[2] = sin( phi ) * sin( theta );
	mat->setParameter3fv( context, "sunDirection", &sunDir[0] );
	mat->setParameter3fv( context, "sunDir", &sunDir[0] );

	/*   float sunDir[4] = {  m_ScatteringParameter.m_SunDirection[0],
	m_ScatteringParameter.m_SunDirection[1],
	m_ScatteringParameter.m_SunDirection[2],0};
	*/
	//   mat->setParameter3fv( context, "sunDir", &m_ScatteringParameter.m_SunDirection[0] );

	float terrainReflectance[3] = {0.138f, 0.113f, 0.08f};
	mat->setParameter3fv( context, "terrainReflectance", terrainReflectance );

	float sunAtt[4] = {  m_ScatteringParameter.m_SunAttenuation[0],
		m_ScatteringParameter.m_SunAttenuation[1],
		m_ScatteringParameter.m_SunAttenuation[2],
		m_ScatteringParameter.m_SunIntensity};
	mat->setParameter4fv( context, "sunAtt", sunAtt );

	// Rayleigh
	Vector3f beta1 = m_ScatteringParameter.m_vBetaRay * m_Rayleigh;
	Vector3f betaDash1 = m_ScatteringParameter.m_vBetaDashRay * m_Rayleigh;

	mat->setParameter3fv( context, "beta1", &beta1[0] );
	mat->setParameter3fv( context, "betaDash1", &betaDash1[0] );

	// Mie
	Vector3f beta2 = m_ScatteringParameter.m_vBetaMie * m_Mie;
	Vector3f betaDash2 = m_ScatteringParameter.m_vBetaDashMie * m_Mie;

	mat->setParameter3fv( context, "beta2", &beta2[0] );
	mat->setParameter3fv( context, "betaDash2", &betaDash2[0] );



	Vector3f beta_rm = beta1 + beta2;
	Vector3f one_over_beta_rm = makeVector3f(0,0,0);
	for( card32 i=0;i<3;i++ )
		if( fabs( beta_rm[i]) > 0.000001f )
			one_over_beta_rm[i] = 1.0f / beta_rm[i];

	mat->setParameter3fv( context, "beta1Plus2", &beta_rm[0] );
	mat->setParameter3fv( context, "oneOverBeta12", &one_over_beta_rm[0] );


	// Henyey Greenstein's G value.
	float hg[4] = {1.0f - m_HG * m_HG, 1.0f + m_HG, 2.0f * m_HG,0};
	mat->setParameter4fv( context, "HG", hg );


	float constants[4] = {1.0f, 1.0f / log(2.0f), 0.5f, m_Inscattering};
	mat->setParameter4fv( context, "constants", constants );

	Vector3f sunAtt2 = m_ScatteringParameter.m_SunAttenuation * m_ScatteringParameter.m_SunIntensity;
	mat->setParameter4fv( context, "sunAtt2", &sunAtt2[0] );

	Vector3f camPos = scene->getRootState()->staticState->camera.getPosition();
	mat->setParameter3fv( context, "camPos", camPos.data());
}