#ifndef RenderTextureAttachmentH
#define RenderTextureAttachmentH
//---------------------------------------------------------------------------
#include "x3rendering.h"
//---------------------------------------------------------------------------
#include "AttachedData.h"
//---------------------------------------------------------------------------

namespace X4
{

class GLRenderTextureFBO;

/**
	holds a render texture and provides bind()/unbind()
*/
class X3RENDERING_API RenderTextureAttachment : public AttachedData
{
	X4_CLASS( RenderTextureAttachment )

private:

	GLRenderTextureFBO	*	m_RenderTexture;

public:
	RenderTextureAttachment(void);
	~RenderTextureAttachment(void);

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

	void setRenderTexture( GLRenderTextureFBO * rt ) {m_RenderTexture = rt;}

	void bind( int stage = 0);
	void unbind();

};

}

#endif