#ifndef ShaderEditorWidgetH 
#define ShaderEditorWidgetH
//---------------------------------------------------------------------------
#include "x3rendering.h"
//---------------------------------------------------------------------------
#include "ClassEditor.h"
#include "x3rendering/ShaderEditorForm_ui.h"
//---------------------------------------------------------------------------

namespace X4
{

class Shader;
class GLContext;


class X3RENDERING_API ShaderEditorWidget : public QWidget
{
	Q_OBJECT

private:

	Shader * m_Shader;
    GLContext * m_TestContext;

	///used to access buttons, etc. from QtDesigner
	Ui_ShaderEditorForm ui;

public:
	ShaderEditorWidget(QWidget * parent = NULL, Qt::WindowFlags f=0);
	~ShaderEditorWidget(void);
	
	std::string removeChar(const std::string &dest, char c );
	std::string replaceChar(const std::string &dest, char c, const std::string &replaceStr);

	void setup( Shader * obj );

	/// update editor content with object data
	void updateEditor();
	Shader * getObj();
	void setTestContext( GLContext * context ) {m_TestContext = context;}
	static GLContext	*	m_DefaultGLContext;

	public slots:
		 void sltCompile();
		 void sltSave();
		 void sltLoad();
		 void sltShaderClassChange(int);
       void sltShaderTypeChange(int);
		 void sltEditChange();
		 void sltCursorPosChanged();


};

MAKE_CLASS_EDITOR( X3RENDERING_API , Shader )


}

#endif