//---------------------------------------------------------------------------
#ifndef SimpleGLTriMeshMaterialH
#define SimpleGLTriMeshMaterialH
//---------------------------------------------------------------------------
#include "x3rendering.h"
//---------------------------------------------------------------------------
#include "GLMaterial.h"
//---------------------------------------------------------------------------

namespace X4 {


class X3RENDERING_API  SimpleGLTriMeshMaterial : public GLMaterial {
	X4_CLASS(SimpleGLTriMeshMaterial)
 private:
   static MetaClass *SimpleGLTriMeshMaterialMetaClass;
   //static Object* newInstance();

   bool wireframe;
   bool showNormals;
   float normalLength;
   bool colorizeNormal;
   bool useVertexNormals;
   bool showWireFrameOnly;
   bool showWireFrameOnly_depthTest;
   bool blackWireFrame;
	bool showBorder;
	bool cullBackFace;
	bool intensityPerFace;
	float32 intensityThreshold;

 public:
   SimpleGLTriMeshMaterial();

   void setUseVertexNormals(bool b) {useVertexNormals = b;}

   //virtual const MetaClass *getInstanceClass() const;
   //static const MetaClass *getClass();
   //static void init(const MetaClass *parentClass);
   //static void shutdown();

   virtual void draw( Scene * scene, SceneGraphState *state, SceneObject * cloud,
      SceneObjectIterator *iter, GLContext * context, MemoryManager * mm = NULL,
      const int32 includeFlags = 0, const int32 excludeFlags = PF_FLAG_INVALID );

};


}

#endif
