//---------------------------------------------------------------------------
#ifndef SimpleLinesMaterialH
#define SimpleLinesMaterialH
//---------------------------------------------------------------------------
#include "x3rendering.h"
//---------------------------------------------------------------------------
#include "GLMaterial.h"
//---------------------------------------------------------------------------

namespace X4 {

///	draws ParametricInCorePointClouds as collections of lines
class X3RENDERING_API SimpleLinesMaterial : public GLMaterial {
   X4_CLASS( SimpleLinesMaterial )
 private:
   float32 lineWidth;
   Vector4f color;
   bool blending;
   bool stipple;
   float32 stipplePointSize;
   Vector4f stippleColor;
   
 public:
	SimpleLinesMaterial();
   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

   virtual void draw(Scene *scene, SceneGraphState *state, SceneObject *obj,
      SceneObjectIterator *iter, GLContext *context, MemoryManager * mm = NULL,
      const int32 includeFlags = 0, const int32 excludeFlags = PF_FLAG_INVALID );

	~SimpleLinesMaterial();
};

}

#endif