#include "StdAfx.h"

#include "x3rendering.h"

#include <TaggingMacros.h>
#include <X4Types.h>

#include "CubeTextureAttachmentEditorWidget.h"
#include "RGBATextureAttachmentEditorWidget.h"
#include "ShaderEditorWidget.h"
#include "GLShaderMaterialEditorWidget.h"
#include "InterpFunctionTextureAttachmentEditorWidget.h"
#include "InterpFunctionTextureAttachmentRGBEditorWidget.h"
#include "GLVolumeRaycastMaterialEditorWidget.h"
#include "SceneCreator.h"

#include "x3rendering_rcc.h"

using namespace X4;

#include "x3rendering.init.cpp"



BEGIN_INIT_MODULE
    qInitResources();

	CubeTextureAttachmentEditor::init(ClassEditor::getClass());
	((GUIDescriptor * )CubeTextureAttachment::getClass()->getGUIDescriptor())->addClassEditor(
		CubeTextureAttachmentEditor::getClass(), true);

	RGBATextureAttachmentEditor::init(ClassEditor::getClass());
	((GUIDescriptor * )RGBATextureAttachment::getClass()->getGUIDescriptor())->addClassEditor(
		RGBATextureAttachmentEditor::getClass(), true);

	ShaderEditor::init(ClassEditor::getClass());
	((GUIDescriptor * )Shader::getClass()->getGUIDescriptor())->addClassEditor(
		ShaderEditor::getClass(), true);

	GLShaderMaterialEditor::init(ClassEditor::getClass());
	((GUIDescriptor * )GLShaderMaterial::getClass()->getGUIDescriptor())->addClassEditor(
		GLShaderMaterialEditor::getClass(), true);

	InterpFunctionTextureAttachmentEditor::init( ClassEditor::getClass());
	((GUIDescriptor * )InterpFunctionTextureAttachment::getClass()->getGUIDescriptor())->addClassEditor(
		InterpFunctionTextureAttachmentEditor::getClass(), true);

	InterpFunctionTextureAttachmentRGBEditor::init( ClassEditor::getClass());
	((GUIDescriptor * )InterpFunctionTextureAttachmentRGB::getClass()->getGUIDescriptor())->addClassEditor(
		InterpFunctionTextureAttachmentRGBEditor::getClass(), true);

	GLVolumeRaycastMaterialEditor::init( ClassEditor::getClass());
	((GUIDescriptor * )GLVolumeRaycastMaterial::getClass()->getGUIDescriptor())->addClassEditor(
		GLVolumeRaycastMaterialEditor::getClass(), true);

	const_cast<MetaClass*>(Scene::getClass())->getGUIDescriptor()->addClassCreator(SceneCreator::getClass());

END_INIT_MODULE 

BEGIN_SHUTDOWN_MODULE
END_SHUTDOWN_MODULE 

BEGIN_X4_LOADABLE_MODULE(x3rendering)
	#include "x3rendering.tags.h"
END_X4_LOADABLE_MODULE(x3rendering)


