SET_MODULE_TYPE_LOADABLE_MODULE

ADD_DEPENDENCY("opencv")
ADD_DEPENDENCY("x4basics")
ADD_DEPENDENCY("x4core")
ADD_DEPENDENCY("x4interface")
ADD_DEPENDENCY("x4math")
ADD_DEPENDENCY("x4miscFoundation")
ADD_DEPENDENCY("x4tools")
ADD_DEPENDENCY("x4modules")
ADD_DEPENDENCY("x3geometry")
ADD_DEPENDENCY("x3openGL")
ADD_DEPENDENCY("x3sceneGraph")

ADD_AUTHOR("Michael Wand")
ADD_AUTHOR("Martin Bokeloh")
ADD_AUTHOR("Art Tevs")
ADD_AUTHOR("Alexander Berner")
ADD_AUTHOR("Mark Hoffman")
ADD_AUTHOR("Benjamin Maier")
ADD_AUTHOR("Arno Fleck")

ADD_INSTITUITION("WSI/GRIS, Tbingen University")
ADD_INSTITUITION("MPI Informatik Saarbrcken")

ADD_LICENSE("BSD")

// an icon for this module
ADD_ICON(":/images_x3rendering/images/x3rendering.png")


ADD_CLASS_INC("GLTextureSettings", "Persistent", "GLTexture.h")
ADD_CLASS("Renderer", "Persistent")
ADD_CLASS("LCHierarchyRenderer", "Renderer")
ADD_CLASS("TwoPassBlendingRenderer", "Renderer")
ADD_CLASS("Shader", "Persistent")
ADD_CLASS("GLShaderMaterial", "GLMaterial")
ADD_CLASS("SimplePCMaterial", "GLMaterial")
ADD_CLASS("SimpleGLTriMeshMaterial", "GLMaterial")
ADD_CLASS("GLSimpleVolumeMaterial", "GLMaterial")
ADD_CLASS("PointsAsSpheresMaterial", "GLMaterial")
ADD_CLASS("SimpleLinesMaterial", "GLMaterial")
ADD_CLASS("DirectionsMaterial", "GLMaterial")
ADD_CLASS("CurvatureDirectionsMaterial", "DirectionsMaterial")
ADD_CLASS("GLVolumeMaterialStandard", "GLMaterial")
ADD_CLASS("GLVolumeMaterialGeneral", "GLMaterial")
ADD_CLASS("GLVolumeRaycastMaterial", "GLMaterial")
ADD_CLASS_INC("GLRenderObject", "Object", "GLMaterial.h")
ADD_CLASS_INC("GLImModePtsRenderObject", "GLRenderObject", "GLMaterial.h")
ADD_CLASS("MPContainer", "Persistent")
ADD_CLASS("MaterialParameter", "Persistent")
ADD_CLASS_INC("MPMatrix4x4", "MaterialParameter", "MaterialParameter.h")
ADD_CLASS_INC("MPSingleFloat", "MaterialParameter", "MaterialParameter.h")
ADD_CLASS_INC("MPTexture", "MaterialParameter", "MaterialParameter.h")
ADD_CLASS_INC("MPVector4", "MaterialParameter", "MaterialParameter.h")
ADD_CLASS_INC("MPMieRayleighParameter", "MaterialParameter", "MaterialParameter.h")
ADD_CLASS_INC("Matrix4fAttachment", "AttachedData", "MaterialAttachment.h")
ADD_CLASS_INC("TextureAttachment", "AttachedData", "MaterialAttachment.h")
ADD_CLASS_INC("CubeTextureAttachment", "TextureAttachment", "CubeTextureAttachment.h")
ADD_CLASS_INC("CubeTextureFunctionAttachment", "TextureAttachment", "CubeTextureAttachment.h")
ADD_CLASS_INC("RGBATextureAttachment", "TextureAttachment", "RGBATextureAttachment.h")
ADD_CLASS_INC("RGBAFloat32TextureAttachment", "TextureAttachment", "RGBATextureAttachment.h")
ADD_CLASS_INC("InterpFunctionTextureAttachment", "TextureAttachment", "InterpFunctionTextureAttachment.h")
ADD_CLASS_INC("InterpFunctionTextureAttachmentRGB", "TextureAttachment", "InterpFunctionTextureAttachmentRGB.h")
ADD_CLASS_INC("RandomTextureAttachment", "TextureAttachment", "MaterialAttachment.h")
ADD_CLASS_INC("Vector4fAttachment", "AttachedData", "MaterialAttachment.h")
ADD_CLASS_INC("Vector4iAttachment", "AttachedData", "MaterialAttachment.h")
ADD_CLASS_INC("TextureStackAttachment", "AttachedData", "GLSimpleVolumeMaterial.h")
ADD_CLASS_INC("CubeFunction3toN", "Persistent", "CubeTextureAttachment.h")
ADD_CLASS_INC("CubeFunctionIdentity", "CubeFunction3toN", "CubeTextureAttachment.h")
ADD_CLASS_INC("LCState", "Persistent", "LCTraversal.h")
ADD_CLASS("LCTraversal", "Persistent")
ADD_CLASS("SceneCreator", "ClassCreator")
ADD_CLASS("GLVolumeDisplayer", "GLEventObject")
ADD_CLASS("GLVolumeRenderer2DSlices", "Persistent")
ADD_CLASS("RenderingTool", "Persistent")
ADD_CLASS("ECPhotonTracer", "Persistent")



