//---------------------------------------------------------------------------
#include "stdafx.h"

//---------------------------------------------------------------------------
#include "AttachedDataTypes.h"
#include "EmbeddedObjectClassProperty.h"
//---------------------------------------------------------------------------
 
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



const std::string X4::AttachedRenderObject::GL_MATERIAL_RENDER_OBJECT = "glMatRenderObj";
const std::string X4::AttachedRenderObject::SELECTION_RENDER_OBJECT = "selRenderObj";


MetaClass* AttachedRenderObject::AttachedRenderObjectMetaClass = NULL;

const MetaClass* AttachedRenderObject::getInstanceClass() const {
   return getClass();
}

Object* AttachedRenderObject::newInstance() {
   return new AttachedRenderObject;
}

const MetaClass* AttachedRenderObject::getClass() {
   if (AttachedRenderObjectMetaClass==NULL) {
      AttachedRenderObjectMetaClass = new MetaClass("AttachedRenderObject", "no description.",
                                  newInstance, sizeof(AttachedRenderObject));
   }
   return AttachedRenderObjectMetaClass;
}

void AttachedRenderObject::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   AttachedRenderObjectMetaClass->copyParentProperties();
}

void AttachedRenderObject::shutdown() {
   delete AttachedRenderObjectMetaClass;
}


// ----

MetaClass* AttachedDictionaryObject::AttachedDictionaryObjectMetaClass = NULL;


const MetaClass* AttachedDictionaryObject::getInstanceClass() const {
   return getClass();
}

Object* AttachedDictionaryObject::newInstance() {
   return new AttachedDictionaryObject;
}

const MetaClass* AttachedDictionaryObject::getClass() {
   if (AttachedDictionaryObjectMetaClass == NULL) {
      AttachedDictionaryObjectMetaClass = new MetaClass("AttachedDataDictionaryObject", "no description.",
                                  newInstance, sizeof(AttachedData));
   }
   return AttachedDictionaryObjectMetaClass;
}

void AttachedDictionaryObject::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass, MetaClass::FIRST_VERSION);
   AttachedDictionaryObjectMetaClass->copyParentProperties();

BEGIN_CLASS_INIT( AttachedDictionaryObject );
ADD_EMBEDDED_OBJECT_PROP( dictionary, 0, ObjectDictionary::getClass() );
}

void AttachedDictionaryObject::shutdown() {
   delete AttachedDictionaryObjectMetaClass;
}

void AttachedDictionaryObject::assign(const Object* obj, X4CopyContext *context)
{
  x4Assert(obj->getInstanceClass() == getInstanceClass());
  AttachedData::assign(obj, context);
  AttachedDictionaryObject* attachedDic = (AttachedDictionaryObject*)obj;
  dictionary = attachedDic->dictionary;
}

