//---------------------------------------------------------------------------
#ifndef AttachedDataTypesH
#define AttachedDataTypesH
//---------------------------------------------------------------------------
#include "x3sceneGraph.h"
//---------------------------------------------------------------------------
#include <string>
//---------------------------------------------------------------------------
#include "AttachedData.h"
#include "GLMaterial.h"
#include "ObjectDictionary.h"
//---------------------------------------------------------------------------

namespace X4 {


class RenderObject;

class X3SCENEGRAPH_API AttachedRenderObject : public AttachedData {
 private:
   static MetaClass *AttachedRenderObjectMetaClass;
   static Object* newInstance();

   GLRenderObject *renderObject;

 protected:
   inline ~AttachedRenderObject()                {delete renderObject;}

 public:
   static const std::string GL_MATERIAL_RENDER_OBJECT;
   static const std::string SELECTION_RENDER_OBJECT;

   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   inline AttachedRenderObject()                 {renderObject = NULL;}

   inline GLRenderObject *getRenderObject()        {return renderObject;}
   inline void setRenderObject(GLRenderObject *ro) {renderObject = ro;}
};


class X3SCENEGRAPH_API AttachedDictionaryObject : public AttachedData {
 private:
   ObjectDictionary dictionary;
   static MetaClass *AttachedDictionaryObjectMetaClass;
   static Object* newInstance();

 public:
   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

   inline ObjectDictionary *getObjectDictionary() { return &dictionary; }
};

}


#endif
