#ifndef SGCameraNodeH
#define SGCameraNodeH
//---------------------------------------------------------------------------
#include "x3sceneGraph.h"
//---------------------------------------------------------------------------
#include "SceneGraphNode.h"
//---------------------------------------------------------------------------

namespace X4
{

class Camera;
class CameraController;
class ViewFrustum;
class PCICameraManagerEditorWidget;

/**
	holds camera, viewfrustum and camera-controller
*/
class X3SCENEGRAPH_API SGCameraNode : public SceneGraphNode
{
	X4_CLASS( SGCameraNode )

private:

	Camera	*				m_Camera;
	CameraController	*	m_CameraController;
	ViewFrustum	*			m_ViewFrustum;

	friend PCICameraManagerEditorWidget;


public:
	SGCameraNode(void);
	SGCameraNode(card32 Type); 
	~SGCameraNode(void);

   virtual void assign(const Object* obj, X4CopyContext *context = NULL);

	// becomes owner!
	void setCamera(Camera * cam);
	Camera * getCamera() {return m_Camera;}

	// becomes owner!
	void setViewFrustum(ViewFrustum * vf);
	ViewFrustum * getViewFrustum() {return m_ViewFrustum;}

	// becomes owner!
	void setCameraController(CameraController * controller);
	CameraController *getCameraController();

	virtual max_platform_card getNumChildNodes(const SceneGraphState *state) const {return 0;}
	virtual SceneGraphNode *getChildNode(const SceneGraphState *state, max_platform_card i) {return NULL;};
	virtual void removeChildNode(std::string name) {}
	virtual bool canAddChildNode() {return false;}
	virtual bool addChildNode(SceneGraphNode *node) {return false;}


};

}

#endif