//---------------------------------------------------------------------------
#ifndef SGListNodeH
#define SGListNodeH
//---------------------------------------------------------------------------
#include "x3sceneGraph.h"
//---------------------------------------------------------------------------
#include "SceneGraphNode.h"
//---------------------------------------------------------------------------

namespace X4 {


class X3SCENEGRAPH_API SGListNode : public SceneGraphNode {
 private:
   static MetaClass *SGListNodeMetaClass;
   static Object* newInstance();

   std::vector<SceneGraphNode*> nodes;

 public:
   SGListNode() {}

   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   void write(OutputObjectStream *s) const;
   void read(InputObjectStream *s);

   virtual max_platform_card getNumChildNodes(const SceneGraphState *state) const;
   virtual SceneGraphNode *getChildNode(const SceneGraphState *state, max_platform_card i);
   virtual void removeChildNode(std::string name);
   virtual bool canAddChildNode();
   virtual bool addChildNode(SceneGraphNode *node);
   /// standard visualization: show local coordinate system
   virtual void renderNodeGL(const SceneGraphState *state);

   /// returns -1 in case the name is not found
   virtual max_platform_int getChildIndex(std::string name);
   virtual void swapChildren(mpcard index1, mpcard index2);

   /// add a new node to list (increments ref-count), changes name to be unique if necessary (adds postfix-number)
   virtual void addNode(SceneGraphNode *n);
   /// removes node from list (decrements ref-count)
   virtual void removeNode(card32 index);
   /// removes all nodes
   virtual void clear();

   ~SGListNode();
};

}


#endif
 