//---------------------------------------------------------------------------
#include "stdafx.h"

//---------------------------------------------------------------------------
#include "SGNodeTypeFilterAdaptor.h"
//---------------------------------------------------------------------------
 
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



MetaClass* SGNodeTypeFilterAdaptor::SGNodeTypeFilterAdaptorMetaClass = NULL;

const MetaClass* SGNodeTypeFilterAdaptor::getInstanceClass() const {
   return getClass();
}

const MetaClass* SGNodeTypeFilterAdaptor::getClass() {
   if (SGNodeTypeFilterAdaptorMetaClass==NULL) {
      SGNodeTypeFilterAdaptorMetaClass = new MetaClass("SGNodeTypeFilterAdaptor", "no description.",
                                                       NULL, sizeof(SGNodeTypeFilterAdaptor));
   }
   return SGNodeTypeFilterAdaptorMetaClass;
}

void SGNodeTypeFilterAdaptor::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   SGNodeTypeFilterAdaptorMetaClass->copyParentProperties();
}

void SGNodeTypeFilterAdaptor::shutdown() {
   delete SGNodeTypeFilterAdaptorMetaClass;
}


// ----


SGNodeTypeFilterAdaptor::SGNodeTypeFilterAdaptor() {
   baseIt = NULL;
   basicIt = NULL;
}

void SGNodeTypeFilterAdaptor::setupAndGoToFirstNode(SceneGraphIterator *baseIt) {
   this->baseIt = baseIt;
   basicIt = dynamic_cast<SGBasicNodesIterator*>(baseIt);
   x4Assert(basicIt != NULL);
   if (basicIt == NULL) return;
   // go to first node of interest
   while (!basicIt->atEnd()) {
      if (!basicIt->atEnd()) {
         if (processNode(basicIt->getNode())) break;
      }
      basicIt->next();
   }
}

void SGNodeTypeFilterAdaptor::next() {
   // go to next node of interest
   x4Assert(basicIt != NULL);
   while (!basicIt->atEnd()) {
      basicIt->next();
      if (!basicIt->atEnd()) {
         if (processNode(basicIt->getNode())) break;
      }
   }
}

bool SGNodeTypeFilterAdaptor::atEnd() {
   return basicIt->atEnd();
}

SceneGraphNode *SGNodeTypeFilterAdaptor::getNode() {
   return basicIt->getNode();
}

SceneGraphNode *SGNodeTypeFilterAdaptor::getParent() {
   return basicIt->getParent();
}

SceneGraphState *SGNodeTypeFilterAdaptor::getState() {
   return basicIt->getState();
}


std::string SGNodeTypeFilterAdaptor::getNameWithPath() {
   return basicIt->getNameWithPath();
}


SGNodeTypeFilterAdaptor::~SGNodeTypeFilterAdaptor() {}
