//---------------------------------------------------------------------------
#ifndef SGNodeTypeFilterAdaptorH
#define SGNodeTypeFilterAdaptorH
//---------------------------------------------------------------------------
#include "x3sceneGraph.h"
//---------------------------------------------------------------------------
#include "SceneGraphIterators.h"
//---------------------------------------------------------------------------

namespace X4 {


/// Filter iterator adaptor - skips all scene graph nodes that do not meet a certain
/// condition (as specified by abstract protected method processNode())
class X3SCENEGRAPH_API SGNodeTypeFilterAdaptor : public SceneGraphIterator,
                                        public SGBasicNodesIterator
{
 private:
   static MetaClass *SGNodeTypeFilterAdaptorMetaClass;
   static Object* newInstance();

   SceneGraphIterator *baseIt;
   SGBasicNodesIterator *basicIt;

 protected:
   virtual bool processNode(SceneGraphNode *n) = 0;

 public:
   SGNodeTypeFilterAdaptor();

   /// always call after specifying the filter parameters
   void setupAndGoToFirstNode(SceneGraphIterator *baseIt);

   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   virtual void next();
   virtual bool atEnd();

   virtual SceneGraphNode *getNode();
   virtual SceneGraphNode *getParent();
   virtual SceneGraphState *getState();
   virtual std::string getNameWithPath();

   virtual ~SGNodeTypeFilterAdaptor();
};

}

#endif
 