//---------------------------------------------------------------------------
#include "stdafx.h"

//---------------------------------------------------------------------------
#include "SGObjectNode.h"
//---------------------------------------------------------------------------
#include "SceneObject.h"
#include "Tools.h"
#include "ObjectClassProperty.h"
#include "SGTransformationStateChanger.h"
//---------------------------------------------------------------------------
 
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



MetaClass* SGObjectNode::SGObjectNodeMetaClass = NULL;

const MetaClass* SGObjectNode::getInstanceClass() const {
   return getClass();
}

Object* SGObjectNode::newInstance() {
   return new SGObjectNode;
}

const MetaClass* SGObjectNode::getClass() {
   if (SGObjectNodeMetaClass==NULL) {
      SGObjectNodeMetaClass = new MetaClass("SGObjectNode", "no description.",
                                  newInstance, sizeof(SGObjectNode));
   }
   return SGObjectNodeMetaClass;
}

void SGObjectNode::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   SGObjectNodeMetaClass->copyParentProperties();
   BEGIN_CLASS_INIT(SGObjectNode)
   ADD_OBJECT_PROP( obj, 0, SceneObject::getClass(), true )

}

void SGObjectNode::shutdown() {
   delete SGObjectNodeMetaClass;
}


// ----


void SGObjectNode::clearAndSetup(SceneObject *obj) {
   if (this->obj != obj) {
      delete this->obj;
      this->obj = obj;
   }
}

void SGObjectNode::removeSceneObject() {
	this->obj = NULL;
}

SGStateChanger *SGObjectNode::getNodeEntryStateChange(const SceneGraphState *state) {
   forget(state);
   if (obj == NULL) {
      return NULL;
   } else {
      return new SGTransformationStateChanger(obj->getTransformation());
   }
}

max_platform_card SGObjectNode::getNumChildNodes(const SceneGraphState *state) const {
   forget(state);
   return 0;
}

SceneGraphNode *SGObjectNode::getChildNode(const SceneGraphState *state, max_platform_card i) {
   forget(state);
   forget(i);
   x4Assert(false);
   return NULL;
}

void SGObjectNode::removeChildNode(std::string name) {
   forget(name);
   x4Assert(false);
}

bool SGObjectNode::canAddChildNode() {
   return false;
}

bool SGObjectNode::addChildNode(SceneGraphNode *node) {
   forget(node);
   return false;
}



SGObjectNode::~SGObjectNode() {
   delete obj;
	}

