//---------------------------------------------------------------------------
#include "stdafx.h"

//---------------------------------------------------------------------------
#include "SGTransformationNode.h"
//---------------------------------------------------------------------------
#include "SGTransformationStateChanger.h"
#include "FixedArrayClassProperty.h"
#include "Tools.h"
#include "LinearAlgebra.inline.h"
//---------------------------------------------------------------------------
 
//---------------------------------------------------------------------------
using namespace X4;
//---------------------------------------------------------------------------



MetaClass* SGTransformationNode::SGTransformationNodeMetaClass = NULL;

const MetaClass* SGTransformationNode::getInstanceClass() const {
   return getClass();
}

Object* SGTransformationNode::newInstance() {
   return new SGTransformationNode;
}

const MetaClass* SGTransformationNode::getClass() {
   if (SGTransformationNodeMetaClass==NULL) {
      SGTransformationNodeMetaClass = new MetaClass("SGTransformationNode", "no description.",
                                  newInstance, sizeof(SGTransformationNode));
   }
   return SGTransformationNodeMetaClass;
}

void SGTransformationNode::init(const MetaClass *parentClass) {
   ((MetaClass*)getClass())->init(parentClass);
   SGTransformationNodeMetaClass->copyParentProperties();
   BEGIN_CLASS_INIT( SGTransformationNode )
   ADD_FLOAT32_FIXED_ARRAY_PROP(transformation, 0, 16, 4)
}

void SGTransformationNode::shutdown() {
   delete SGTransformationNodeMetaClass;
}


// ----


SGTransformationNode::SGTransformationNode() {
   transformation = IDENTITY4F;
}

SGStateChanger *SGTransformationNode::getNodeEntryStateChange(const SceneGraphState *state) {
   forget(state);
   return new SGTransformationStateChanger(transformation);
}
