//---------------------------------------------------------------------------
#ifndef SGTransformationNodeH
#define SGTransformationNodeH
//---------------------------------------------------------------------------
#include "x3sceneGraph.h"
//---------------------------------------------------------------------------
#include "LinearAlgebra.h"
#include "SGStateChangeNode.h"
//---------------------------------------------------------------------------


namespace X4 {


class X3SCENEGRAPH_API SGTransformationNode : public SGStateChangeNode {
 private:
   static MetaClass *SGTransformationNodeMetaClass;

   static Object* newInstance();

   Matrix4f transformation;

 public:
   SGTransformationNode();

   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   virtual SGStateChanger *getNodeEntryStateChange(const SceneGraphState *state);
   void setTransformation(const Matrix4f &t) {transformation = t;}
   Matrix4f getTransformation() {return transformation;}
};


}

#endif
 