//---------------------------------------------------------------------------
#ifndef SceneGraphTools_H
#define SceneGraphTools_H
//---------------------------------------------------------------------------
#include "x3sceneGraph.h"
//---------------------------------------------------------------------------
#include "X4Types.h"
//---------------------------------------------------------------------------
#include <string>
//---------------------------------------------------------------------------


namespace X4 {

class Scene;
class SceneGraphNode;
	
// ==== std::string / path routines

/// for "root/pc1": returns "root/"
X3SCENEGRAPH_API std::string extractSGPath(const std::string &nodeWPath);

/// for "root/pc1": returns "pc1"
X3SCENEGRAPH_API std::string extractSGNode(const std::string &nodeWPath);

/// for "root/pc1": returns ["root", "pc1"]
X3SCENEGRAPH_API std::vector<std::string> parseSGPath(const std::string &path);

/// for "root/list": returns "root/list/"
X3SCENEGRAPH_API std::string endPathWithSlash(const std::string &str);


// ==== scene graph access

/// returns node for a path std::string. returns NULL if anything goes wrong.
X3SCENEGRAPH_API SceneGraphNode *getSceneGraphNode(Scene *scene, std::string path);

/// returns node for a node with path. returns NULL if anything goes wrong.
X3SCENEGRAPH_API SceneGraphNode *getSceneGraphNode(Scene *scene, std::vector<std::string> pathComponents);

/// adds new scene graph node to the given path. the path must exist (exception if not)
X3SCENEGRAPH_API void addSceneGraphNode(Scene *scene, std::string path, SceneGraphNode *addThis);

/// returns first unique path of path+"0", path+"1", ... 
X3SCENEGRAPH_API std::string makePathUnique(Scene *scene, std::string path);

}

#endif
