//---------------------------------------------------------------------------
#ifndef VisitSGNodesOnceIteratorH
#define VisitSGNodesOnceIteratorH
//---------------------------------------------------------------------------
#include "x3sceneGraph.h"
//---------------------------------------------------------------------------
#include "StandardSceneGraphIterator.h"
//---------------------------------------------------------------------------

namespace X4 {

class X3SCENEGRAPH_API VisitSGNodesOnceIterator : public SceneGraphIterator,
                                         public SGBasicNodesIterator {
 private:
   static MetaClass *VisitSGNodesOnceIteratorMetaClass;
   static Object* newInstance();

   StandardSceneGraphIterator *it;
   std::vector<SceneGraphNode *> cleanupList;

 public:
   VisitSGNodesOnceIterator();

   void clearAndSetup(SceneGraphNode *rootNode, const SceneGraphState *rootState,
                      SGDynamicState::TraversalModeType traversalMode = SGDynamicState::tmAllNodes,
                      card32 includeNodeFlags = 0,
                      card32 excludeNodeFlags = 0);

   virtual const MetaClass *getInstanceClass() const;
   static const MetaClass *getClass();
   static void init(const MetaClass *parentClass);
   static void shutdown();

   virtual void next();
   virtual bool atEnd();
   virtual SceneGraphNode *getNode();
   virtual SceneGraphNode *getParent();
   virtual SceneGraphState *getState();
   virtual std::string getNameWithPath();

   virtual ~VisitSGNodesOnceIterator();
};


}


#endif
 