//---------------------------------------------------------------------------
#ifndef AR4DijkstraDistPC3fH
#define AR4DijkstraDistPC3fH
//---------------------------------------------------------------------------
#include "threeParameterMatchingGMOD14.h"
#include "AR4FuncOnManifold.h"
#include "AR4MLSManifold.h"
//---------------------------------------------------------------------------

namespace X4
{


///Distance field computed by graph distance.
class THREE_PARAMETER_MATCHING_GMOD14_API AR4DijkstraDistPC3f : public AR4FuncOnManifold<AR4MLSManifold3f, float32>, public AR4ScalarFuncLimits<float32>
{
//Constructor/Destructor
public:
	AR4DijkstraDistPC3f(AR4MLSManifold3f* manifold);
	virtual ~AR4DijkstraDistPC3f() {}

//Methods
public:
	virtual void initialize() {}

	///Compute Distance field for the entire graph starting from the given index.
	void compute(const card32 startIndex);

	///Compute Distance field from the given index until a certain distance is met.
	void computeUpToDistance(const card32 startIndex, const float32 DesiredDistance);

	virtual float32 evaluate(mpcard discrPoint) const;

	virtual float32 getMaxValue() {return maxDist;}
	virtual float32 getMinValue() {return 0;}

protected:
	void updateMinMax();

//Atributes
private:
	vector< float32 > distances;
	float32 maxDist;
};


}

#endif
