#ifndef AR4FuncOnManifoldH
#define AR4FuncOnManifoldH

#include "threeParameterMatchingGMOD14.h"

#include "X4Types.h"




namespace X4 {

/// function on a manifold
template<class DiscreteManifoldType, typename OutputType>
class THREE_PARAMETER_MATCHING_GMOD14_API AR4FuncOnManifold {
 private:
   DiscreteManifoldType *manifold;
 protected:
   DiscreteManifoldType *getManifold() {return manifold;}

 public:
   AR4FuncOnManifold(DiscreteManifoldType *manifold) {this->manifold = manifold;}
   
   virtual void initialize() = 0;

   const DiscreteManifoldType *getManifold() const {return manifold;}

   virtual OutputType evaluate(mpcard discrPoint) const = 0;
};

/// add this interface to AR4FuncOnManifold for bounded scalar functions
template<typename ScalarType>
class THREE_PARAMETER_MATCHING_GMOD14_API AR4ScalarFuncLimits {
 public:
   virtual ScalarType getMaxValue() = 0;
   virtual ScalarType getMinValue() = 0;
};


}



#endif