#ifndef AR4FuncOnManifoldTempH
#define AR4FuncOnManifoldTempH

#include "threeParameterMatchingGMOD14.h"

#include "AR4FuncOnManifold.h"



namespace X4 {


/// the function is precomputed and stored in a channel
/// works only for statically sized output types
template<class DiscreteManifoldType, typename OutputType>
class THREE_PARAMETER_MATCHING_GMOD14_API AR4FuncOnManifoldInChannel : public AR4FuncOnManifold {
 private:
   PointSet *ps;
   AAT channelAAT;
   VAD channelVAD;

 protected:
   virtual void precompute(DiscreteManifoldType *manifold, vector<OutputType> &precompFuncValues) = 0;

 public:
   AR4FuncOnManifoldInChannel(DiscreteManifold *manifold, PointSet *representation, VAD channel);

   virtual void initialize();

   inline virtual OutputType evaluate(mpcard discrPoint) const;
};


}

#endif