#ifndef AR4FuncOnManifoldTempH
#define AR4FuncOnManifoldTempH

#include "threeParameterMatchingGMOD14.h"

#include "AR4FuncOnManifold.h"



namespace X4 {


/// the function is precomputed and stored temporary in this object
template<class DiscreteManifoldType, typename OutputType>
class THREE_PARAMETER_MATCHING_GMOD14_API AR4FuncOnManifoldTemp : public AR4FuncOnManifold<DiscreteManifoldType, OutputType> {
 private:
   vector<OutputType> funcValues;

 protected:
   virtual void precompute(DiscreteManifoldType *manifold, vector<OutputType> &precompFuncValues) = 0;

 public:
   virtual void initialize() {precompute(getManifold(), funcValues);}

   inline virtual OutputType evaluate(mpcard discrPoint) const {return funcValues[discrPoint];}

};



}



#endif