#ifndef AR4ManifoldH
#define AR4ManifoldH

#include "threeParameterMatchingGMOD14.h"

#include "X4Types.h"
#include "Persistent.h"



namespace X4 {


/// This is the base class of all different types of manifolds
template <class ManifoldTraits>
class THREE_PARAMETER_MATCHING_GMOD14_API AR4Manifold {
 public: 
   typedef typename ManifoldTraits::FloatType  FloatType;
   typedef typename ManifoldTraits::VectorType VectorType;
   typedef typename ManifoldTraits AR4DiscreteManifoldTraits;
   typedef typename ManifoldTraits::TangentSpace TangentSpace;
   typedef typename ManifoldTraits::BoundingBoxType BoundingBoxType;

   virtual BoundingBoxType getBoundingBox() = 0;
};

}

#endif