#ifndef AR4SmoothManifoldH
#define AR4SmoothManifoldH

#include "threeParameterMatchingGMOD14.h"

#include "AR4ManifoldTraits.h"


namespace X4 {

template<class ManifoldTraits>
class AR4SmoothManifold : virtual public AR4Manifold<ManifoldTraits> {
 public:
   /// Move along surfaces by projection...
   /// return value: false if projection is not trusted, i.e., likely to be projected on the wrong piece of surface, or not projected at all
   virtual bool project(const VectorType &startPos, VectorType &surfacePoint) = 0;
   /// ...compute normals as well...
	/// return value: false if projection is not trusted
	virtual bool project(const VectorType &startPos, VectorType &surfacePoint, VectorType &normal) = 0;
   /// ...and a local tangent space.
	/// return value: false if projection is not trusted
   virtual bool project(const VectorType &startPos, VectorType &surfacePoint, VectorType &normal, TangentSpace &tangentFrame) = 0;
};

}


#endif