//---------------------------------------------------------------------------
#ifndef PCCGaussianCurvatureH
#define PCCGaussianCurvatureH
//---------------------------------------------------------------------------
#include "threeParameterMatchingGMOD14.h"
//---------------------------------------------------------------------------
#include "X4Types.h"
#include "PCCommand.h"
//---------------------------------------------------------------------------


namespace X4 {

class AR4Settings;

/// a simple tool to compute Gaussian curvature on point clouds
/// it uses the current selection
/// designed to be batch-mode friendly (multi-selection capable, automatic resampling of meshes)
class THREE_PARAMETER_MATCHING_GMOD14_API PCCGaussianCurvature : public PCCommand {
	X4_CLASS( PCCGaussianCurvature )
 private:
   float32 sampleSpacing;
   float32 relativeFittingRadius;
   bool useFittingReAlignment;
   bool outputResampledMeshes;
   
 public:
	PCCGaussianCurvature();

	virtual void assign(const Object* obj, X4CopyContext *context = NULL);
   virtual void execute(Scene *scene);

	virtual ~PCCGaussianCurvature();
};


}

#endif
